#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "system.h"

#define str_con 0x7f000000

long int u_tables=0;
struct table *u_table=0;

long int u_indexes=0;
struct index *u_index=0;

long int u_globals=0;
char **u_global=0; /* data for the global variables */

void newptr(struct pointer *p, /* the pointer to administer */
  long int idx, /* the index of the pointer */
  char tp) /* type of the pointer to administer */
{ long int i;
  for(i=u_index[idx].ptrs-1; i>=0; i--)
  { if (u_index[idx].padm[i]==p) return;
  }
  u_index[idx].ptrs+=1;
  u_index[idx].padm=realloc(u_index[idx].padm, u_index[idx].ptrs*sizeof(struct pointer*));
  u_index[idx].patp=realloc(u_index[idx].patp, u_index[idx].ptrs);
  u_index[idx].padm[u_index[idx].ptrs-1]=p;
  u_index[idx].patp[u_index[idx].ptrs-1]=tp;
}

void delptr(struct pointer *p, /* the pointer to de-administer */
  long int idx) /* the index of the pointer */
{ long int i;
  for(i=u_index[idx].ptrs-1; i>=0; i--)
  { if (u_index[idx].padm[i]==p) 
    { u_index[idx].padm[i]=u_index[idx].padm[u_index[idx].ptrs-1];
      u_index[idx].patp[i]=u_index[idx].patp[u_index[idx].ptrs-1];
      u_index[idx].ptrs--;
      break;
    }
  }
}

char *snew(char *a, char *b)
{ if (a!=0) {free(a); a=0;}
  return b;
}

char *sadd(char *a, char *b)
{ long int nl=0;
  if (b==0) return a;
  if (a!=0)
  { nl=strlen(a)+strlen(b)+1;
    a=realloc(a, nl);
  } else 
  { nl=strlen(b)+1;
    a=malloc(nl);
    a[0]=0;
  }
  strcat(a, b);
  free(b);
  return a;
}

char *scon(char *a, const char *b)
{ long int nl=0;
  if (b==0) return a;
  if (a!=0)
  { nl=strlen(a)+strlen(b)+1;
    a=realloc(a, nl);
  } else 
  { nl=strlen(b)+1;
    a=malloc(nl);
    a[0]=0;
  }
  strcat(a, b);
  return a;
}

char *snum(char *a, long int n)
{ char *s=malloc(40);
  s[0]=0;
  if (sprintf(s, "%li", n)==0) 
  { free(s);
    return a;
  }
  return sadd(a, s);
}

char *scpy(char *s)
{ char *r;
  if (s==0) return 0; 
  r=malloc(strlen(s)+1);
  strcpy(r, s);
  return r;
}

char *isep(int *pos, char *s, char *sep)
{ int o=*pos;
  char *n;
  if (s==0) {*pos=-1; return 0;}
  if (*pos>-1 && *pos<=(int)strlen(s))
  { n=strstr(s+*pos, sep);
    if (n==0)
    { *pos=-1;
      n=malloc(strlen(s+o)+1);
      strcpy(n, s+o);
      return n;
    }
    *pos=n-s+1;
    n=malloc(*pos-o+1);
    n[*pos-o-1]=0;
    strncpy(n, s+o, *pos-o-1);
    return n;
  }
  *pos=-1;
  return 0;
}

long int iscan(char *s)
{ long int r;
  if (s==0) return 0;
  while (s[0]==' ') s++;
  if (sscanf(s, "%li", &r)==0)
  { return null;
  }
  return r;
}

int ienum(char *s, char *e)
{ int pos=0;
  int n=0;
  int res=-1;
  if (s==0 || e==0) return res;
  while(pos>-1)
  { char *r=isep(&pos, e, " ");
    if (r!=0)
    { if (strcmp(s, r)==0) res=n;
      free(r);
      n++;
    }
  }
  return res;
}

char *get_enum(int en, char *e)
{ int pos=0;
  int n=0;
  char *res=0;
  while(pos>-1)
  { char *r=isep(&pos, e, " ");
    if (en==n) res=r;
    else free(r);
    n++;
  }
  return res;
}

char *get_int(long int i)
{ char str[50];
  if (i==null) return 0;
  sprintf(str, "%li", i);
  return scpy(str);
}

char *get_sort(long int i)
{ static char str[50];
  sprintf(str, "%li", i);
  return str;
}

char *sinput(FILE *f)
{ int ch;
  char s[2];
  char *r=0;
  ch=fgetc(f);
  s[1]=0;
  while (ch!=10 && ch!=-1)
  { s[0]=ch;
    r=scon(r, s);
    ch=fgetc(f);
  }
  return r;
}


void save_num(FILE *o, long int n)
{ fwrite(&n, 4, 1, o);
}

void save_str(FILE *o, char *s)
{ if (s!=0) 
  { save_num(o, strlen(s)+str_con);
    fwrite(s, 1, strlen(s), o);
  } else
  { save_num(o, 0);
  }
}

long int load_num(FILE *i)
{ long int n;
  n=null;
  fread(&n, 4, 1, i);
  return n;
}

char *load_str(FILE *i)
{ long int l=load_num(i)-str_con;
  char *s=malloc(l+1);
  fread(s, 1, l, i);
  return s;
}

void swrite(char *s, FILE *f)
{ if (s==0 || f==0) return;
  fwrite(s, strlen(s), 1, f);
}

void wline(FILE *f)
{ char s[2];
  s[0]=10;
  s[1]=0;
  swrite(s, f);
}
