#define null 0x7FFFFFFF
#define s_cmp(r, a, b) (((r)!=0)?(r):((a)==0 || (b)==0)?0:strcmp((a),(b)))
#define i_cmp(r, a, b) (((r)!=0)?(r):((a)==null || (b)==null)?0:((a)<(b))?-1:(a)>(b))
#define scmp(a, b) (((a)==0)?-1:((b)==0)?1:strcmp((a),(b)))

#define global(type, nr) (*(type*)(globals[nr]))
#define surefld(type, field, pointer) ((pointer.pos>=0)?field(type, field, pointer):0)
#define field(type, field, pointer) (*(type*)(table[pointer.tbl].ptr+pointer.pos+field))

extern long int u_tables;
extern struct table {
  long int len; /* number of records in the table */
  long int size; /* number of bytes in the table */
  char **ptr;   /* list of parts of the table, each 250 records */
} *u_table;

struct pointer {
  long int branch;  /* record number within index */
  long int leaf;  /* branch in the index */
  long int rec;  /* record number of the record in the table */
};

extern long int u_indexes;
extern struct index {
  long int tbl;
  long int scale; /* number of branches */
  long int *len; /* length of all the branches, max 4000 records */
  long int **ptr; /* pointer lists of the branches */
  long int ptrs; /* number of administered pointer to this index */
  struct pointer **padm; /* list of administered pointers to this index */
  char *patp; /* type of administered pointers */
} *u_index;

extern long int u_globals;
extern char **u_global; /* data for the global variables */

void newptr(struct pointer *p, /* the pointer to administer */
  long int idx, /* the index of the pointer */
  char tp); /* type of the pointer */

void delptr(struct pointer *p, /* the pointer to de-administer */
  long int idx); /* the index of the pointer */

char *isep(int *pos, /* create a new string for each substring from pos */
  char *s,           /* this is the total string */
  char *sep);        /* this is the seperator string */
  
long int iscan(char *s); /* change the string into a long number */

int ienum(char *s, char *e); /* get the number from an enumerate type string */
char *get_enum(int en, char *e); /* get the text from an enumerate type number */
char *get_int(long int i); /* get the text from a long integer */
char *get_sort(long int i); /* get the constant string from a long integer */

char *scpy(char *s); /* copy this string into a new one */
char *snew(char *a, char *b); /* free the variable a and give b back */
char *sadd(char *a, char *b); /* add one string to another */
char *scon(char *a, const char *b); /* add one string to another */
void swrite(char *s, FILE *f); /* write a string to a file */
void wline(FILE *f); /* write a newline to a file */
