#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
struct text {long int len; char *ptr;};
#include "system.h"
#include "unistd.h"
#include "time.h"
#include "sys/time.h"
int v_dbstate=0;
 
void rtn_showidxs(long int v_table) {
  
  long int in; 
  long int br; 
  long int lf; 
  for(in=1; in<u_indexes; in++)
  { if (u_index[in].tbl==v_table)
    { printf("\nIndex: %li of table %li size %li\n", in, v_table, u_index[in].scale);
      for(br=0; br<u_index[in].scale; br++)
      { printf("%4li %4li ", br, u_index[in].len[br]);
        for(lf=0; lf<u_index[in].len[br]; lf++)
        { if (lf!=0) printf("          ");
          printf("%4li %4li\n", lf, u_index[in].ptr[br][lf]);
        }
      }
    }
  }
}
 
char *rtn_ptrinfo(struct pointer v_ptr) {
  
  return scon(sadd(scon(sadd(scon(sadd(scpy("{"),get_int(v_ptr.branch)),", "),get_int(v_ptr.leaf)),", "),get_int(v_ptr.rec)),"}");
}
 
long int rtn_getrec(struct pointer v_ptr, long int v_index) {
  
  return v_ptr.rec;
}
 
long int rtn_tablelen(long int v_table) {
  
  if (v_table<1 || v_table>u_tables) return 0;
  return u_table[v_table].len;
}
 
long int rtn_maxbranch(long int v_index) {
  
 if (v_index<1 || v_index>u_indexes) return -1;
 return u_index[v_index].scale-1;
}
 
long int rtn_maxleaf(long int v_branch, long int v_index) {
  
 if (v_branch<0 || v_index<1 || v_index>=u_indexes || u_index[v_index].len==0) return -1;
 return u_index[v_index].len[v_branch]-1;
}
FILE *v_log=0;
 
void rtn_initdb(long int v_tables, long int v_indexes) {
  
  v_log=fopen("log.txt", "w");
  u_table=realloc(u_table, sizeof(struct table)*v_tables);
  if (u_table==0) {printf("Could not startup"); exit(1);}
  u_tables=v_tables;
  u_index=realloc(u_index, sizeof(struct index)*v_indexes);
  if (u_index==0) {printf("Could not startup"); exit(1);}
  u_indexes=v_indexes;
}
 
struct pointer rtn_addrecord(long int v_table) {
  
  static struct pointer res;
  long int p=u_table[v_table].len / 250;
  long int r=u_table[v_table].len % 250;
  if (u_table[v_table].ptr==0 || r==0)
  { u_table[v_table].ptr=realloc(u_table[v_table].ptr, (p+1) * sizeof(char*));
    if (u_table[v_table].ptr==0) {printf("Out of memory 1\n"); exit(1);}
    u_table[v_table].ptr[p]=0;
  }
  u_table[v_table].ptr[p]=realloc(u_table[v_table].ptr[p], (r+1) * u_table[v_table].size);
  if (u_table[v_table].ptr[p]==0) {printf("Out of memory 2\n"); exit(1);}
  u_table[v_table].len++;
  res.leaf=-1;
  res.branch=-1;
  res.rec=u_table[v_table].len-1;
  return res;
}
 
struct pointer rtn_cpyrecord(struct pointer v_ptr, long int v_table) {
  
  static struct pointer res;
  long int p=u_table[v_table].len / 250;
  long int r=u_table[v_table].len % 250;
  long int fp=v_ptr.rec / 250;
  long int fr=v_ptr.rec % 250;
  if (u_table[v_table].ptr==0 || r==0)
  { u_table[v_table].ptr=realloc(u_table[v_table].ptr, (p+1) * sizeof(char*));
    if (u_table[v_table].ptr==0) {printf("Out of memory 3\n"); exit(1);}
    u_table[v_table].ptr[p]=0;
  }
  u_table[v_table].ptr[p]=realloc(u_table[v_table].ptr[p], (r+1) * u_table[v_table].size);
  if (u_table[v_table].ptr[p]==0) {printf("Out of memory 4\n"); exit(1);}
  u_table[v_table].len++;
  memcpy(u_table[v_table].ptr[p]+r* u_table[v_table].size, 
         u_table[v_table].ptr[fp]+fr* u_table[v_table].size,
	 u_table[v_table].size);
  res.branch=v_ptr.branch;
  res.leaf=v_ptr.leaf;
  res.rec=u_table[v_table].len-1;
  return res;
}
 
void rtn_deleterecord(long int v_record, long int v_table) {
   
  long int p=v_record / 250;
  long int r=v_record % 250;
  long int lp=0;
  long int lr=0;
  if (v_record<0 || v_record>=u_table[v_table].len)
  { fprintf(v_log, "Error in deleting record %li from table %li.\n", v_record, v_table);
    return;
  }
  lp=(u_table[v_table].len-1) / 250;
  lr=(u_table[v_table].len-1) % 250;
  memmove(u_table[v_table].ptr[p]+r*u_table[v_table].size,
    u_table[v_table].ptr[lp]+lr*u_table[v_table].size,
    u_table[v_table].size);
  if (lr==0 && lp!=0)
  { u_table[v_table].ptr=realloc(u_table[v_table].ptr, lp * sizeof(char*));
    if (u_table[v_table].ptr==0) {printf("Out of memory 5\n"); exit(1);}
  } else
  { u_table[v_table].ptr[lp]=realloc(u_table[v_table].ptr[lp], lr * u_table[v_table].size);
    if (lr>0 && u_table[v_table].ptr[lp]==0) {printf("Out of memory 6\n"); exit(1);}
  }
  u_table[v_table].len--;
}
 
void rtn_changeindex(struct pointer v_ptr, long int v_rec, long int v_index) {
  
  if (v_ptr.branch<0 || v_ptr.branch>=u_index[v_index].scale || 
      v_ptr.leaf<0 || v_ptr.leaf>=u_index[v_index].len[v_ptr.branch]) return;
  u_index[v_index].ptr[v_ptr.branch][v_ptr.leaf]=v_rec;
}
 
long int rtn_searchindex(long int v_current, char v_level, char v_check, long int v_max) {
  
 long int factor=((v_max>>(v_level-1))+1)>>1;
 if ((1<<v_level)>v_max*2) return -1;
 if (v_current==-1) return factor-1;
 if (v_check<=0) return (v_current<factor)?0:v_current-factor;
 return (v_current+factor>=v_max)?v_max-1:v_current+factor;
}
 
struct pointer rtn_getrecptr(long int v_rec, long int v_table) {
  
  struct pointer res;
  res.branch=-1;
  res.leaf=-1;
  res.rec=v_rec;
  return res;
}
 
struct pointer rtn_getpointer(long int v_branch, long int v_leaf, long int v_index) {
  
 long int rec;
 long int tbl;
 struct pointer res;
 if (v_branch<0 || v_leaf<0 || v_index<1 || v_index>u_indexes || v_branch>=u_index[v_index].scale || v_leaf>=u_index[v_index].len[v_branch]) 
 { res.branch=-1;
   res.leaf=-1;
   res.rec=-1;
   return res;
 }
 rec=u_index[v_index].ptr[v_branch][v_leaf];
 tbl=u_index[v_index].tbl;
 res.branch=v_branch;
 res.leaf=v_leaf;
 res.rec=rec;
 return res;
}
 
long int rtn_getbranch(struct pointer v_ptr) {
  
  return v_ptr.branch;  
}
 
struct pointer rtn_ptrmin1(struct pointer v_ptr, long int v_index) {
  
  long int br=v_ptr.branch;
  long int lf=v_ptr.leaf;
  struct pointer res={-1, -1, -1};
  if (lf==0 && br==0) return res;
  if (lf==0) 
  { br-=1;
    lf=rtn_maxleaf(br, v_index);
  } else lf--;
  return rtn_getpointer(br, lf, v_index);
}
 
struct pointer rtn_recalcptr(struct pointer v_ptr, long int v_index) {
  
  return rtn_getpointer(v_ptr.branch, v_ptr.leaf, v_index);
}
 
struct pointer rtn_ptrplus1(struct pointer v_ptr, long int v_index) {
  
  long int br=v_ptr.branch;
  long int lf=v_ptr.leaf;
  struct pointer res={-1, -1, -1};
  if (v_ptr.branch==-1) return res;
  if (lf>=rtn_maxleaf(br, v_index))
  { if (br==rtn_maxbranch(v_index)) return res;
    br+=1;
    lf=0;
  } else lf+=1;
  return rtn_getpointer(br, lf, v_index);
}
 
void rtn_subptr(long int v_val, long int v_index, long int v_branch, long int v_diff) {
  
  long int i;
  struct pointer *p;
  
  for(i=0; i<u_index[v_index].ptrs; i++)
  { p=u_index[v_index].padm[i];
    if (p==0) return;
    if (p->branch==v_branch) {p->branch--; p->leaf+=v_diff;}
    if (p->branch>v_branch) p->branch--;
    if (p->rec==v_val && v_dbstate==3)
    { 
      p->branch=-1;
      p->leaf=-2;
    } else if (p->rec>=v_val && u_index[v_index].patp[i]==0)
    { *p=rtn_ptrmin1(*p, v_index);
    }
  }
}
 
void rtn_addptr(long int v_val, long int v_index, long int v_branch, long int v_leaf, long int v_old) {
  
  long int i;
  struct pointer *p;
  
  for(i=0; i<u_index[v_index].ptrs; i++)
  { p=u_index[v_index].padm[i];
    if (p==0) return;
    if (p->branch==-1 && p->leaf==-2)
    { 
      p->branch=v_branch;
      p->leaf=v_leaf;
      p->rec=v_val;
      if (v_old>=0 && p->branch>v_branch) p->branch++;
      if (v_old>=0 && p->branch==v_branch && p->leaf>=v_old) 
      {p->branch++; p->leaf-=v_old;}
    } else
    { if (v_old>=0 && p->branch>v_branch) p->branch++;
      if (v_old>=0 && p->branch==v_branch && p->leaf>=v_old) 
      {p->branch++; p->leaf-=v_old;}
      if (p->rec>=v_val && u_index[v_index].patp[i]==0)
        *p=rtn_ptrplus1(*p, v_index);
    }
  }
}
 
void rtn_addindex(struct pointer v_ptr, long int v_rec, long int v_index) {
  
  
  if (v_ptr.branch<0)
  { v_ptr.branch=rtn_maxbranch(v_index);
    v_ptr.leaf=rtn_maxleaf(v_ptr.branch, v_index)+1;
  }
  if (v_ptr.branch<0) v_ptr.branch=0;
  if (v_ptr.leaf<0) v_ptr.leaf=0;
  if (u_index[v_index].scale==0)
  { u_index[v_index].len=realloc(u_index[v_index].len, sizeof(long int));
    if (u_index[v_index].len==0) {printf("Out of memory 7\n"); exit(1);}
    u_index[v_index].ptr=realloc(u_index[v_index].ptr, sizeof(char*));
    if (u_index[v_index].ptr==0) {printf("Out of memory 8\n"); exit(1);}
    u_index[v_index].len[0]=0;
    u_index[v_index].ptr[0]=0;
    u_index[v_index].scale=1;
  }
  u_index[v_index].len[v_ptr.branch]++;
  u_index[v_index].ptr[v_ptr.branch]=realloc(u_index[v_index].ptr[v_ptr.branch], sizeof(long int)*u_index[v_index].len[v_ptr.branch]);
  if (u_index[v_index].ptr[v_ptr.branch]==0) {printf("Out of memory 9\n"); exit(1);}
  memmove(u_index[v_index].ptr[v_ptr.branch]+v_ptr.leaf+1, u_index[v_index].ptr[v_ptr.branch]+v_ptr.leaf, 
    (u_index[v_index].len[v_ptr.branch]-v_ptr.leaf-1)*sizeof(long int));
  u_index[v_index].ptr[v_ptr.branch][v_ptr.leaf]=v_rec;
  if (u_index[v_index].len[v_ptr.branch]>5000) 
  { long int new=2000; 
    long int old=u_index[v_index].len[v_ptr.branch]-new;
    rtn_addptr(v_rec, v_index, v_ptr.branch, v_ptr.leaf, old); 
    u_index[v_index].scale++;
    u_index[v_index].len=realloc(u_index[v_index].len, u_index[v_index].scale*sizeof(long int));
    if (u_index[v_index].len==0) {printf("Out of memory 10\n"); exit(1);}
    memmove(u_index[v_index].len+v_ptr.branch+1, u_index[v_index].len+v_ptr.branch,
      (u_index[v_index].scale-v_ptr.branch-1)*sizeof(long int));
    u_index[v_index].ptr=realloc(u_index[v_index].ptr, u_index[v_index].scale*sizeof(char*));
    if (u_index[v_index].ptr==0) {printf("Out of memory 11\n"); exit(1);}
    memmove(u_index[v_index].ptr+v_ptr.branch+1, u_index[v_index].ptr+v_ptr.branch,
      (u_index[v_index].scale-v_ptr.branch-1)*sizeof(char*));
    u_index[v_index].len[v_ptr.branch+1]=new;
    u_index[v_index].ptr[v_ptr.branch+1]=malloc(new * sizeof(long int));
    if (u_index[v_index].ptr[v_ptr.branch+1]==0) {printf("Out of memory 12\n"); exit(1);}
    memmove(u_index[v_index].ptr[v_ptr.branch+1], 
            u_index[v_index].ptr[v_ptr.branch]+old,
	    new*sizeof(long int));
    u_index[v_index].len[v_ptr.branch]=old;
    u_index[v_index].ptr[v_ptr.branch]=realloc(u_index[v_index].ptr[v_ptr.branch], old * sizeof(long int));
    if (u_index[v_index].ptr[v_ptr.branch]==0) {printf("Out of memory 13\n"); exit(1);}
  } else rtn_addptr(v_rec, v_index, v_ptr.branch, v_ptr.leaf, -1);
}
 
void rtn_mergeleft(struct pointer v_ptr, long int v_index) {
  
  long int left=u_index[v_index].len[v_ptr.branch-1];
  long int old=u_index[v_index].len[v_ptr.branch];
  u_index[v_index].len[v_ptr.branch-1]+=old;
  u_index[v_index].ptr[v_ptr.branch-1]=realloc(u_index[v_index].ptr[v_ptr.branch-1],
    (old + left) * sizeof(long int));
  if (u_index[v_index].ptr[v_ptr.branch-1]==0) {printf("Out of memory 14\n"); exit(1);}
  memmove(u_index[v_index].ptr[v_ptr.branch-1]+left, 
    u_index[v_index].ptr[v_ptr.branch],
    old * sizeof(long int));
  free(u_index[v_index].ptr[v_ptr.branch]);
  
  u_index[v_index].scale--;
  memmove(u_index[v_index].len+v_ptr.branch, u_index[v_index].len+v_ptr.branch+1,
   (u_index[v_index].scale-v_ptr.branch)*sizeof(long int));
  u_index[v_index].len=realloc(u_index[v_index].len, u_index[v_index].scale*sizeof(long int));
  if (u_index[v_index].len==0) {printf("Out of memory 15\n"); exit(1);}
  memmove(u_index[v_index].ptr+v_ptr.branch, u_index[v_index].ptr+v_ptr.branch+1,
   (u_index[v_index].scale-v_ptr.branch)*sizeof(char*));
  u_index[v_index].ptr=realloc(u_index[v_index].ptr, u_index[v_index].scale*sizeof(char*));
  if (u_index[v_index].ptr==0) {printf("Out of memory 16\n"); exit(1);}
}
 
void rtn_mergeright(struct pointer v_ptr, long int v_index) {
  
  long int right=u_index[v_index].len[v_ptr.branch+1];
  long int old=u_index[v_index].len[v_ptr.branch];
  u_index[v_index].len[v_ptr.branch]+=right;
  u_index[v_index].ptr[v_ptr.branch]=realloc(u_index[v_index].ptr[v_ptr.branch],
    (old + right) * sizeof(long int));
  if (u_index[v_index].ptr[v_ptr.branch]==0) {printf("Out of memory 17\n"); exit(1);}
  memmove(u_index[v_index].ptr[v_ptr.branch]+old,
    u_index[v_index].ptr[v_ptr.branch+1],
    right * sizeof(long int));
  free(u_index[v_index].ptr[v_ptr.branch+1]);
  
  u_index[v_index].scale--;
  memmove(u_index[v_index].len+v_ptr.branch+1, u_index[v_index].len+v_ptr.branch+2,
   (u_index[v_index].scale-v_ptr.branch-1)*sizeof(long int));
  u_index[v_index].len=realloc(u_index[v_index].len, u_index[v_index].scale*sizeof(long int));
  if (u_index[v_index].len==0) {printf("Out of memory 18\n"); exit(1);}
  memmove(u_index[v_index].ptr+v_ptr.branch+1, u_index[v_index].ptr+v_ptr.branch+2,
   (u_index[v_index].scale-v_ptr.branch-1)*sizeof(char*));
  u_index[v_index].ptr=realloc(u_index[v_index].ptr, u_index[v_index].scale*sizeof(char*));
  if (u_index[v_index].ptr==0) {printf("Out of memory 19\n"); exit(1);}
}
 
void rtn_deleteindex(struct pointer v_ptr, long int v_index) {
  
 
 long int r;
 if (v_ptr.branch==-1) return;
 r=rtn_getrec(v_ptr, v_index);
 u_index[v_index].len[v_ptr.branch]--;
 memmove(u_index[v_index].ptr[v_ptr.branch]+v_ptr.leaf, u_index[v_index].ptr[v_ptr.branch]+v_ptr.leaf+1, 
    (u_index[v_index].len[v_ptr.branch]-v_ptr.leaf)*sizeof(long int));
 u_index[v_index].ptr[v_ptr.branch]=realloc(u_index[v_index].ptr[v_ptr.branch], sizeof(long int)*u_index[v_index].len[v_ptr.branch]);
 if (u_index[v_index].len[v_ptr.branch]!=0 && u_index[v_index].ptr[v_ptr.branch]==0) {printf("Out of memory 20\n"); exit(1);}
 if (u_index[v_index].len[v_ptr.branch] < 1000 && u_index[v_index].scale > 1) 
 { 
   long int left=99999;
   long int right=99999;
   if (v_ptr.branch > 0) left=u_index[v_index].len[v_ptr.branch-1];
   if (v_ptr.branch < u_index[v_index].scale-1) right=u_index[v_index].len[v_ptr.branch+1];
   if (left < 6000 || right < 6000) 
   { if (left < right) 
     { rtn_mergeleft(v_ptr, v_index);
       rtn_subptr(r, v_index, v_ptr.branch, rtn_maxleaf(v_ptr.branch-1, v_index));
     } else
     { rtn_mergeright(v_ptr, v_index);
       rtn_subptr(r, v_index, v_ptr.branch+1, rtn_maxleaf(v_ptr.branch, v_index));
     }
   } else rtn_subptr(r, v_index, 99999999, 0);
 } else rtn_subptr(r, v_index, 99999999, 0); 
}
 
long int rtn_fromhex(char *v_hex) {
  
  long int n;
  int t;
  n=0;
  if (v_hex==0) return 0;
  for(t=0; t< strlen(v_hex); t++)
  { if (isdigit(v_hex[t])) n=n*16+v_hex[t]-'0';
    else n=n*16+v_hex[t]-'A'+10;
  }
  return n;
}
 
char *rtn_tohex(long int v_num) {
  
  char *r=0;
  char ch[2];
  int t;
  ch[1]=0;
  if (v_num<0 || v_num>0xfffffff) return 0;
  for(t=0; t<7; t++)
  { long int n=v_num % 16;
    v_num = v_num/16;
    if (v_num==0 && n==0) break;
    if (n>9) ch[0]=n+'A'-10;
    else ch[0]=n+'0';
    r=sadd(scpy(ch), r);
  }
  return r;
}
 
long int rtn_ascii(char *v_str) {
  
  if (v_str==0) return -1;
  return v_str[0];
}
 
char *rtn_char(long int v_ascii) {
  
  static char ch[2];
  ch[0]=v_ascii;
  ch[1]=0;
  return ch;
}
 
long int rtn_findstring(char *v_haystack, char *v_needle, long int v_from) {
  
  char *result;
  if (v_haystack==0 || v_needle==0) return -1;
  if (v_from<0) v_from=0;
  if (v_from>strlen(v_haystack)) v_from=strlen(v_haystack)+1;
  result=strstr(v_haystack+v_from-1, v_needle);
  if (result==0) return -1;
  return (((long int)result) - ((long int)v_haystack))+1;
}
 
char *rtn_pattern(char *v_pattern, long int v_times) {
  
  long int t;
  char *r=0;
  for (t=0; t < v_times; t++) r=scon(r, v_pattern);
  return r;
}
 
char *rtn_left(char *v_string, long int v_length) {
  
  char *r;
  if (v_string==0) return 0;
  if (v_length>(long int)strlen(v_string)) v_length=strlen(v_string);
  if (v_length<1 || v_string==0)
  { r=scpy("");
  } else
  { r=malloc(v_length+1);
    strncpy(r, v_string, v_length);
    r[v_length]=0;
  }
  return r;
}
 
char *rtn_right(char *v_string, long int v_length) {
  
  char *r;
  if (v_string==0) return 0;
  if (v_length>(long int)strlen(v_string)) v_length=strlen(v_string);
  if (v_length<0 || v_string==0) r=scpy("");
  else r=scpy(v_string+(strlen(v_string)-v_length));
  return r;
}
 
char *rtn_mid(char *v_string, long int v_position, long int v_length) {
  
  char *r;
  if (v_length<1 || v_position>(long int)strlen(v_string)) return 0;
  if (v_length+v_position>(long int)strlen(v_string)) v_length=1+strlen(v_string)-v_position;
  r=malloc(v_length+1);
  strncpy(r, v_string+(v_position-1), v_length);
  r[v_length]=0;
  return r;
}
 
char *rtn_trim(char *v_str) {
  
  int f;
  int t;
  if (v_str==0) return 0;
  f=1;
  while (v_str[f-1]==' ' || v_str[f-1]==10 || v_str[f-1]==13 || v_str[f-1]==9) f++;
  t=strlen(v_str);
  while (t>=f && (v_str[t-1]==' ' || v_str[t-1]==10 || v_str[t-1]==13 || v_str[t-1]==9)) t--;
  return rtn_mid(v_str, f, t-f+1);
}
 
char *rtn_lefttrim(char *v_str) {
  
  int f;
  int t;
  f=1;
  if (v_str==0) return 0;
  while (v_str[f-1]==' ' || v_str[f-1]==10 || v_str[f-1]==13 || v_str[f-1]==9) f++;
  t=strlen(v_str);
  return rtn_mid(v_str, f, t-f+1);
}
 
char *rtn_righttrim(char *v_str) {
  
  int f;
  int t;
  if (v_str==0) return 0;
  f=1;
  t=strlen(v_str);
  while (t>1 && (v_str[t-1]==' ' || v_str[t-1]==10 || v_str[t-1]==13 || v_str[t-1]==9)) t--;
  return rtn_mid(v_str, f, t-f+1);
}
 
char *rtn_uppercase(char *v_str) {
  
  long int p;
  char *r;
  if (v_str==0) return 0;
  r=scpy(v_str);
  for(p=0; p< strlen(r); p++) r[p]=toupper(r[p]);
  return r;
}
 
char *rtn_lowercase(char *v_str) {
  
  long int p;
  char *r=scpy(v_str);
  for(p=0; p< strlen(r); p++) r[p]=tolower(r[p]);
  return r;
}
 
long int rtn_length(char *v_string) {
  
  if (v_string==0) return 0;
  return strlen(v_string);
}
 
char rtn_isalpha(char *v_string) {
  
  int p=0;
  if (v_string==0 || strlen(v_string)==0) return (1==0);
  while (v_string[p]!=0)
  { if (!isalpha(v_string[p])) return (1==0);
    p++;
  }
  return (1==1);
}
 
char rtn_isnumber(char *v_string) {
  
  int p=0;
  if (v_string==0 || strlen(v_string)==0) return (1==0);
  while (v_string[p]!=0)
  { if (!isdigit(v_string[p])) return (1==0);
    p++;
  }
  return (1==1);
}
 
FILE *rtn_open(char *v_file) {
  
  FILE *n=fopen(v_file, "r+");
  return n;
}
 
void rtn_close(FILE *v_stream) {
  
  if (v_stream>0) fclose(v_stream);
}
 
void rtn_write(long int v_data, FILE *v_stream) {
  
  if (v_stream==0) return;
  fwrite(&v_data, 4, 1, v_stream);
}
 
void rtn_write1(struct text v_data, FILE *v_stream) {
  
  if (v_stream==0) return;
  fwrite(&v_data.len, 4, 1, v_stream);
  fwrite(v_data.ptr, v_data.len, 1, v_stream);
}
 
long int rtn_read(FILE *v_stream) {
  
  long int r=0;
  if (v_stream==0 || feof(v_stream)) return null;
  fread(&r, 4, 1, v_stream);
  return r;
}
 
struct text rtn_readtext(FILE *v_stream) {
  
  struct text t;
  if (v_stream==0 || feof(v_stream)) {t.len=0; t.ptr=0; return t;}
  fread(&t.len, 4, 1, v_stream);
  if (t.len>0 && !feof(v_stream)) 
  { t.ptr=malloc(t.len+1); 
    fread(&t.ptr, t.len, 1, v_stream);
    t.ptr[t.len]=0;
  } else
  { t.len=0;
    t.ptr=0;
  }
  return t;
}
 
char *rtn_get(FILE *v_stream) {
  
  int i=-1;
  static char ch[2];
  if (((long int)v_stream)==null) return 0;
  if (v_stream>0) i=fgetc(v_stream);
  if (v_stream==0 || i<0) return 0;
  ch[0]=i;
  ch[1]=0;
  return ch;
}
 
char *rtn_input(FILE *v_from) {
  
  int ch;
  char s[2];
  char *r=0;
  if (v_from==0) v_from=stdin;
  ch=fgetc(v_from);
  s[1]=0;
  while (ch!=10 && ch!=-1)
  { s[0]=ch;
    r=scon(r, s);
    ch=fgetc(v_from);
  }
  return r;
}
 
char rtn_eof(FILE *v_str) {
  
  return (v_str==0)?(1==1):(feof(v_str)!=0);
}
 
FILE *rtn_append(char *v_file) {
  
  FILE *n=fopen(v_file, "a+");
  return n;
}
 
FILE *rtn_create(char *v_file) {
  
  FILE *n=fopen(v_file, "w");
  return n;
}
 
void rtn_seek(FILE *v_str, long int v_pos) {
  
  fseek(v_str, v_pos, SEEK_SET);
}
 
void rtn_flush(FILE *v_str) {
  
  if (v_str==0) v_str=stdout;
  fflush(v_str);
}
 
int rtn_shell(char *v_command) {
  
  char *argv[4];
  argv[0]="sh";
  argv[1]="-c";
  argv[2]=v_command;
  argv[3]=0;
  if (execvp("/bin/sh", argv)==-1) return 2;
  return 1;
}
 
char *rtn_getstring(char **v_sarray, long int v_pos) {
  
  if (v_pos<1) return 0;
  return v_sarray[v_pos-1];
}
 
char *rtn_getenv(char *v_variable) {
  
  char *s=getenv(v_variable);
  return s;
}
 
long int rtn_random() {
  
  return random();
}
 
void rtn_initiate() {
  
  struct timeval tv;
  struct timezone tz;
  gettimeofday(&tv, &tz);
  srandom((int)(tv.tv_usec/100));
}
 
time_t rtn_curtime() {
  
  return time(0);
}
 
char *rtn_showtime(time_t v_time) {
  
 return rtn_trim(ctime(&v_time));
}
 
char rtn_check(long int v_num1, long int v_num2) {
  
  if (v_num1==v_num2) return 0;
  if (v_num1==null) return -1;
  if (v_num2==null) return 1;
  return (v_num1<v_num2)?-1:(v_num1>v_num2);
}
 
char rtn_check1(char *v_str1, char *v_str2) {
  
 if (v_str1==v_str2) return 0;
 if (v_str1==0) return -1;
 if (v_str2==0) return 1;
 return strcmp(v_str1, v_str2);
}
 
char rtn_check2(struct pointer v_ptr1, struct pointer v_ptr2) {
  
 long int i1=v_ptr1.branch*4000+v_ptr1.leaf;
 long int i2=v_ptr2.branch*4000+v_ptr2.leaf;
 if (i1==i2) return 0;
 if (v_ptr1.branch==-1) return -1;
 if (v_ptr2.branch==-1) return 1;
 return (i1<i2)?-1:(i1>i2);
}
 
long int rtn_abs(long int v_num) {
  
 return (v_num<-1)?(-v_num):v_num;
}
 
struct text rtn_newtext(char *v_str) {
  
  struct text t;
  if (v_str==0) {t.len=0; t.ptr=0; return t;}
  t.len=rtn_length(v_str);
  t.ptr=v_str;
  return t;
}
 
char *rtn_gettext(struct text v_text) {
  
  return v_text.ptr;
}
 
struct text rtn_addtext(struct text v_first, struct text v_second) {
  
  struct text t;
  if (v_first.ptr==0) return v_second;
  if (v_second.ptr==0) return v_first;
  t.len=v_first.len+v_second.len;
  t.ptr=realloc(v_first.ptr, t.len+1);
  memcpy(t.ptr+v_first.len, v_second.ptr, v_second.len+1);
  free(v_second.ptr);
  return t;
}
 
struct pointer rtn_nullpointer() {
  
  struct pointer res;
  res.branch=-1;
  res.leaf=-1;
  res.rec=-1;
  return res;
}
 
void rtn_pause() {
  
  pause();
}
 
char *rtn_http_encode(char *v_str) {
  char *v_r=0;
  char *v_t=0;
  long int v_pos=0;
  char *v_p=0;
  long int c_p=0;
  char *var1=0;
  char *var2=0;
  c_p=1;
  {int spp=0; if (v_p!=0) free(v_p); v_p=0; while (spp>=0) {if (spp<0) break; v_p=isep(&spp, v_str, " ");
    if (c_p==1) {
      v_r=snew(v_r, scpy(v_p));
    }
    else {
      v_r=sadd(v_r, scon(scpy("+"), v_p));
    }
    c_p+=1;
  }}
  v_pos=1;
  while (1) {
    if (v_pos>rtn_length(v_r)) {
      break;
    }
    if ((rtn_isalpha((var1=snew(var1, rtn_mid(v_r, v_pos, 1))))) || (scmp((var2=snew(var2, rtn_mid(v_r, v_pos, 1))), "+")==0)) {
      v_t=sadd(v_t, rtn_mid(v_r, v_pos, 1));
    }
    else {
      if (rtn_ascii(rtn_mid(v_r, v_pos, 1))==10) {
        v_t=sadd(v_t, scpy("%0D"));
      }
      v_t=sadd(v_t, sadd(scpy("%"), rtn_tohex(rtn_ascii(rtn_mid(v_r, v_pos, 1)))));
    }
    v_pos=v_pos+1;
  }
  var1=snew(var1, scpy(v_t));
  if (v_str!=0) {free(v_str); v_str=0;}
  return var1;
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  if (v_str!=0) {free(v_str); v_str=0;}
}
 
 
char *rtn_http_decode(char *v_str) {
  char *v_r=0;
  char *v_t=0;
  char *v_p=0;
  long int c_p=0;
  char *v_q=0;
  long int c_q=0;
  char *var1=0;
  c_p=1;
  {int spp=0; if (v_p!=0) free(v_p); v_p=0; while (spp>=0) {if (spp<0) break; v_p=isep(&spp, v_str, "+");
    if (c_p==1) {
      v_r=snew(v_r, scpy(v_p));
    }
    else {
      v_r=sadd(v_r, scon(scpy(" "), v_p));
    }
    c_p+=1;
  }}
  c_q=1;
  {int spp=0; if (v_q!=0) free(v_q); v_q=0; while (spp>=0) {if (spp<0) break; v_q=isep(&spp, v_r, "%");
    if (c_q==1) {
      v_t=snew(v_t, scpy(v_q));
    }
    else {
      if (scmp((var1=snew(var1, rtn_left(v_q, 2))), "0D")!=0) {
        v_t=sadd(v_t, sadd(scpy(rtn_char(rtn_fromhex((var1=snew(var1, rtn_left(v_q, 2)))))), rtn_mid(v_q, 3, 99999)));
      }
    }
    c_q+=1;
  }}
  var1=snew(var1, scpy(v_t));
  if (v_str!=0) {free(v_str); v_str=0;}
  return var1;
  if (var1!=0) {free(var1); var1=0;}
  if (v_str!=0) {free(v_str); v_str=0;}
}
 
 
char *rtn_cookie(char *v_name, char *v_value, int v_duration) {
  char *var1=0;
  var1=snew(var1, scon(sadd(scon(sadd(scpy("Set-Cookie: "), rtn_http_encode(scpy(v_name))), "="), rtn_http_encode(scpy(v_value))), "; path=/"));
  return var1;
}
 
 
char *rtn_tag(char *v_str) {
  char *var1=0;
  var1=snew(var1, scon(scon(scpy("<"), v_str), ">"));
  return var1;
}
 
 
char *rtn_html(char *v_str) {
  char *v_r=0;
  char *v_a=0;
  long int c_a=0;
  char *var1=0;
  c_a=1;
  {int spp=0; if (v_a!=0) free(v_a); v_a=0; while (spp>=0) {if (spp<0) break; v_a=isep(&spp, v_str, rtn_char(10));
    if (c_a==1) {
      v_r=snew(v_r, scon(scpy(v_r), v_a));
    }
    else {
      v_r=snew(v_r, sadd(scpy(v_r), rtn_tag("br")));
    }
    c_a+=1;
  }}
  var1=snew(var1, scpy(v_r));
  return var1;
}
 
 
char *rtn_notag(char *v_str) {
  char *v_r=0;
  char *v_cr=0;
  char *v_r2=0;
  char *v_r3=0;
  long int v_lpos=0;
  long int v_rpos=0;
  char *v_a=0;
  long int c_a=0;
  char *v_b=0;
  long int c_b=0;
  char *v_b2=0;
  long int c_b2=0;
  char *var1=0;
  c_a=1;
  {int spp=0; if (v_a!=0) free(v_a); v_a=0; while (spp>=0) {if (spp<0) break; v_a=isep(&spp, v_str, "<");
    if (c_a==1) {
      v_r=snew(v_r, scon(scpy(v_r), v_a));
    }
    else {
      v_r=snew(v_r, scon(scon(scpy(v_r), "&lt;"), v_a));
    }
    c_a+=1;
  }}
  c_b=1;
  {int spp=0; if (v_b!=0) free(v_b); v_b=0; while (spp>=0) {if (spp<0) break; v_b=isep(&spp, v_r, " ");
    if (c_b==1) {
      v_r2=snew(v_r2, scon(scpy(v_r2), v_b));
    }
    else {
      v_r2=snew(v_r2, scon(scon(scpy(v_r2), "&nbsp;"), v_b));
    }
    c_b+=1;
  }}
  v_cr=snew(v_cr, scpy(rtn_char(10)));
  c_b2=1;
  {int spp=0; if (v_b2!=0) free(v_b2); v_b2=0; while (spp>=0) {if (spp<0) break; v_b2=isep(&spp, v_r2, v_cr);
    if (c_b2==1) {
      v_r3=snew(v_r3, scon(scpy(v_r3), v_b2));
    }
    else {
      v_r3=snew(v_r3, scon(scon(sadd(scpy(v_r3), rtn_tag("br")), v_cr), v_b2));
    }
    c_b2+=1;
  }}
  v_lpos=rtn_findstring(v_r3, "#", 1);
  while (1) {
    if (v_lpos<1) {
      break;
    }
    v_rpos=rtn_findstring(v_r3, "#", v_lpos+1);
    if ((v_rpos<1) || (rtn_findstring((var1=snew(var1, rtn_mid(v_r3, v_lpos+1, v_rpos-v_lpos-1))), " ", 1)>0)) {
      break;
    }
    v_r3=snew(v_r3, sadd(sadd(sadd(sadd(rtn_left(v_r3, v_lpos-1), rtn_tag("i")), rtn_mid(v_r3, v_lpos+1, v_rpos-v_lpos-1)), rtn_tag("/i")), rtn_mid(v_r3, v_rpos+1, iscan("99999"))));
    v_lpos=rtn_findstring(v_r3, "#", 1);
  }
  var1=snew(var1, scpy(v_r3));
  return var1;
  if (var1!=0) {free(var1); var1=0;}
}
 
 
long int rtn_tbl_get_scan_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) return 0;
  return *(long int*)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+0);
}
 
void rtn_tbl_put_scan_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in filling field scan.order\n");
    return;
  }
  *(long int*)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+0)=v_val;
}
 
void rtn_tbl_add_scan_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in adding to field scan.order\n");
    return;
  }
  *(long int*)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+0)+=v_val;
}
 
void rtn_tbl_sub_scan_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("Error in subtraction from field scan.order\n");
    return;
  }
  *(long int*)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+0)-=v_val;
}
 
char *rtn_tbl_get_scan_key(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) return 0;
  return *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+4);
}
 
void rtn_tbl_put_scan_key(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in filling field scan.key\n");
    return;
  }
  *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+4)=v_val;
}
 
void rtn_tbl_add_scan_key(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in adding to field scan.key\n");
    return;
  }
  *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+4)= 
  sadd(*(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+4), v_val);
}
 
char *rtn_tbl_get_scan_value(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) return 0;
  return *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+8);
}
 
void rtn_tbl_put_scan_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in filling field scan.value\n");
    return;
  }
  *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+8)=v_val;
}
 
void rtn_tbl_add_scan_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[1].len) {
    printf("error in adding to field scan.value\n");
    return;
  }
  *(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+8)= 
  sadd(*(char**)(u_table[1].ptr[v_rec/250]+(v_rec%250)*u_table[1].size+8), v_val);
}
 
struct pointer rtn_tbl_search_scan(long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 1, 1);
  newptr(&v_ptr, 1, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(1)+1);
    v_idx=rtn_getpointer(v_curr, 0, 1);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_order, rtn_tbl_get_scan_order(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(1);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 1)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 1);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_order, rtn_tbl_get_scan_order(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 1);
  }
  delptr(&v_idx, 1);
  delptr(&v_ptr, 1);
  return v_ptr;
  delptr(&v_idx, 1);
  delptr(&v_ptr, 1);
}
 
 
struct pointer rtn_tbl_search_scankey(char *v_p_key, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 2, 1);
  newptr(&v_ptr, 2, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(2)+1);
    v_idx=rtn_getpointer(v_curr, 0, 2);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_key, rtn_tbl_get_scan_key(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_scan_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(2);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 2)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 2);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_key, rtn_tbl_get_scan_key(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_scan_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 2);
  }
  if (v_p_key!=0) {free(v_p_key); v_p_key=0;}
  delptr(&v_idx, 2);
  delptr(&v_ptr, 2);
  return v_ptr;
  if (v_p_key!=0) {free(v_p_key); v_p_key=0;}
  delptr(&v_idx, 2);
  delptr(&v_ptr, 2);
}
 
 
struct pointer rtn_tbl_add_scan(struct pointer v_new) {
  struct pointer v_idx_scan={-1, -1, -1};
  struct pointer v_idx_scankey={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_scan, 1, 1);
  newptr(&v_idx_scankey, 2, 1);
  newptr(&v_last, 1, 1);
  rtn_tbl_put_scan_order(v_new.rec, 999999999);
  v_idx_scan=rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_new.rec));
  if (v_idx_scan.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(1), rtn_maxleaf(rtn_maxbranch(1), 1), 1);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_scan, 1);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_scan_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_scan_order(v_new.rec, rtn_tbl_get_scan_order(v_last.rec)+1);
  }
  v_idx_scankey=rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_new.rec)), rtn_tbl_get_scan_order(v_new.rec));
  rtn_addindex(v_idx_scan, rtn_tablelen(1)-1, 1);
  rtn_addindex(v_idx_scankey, rtn_tablelen(1)-1, 2);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scpy("add scan(1):"), scpy(get_sort(rtn_tbl_get_scan_order(v_new.rec)))), "|"), rtn_tbl_get_scan_key(v_new.rec)), "|"), rtn_tbl_get_scan_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 1);
    delptr(&v_idx_scan, 1);
    delptr(&v_idx_scankey, 2);
    delptr(&v_last, 1);
    return rtn_getpointer(0, 0, 1);
  }
  delptr(&v_new, 1);
  delptr(&v_idx_scan, 1);
  delptr(&v_idx_scankey, 2);
  delptr(&v_last, 1);
  return rtn_ptrplus1(v_last, 1);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 1);
  delptr(&v_idx_scan, 1);
  delptr(&v_idx_scankey, 2);
  delptr(&v_last, 1);
}
 
 
void rtn_tbl_delete_scan(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 1, 1);
  newptr(&v_chk, 1, 1);
  newptr(&v_del, 1, 1);
  v_del=rtn_getrecptr(v_delrec, 1);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scpy("delete scan(1):"), scpy(get_sort(rtn_tbl_get_scan_order(v_del.rec)))), "|"), rtn_tbl_get_scan_key(v_del.rec)), "|"), rtn_tbl_get_scan_value(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_del.rec));
  rtn_deleteindex(v_chk, 1);
  v_chk=rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_del.rec)), rtn_tbl_get_scan_order(v_del.rec)), 2);
  rtn_tbl_put_scan_key(v_del.rec, 0);
  rtn_tbl_put_scan_value(v_del.rec, 0);
  if (rtn_getrec(v_del, 1)!=rtn_tablelen(1)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(1)-1, 1);
    rtn_changeindex(rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_last.rec)), v_delrec, 1);
    rtn_changeindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_last.rec)), rtn_tbl_get_scan_order(v_last.rec)), v_delrec, 2);
  }
  rtn_deleterecord(v_delrec, 1);
  if (v_chk.branch==-1) {
    delptr(&v_last, 1);
    delptr(&v_chk, 1);
    delptr(&v_del, 1);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 1);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_scan_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 1);
    rtn_deleteindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_chk.rec)), rtn_tbl_get_scan_order(v_chk.rec)), 2);
    rtn_tbl_sub_scan_order(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_chk.rec)), rtn_tbl_get_scan_order(v_chk.rec)), v_rec, 2);
    v_chk=rtn_ptrplus1(v_chk, 1);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 1);
  delptr(&v_chk, 1);
  delptr(&v_del, 1);
}
 
 
struct pointer rtn_tbl_update_scan(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 1, 1);
  newptr(&v_del, 1, 1);
  v_del=rtn_getrecptr(v_rec, 1);
  v_new=rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_del.rec));
  rtn_deleteindex(v_new, 1);
  rtn_deleteindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_del.rec)), rtn_tbl_get_scan_order(v_del.rec)), 2);
  rtn_deleterecord(v_rec, 1);
  rtn_addindex(rtn_tbl_search_scan(rtn_tbl_get_scan_order(v_new.rec)), rtn_getrec(v_new, 1), 1);
  rtn_addindex(rtn_tbl_search_scankey(scpy(rtn_tbl_get_scan_key(v_new.rec)), rtn_tbl_get_scan_order(v_new.rec)), rtn_getrec(v_new, 1), 2);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 1);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scpy("update scan:"), scpy(get_sort(rtn_tbl_get_scan_order(v_new.rec)))), "|"), rtn_tbl_get_scan_key(v_new.rec)), "|"), rtn_tbl_get_scan_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 1);
  delptr(&v_del, 1);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 1);
  delptr(&v_del, 1);
}
 
 
void rtn_tbl_clear_scan() {
  
  long int r=0;
  long int branch;
  while (r < u_table[1].len) {
    if (*(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+4)!=0) {free(*(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+4)); *(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+4)=0;}
    if (*(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+8)!=0) {free(*(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+8)); *(char**)(u_table[1].ptr[r/250]+(r%250)*u_table[1].size+8)=0;}
    r++;
  }
  free(u_table[1].ptr);
  u_table[1].ptr=0;
  u_table[1].len=0;
  for(branch=0; branch < u_index[1].scale; branch++)
  { free(u_index[1].ptr[branch]);
  }
  free(u_index[1].len);
  free(u_index[1].ptr);
  u_index[1].scale=0;
  u_index[1].len=0;
  u_index[1].ptr=0;
  for(branch=0; branch < u_index[2].scale; branch++)
  { free(u_index[2].ptr[branch]);
  }
  free(u_index[2].len);
  free(u_index[2].ptr);
  u_index[2].scale=0;
  u_index[2].len=0;
  u_index[2].ptr=0;
  fprintf(v_log, "clear scan(1)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_scan() {
  
  return u_table[1].len;
}
 
void rtn_tbl_init_scan() {
  
  u_table[1].len=0;
  u_table[1].size=12;
  u_table[1].ptr=0;
  u_index[1].tbl=1;
  u_index[1].scale=0;
  u_index[1].len=0;
  u_index[1].ptr=0;
  u_index[1].ptrs=0;
  u_index[1].padm=0;
  u_index[2].tbl=1;
  u_index[2].scale=0;
  u_index[2].len=0;
  u_index[2].ptr=0;
  u_index[2].ptrs=0;
  u_index[2].padm=0;
}
 
void rtn_tbl_write_scan(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 1, 0);
  rtn_write(rtn_tbl_get_scan_order(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_scan_key(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scan_value(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 1);
}
 
 
struct pointer rtn_tbl_read_scan(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 1, 0);
  v_new=rtn_addrecord(1);
  rtn_tbl_put_scan_order(v_new.rec, 0);
  rtn_tbl_put_scan_key(v_new.rec, 0);
  rtn_tbl_put_scan_value(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_scan_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_scan_key(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scan_value(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_scan(v_new);
  v_dbstate=0;
  delptr(&v_new, 1);
  return v_new;
  delptr(&v_new, 1);
}
 
char *v_ch=0;
char *v_nextch=0;
char *v_keyword=0;
char *v_keywstr=0;
char *v_addcd=0;
long int v_addcdpos=0;
FILE *v_chin=0;
FILE *v_chout=0;
char *v_chmess=0;
char *v_chline=0;
char *v_chold=0;
char *v_chbetween=0;
char *v_chnew=0;
int v_chwhat=0;
int v_chwhere=0;
int v_chstate=0;
char *v_scantag=0;
int v_scantype=0;
char *v_scanstring=0;
long int v_scanmessnr=0;
 
void rtn_scanmessage(char *v_messid, char *v_type, char *v_message) {
  char *var1=0;
  if (v_type==0) {
    v_chmess=sadd(v_chmess, sadd(scon(rtn_tag((var1=snew(var1, scon(scon(scpy("A name=\""), v_messid), "\"")))), v_message), rtn_tag("/A")));
  }
  else {
    v_chmess=sadd(v_chmess, sadd(sadd(scon(sadd(scon(scon(sadd(rtn_tag((var1=snew(var1, scon(scon(scpy("A name=\""), v_messid), "\"")))), rtn_tag("FONT color=\"#F00000\"")), v_type), ": "), rtn_tag("/FONT")), v_message), rtn_tag("/A")), rtn_tag("br")));
  }
  if (var1!=0) {free(var1); var1=0;}
  if (v_messid!=0) {free(v_messid); v_messid=0;}
  if (v_type!=0) {free(v_type); v_type=0;}
  if (v_message!=0) {free(v_message); v_message=0;}
}
 
 
void rtn_putmessage(char *v_message) {
  v_scanmessnr+=1;
  rtn_scanmessage(sadd(scpy("scan"), get_int(v_scanmessnr)), scpy("Error"), scpy(v_message));
  if (v_message!=0) {free(v_message); v_message=0;}
}
 
 
void rtn_getsingle() {
  long int v_pos=0;
  char *var1=0;
  if (v_chwhat==2) {
    v_chwhere=1;
    v_chwhat=0;
    v_chline=snew(v_chline, scon(scon(scpy(v_chline), v_chold), v_chbetween));
    while (1) {
      v_pos=rtn_findstring(v_chline, rtn_char(10), 1);
      if (v_pos<1) {
        break;
      }
      swrite((var1=snew(var1, scon(rtn_left(v_chline, v_pos-1), v_chmess))), v_chout); wline(v_chout);
      rtn_flush(v_chout);
      if (v_pos==rtn_length(v_chline)) {
        v_chline=snew(v_chline, 0);
      }
      else {
        v_chline=snew(v_chline, rtn_mid(v_chline, v_pos+1, 999999));
      }
      v_chmess=snew(v_chmess, 0);
    }
    v_chold=snew(v_chold, scpy(v_chnew));
    v_chbetween=snew(v_chbetween, 0);
    v_chnew=snew(v_chnew, 0);
  }
  if (v_chwhat==1) {
    v_chwhere=0;
    v_chwhat=0;
  }
  if (v_addcdpos==0) {
    if (v_chwhere==0) {
      v_chnew=sadd(v_chnew, rtn_notag(v_ch));
    }
    else {
      v_chbetween=sadd(v_chbetween, rtn_notag(v_ch));
    }
  }
  v_ch=snew(v_ch, scpy(v_nextch));
  if (v_addcdpos>0) {
    if (v_addcdpos>rtn_length(v_addcd)) {
      v_addcdpos=0;
      v_nextch=snew(v_nextch, scpy(rtn_get(v_chin)));
    }
    else {
      v_nextch=snew(v_nextch, rtn_mid(v_addcd, v_addcdpos, 1));
      v_addcdpos+=1;
    }
  }
  else {
    v_nextch=snew(v_nextch, scpy(rtn_get(v_chin)));
    if (scmp(v_nextch, rtn_char(13))==0) {
      v_nextch=snew(v_nextch, scpy(rtn_get(v_chin)));
    }
  }
  if (var1!=0) {free(var1); var1=0;}
}
 
 
void rtn_getchar() {
  rtn_getsingle();
  if ((v_chstate==0) || (v_chstate==1)) {
    if (scmp(v_ch, "/")==0 && scmp(v_nextch, "*")==0) {
      rtn_getsingle();
      rtn_getsingle();
      while (1) {
        if ((v_nextch==0) || ((scmp(v_ch, "*")==0 && scmp(v_nextch, "/")==0))) {
          break;
        }
        rtn_getsingle();
      }
      rtn_getsingle();
      rtn_getsingle();
    }
  }
  if (v_ch==0) {
    v_chwhat=2;
    rtn_getsingle();
    v_chwhat=2;
    rtn_getsingle();
  }
}
 
 
void rtn_separator() {
  while (1) {
    if (v_ch==0) {
      break;
    }
    if (scmp(v_ch, " ")!=0 && scmp(v_ch, rtn_char(10))!=0 && scmp(v_ch, rtn_char(9))!=0 && scmp(v_ch, rtn_char(13))!=0) {
      break;
    }
    rtn_getchar();
  }
}
 
 
void rtn_scankeyword() {
  if (v_keyword!=0) {
    v_chwhat=2;
  }
  v_keyword=snew(v_keyword, 0);
  v_keywstr=snew(v_keywstr, 0);
  rtn_separator();
  if (v_ch!=0) {
    if ((rtn_isalpha(v_ch)) || (rtn_isnumber(v_ch))) {
      v_chwhat=1;
      while (1) {
        if (!((((rtn_isnumber(v_ch)) || (rtn_isalpha(v_ch))) || (scmp(v_ch, "_")==0)))) {
          break;
        }
        v_keyword=sadd(v_keyword, scpy(v_ch));
        rtn_getchar();
      }
    }
    else {
      if (scmp(v_ch, "\"")==0) {
        rtn_getchar();
        while (1) {
          if ((((scmp(v_ch, "\"")==0 && scmp(v_nextch, "\"")!=0)) || (v_ch==0)) || (scmp(v_ch, rtn_char(10))==0)) {
            break;
          }
          if (scmp(v_ch, "\"")==0 && scmp(v_nextch, "\"")==0) {
            rtn_getchar();
          }
          v_keywstr=sadd(v_keywstr, scpy(v_ch));
          rtn_getchar();
        }
        if (scmp(v_ch, "\"")!=0) {
          rtn_putmessage(scpy("No end of String found within a line"));
        }
        else {
          rtn_getchar();
        }
      }
      else {
        if (scmp(v_ch, "<")==0 && ((scmp(v_nextch, "/")==0) || (rtn_isalpha(v_nextch)))) {
          v_keyword=snew(v_keyword, 0);
        }
        else {
          v_keyword=snew(v_keyword, scpy(v_ch));
          rtn_getchar();
        }
      }
    }
  }
}
 
 
void rtn_addscancode(char *v_code) {
  char *var1=0;
  v_addcd=snew(v_addcd, rtn_mid((var1=snew(var1, scon(scon(scon(scpy(v_code), v_keyword), v_ch), v_nextch))), 3, 999));
  v_ch=snew(v_ch, rtn_left(v_code, 1));
  v_nextch=snew(v_nextch, rtn_mid(v_code, 2, 1));
  v_addcdpos=1;
  v_chmess=sadd(v_chmess, sadd(sadd(rtn_tag("FONT color=\"#666666\""), rtn_notag(v_code)), rtn_tag("/FONT")));
  rtn_scankeyword();
  if (var1!=0) {free(var1); var1=0;}
  if (v_code!=0) {free(v_code); v_code=0;}
}
 
 
char *rtn_scantoken() {
  char *v_w=0;
  char *var1=0;
  v_w=snew(v_w, scpy(v_ch));
  rtn_getchar();
  if (rtn_isalpha(v_w)) {
    while (1) {
      if (((rtn_isalpha(v_ch)) || (scmp(v_ch, "_")==0)) || (rtn_isnumber(v_ch))) {
        v_w=sadd(v_w, scpy(v_ch));
        rtn_getchar();
      }
      else {
        break;
      }
    }
  }
  var1=snew(var1, scpy(v_w));
  return var1;
}
 
 
void rtn_do_scan(char *v_expect) {
  char *v_str=0;
  char *v_last=0;
  char *v_token=0;
  char *var1=0;
  char *var2=0;
  char *var3=0;
  struct pointer v_scan={-1, -1, -1};
  v_scantype=0;
  if (v_scantag!=0) {
    v_chwhat=2;
  }
  v_scantag=snew(v_scantag, 0);
  v_scanstring=snew(v_scanstring, 0);
  v_chstate=0;
  v_last=snew(v_last, rtn_scantoken());
  while (1) {
    v_token=snew(v_token, rtn_scantoken());
    if (v_last==0) {
      break;
    }
    if (scmp(v_last, "<")==0 && scmp(v_token, "/")==0) {
      v_last=sadd(v_last, scpy("/"));
      v_token=snew(v_token, rtn_scantoken());
    }
    if (((scmp(v_last, "<")==0) || (scmp(v_last, (var1=snew(var1, scon(scpy("<"), "/"))))==0)) && rtn_findstring((var2=snew(var2, scon(scon(scpy(" "), v_expect), " "))), (var3=snew(var3, scon(scon(scpy(" "), v_token), " "))), 1)>0) {
      break;
    }
    v_scanstring=sadd(v_scanstring, scpy(v_last));
    v_last=snew(v_last, scpy(v_token));
  }
  if ((scmp(v_last, "<")==0) || (scmp(v_last, (var1=snew(var1, scon(scpy("<"), "/"))))==0)) {
    v_chwhat=1;
    rtn_tbl_clear_scan();
    v_chstate=1;
    if (scmp(v_last, (var1=snew(var1, scon(scpy("<"), "/"))))==0) {
      v_scantype=2;
    }
    else {
      v_scantype=1;
    }
    v_scantag=snew(v_scantag, scpy(v_token));
    rtn_separator();
    v_chwhat=2;
    while (1) {
      if (((v_ch==0) || (scmp(v_ch, "/")==0)) || (scmp(v_ch, ">")==0)) {
        break;
      }
      if (rtn_isalpha(v_ch)) {
        newptr(&v_scan, 1, 0);
        v_scan=rtn_addrecord(1);
        rtn_tbl_put_scan_order(v_scan.rec, 0);
        rtn_tbl_put_scan_key(v_scan.rec, 0);
        rtn_tbl_put_scan_value(v_scan.rec, 0);
        v_dbstate=1;
        rtn_tbl_put_scan_key(v_scan.rec, 0);
        while (1) {
          if ((v_ch==0) || (!(rtn_isalpha(v_ch)))) {
            break;
          }
          rtn_tbl_add_scan_key(v_scan.rec, scpy(v_ch));
          rtn_getchar();
        }
        rtn_separator();
        if (scmp(v_ch, "=")==0) {
          rtn_getchar();
          rtn_separator();
          if ((scmp(v_ch, "-")==0) || (rtn_isnumber(v_ch))) {
            rtn_tbl_put_scan_value(v_scan.rec, scpy(v_ch));
            rtn_getchar();
            while (1) {
              if ((v_ch==0) || (!(rtn_isnumber(v_ch)))) {
                break;
              }
              rtn_tbl_add_scan_value(v_scan.rec, scpy(v_ch));
              rtn_getchar();
            }
          }
          else {
            if (scmp(v_ch, "\"")==0) {
              v_chstate=2;
              rtn_getchar();
              v_str=snew(v_str, 0);
              while (1) {
                if (((v_ch==0) || ((scmp(v_ch, "\"")==0 && scmp(v_nextch, "\"")!=0))) || (scmp(v_ch, rtn_char(10))==0)) {
                  break;
                }
                if (scmp(v_ch, "\"")==0 && scmp(v_nextch, "\"")==0) {
                  rtn_getchar();
                }
                v_str=sadd(v_str, scpy(v_ch));
                rtn_getchar();
              }
              rtn_tbl_put_scan_value(v_scan.rec, scpy(v_str));
              if ((scmp(v_ch, rtn_char(10))==0) || (v_ch==0)) {
                rtn_putmessage(scpy("No end of string found within a line"));
              }
              else {
                rtn_getchar();
                rtn_separator();
              }
              v_chstate=1;
            }
          }
        }
        v_scan=rtn_tbl_add_scan(v_scan);
        v_dbstate=0;
      }
      else {
        rtn_putmessage(scon(sadd(scon(scon(scpy("Unexpected symbol '"), v_ch), "' ("), get_int(rtn_ascii(scpy(v_ch)))), ") found in tag"));
        rtn_getchar();
      }
    }
    if (scmp(v_ch, "/")==0) {
      v_scantype=3;
      rtn_getchar();
    }
    if (scmp(v_ch, ">")==0) {
      rtn_getchar();
    }
    else {
      rtn_putmessage(scon(scon(scon(scon(scpy("No end of a tag found ("), v_ch), "/"), v_nextch), ")"));
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  if (var3!=0) {free(var3); var3=0;}
  if (v_expect!=0) {free(v_expect); v_expect=0;}
  delptr(&v_scan, 1);
}
 
 
void rtn_initscan(char *v_file) {
  char *var1=0;
  v_chout=rtn_create((var1=snew(var1, scon(scpy(v_file), ".html"))));
  if (v_chout==0) {
    swrite((var1=snew(var1, scon(scon(scpy("Cannot write to '"), v_file), ".html'"))), stdout); wline(stdout);
  }
  swrite((var1=snew(var1, sadd(sadd(sadd(scon(sadd(sadd(rtn_tag("HTML"), rtn_tag("BODY LINK=\"0\" VLINK=\"0\"")), rtn_tag("h1")), "Module : "), rtn_left(v_file, rtn_length(v_file)-2)), rtn_tag("/h1")), rtn_tag("font size=2")))), v_chout); wline(v_chout);
  v_chin=rtn_open(v_file);
  v_chwhat=0;
  v_chwhere=1;
  if (v_chin!=0) {
    v_nextch=snew(v_nextch, scpy(rtn_get(v_chin)));
    rtn_getchar();
  }
  if (var1!=0) {free(var1); var1=0;}
  if (v_file!=0) {free(v_file); v_file=0;}
}
 
long int v_scanstackpointer=0;
 
long int rtn_tbl_get_scanstack_pos(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+0);
}
 
void rtn_tbl_put_scanstack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.pos\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+0)=v_val;
}
 
void rtn_tbl_add_scanstack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.pos\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+0)+=v_val;
}
 
void rtn_tbl_sub_scanstack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("Error in subtraction from field scanstack.pos\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+0)-=v_val;
}
 
long int rtn_tbl_get_scanstack_file(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return null;
  return *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+4);
}
 
void rtn_tbl_put_scanstack_file(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.file\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+4)=v_val;
}
 
void rtn_tbl_add_scanstack_file(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.file\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+4)+=v_val;
}
 
void rtn_tbl_sub_scanstack_file(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("Error in subtraction from field scanstack.file\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+4)-=v_val;
}
 
long int rtn_tbl_get_scanstack_outfile(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return null;
  return *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+8);
}
 
void rtn_tbl_put_scanstack_outfile(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.outfile\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+8)=v_val;
}
 
void rtn_tbl_add_scanstack_outfile(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.outfile\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+8)+=v_val;
}
 
void rtn_tbl_sub_scanstack_outfile(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("Error in subtraction from field scanstack.outfile\n");
    return;
  }
  *(long int*)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+8)-=v_val;
}
 
char *rtn_tbl_get_scanstack_ch(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+12);
}
 
void rtn_tbl_put_scanstack_ch(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.ch\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+12)=v_val;
}
 
void rtn_tbl_add_scanstack_ch(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.ch\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+12)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+12), v_val);
}
 
char *rtn_tbl_get_scanstack_nextch(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+16);
}
 
void rtn_tbl_put_scanstack_nextch(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.nextch\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+16)=v_val;
}
 
void rtn_tbl_add_scanstack_nextch(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.nextch\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+16)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+16), v_val);
}
 
char *rtn_tbl_get_scanstack_chwhat(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+20);
}
 
void rtn_tbl_put_scanstack_chwhat(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chwhat\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+20)=v_val;
}
 
void rtn_tbl_add_scanstack_chwhat(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chwhat\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+20)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+20), v_val);
}
 
char *rtn_tbl_get_scanstack_chwhere(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+24);
}
 
void rtn_tbl_put_scanstack_chwhere(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chwhere\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+24)=v_val;
}
 
void rtn_tbl_add_scanstack_chwhere(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chwhere\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+24)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+24), v_val);
}
 
char *rtn_tbl_get_scanstack_chmess(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+28);
}
 
void rtn_tbl_put_scanstack_chmess(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chmess\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+28)=v_val;
}
 
void rtn_tbl_add_scanstack_chmess(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chmess\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+28)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+28), v_val);
}
 
char *rtn_tbl_get_scanstack_chline(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+32);
}
 
void rtn_tbl_put_scanstack_chline(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chline\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+32)=v_val;
}
 
void rtn_tbl_add_scanstack_chline(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chline\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+32)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+32), v_val);
}
 
char *rtn_tbl_get_scanstack_chold(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+36);
}
 
void rtn_tbl_put_scanstack_chold(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chold\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+36)=v_val;
}
 
void rtn_tbl_add_scanstack_chold(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chold\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+36)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+36), v_val);
}
 
char *rtn_tbl_get_scanstack_chbetween(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+40);
}
 
void rtn_tbl_put_scanstack_chbetween(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chbetween\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+40)=v_val;
}
 
void rtn_tbl_add_scanstack_chbetween(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chbetween\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+40)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+40), v_val);
}
 
char *rtn_tbl_get_scanstack_chnew(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) return 0;
  return *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+44);
}
 
void rtn_tbl_put_scanstack_chnew(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in filling field scanstack.chnew\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+44)=v_val;
}
 
void rtn_tbl_add_scanstack_chnew(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[2].len) {
    printf("error in adding to field scanstack.chnew\n");
    return;
  }
  *(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+44)= 
  sadd(*(char**)(u_table[2].ptr[v_rec/250]+(v_rec%250)*u_table[2].size+44), v_val);
}
 
struct pointer rtn_tbl_search_scanstack(long int v_p_pos) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 3, 1);
  newptr(&v_ptr, 3, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(3)+1);
    v_idx=rtn_getpointer(v_curr, 0, 3);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_pos, rtn_tbl_get_scanstack_pos(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(3);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 3)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 3);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_pos, rtn_tbl_get_scanstack_pos(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 3);
  }
  delptr(&v_idx, 3);
  delptr(&v_ptr, 3);
  return v_ptr;
  delptr(&v_idx, 3);
  delptr(&v_ptr, 3);
}
 
 
struct pointer rtn_tbl_add_scanstack(struct pointer v_new) {
  struct pointer v_idx_scanstack={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_scanstack, 3, 1);
  newptr(&v_last, 3, 1);
  rtn_tbl_put_scanstack_pos(v_new.rec, 999999999);
  v_idx_scanstack=rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_new.rec));
  if (v_idx_scanstack.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(3), rtn_maxleaf(rtn_maxbranch(3), 3), 3);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_scanstack, 3);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_scanstack_pos(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_scanstack_pos(v_new.rec, rtn_tbl_get_scanstack_pos(v_last.rec)+1);
  }
  rtn_addindex(v_idx_scanstack, rtn_tablelen(2)-1, 3);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scpy("add scanstack(2):"), scpy(get_sort(rtn_tbl_get_scanstack_pos(v_new.rec)))), "|"), get_int(rtn_tbl_get_scanstack_file(v_new.rec))), "|"), get_int(rtn_tbl_get_scanstack_outfile(v_new.rec))), "|"), rtn_tbl_get_scanstack_ch(v_new.rec)), "|"), rtn_tbl_get_scanstack_nextch(v_new.rec)), "|"), rtn_tbl_get_scanstack_chwhat(v_new.rec)), "|"), rtn_tbl_get_scanstack_chwhere(v_new.rec)), "|"), rtn_tbl_get_scanstack_chmess(v_new.rec)), "|"), rtn_tbl_get_scanstack_chline(v_new.rec)), "|"), rtn_tbl_get_scanstack_chold(v_new.rec)), "|"), rtn_tbl_get_scanstack_chbetween(v_new.rec)), "|"), rtn_tbl_get_scanstack_chnew(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 3);
    delptr(&v_idx_scanstack, 3);
    delptr(&v_last, 3);
    return rtn_getpointer(0, 0, 3);
  }
  delptr(&v_new, 3);
  delptr(&v_idx_scanstack, 3);
  delptr(&v_last, 3);
  return rtn_ptrplus1(v_last, 3);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 3);
  delptr(&v_idx_scanstack, 3);
  delptr(&v_last, 3);
}
 
 
void rtn_tbl_delete_scanstack(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 3, 1);
  newptr(&v_chk, 3, 1);
  newptr(&v_del, 3, 1);
  v_del=rtn_getrecptr(v_delrec, 2);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scpy("delete scanstack(2):"), scpy(get_sort(rtn_tbl_get_scanstack_pos(v_del.rec)))), "|"), get_int(rtn_tbl_get_scanstack_file(v_del.rec))), "|"), get_int(rtn_tbl_get_scanstack_outfile(v_del.rec))), "|"), rtn_tbl_get_scanstack_ch(v_del.rec)), "|"), rtn_tbl_get_scanstack_nextch(v_del.rec)), "|"), rtn_tbl_get_scanstack_chwhat(v_del.rec)), "|"), rtn_tbl_get_scanstack_chwhere(v_del.rec)), "|"), rtn_tbl_get_scanstack_chmess(v_del.rec)), "|"), rtn_tbl_get_scanstack_chline(v_del.rec)), "|"), rtn_tbl_get_scanstack_chold(v_del.rec)), "|"), rtn_tbl_get_scanstack_chbetween(v_del.rec)), "|"), rtn_tbl_get_scanstack_chnew(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_del.rec));
  rtn_deleteindex(v_chk, 3);
  v_chk=rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_del.rec)+1);
  rtn_tbl_put_scanstack_ch(v_del.rec, 0);
  rtn_tbl_put_scanstack_nextch(v_del.rec, 0);
  rtn_tbl_put_scanstack_chwhat(v_del.rec, 0);
  rtn_tbl_put_scanstack_chwhere(v_del.rec, 0);
  rtn_tbl_put_scanstack_chmess(v_del.rec, 0);
  rtn_tbl_put_scanstack_chline(v_del.rec, 0);
  rtn_tbl_put_scanstack_chold(v_del.rec, 0);
  rtn_tbl_put_scanstack_chbetween(v_del.rec, 0);
  rtn_tbl_put_scanstack_chnew(v_del.rec, 0);
  if (rtn_getrec(v_del, 2)!=rtn_tablelen(2)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(2)-1, 3);
    rtn_changeindex(rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_last.rec)), v_delrec, 3);
  }
  rtn_deleterecord(v_delrec, 2);
  if (v_chk.branch==-1) {
    delptr(&v_last, 3);
    delptr(&v_chk, 3);
    delptr(&v_del, 3);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 3);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_scanstack_pos(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 2);
    rtn_tbl_sub_scanstack_pos(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 3);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 3);
  delptr(&v_chk, 3);
  delptr(&v_del, 3);
}
 
 
struct pointer rtn_tbl_update_scanstack(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 3, 1);
  newptr(&v_del, 3, 1);
  v_del=rtn_getrecptr(v_rec, 2);
  v_new=rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_del.rec));
  rtn_deleteindex(v_new, 3);
  rtn_deleterecord(v_rec, 2);
  rtn_addindex(rtn_tbl_search_scanstack(rtn_tbl_get_scanstack_pos(v_new.rec)), rtn_getrec(v_new, 3), 3);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 2);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scpy("update scanstack:"), scpy(get_sort(rtn_tbl_get_scanstack_pos(v_new.rec)))), "|"), get_int(rtn_tbl_get_scanstack_file(v_new.rec))), "|"), get_int(rtn_tbl_get_scanstack_outfile(v_new.rec))), "|"), rtn_tbl_get_scanstack_ch(v_new.rec)), "|"), rtn_tbl_get_scanstack_nextch(v_new.rec)), "|"), rtn_tbl_get_scanstack_chwhat(v_new.rec)), "|"), rtn_tbl_get_scanstack_chwhere(v_new.rec)), "|"), rtn_tbl_get_scanstack_chmess(v_new.rec)), "|"), rtn_tbl_get_scanstack_chline(v_new.rec)), "|"), rtn_tbl_get_scanstack_chold(v_new.rec)), "|"), rtn_tbl_get_scanstack_chbetween(v_new.rec)), "|"), rtn_tbl_get_scanstack_chnew(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 3);
  delptr(&v_del, 3);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 3);
  delptr(&v_del, 3);
}
 
 
void rtn_tbl_clear_scanstack() {
  
  long int r=0;
  long int branch;
  while (r < u_table[2].len) {
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+12)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+12)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+12)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+16)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+16)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+16)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+20)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+20)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+20)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+24)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+24)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+24)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+28)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+28)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+28)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+32)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+32)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+32)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+36)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+36)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+36)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+40)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+40)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+40)=0;}
    if (*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+44)!=0) {free(*(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+44)); *(char**)(u_table[2].ptr[r/250]+(r%250)*u_table[2].size+44)=0;}
    r++;
  }
  free(u_table[2].ptr);
  u_table[2].ptr=0;
  u_table[2].len=0;
  for(branch=0; branch < u_index[3].scale; branch++)
  { free(u_index[3].ptr[branch]);
  }
  free(u_index[3].len);
  free(u_index[3].ptr);
  u_index[3].scale=0;
  u_index[3].len=0;
  u_index[3].ptr=0;
  fprintf(v_log, "clear scanstack(2)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_scanstack() {
  
  return u_table[2].len;
}
 
void rtn_tbl_init_scanstack() {
  
  u_table[2].len=0;
  u_table[2].size=48;
  u_table[2].ptr=0;
  u_index[3].tbl=2;
  u_index[3].scale=0;
  u_index[3].len=0;
  u_index[3].ptr=0;
  u_index[3].ptrs=0;
  u_index[3].padm=0;
}
 
void rtn_tbl_write_scanstack(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 3, 0);
  rtn_write(rtn_tbl_get_scanstack_pos(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_scanstack_file(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_scanstack_outfile(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_ch(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_nextch(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chwhat(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chwhere(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chmess(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chline(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chold(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chbetween(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_scanstack_chnew(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 3);
}
 
 
struct pointer rtn_tbl_read_scanstack(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 3, 0);
  v_new=rtn_addrecord(2);
  rtn_tbl_put_scanstack_pos(v_new.rec, 0);
  rtn_tbl_put_scanstack_file(v_new.rec, null);
  rtn_tbl_put_scanstack_outfile(v_new.rec, null);
  rtn_tbl_put_scanstack_ch(v_new.rec, 0);
  rtn_tbl_put_scanstack_nextch(v_new.rec, 0);
  rtn_tbl_put_scanstack_chwhat(v_new.rec, 0);
  rtn_tbl_put_scanstack_chwhere(v_new.rec, 0);
  rtn_tbl_put_scanstack_chmess(v_new.rec, 0);
  rtn_tbl_put_scanstack_chline(v_new.rec, 0);
  rtn_tbl_put_scanstack_chold(v_new.rec, 0);
  rtn_tbl_put_scanstack_chbetween(v_new.rec, 0);
  rtn_tbl_put_scanstack_chnew(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_scanstack_pos(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_scanstack_file(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_scanstack_outfile(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_scanstack_ch(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_nextch(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chwhat(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chwhere(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chmess(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chline(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chold(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chbetween(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_scanstack_chnew(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_scanstack(v_new);
  v_dbstate=0;
  delptr(&v_new, 3);
  return v_new;
  delptr(&v_new, 3);
}
 
 
long int rtn_getstream(FILE *v_file) {
  
  return (long int)v_file;
}
 
FILE *rtn_setstream(long int v_numb) {
  
  return (FILE*)v_numb;
}
 
void rtn_scanpush(char *v_file) {
  struct pointer v_scanstack={-1, -1, -1};
  char *var1=0;
  newptr(&v_scanstack, 3, 0);
  v_scanstack=rtn_addrecord(2);
  rtn_tbl_put_scanstack_pos(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_file(v_scanstack.rec, null);
  rtn_tbl_put_scanstack_outfile(v_scanstack.rec, null);
  rtn_tbl_put_scanstack_ch(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_nextch(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chwhat(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chwhere(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chmess(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chline(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chold(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chbetween(v_scanstack.rec, 0);
  rtn_tbl_put_scanstack_chnew(v_scanstack.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_scanstack_file(v_scanstack.rec, rtn_getstream(v_chin));
  rtn_tbl_put_scanstack_outfile(v_scanstack.rec, rtn_getstream(v_chout));
  rtn_tbl_put_scanstack_ch(v_scanstack.rec, scpy(v_ch));
  rtn_tbl_put_scanstack_nextch(v_scanstack.rec, scpy(v_nextch));
  rtn_tbl_put_scanstack_chwhat(v_scanstack.rec, get_enum(v_chwhat, "nothing start next"));
  rtn_tbl_put_scanstack_chwhere(v_scanstack.rec, get_enum(v_chwhere, "tonew tobetween"));
  rtn_tbl_put_scanstack_chmess(v_scanstack.rec, scpy(v_chmess));
  rtn_tbl_put_scanstack_chline(v_scanstack.rec, scpy(v_chline));
  rtn_tbl_put_scanstack_chold(v_scanstack.rec, scpy(v_chold));
  rtn_tbl_put_scanstack_chbetween(v_scanstack.rec, scpy(v_chbetween));
  rtn_tbl_put_scanstack_chnew(v_scanstack.rec, scpy(v_chnew));
  v_scanstack=rtn_tbl_add_scanstack(v_scanstack);
  v_dbstate=0;
  v_chout=rtn_create((var1=snew(var1, scon(scpy(v_file), ".html"))));
  if (v_chout==0) {
    swrite((var1=snew(var1, scon(scon(scpy("Cannot write to '"), v_file), ".html'"))), stdout); wline(stdout);
  }
  swrite((var1=snew(var1, sadd(sadd(sadd(scon(sadd(sadd(rtn_tag("HTML"), rtn_tag("BODY LINK=\"0\" VLINK=\"0\"")), rtn_tag("h1")), "Module : "), rtn_left(v_file, rtn_length(v_file)-2)), rtn_tag("/h1")), rtn_tag("font size=2")))), v_chout); wline(v_chout);
  v_chin=rtn_open(v_file);
  v_chmess=snew(v_chmess, 0);
  v_chline=snew(v_chline, 0);
  v_chold=snew(v_chold, 0);
  v_chbetween=snew(v_chbetween, 0);
  v_chnew=snew(v_chnew, 0);
  v_ch=snew(v_ch, 0);
  v_nextch=snew(v_nextch, 0);
  v_chwhat=0;
  v_chwhere=1;
  v_scanstackpointer=rtn_tbl_get_scanstack_pos(v_scanstack.rec);
  if (v_chin!=0) {
    v_nextch=snew(v_nextch, scpy(rtn_get(v_chin)));
    rtn_getchar();
  }
  if (var1!=0) {free(var1); var1=0;}
  if (v_file!=0) {free(v_file); v_file=0;}
  delptr(&v_scanstack, 3);
}
 
 
void rtn_scanpop() {
  char *var1=0;
  struct pointer v_scanstack={-1, -1, -1};
  swrite((var1=snew(var1, sadd(rtn_tag("/BODY"), rtn_tag("/HTML")))), v_chout); wline(v_chout);
  rtn_close(v_chout);
  rtn_close(v_chin);
  newptr(&v_scanstack, 3, 0);
  v_scanstack=rtn_tbl_search_scanstack(v_scanstackpointer);
  while (1) {
    if ((v_scanstack.branch==-1) || ((rtn_tbl_get_scanstack_pos(v_scanstack.rec)>v_scanstackpointer))) {
      v_scanstack=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_scanstack_pos(v_scanstack.rec)==v_scanstackpointer) {
      break;
    }
    v_scanstack=rtn_ptrplus1(v_scanstack, 3);
  }
  if (!(v_scanstack.branch!=-1)) {
    rtn_putmessage(scpy("Already at top level module"));
  }
  v_chin=rtn_setstream(rtn_tbl_get_scanstack_file(v_scanstack.rec));
  v_chout=rtn_setstream(rtn_tbl_get_scanstack_outfile(v_scanstack.rec));
  v_ch=snew(v_ch, scpy(rtn_tbl_get_scanstack_ch(v_scanstack.rec)));
  v_nextch=snew(v_nextch, scpy(rtn_tbl_get_scanstack_nextch(v_scanstack.rec)));
  v_chwhat=ienum(rtn_tbl_get_scanstack_chwhat(v_scanstack.rec), "nothing start next");
  v_chwhere=ienum(rtn_tbl_get_scanstack_chwhere(v_scanstack.rec), "tonew tobetween");
  v_chmess=snew(v_chmess, scpy(rtn_tbl_get_scanstack_chmess(v_scanstack.rec)));
  v_chline=snew(v_chline, scpy(rtn_tbl_get_scanstack_chline(v_scanstack.rec)));
  v_chold=snew(v_chold, scpy(rtn_tbl_get_scanstack_chold(v_scanstack.rec)));
  v_chbetween=snew(v_chbetween, scpy(rtn_tbl_get_scanstack_chbetween(v_scanstack.rec)));
  v_chnew=snew(v_chnew, scpy(rtn_tbl_get_scanstack_chnew(v_scanstack.rec)));
  rtn_tbl_delete_scanstack(rtn_getrec(v_scanstack, 3));
  v_scanstackpointer-=1;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_scanstack, 3);
}
 
 
void rtn_addtag(char *v_left, char *v_right) {
  v_chnew=snew(v_chnew, sadd(scon(rtn_tag(v_left), v_chnew), rtn_tag(v_right)));
  if (v_left!=0) {free(v_left); v_left=0;}
  if (v_right!=0) {free(v_right); v_right=0;}
}
 
char v_tagfound=0;
FILE *v_c=0;
long int v_croutine=0;
long int v_specrout=0;
char *v_cindex=0;
 
char *rtn_tbl_get_options_option(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) return 0;
  return *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+0);
}
 
void rtn_tbl_put_options_option(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) {
    printf("error in filling field options.option\n");
    return;
  }
  *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+0)=v_val;
}
 
void rtn_tbl_add_options_option(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) {
    printf("error in adding to field options.option\n");
    return;
  }
  *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+0)= 
  sadd(*(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+0), v_val);
}
 
char *rtn_tbl_get_options_value(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) return 0;
  return *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+4);
}
 
void rtn_tbl_put_options_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) {
    printf("error in filling field options.value\n");
    return;
  }
  *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+4)=v_val;
}
 
void rtn_tbl_add_options_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[3].len) {
    printf("error in adding to field options.value\n");
    return;
  }
  *(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+4)= 
  sadd(*(char**)(u_table[3].ptr[v_rec/250]+(v_rec%250)*u_table[3].size+4), v_val);
}
 
struct pointer rtn_tbl_search_options(char *v_p_option) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 4, 1);
  newptr(&v_ptr, 4, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(4)+1);
    v_idx=rtn_getpointer(v_curr, 0, 4);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_option, rtn_tbl_get_options_option(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(4);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 4)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 4);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_option, rtn_tbl_get_options_option(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 4);
  }
  if (v_p_option!=0) {free(v_p_option); v_p_option=0;}
  delptr(&v_idx, 4);
  delptr(&v_ptr, 4);
  return v_ptr;
  if (v_p_option!=0) {free(v_p_option); v_p_option=0;}
  delptr(&v_idx, 4);
  delptr(&v_ptr, 4);
}
 
 
struct pointer rtn_tbl_add_options(struct pointer v_new) {
  struct pointer v_idx_options={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_options, 4, 1);
  newptr(&v_last, 4, 1);
  v_idx_options=rtn_tbl_search_options(scpy(rtn_tbl_get_options_option(v_new.rec)));
  if (v_idx_options.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(4), rtn_maxleaf(rtn_maxbranch(4), 4), 4);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_options, 4);
  }
  rtn_addindex(v_idx_options, rtn_tablelen(3)-1, 4);
  swrite((var1=snew(var1, scon(scon(scon(scon(scpy("add options(3):"), rtn_tbl_get_options_option(v_new.rec)), "|"), rtn_tbl_get_options_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 4);
    delptr(&v_idx_options, 4);
    delptr(&v_last, 4);
    return rtn_getpointer(0, 0, 4);
  }
  delptr(&v_new, 4);
  delptr(&v_idx_options, 4);
  delptr(&v_last, 4);
  return rtn_ptrplus1(v_last, 4);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 4);
  delptr(&v_idx_options, 4);
  delptr(&v_last, 4);
}
 
 
void rtn_tbl_delete_options(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 4, 1);
  newptr(&v_chk, 4, 1);
  newptr(&v_del, 4, 1);
  v_del=rtn_getrecptr(v_delrec, 3);
  swrite((var1=snew(var1, scon(scon(scon(scon(scpy("delete options(3):"), rtn_tbl_get_options_option(v_del.rec)), "|"), rtn_tbl_get_options_value(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_options(scpy(rtn_tbl_get_options_option(v_del.rec)));
  rtn_deleteindex(v_chk, 4);
  rtn_tbl_put_options_option(v_del.rec, 0);
  rtn_tbl_put_options_value(v_del.rec, 0);
  if (rtn_getrec(v_del, 3)!=rtn_tablelen(3)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(3)-1, 4);
    rtn_changeindex(rtn_tbl_search_options(scpy(rtn_tbl_get_options_option(v_last.rec))), v_delrec, 4);
  }
  rtn_deleterecord(v_delrec, 3);
  if (v_chk.branch==-1) {
    delptr(&v_last, 4);
    delptr(&v_chk, 4);
    delptr(&v_del, 4);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 4);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 4);
  delptr(&v_chk, 4);
  delptr(&v_del, 4);
}
 
 
struct pointer rtn_tbl_update_options(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 4, 1);
  newptr(&v_del, 4, 1);
  v_del=rtn_getrecptr(v_rec, 3);
  v_new=rtn_tbl_search_options(scpy(rtn_tbl_get_options_option(v_del.rec)));
  rtn_deleteindex(v_new, 4);
  rtn_deleterecord(v_rec, 3);
  rtn_addindex(rtn_tbl_search_options(scpy(rtn_tbl_get_options_option(v_new.rec))), rtn_getrec(v_new, 4), 4);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 3);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scpy("update options:"), rtn_tbl_get_options_option(v_new.rec)), "|"), rtn_tbl_get_options_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 4);
  delptr(&v_del, 4);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 4);
  delptr(&v_del, 4);
}
 
 
void rtn_tbl_clear_options() {
  
  long int r=0;
  long int branch;
  while (r < u_table[3].len) {
    if (*(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+0)!=0) {free(*(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+0)); *(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+0)=0;}
    if (*(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+4)!=0) {free(*(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+4)); *(char**)(u_table[3].ptr[r/250]+(r%250)*u_table[3].size+4)=0;}
    r++;
  }
  free(u_table[3].ptr);
  u_table[3].ptr=0;
  u_table[3].len=0;
  for(branch=0; branch < u_index[4].scale; branch++)
  { free(u_index[4].ptr[branch]);
  }
  free(u_index[4].len);
  free(u_index[4].ptr);
  u_index[4].scale=0;
  u_index[4].len=0;
  u_index[4].ptr=0;
  fprintf(v_log, "clear options(3)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_options() {
  
  return u_table[3].len;
}
 
void rtn_tbl_init_options() {
  
  u_table[3].len=0;
  u_table[3].size=8;
  u_table[3].ptr=0;
  u_index[4].tbl=3;
  u_index[4].scale=0;
  u_index[4].len=0;
  u_index[4].ptr=0;
  u_index[4].ptrs=0;
  u_index[4].padm=0;
}
 
void rtn_tbl_write_options(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 4, 0);
  rtn_write(iscan(rtn_tbl_get_options_option(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_options_value(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 4);
}
 
 
struct pointer rtn_tbl_read_options(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 4, 0);
  v_new=rtn_addrecord(3);
  rtn_tbl_put_options_option(v_new.rec, 0);
  rtn_tbl_put_options_value(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_options_option(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_options_value(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_options(v_new);
  v_dbstate=0;
  delptr(&v_new, 4);
  return v_new;
  delptr(&v_new, 4);
}
 
 
long int rtn_tbl_get_module_module(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(long int*)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+0);
}
 
void rtn_tbl_put_module_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.module\n");
    return;
  }
  *(long int*)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+0)=v_val;
}
 
void rtn_tbl_add_module_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.module\n");
    return;
  }
  *(long int*)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+0)+=v_val;
}
 
void rtn_tbl_sub_module_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("Error in subtraction from field module.module\n");
    return;
  }
  *(long int*)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+0)-=v_val;
}
 
char *rtn_tbl_get_module_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+4);
}
 
void rtn_tbl_put_module_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.name\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+4)=v_val;
}
 
void rtn_tbl_add_module_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.name\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+4)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+4), v_val);
}
 
char *rtn_tbl_get_module_title(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+8);
}
 
void rtn_tbl_put_module_title(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.title\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+8)=v_val;
}
 
void rtn_tbl_add_module_title(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.title\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+8)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+8), v_val);
}
 
char *rtn_tbl_get_module_author(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+12);
}
 
void rtn_tbl_put_module_author(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.author\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+12)=v_val;
}
 
void rtn_tbl_add_module_author(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.author\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+12)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+12), v_val);
}
 
char *rtn_tbl_get_module_revision(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+16);
}
 
void rtn_tbl_put_module_revision(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.revision\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+16)=v_val;
}
 
void rtn_tbl_add_module_revision(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.revision\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+16)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+16), v_val);
}
 
char *rtn_tbl_get_module_URL(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+20);
}
 
void rtn_tbl_put_module_URL(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.URL\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+20)=v_val;
}
 
void rtn_tbl_add_module_URL(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.URL\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+20)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+20), v_val);
}
 
char *rtn_tbl_get_module_maintainer(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) return 0;
  return *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+24);
}
 
void rtn_tbl_put_module_maintainer(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in filling field module.maintainer\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+24)=v_val;
}
 
void rtn_tbl_add_module_maintainer(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[4].len) {
    printf("error in adding to field module.maintainer\n");
    return;
  }
  *(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+24)= 
  sadd(*(char**)(u_table[4].ptr[v_rec/250]+(v_rec%250)*u_table[4].size+24), v_val);
}
 
struct pointer rtn_tbl_search_module(long int v_p_module) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 5, 1);
  newptr(&v_ptr, 5, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(5)+1);
    v_idx=rtn_getpointer(v_curr, 0, 5);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_module_module(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(5);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 5)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 5);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_module_module(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 5);
  }
  delptr(&v_idx, 5);
  delptr(&v_ptr, 5);
  return v_ptr;
  delptr(&v_idx, 5);
  delptr(&v_ptr, 5);
}
 
 
struct pointer rtn_tbl_add_module(struct pointer v_new) {
  struct pointer v_idx_module={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_module, 5, 1);
  newptr(&v_last, 5, 1);
  rtn_tbl_put_module_module(v_new.rec, 999999999);
  v_idx_module=rtn_tbl_search_module(rtn_tbl_get_module_module(v_new.rec));
  if (v_idx_module.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(5), rtn_maxleaf(rtn_maxbranch(5), 5), 5);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_module, 5);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_module_module(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_module_module(v_new.rec, rtn_tbl_get_module_module(v_last.rec)+1);
  }
  rtn_addindex(v_idx_module, rtn_tablelen(4)-1, 5);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("add module(4):"), scpy(get_sort(rtn_tbl_get_module_module(v_new.rec)))), "|"), rtn_tbl_get_module_name(v_new.rec)), "|"), rtn_tbl_get_module_title(v_new.rec)), "|"), rtn_tbl_get_module_author(v_new.rec)), "|"), rtn_tbl_get_module_revision(v_new.rec)), "|"), rtn_tbl_get_module_URL(v_new.rec)), "|"), rtn_tbl_get_module_maintainer(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 5);
    delptr(&v_idx_module, 5);
    delptr(&v_last, 5);
    return rtn_getpointer(0, 0, 5);
  }
  delptr(&v_new, 5);
  delptr(&v_idx_module, 5);
  delptr(&v_last, 5);
  return rtn_ptrplus1(v_last, 5);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 5);
  delptr(&v_idx_module, 5);
  delptr(&v_last, 5);
}
 
 
void rtn_tbl_delete_module(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 5, 1);
  newptr(&v_chk, 5, 1);
  newptr(&v_del, 5, 1);
  v_del=rtn_getrecptr(v_delrec, 4);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("delete module(4):"), scpy(get_sort(rtn_tbl_get_module_module(v_del.rec)))), "|"), rtn_tbl_get_module_name(v_del.rec)), "|"), rtn_tbl_get_module_title(v_del.rec)), "|"), rtn_tbl_get_module_author(v_del.rec)), "|"), rtn_tbl_get_module_revision(v_del.rec)), "|"), rtn_tbl_get_module_URL(v_del.rec)), "|"), rtn_tbl_get_module_maintainer(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_module(rtn_tbl_get_module_module(v_del.rec));
  rtn_deleteindex(v_chk, 5);
  v_chk=rtn_tbl_search_module(rtn_tbl_get_module_module(v_del.rec)+1);
  rtn_tbl_put_module_name(v_del.rec, 0);
  rtn_tbl_put_module_title(v_del.rec, 0);
  rtn_tbl_put_module_author(v_del.rec, 0);
  rtn_tbl_put_module_revision(v_del.rec, 0);
  rtn_tbl_put_module_URL(v_del.rec, 0);
  rtn_tbl_put_module_maintainer(v_del.rec, 0);
  if (rtn_getrec(v_del, 4)!=rtn_tablelen(4)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(4)-1, 5);
    rtn_changeindex(rtn_tbl_search_module(rtn_tbl_get_module_module(v_last.rec)), v_delrec, 5);
  }
  rtn_deleterecord(v_delrec, 4);
  if (v_chk.branch==-1) {
    delptr(&v_last, 5);
    delptr(&v_chk, 5);
    delptr(&v_del, 5);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 5);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_module_module(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 4);
    rtn_tbl_sub_module_module(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 5);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 5);
  delptr(&v_chk, 5);
  delptr(&v_del, 5);
}
 
 
struct pointer rtn_tbl_update_module(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 5, 1);
  newptr(&v_del, 5, 1);
  v_del=rtn_getrecptr(v_rec, 4);
  v_new=rtn_tbl_search_module(rtn_tbl_get_module_module(v_del.rec));
  rtn_deleteindex(v_new, 5);
  rtn_deleterecord(v_rec, 4);
  rtn_addindex(rtn_tbl_search_module(rtn_tbl_get_module_module(v_new.rec)), rtn_getrec(v_new, 5), 5);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 4);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("update module:"), scpy(get_sort(rtn_tbl_get_module_module(v_new.rec)))), "|"), rtn_tbl_get_module_name(v_new.rec)), "|"), rtn_tbl_get_module_title(v_new.rec)), "|"), rtn_tbl_get_module_author(v_new.rec)), "|"), rtn_tbl_get_module_revision(v_new.rec)), "|"), rtn_tbl_get_module_URL(v_new.rec)), "|"), rtn_tbl_get_module_maintainer(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 5);
  delptr(&v_del, 5);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 5);
  delptr(&v_del, 5);
}
 
 
void rtn_tbl_clear_module() {
  
  long int r=0;
  long int branch;
  while (r < u_table[4].len) {
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+4)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+4)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+4)=0;}
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+8)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+8)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+8)=0;}
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+12)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+12)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+12)=0;}
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+16)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+16)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+16)=0;}
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+20)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+20)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+20)=0;}
    if (*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+24)!=0) {free(*(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+24)); *(char**)(u_table[4].ptr[r/250]+(r%250)*u_table[4].size+24)=0;}
    r++;
  }
  free(u_table[4].ptr);
  u_table[4].ptr=0;
  u_table[4].len=0;
  for(branch=0; branch < u_index[5].scale; branch++)
  { free(u_index[5].ptr[branch]);
  }
  free(u_index[5].len);
  free(u_index[5].ptr);
  u_index[5].scale=0;
  u_index[5].len=0;
  u_index[5].ptr=0;
  fprintf(v_log, "clear module(4)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_module() {
  
  return u_table[4].len;
}
 
void rtn_tbl_init_module() {
  
  u_table[4].len=0;
  u_table[4].size=28;
  u_table[4].ptr=0;
  u_index[5].tbl=4;
  u_index[5].scale=0;
  u_index[5].len=0;
  u_index[5].ptr=0;
  u_index[5].ptrs=0;
  u_index[5].padm=0;
}
 
void rtn_tbl_write_module(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 5, 0);
  rtn_write(rtn_tbl_get_module_module(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_name(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_title(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_author(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_revision(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_URL(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_module_maintainer(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 5);
}
 
 
struct pointer rtn_tbl_read_module(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 5, 0);
  v_new=rtn_addrecord(4);
  rtn_tbl_put_module_module(v_new.rec, 0);
  rtn_tbl_put_module_name(v_new.rec, 0);
  rtn_tbl_put_module_title(v_new.rec, 0);
  rtn_tbl_put_module_author(v_new.rec, 0);
  rtn_tbl_put_module_revision(v_new.rec, 0);
  rtn_tbl_put_module_URL(v_new.rec, 0);
  rtn_tbl_put_module_maintainer(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_module_module(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_module_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_module_title(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_module_author(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_module_revision(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_module_URL(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_module_maintainer(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_module(v_new);
  v_dbstate=0;
  delptr(&v_new, 5);
  return v_new;
  delptr(&v_new, 5);
}
 
 
long int rtn_tbl_get_routine_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+0);
}
 
void rtn_tbl_put_routine_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.order\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+0)=v_val;
}
 
void rtn_tbl_add_routine_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.order\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+0)+=v_val;
}
 
void rtn_tbl_sub_routine_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("Error in subtraction from field routine.order\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+0)-=v_val;
}
 
char *rtn_tbl_get_routine_module(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+4);
}
 
void rtn_tbl_put_routine_module(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.module\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+4)=v_val;
}
 
void rtn_tbl_add_routine_module(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.module\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+4)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+4), v_val);
}
 
char *rtn_tbl_get_routine_function(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+8);
}
 
void rtn_tbl_put_routine_function(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.function\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+8)=v_val;
}
 
void rtn_tbl_add_routine_function(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.function\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+8)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+8), v_val);
}
 
char *rtn_tbl_get_routine_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+12);
}
 
void rtn_tbl_put_routine_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.name\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+12)=v_val;
}
 
void rtn_tbl_add_routine_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.name\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+12)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+12), v_val);
}
 
int rtn_tbl_get_routine_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return -1;
  return *(int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+16);
}
 
void rtn_tbl_put_routine_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.kind\n");
    return;
  }
  *(int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+16)=v_val;
}
 
void rtn_tbl_add_routine_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.kind\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+16)+=v_val;
}
 
void rtn_tbl_sub_routine_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("Error in subtraction from field routine.kind\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+16)-=v_val;
}
 
int rtn_tbl_get_routine_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return -1;
  return *(int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+20);
}
 
void rtn_tbl_put_routine_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.type\n");
    return;
  }
  *(int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+20)=v_val;
}
 
void rtn_tbl_add_routine_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.type\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+20)+=v_val;
}
 
void rtn_tbl_sub_routine_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("Error in subtraction from field routine.type\n");
    return;
  }
  *(long int*)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+20)-=v_val;
}
 
char *rtn_tbl_get_routine_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+24);
}
 
void rtn_tbl_put_routine_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.use\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+24)=v_val;
}
 
void rtn_tbl_add_routine_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.use\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+24)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+24), v_val);
}
 
char *rtn_tbl_get_routine_returntype(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+28);
}
 
void rtn_tbl_put_routine_returntype(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.returntype\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+28)=v_val;
}
 
void rtn_tbl_add_routine_returntype(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.returntype\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+28)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+28), v_val);
}
 
char *rtn_tbl_get_routine_returndata(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+32);
}
 
void rtn_tbl_put_routine_returndata(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.returndata\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+32)=v_val;
}
 
void rtn_tbl_add_routine_returndata(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.returndata\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+32)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+32), v_val);
}
 
char *rtn_tbl_get_routine_returnuse(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) return 0;
  return *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+36);
}
 
void rtn_tbl_put_routine_returnuse(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in filling field routine.returnuse\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+36)=v_val;
}
 
void rtn_tbl_add_routine_returnuse(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[5].len) {
    printf("error in adding to field routine.returnuse\n");
    return;
  }
  *(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+36)= 
  sadd(*(char**)(u_table[5].ptr[v_rec/250]+(v_rec%250)*u_table[5].size+36), v_val);
}
 
struct pointer rtn_tbl_search_routine(long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 6, 1);
  newptr(&v_ptr, 6, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(6)+1);
    v_idx=rtn_getpointer(v_curr, 0, 6);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(6);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 6)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 6);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 6);
  }
  delptr(&v_idx, 6);
  delptr(&v_ptr, 6);
  return v_ptr;
  delptr(&v_idx, 6);
  delptr(&v_ptr, 6);
}
 
 
struct pointer rtn_tbl_search_routinelist(char *v_p_module, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 7, 1);
  newptr(&v_ptr, 7, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(7)+1);
    v_idx=rtn_getpointer(v_curr, 0, 7);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_module, rtn_tbl_get_routine_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(7);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 7)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 7);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_module, rtn_tbl_get_routine_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 7);
  }
  if (v_p_module!=0) {free(v_p_module); v_p_module=0;}
  delptr(&v_idx, 7);
  delptr(&v_ptr, 7);
  return v_ptr;
  if (v_p_module!=0) {free(v_p_module); v_p_module=0;}
  delptr(&v_idx, 7);
  delptr(&v_ptr, 7);
}
 
 
struct pointer rtn_tbl_search_routinename(char *v_p_name, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 8, 1);
  newptr(&v_ptr, 8, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(8)+1);
    v_idx=rtn_getpointer(v_curr, 0, 8);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_routine_name(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(8);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 8)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 8);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_routine_name(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_routine_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 8);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 8);
  delptr(&v_ptr, 8);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 8);
  delptr(&v_ptr, 8);
}
 
 
struct pointer rtn_tbl_add_routine(struct pointer v_new) {
  struct pointer v_idx_routine={-1, -1, -1};
  struct pointer v_idx_routinelist={-1, -1, -1};
  struct pointer v_idx_routinename={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_routine, 6, 1);
  newptr(&v_idx_routinelist, 7, 1);
  newptr(&v_idx_routinename, 8, 1);
  newptr(&v_last, 6, 1);
  rtn_tbl_put_routine_order(v_new.rec, 999999999);
  v_idx_routine=rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_new.rec));
  if (v_idx_routine.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(6), rtn_maxleaf(rtn_maxbranch(6), 6), 6);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_routine, 6);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_routine_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_routine_order(v_new.rec, rtn_tbl_get_routine_order(v_last.rec)+1);
  }
  v_idx_routinelist=rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_new.rec)), rtn_tbl_get_routine_order(v_new.rec));
  v_idx_routinename=rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_new.rec)), rtn_tbl_get_routine_order(v_new.rec));
  rtn_addindex(v_idx_routine, rtn_tablelen(5)-1, 6);
  rtn_addindex(v_idx_routinelist, rtn_tablelen(5)-1, 7);
  rtn_addindex(v_idx_routinename, rtn_tablelen(5)-1, 8);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("add routine(5):"), scpy(get_sort(rtn_tbl_get_routine_order(v_new.rec)))), "|"), rtn_tbl_get_routine_module(v_new.rec)), "|"), rtn_tbl_get_routine_function(v_new.rec)), "|"), rtn_tbl_get_routine_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_routine_kind(v_new.rec), "public local")), "|"), get_enum(rtn_tbl_get_routine_type(v_new.rec), "normal system special header")), "|"), rtn_tbl_get_routine_use(v_new.rec)), "|"), rtn_tbl_get_routine_returntype(v_new.rec)), "|"), rtn_tbl_get_routine_returndata(v_new.rec)), "|"), rtn_tbl_get_routine_returnuse(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 6);
    delptr(&v_idx_routine, 6);
    delptr(&v_idx_routinelist, 7);
    delptr(&v_idx_routinename, 8);
    delptr(&v_last, 6);
    return rtn_getpointer(0, 0, 6);
  }
  delptr(&v_new, 6);
  delptr(&v_idx_routine, 6);
  delptr(&v_idx_routinelist, 7);
  delptr(&v_idx_routinename, 8);
  delptr(&v_last, 6);
  return rtn_ptrplus1(v_last, 6);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 6);
  delptr(&v_idx_routine, 6);
  delptr(&v_idx_routinelist, 7);
  delptr(&v_idx_routinename, 8);
  delptr(&v_last, 6);
}
 
 
void rtn_tbl_delete_routine(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 6, 1);
  newptr(&v_chk, 6, 1);
  newptr(&v_del, 6, 1);
  v_del=rtn_getrecptr(v_delrec, 5);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("delete routine(5):"), scpy(get_sort(rtn_tbl_get_routine_order(v_del.rec)))), "|"), rtn_tbl_get_routine_module(v_del.rec)), "|"), rtn_tbl_get_routine_function(v_del.rec)), "|"), rtn_tbl_get_routine_name(v_del.rec)), "|"), get_enum(rtn_tbl_get_routine_kind(v_del.rec), "public local")), "|"), get_enum(rtn_tbl_get_routine_type(v_del.rec), "normal system special header")), "|"), rtn_tbl_get_routine_use(v_del.rec)), "|"), rtn_tbl_get_routine_returntype(v_del.rec)), "|"), rtn_tbl_get_routine_returndata(v_del.rec)), "|"), rtn_tbl_get_routine_returnuse(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_del.rec));
  rtn_deleteindex(v_chk, 6);
  v_chk=rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_del.rec)), rtn_tbl_get_routine_order(v_del.rec)), 7);
  rtn_deleteindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_del.rec)), rtn_tbl_get_routine_order(v_del.rec)), 8);
  rtn_tbl_put_routine_module(v_del.rec, 0);
  rtn_tbl_put_routine_function(v_del.rec, 0);
  rtn_tbl_put_routine_name(v_del.rec, 0);
  rtn_tbl_put_routine_use(v_del.rec, 0);
  rtn_tbl_put_routine_returntype(v_del.rec, 0);
  rtn_tbl_put_routine_returndata(v_del.rec, 0);
  rtn_tbl_put_routine_returnuse(v_del.rec, 0);
  if (rtn_getrec(v_del, 5)!=rtn_tablelen(5)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(5)-1, 6);
    rtn_changeindex(rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_last.rec)), v_delrec, 6);
    rtn_changeindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_last.rec)), rtn_tbl_get_routine_order(v_last.rec)), v_delrec, 7);
    rtn_changeindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_last.rec)), rtn_tbl_get_routine_order(v_last.rec)), v_delrec, 8);
  }
  rtn_deleterecord(v_delrec, 5);
  if (v_chk.branch==-1) {
    delptr(&v_last, 6);
    delptr(&v_chk, 6);
    delptr(&v_del, 6);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 6);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_routine_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 5);
    rtn_deleteindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_chk.rec)), rtn_tbl_get_routine_order(v_chk.rec)), 7);
    rtn_deleteindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_chk.rec)), rtn_tbl_get_routine_order(v_chk.rec)), 8);
    rtn_tbl_sub_routine_order(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_chk.rec)), rtn_tbl_get_routine_order(v_chk.rec)), v_rec, 7);
    rtn_addindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_chk.rec)), rtn_tbl_get_routine_order(v_chk.rec)), v_rec, 8);
    v_chk=rtn_ptrplus1(v_chk, 6);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 6);
  delptr(&v_chk, 6);
  delptr(&v_del, 6);
}
 
 
struct pointer rtn_tbl_update_routine(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 6, 1);
  newptr(&v_del, 6, 1);
  v_del=rtn_getrecptr(v_rec, 5);
  v_new=rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_del.rec));
  rtn_deleteindex(v_new, 6);
  rtn_deleteindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_del.rec)), rtn_tbl_get_routine_order(v_del.rec)), 7);
  rtn_deleteindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_del.rec)), rtn_tbl_get_routine_order(v_del.rec)), 8);
  rtn_deleterecord(v_rec, 5);
  rtn_addindex(rtn_tbl_search_routine(rtn_tbl_get_routine_order(v_new.rec)), rtn_getrec(v_new, 6), 6);
  rtn_addindex(rtn_tbl_search_routinelist(scpy(rtn_tbl_get_routine_module(v_new.rec)), rtn_tbl_get_routine_order(v_new.rec)), rtn_getrec(v_new, 6), 7);
  rtn_addindex(rtn_tbl_search_routinename(scpy(rtn_tbl_get_routine_name(v_new.rec)), rtn_tbl_get_routine_order(v_new.rec)), rtn_getrec(v_new, 6), 8);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 5);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scpy("update routine:"), scpy(get_sort(rtn_tbl_get_routine_order(v_new.rec)))), "|"), rtn_tbl_get_routine_module(v_new.rec)), "|"), rtn_tbl_get_routine_function(v_new.rec)), "|"), rtn_tbl_get_routine_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_routine_kind(v_new.rec), "public local")), "|"), get_enum(rtn_tbl_get_routine_type(v_new.rec), "normal system special header")), "|"), rtn_tbl_get_routine_use(v_new.rec)), "|"), rtn_tbl_get_routine_returntype(v_new.rec)), "|"), rtn_tbl_get_routine_returndata(v_new.rec)), "|"), rtn_tbl_get_routine_returnuse(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 6);
  delptr(&v_del, 6);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 6);
  delptr(&v_del, 6);
}
 
 
void rtn_tbl_clear_routine() {
  
  long int r=0;
  long int branch;
  while (r < u_table[5].len) {
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+4)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+4)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+4)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+8)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+8)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+8)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+12)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+12)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+12)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+24)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+24)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+24)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+28)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+28)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+28)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+32)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+32)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+32)=0;}
    if (*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+36)!=0) {free(*(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+36)); *(char**)(u_table[5].ptr[r/250]+(r%250)*u_table[5].size+36)=0;}
    r++;
  }
  free(u_table[5].ptr);
  u_table[5].ptr=0;
  u_table[5].len=0;
  for(branch=0; branch < u_index[6].scale; branch++)
  { free(u_index[6].ptr[branch]);
  }
  free(u_index[6].len);
  free(u_index[6].ptr);
  u_index[6].scale=0;
  u_index[6].len=0;
  u_index[6].ptr=0;
  for(branch=0; branch < u_index[7].scale; branch++)
  { free(u_index[7].ptr[branch]);
  }
  free(u_index[7].len);
  free(u_index[7].ptr);
  u_index[7].scale=0;
  u_index[7].len=0;
  u_index[7].ptr=0;
  for(branch=0; branch < u_index[8].scale; branch++)
  { free(u_index[8].ptr[branch]);
  }
  free(u_index[8].len);
  free(u_index[8].ptr);
  u_index[8].scale=0;
  u_index[8].len=0;
  u_index[8].ptr=0;
  fprintf(v_log, "clear routine(5)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_routine() {
  
  return u_table[5].len;
}
 
void rtn_tbl_init_routine() {
  
  u_table[5].len=0;
  u_table[5].size=40;
  u_table[5].ptr=0;
  u_index[6].tbl=5;
  u_index[6].scale=0;
  u_index[6].len=0;
  u_index[6].ptr=0;
  u_index[6].ptrs=0;
  u_index[6].padm=0;
  u_index[7].tbl=5;
  u_index[7].scale=0;
  u_index[7].len=0;
  u_index[7].ptr=0;
  u_index[7].ptrs=0;
  u_index[7].padm=0;
  u_index[8].tbl=5;
  u_index[8].scale=0;
  u_index[8].len=0;
  u_index[8].ptr=0;
  u_index[8].ptrs=0;
  u_index[8].padm=0;
}
 
void rtn_tbl_write_routine(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 6, 0);
  rtn_write(rtn_tbl_get_routine_order(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_module(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_function(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_routine_kind(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_routine_type(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_use(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_returntype(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_returndata(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_routine_returnuse(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 6);
}
 
 
struct pointer rtn_tbl_read_routine(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 6, 0);
  v_new=rtn_addrecord(5);
  rtn_tbl_put_routine_order(v_new.rec, 0);
  rtn_tbl_put_routine_module(v_new.rec, 0);
  rtn_tbl_put_routine_function(v_new.rec, 0);
  rtn_tbl_put_routine_name(v_new.rec, 0);
  rtn_tbl_put_routine_kind(v_new.rec, -1);
  rtn_tbl_put_routine_type(v_new.rec, -1);
  rtn_tbl_put_routine_use(v_new.rec, 0);
  rtn_tbl_put_routine_returntype(v_new.rec, 0);
  rtn_tbl_put_routine_returndata(v_new.rec, 0);
  rtn_tbl_put_routine_returnuse(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_routine_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_routine_module(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_function(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_routine_type(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_routine_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_returntype(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_returndata(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_routine_returnuse(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_routine(v_new);
  v_dbstate=0;
  delptr(&v_new, 6);
  return v_new;
  delptr(&v_new, 6);
}
 
 
long int rtn_tbl_get_parameter_routine(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return null;
  return *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+0);
}
 
void rtn_tbl_put_parameter_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.routine\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+0)=v_val;
}
 
void rtn_tbl_add_parameter_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.routine\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+0)+=v_val;
}
 
void rtn_tbl_sub_parameter_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("Error in subtraction from field parameter.routine\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+0)-=v_val;
}
 
long int rtn_tbl_get_parameter_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+4);
}
 
void rtn_tbl_put_parameter_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.order\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+4)=v_val;
}
 
void rtn_tbl_add_parameter_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.order\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+4)+=v_val;
}
 
void rtn_tbl_sub_parameter_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("Error in subtraction from field parameter.order\n");
    return;
  }
  *(long int*)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+4)-=v_val;
}
 
char *rtn_tbl_get_parameter_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+8);
}
 
void rtn_tbl_put_parameter_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.name\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+8)=v_val;
}
 
void rtn_tbl_add_parameter_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.name\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+8)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+8), v_val);
}
 
char *rtn_tbl_get_parameter_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+12);
}
 
void rtn_tbl_put_parameter_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.type\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+12)=v_val;
}
 
void rtn_tbl_add_parameter_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.type\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+12)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+12), v_val);
}
 
char *rtn_tbl_get_parameter_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+16);
}
 
void rtn_tbl_put_parameter_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.data\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+16)=v_val;
}
 
void rtn_tbl_add_parameter_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.data\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+16)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+16), v_val);
}
 
char *rtn_tbl_get_parameter_code(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+20);
}
 
void rtn_tbl_put_parameter_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.code\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+20)=v_val;
}
 
void rtn_tbl_add_parameter_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.code\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+20)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+20), v_val);
}
 
char *rtn_tbl_get_parameter_defaultvalue(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+24);
}
 
void rtn_tbl_put_parameter_defaultvalue(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.defaultvalue\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+24)=v_val;
}
 
void rtn_tbl_add_parameter_defaultvalue(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.defaultvalue\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+24)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+24), v_val);
}
 
char *rtn_tbl_get_parameter_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) return 0;
  return *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+28);
}
 
void rtn_tbl_put_parameter_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in filling field parameter.use\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+28)=v_val;
}
 
void rtn_tbl_add_parameter_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[6].len) {
    printf("error in adding to field parameter.use\n");
    return;
  }
  *(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+28)= 
  sadd(*(char**)(u_table[6].ptr[v_rec/250]+(v_rec%250)*u_table[6].size+28), v_val);
}
 
struct pointer rtn_tbl_search_parameter(long int v_p_routine, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 9, 1);
  newptr(&v_ptr, 9, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(9)+1);
    v_idx=rtn_getpointer(v_curr, 0, 9);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_parameter_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_parameter_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(9);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 9)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 9);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_parameter_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_parameter_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 9);
  }
  delptr(&v_idx, 9);
  delptr(&v_ptr, 9);
  return v_ptr;
  delptr(&v_idx, 9);
  delptr(&v_ptr, 9);
}
 
 
struct pointer rtn_tbl_search_parametername(long int v_p_routine, char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 10, 1);
  newptr(&v_ptr, 10, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(10)+1);
    v_idx=rtn_getpointer(v_curr, 0, 10);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_parameter_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_name, rtn_tbl_get_parameter_name(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(10);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 10)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 10);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_parameter_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_name, rtn_tbl_get_parameter_name(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 10);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 10);
  delptr(&v_ptr, 10);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 10);
  delptr(&v_ptr, 10);
}
 
 
struct pointer rtn_tbl_add_parameter(struct pointer v_new) {
  struct pointer v_idx_parameter={-1, -1, -1};
  struct pointer v_idx_parametername={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_parameter, 9, 1);
  newptr(&v_idx_parametername, 10, 1);
  newptr(&v_last, 9, 1);
  rtn_tbl_put_parameter_order(v_new.rec, 999999999);
  v_idx_parameter=rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_new.rec), rtn_tbl_get_parameter_order(v_new.rec));
  if (v_idx_parameter.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(9), rtn_maxleaf(rtn_maxbranch(9), 9), 9);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_parameter, 9);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_parameter_routine(v_last.rec)!=rtn_tbl_get_parameter_routine(v_new.rec))) {
    rtn_tbl_put_parameter_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_parameter_order(v_new.rec, rtn_tbl_get_parameter_order(v_last.rec)+1);
  }
  v_idx_parametername=rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_new.rec), scpy(rtn_tbl_get_parameter_name(v_new.rec)));
  rtn_addindex(v_idx_parameter, rtn_tablelen(6)-1, 9);
  rtn_addindex(v_idx_parametername, rtn_tablelen(6)-1, 10);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("add parameter(6):"), get_int(rtn_tbl_get_parameter_routine(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_parameter_order(v_new.rec)))), "|"), rtn_tbl_get_parameter_name(v_new.rec)), "|"), rtn_tbl_get_parameter_type(v_new.rec)), "|"), rtn_tbl_get_parameter_data(v_new.rec)), "|"), rtn_tbl_get_parameter_code(v_new.rec)), "|"), rtn_tbl_get_parameter_defaultvalue(v_new.rec)), "|"), rtn_tbl_get_parameter_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 9);
    delptr(&v_idx_parameter, 9);
    delptr(&v_idx_parametername, 10);
    delptr(&v_last, 9);
    return rtn_getpointer(0, 0, 9);
  }
  delptr(&v_new, 9);
  delptr(&v_idx_parameter, 9);
  delptr(&v_idx_parametername, 10);
  delptr(&v_last, 9);
  return rtn_ptrplus1(v_last, 9);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 9);
  delptr(&v_idx_parameter, 9);
  delptr(&v_idx_parametername, 10);
  delptr(&v_last, 9);
}
 
 
void rtn_tbl_delete_parameter(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 9, 1);
  newptr(&v_chk, 9, 1);
  newptr(&v_del, 9, 1);
  v_del=rtn_getrecptr(v_delrec, 6);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("delete parameter(6):"), get_int(rtn_tbl_get_parameter_routine(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_parameter_order(v_del.rec)))), "|"), rtn_tbl_get_parameter_name(v_del.rec)), "|"), rtn_tbl_get_parameter_type(v_del.rec)), "|"), rtn_tbl_get_parameter_data(v_del.rec)), "|"), rtn_tbl_get_parameter_code(v_del.rec)), "|"), rtn_tbl_get_parameter_defaultvalue(v_del.rec)), "|"), rtn_tbl_get_parameter_use(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_del.rec), rtn_tbl_get_parameter_order(v_del.rec));
  rtn_deleteindex(v_chk, 9);
  v_chk=rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_del.rec), rtn_tbl_get_parameter_order(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_del.rec), scpy(rtn_tbl_get_parameter_name(v_del.rec))), 10);
  rtn_tbl_put_parameter_name(v_del.rec, 0);
  rtn_tbl_put_parameter_type(v_del.rec, 0);
  rtn_tbl_put_parameter_data(v_del.rec, 0);
  rtn_tbl_put_parameter_code(v_del.rec, 0);
  rtn_tbl_put_parameter_defaultvalue(v_del.rec, 0);
  rtn_tbl_put_parameter_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 6)!=rtn_tablelen(6)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(6)-1, 9);
    rtn_changeindex(rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_last.rec), rtn_tbl_get_parameter_order(v_last.rec)), v_delrec, 9);
    rtn_changeindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_last.rec), scpy(rtn_tbl_get_parameter_name(v_last.rec))), v_delrec, 10);
  }
  rtn_deleterecord(v_delrec, 6);
  if (v_chk.branch==-1) {
    delptr(&v_last, 9);
    delptr(&v_chk, 9);
    delptr(&v_del, 9);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 9);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_parameter_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 6);
    rtn_deleteindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_chk.rec), scpy(rtn_tbl_get_parameter_name(v_chk.rec))), 10);
    rtn_tbl_sub_parameter_order(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_chk.rec), scpy(rtn_tbl_get_parameter_name(v_chk.rec))), v_rec, 10);
    v_chk=rtn_ptrplus1(v_chk, 9);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 9);
  delptr(&v_chk, 9);
  delptr(&v_del, 9);
}
 
 
struct pointer rtn_tbl_update_parameter(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 9, 1);
  newptr(&v_del, 9, 1);
  v_del=rtn_getrecptr(v_rec, 6);
  v_new=rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_del.rec), rtn_tbl_get_parameter_order(v_del.rec));
  rtn_deleteindex(v_new, 9);
  rtn_deleteindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_del.rec), scpy(rtn_tbl_get_parameter_name(v_del.rec))), 10);
  rtn_deleterecord(v_rec, 6);
  rtn_addindex(rtn_tbl_search_parameter(rtn_tbl_get_parameter_routine(v_new.rec), rtn_tbl_get_parameter_order(v_new.rec)), rtn_getrec(v_new, 9), 9);
  rtn_addindex(rtn_tbl_search_parametername(rtn_tbl_get_parameter_routine(v_new.rec), scpy(rtn_tbl_get_parameter_name(v_new.rec))), rtn_getrec(v_new, 9), 10);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 6);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("update parameter:"), get_int(rtn_tbl_get_parameter_routine(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_parameter_order(v_new.rec)))), "|"), rtn_tbl_get_parameter_name(v_new.rec)), "|"), rtn_tbl_get_parameter_type(v_new.rec)), "|"), rtn_tbl_get_parameter_data(v_new.rec)), "|"), rtn_tbl_get_parameter_code(v_new.rec)), "|"), rtn_tbl_get_parameter_defaultvalue(v_new.rec)), "|"), rtn_tbl_get_parameter_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 9);
  delptr(&v_del, 9);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 9);
  delptr(&v_del, 9);
}
 
 
void rtn_tbl_clear_parameter() {
  
  long int r=0;
  long int branch;
  while (r < u_table[6].len) {
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+8)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+8)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+8)=0;}
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+12)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+12)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+12)=0;}
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+16)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+16)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+16)=0;}
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+20)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+20)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+20)=0;}
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+24)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+24)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+24)=0;}
    if (*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+28)!=0) {free(*(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+28)); *(char**)(u_table[6].ptr[r/250]+(r%250)*u_table[6].size+28)=0;}
    r++;
  }
  free(u_table[6].ptr);
  u_table[6].ptr=0;
  u_table[6].len=0;
  for(branch=0; branch < u_index[9].scale; branch++)
  { free(u_index[9].ptr[branch]);
  }
  free(u_index[9].len);
  free(u_index[9].ptr);
  u_index[9].scale=0;
  u_index[9].len=0;
  u_index[9].ptr=0;
  for(branch=0; branch < u_index[10].scale; branch++)
  { free(u_index[10].ptr[branch]);
  }
  free(u_index[10].len);
  free(u_index[10].ptr);
  u_index[10].scale=0;
  u_index[10].len=0;
  u_index[10].ptr=0;
  fprintf(v_log, "clear parameter(6)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_parameter() {
  
  return u_table[6].len;
}
 
void rtn_tbl_init_parameter() {
  
  u_table[6].len=0;
  u_table[6].size=32;
  u_table[6].ptr=0;
  u_index[9].tbl=6;
  u_index[9].scale=0;
  u_index[9].len=0;
  u_index[9].ptr=0;
  u_index[9].ptrs=0;
  u_index[9].padm=0;
  u_index[10].tbl=6;
  u_index[10].scale=0;
  u_index[10].len=0;
  u_index[10].ptr=0;
  u_index[10].ptrs=0;
  u_index[10].padm=0;
}
 
void rtn_tbl_write_parameter(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 9, 0);
  rtn_write(rtn_tbl_get_parameter_routine(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_parameter_order(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_name(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_data(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_code(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_defaultvalue(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_parameter_use(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 9);
}
 
 
struct pointer rtn_tbl_read_parameter(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 9, 0);
  v_new=rtn_addrecord(6);
  rtn_tbl_put_parameter_routine(v_new.rec, null);
  rtn_tbl_put_parameter_order(v_new.rec, 0);
  rtn_tbl_put_parameter_name(v_new.rec, 0);
  rtn_tbl_put_parameter_type(v_new.rec, 0);
  rtn_tbl_put_parameter_data(v_new.rec, 0);
  rtn_tbl_put_parameter_code(v_new.rec, 0);
  rtn_tbl_put_parameter_defaultvalue(v_new.rec, 0);
  rtn_tbl_put_parameter_use(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_parameter_routine(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_parameter_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_parameter_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_parameter_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_parameter_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_parameter_code(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_parameter_defaultvalue(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_parameter_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_parameter(v_new);
  v_dbstate=0;
  delptr(&v_new, 9);
  return v_new;
  delptr(&v_new, 9);
}
 
 
char *rtn_tbl_get_extracode_keyword(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) return 0;
  return *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+0);
}
 
void rtn_tbl_put_extracode_keyword(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in filling field extracode.keyword\n");
    return;
  }
  *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+0)=v_val;
}
 
void rtn_tbl_add_extracode_keyword(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in adding to field extracode.keyword\n");
    return;
  }
  *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+0)= 
  sadd(*(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+0), v_val);
}
 
long int rtn_tbl_get_extracode_level(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) return null;
  return *(long int*)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+4);
}
 
void rtn_tbl_put_extracode_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in filling field extracode.level\n");
    return;
  }
  *(long int*)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+4)=v_val;
}
 
void rtn_tbl_add_extracode_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in adding to field extracode.level\n");
    return;
  }
  *(long int*)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+4)+=v_val;
}
 
void rtn_tbl_sub_extracode_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("Error in subtraction from field extracode.level\n");
    return;
  }
  *(long int*)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+4)-=v_val;
}
 
char *rtn_tbl_get_extracode_code(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) return 0;
  return *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+8);
}
 
void rtn_tbl_put_extracode_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in filling field extracode.code\n");
    return;
  }
  *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+8)=v_val;
}
 
void rtn_tbl_add_extracode_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[7].len) {
    printf("error in adding to field extracode.code\n");
    return;
  }
  *(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+8)= 
  sadd(*(char**)(u_table[7].ptr[v_rec/250]+(v_rec%250)*u_table[7].size+8), v_val);
}
 
struct pointer rtn_tbl_search_extracode(char *v_p_keyword, long int v_p_level) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 11, 1);
  newptr(&v_ptr, 11, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(11)+1);
    v_idx=rtn_getpointer(v_curr, 0, 11);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_keyword, rtn_tbl_get_extracode_keyword(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_level, rtn_tbl_get_extracode_level(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(11);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 11)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 11);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_keyword, rtn_tbl_get_extracode_keyword(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_level, rtn_tbl_get_extracode_level(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 11);
  }
  if (v_p_keyword!=0) {free(v_p_keyword); v_p_keyword=0;}
  delptr(&v_idx, 11);
  delptr(&v_ptr, 11);
  return v_ptr;
  if (v_p_keyword!=0) {free(v_p_keyword); v_p_keyword=0;}
  delptr(&v_idx, 11);
  delptr(&v_ptr, 11);
}
 
 
struct pointer rtn_tbl_add_extracode(struct pointer v_new) {
  struct pointer v_idx_extracode={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_extracode, 11, 1);
  newptr(&v_last, 11, 1);
  v_idx_extracode=rtn_tbl_search_extracode(scpy(rtn_tbl_get_extracode_keyword(v_new.rec)), rtn_tbl_get_extracode_level(v_new.rec));
  if (v_idx_extracode.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(11), rtn_maxleaf(rtn_maxbranch(11), 11), 11);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_extracode, 11);
  }
  rtn_addindex(v_idx_extracode, rtn_tablelen(7)-1, 11);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(scon(scpy("add extracode(7):"), rtn_tbl_get_extracode_keyword(v_new.rec)), "|"), get_int(rtn_tbl_get_extracode_level(v_new.rec))), "|"), rtn_tbl_get_extracode_code(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 11);
    delptr(&v_idx_extracode, 11);
    delptr(&v_last, 11);
    return rtn_getpointer(0, 0, 11);
  }
  delptr(&v_new, 11);
  delptr(&v_idx_extracode, 11);
  delptr(&v_last, 11);
  return rtn_ptrplus1(v_last, 11);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 11);
  delptr(&v_idx_extracode, 11);
  delptr(&v_last, 11);
}
 
 
void rtn_tbl_delete_extracode(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 11, 1);
  newptr(&v_chk, 11, 1);
  newptr(&v_del, 11, 1);
  v_del=rtn_getrecptr(v_delrec, 7);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(scon(scpy("delete extracode(7):"), rtn_tbl_get_extracode_keyword(v_del.rec)), "|"), get_int(rtn_tbl_get_extracode_level(v_del.rec))), "|"), rtn_tbl_get_extracode_code(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_extracode(scpy(rtn_tbl_get_extracode_keyword(v_del.rec)), rtn_tbl_get_extracode_level(v_del.rec));
  rtn_deleteindex(v_chk, 11);
  rtn_tbl_put_extracode_keyword(v_del.rec, 0);
  rtn_tbl_put_extracode_code(v_del.rec, 0);
  if (rtn_getrec(v_del, 7)!=rtn_tablelen(7)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(7)-1, 11);
    rtn_changeindex(rtn_tbl_search_extracode(scpy(rtn_tbl_get_extracode_keyword(v_last.rec)), rtn_tbl_get_extracode_level(v_last.rec)), v_delrec, 11);
  }
  rtn_deleterecord(v_delrec, 7);
  if (v_chk.branch==-1) {
    delptr(&v_last, 11);
    delptr(&v_chk, 11);
    delptr(&v_del, 11);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 11);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 11);
  delptr(&v_chk, 11);
  delptr(&v_del, 11);
}
 
 
struct pointer rtn_tbl_update_extracode(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 11, 1);
  newptr(&v_del, 11, 1);
  v_del=rtn_getrecptr(v_rec, 7);
  v_new=rtn_tbl_search_extracode(scpy(rtn_tbl_get_extracode_keyword(v_del.rec)), rtn_tbl_get_extracode_level(v_del.rec));
  rtn_deleteindex(v_new, 11);
  rtn_deleterecord(v_rec, 7);
  rtn_addindex(rtn_tbl_search_extracode(scpy(rtn_tbl_get_extracode_keyword(v_new.rec)), rtn_tbl_get_extracode_level(v_new.rec)), rtn_getrec(v_new, 11), 11);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 7);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(scon(scpy("update extracode:"), rtn_tbl_get_extracode_keyword(v_new.rec)), "|"), get_int(rtn_tbl_get_extracode_level(v_new.rec))), "|"), rtn_tbl_get_extracode_code(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 11);
  delptr(&v_del, 11);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 11);
  delptr(&v_del, 11);
}
 
 
void rtn_tbl_clear_extracode() {
  
  long int r=0;
  long int branch;
  while (r < u_table[7].len) {
    if (*(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+0)!=0) {free(*(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+0)); *(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+0)=0;}
    if (*(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+8)!=0) {free(*(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+8)); *(char**)(u_table[7].ptr[r/250]+(r%250)*u_table[7].size+8)=0;}
    r++;
  }
  free(u_table[7].ptr);
  u_table[7].ptr=0;
  u_table[7].len=0;
  for(branch=0; branch < u_index[11].scale; branch++)
  { free(u_index[11].ptr[branch]);
  }
  free(u_index[11].len);
  free(u_index[11].ptr);
  u_index[11].scale=0;
  u_index[11].len=0;
  u_index[11].ptr=0;
  fprintf(v_log, "clear extracode(7)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_extracode() {
  
  return u_table[7].len;
}
 
void rtn_tbl_init_extracode() {
  
  u_table[7].len=0;
  u_table[7].size=12;
  u_table[7].ptr=0;
  u_index[11].tbl=7;
  u_index[11].scale=0;
  u_index[11].len=0;
  u_index[11].ptr=0;
  u_index[11].ptrs=0;
  u_index[11].padm=0;
}
 
void rtn_tbl_write_extracode(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 11, 0);
  rtn_write(iscan(rtn_tbl_get_extracode_keyword(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_extracode_level(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_extracode_code(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 11);
}
 
 
struct pointer rtn_tbl_read_extracode(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 11, 0);
  v_new=rtn_addrecord(7);
  rtn_tbl_put_extracode_keyword(v_new.rec, 0);
  rtn_tbl_put_extracode_level(v_new.rec, null);
  rtn_tbl_put_extracode_code(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_extracode_keyword(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_extracode_level(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_extracode_code(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_extracode(v_new);
  v_dbstate=0;
  delptr(&v_new, 11);
  return v_new;
  delptr(&v_new, 11);
}
 
 
void rtn_insertextracode(char *v_keyword, long int v_level, char *v_code) {
  struct pointer v_e={-1, -1, -1};
  newptr(&v_e, 11, 0);
  v_e=rtn_addrecord(7);
  rtn_tbl_put_extracode_keyword(v_e.rec, 0);
  rtn_tbl_put_extracode_level(v_e.rec, null);
  rtn_tbl_put_extracode_code(v_e.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_extracode_keyword(v_e.rec, scpy(v_keyword));
  rtn_tbl_put_extracode_level(v_e.rec, v_level);
  rtn_tbl_put_extracode_code(v_e.rec, scpy(v_code));
  v_e=rtn_tbl_add_extracode(v_e);
  v_dbstate=0;
  if (v_keyword!=0) {free(v_keyword); v_keyword=0;}
  if (v_code!=0) {free(v_code); v_code=0;}
  delptr(&v_e, 11);
}
 
FILE *v_logfile=0;
long int v_errnr=0;
char *v_errormsg=0;
char *v_cmodule=0;
 
void rtn_error(char *v_message) {
  char *var1=0;
  if (v_errormsg==0) {
    v_errormsg=snew(v_errormsg, scpy(v_message));
  }
  swrite((var1=snew(var1, scon(scpy("Error: "), v_message))), stdout); wline(stdout);
  if (var1!=0) {free(var1); var1=0;}
  if (v_message!=0) {free(v_message); v_message=0;}
}
 
 
char rtn_is_keyword(char *v_check) {
  
 int t;
 if (v_check==0) return 0;
 if (isdigit(v_check[0])) return 0;
 for(t=0; t< strlen(v_check); t++)
   if (!isalnum(v_check[t]) && v_check[t]!='_')
     return 0;
 return 1;
}
 
void rtn_startlog(char *v_file) {
  char *var1=0;
  v_logfile=rtn_create(v_file);
  swrite((var1=snew(var1, sadd(sadd(scon(sadd(sadd(rtn_tag("HTML"), rtn_tag("BODY")), rtn_tag("H1")), "Logfile"), rtn_tag("/H1")), rtn_tag("br")))), v_logfile); wline(v_logfile);
  rtn_flush(v_logfile);
  if (var1!=0) {free(var1); var1=0;}
  if (v_file!=0) {free(v_file); v_file=0;}
}
 
 
void rtn_puterror(char *v_message) {
  char *var1=0;
  char *var2=0;
  v_errnr+=1;
  if (v_errormsg==0) {
    v_errormsg=snew(v_errormsg, scpy(v_message));
  }
  rtn_scanmessage(sadd(scpy("err"), get_int(v_errnr)), scpy("Error"), scpy(v_message));
  swrite((var2=snew(var2, sadd(sadd(sadd(sadd(scon(scon(scon(sadd(scpy("Error "), get_int(v_errnr)), " in "), v_cmodule), ": "), rtn_tag((var1=snew(var1, scon(sadd(scon(scon(scpy("a href=\""), v_cmodule), ".u.html#err"), get_int(v_errnr)), "\""))))), rtn_notag(v_message)), rtn_tag("/a")), rtn_tag("br")))), v_logfile); wline(v_logfile);
  rtn_flush(v_logfile);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  if (v_message!=0) {free(v_message); v_message=0;}
}
 
 
void rtn_putwarning(char *v_message) {
  char *var1=0;
  char *var2=0;
  v_errnr+=1;
  rtn_scanmessage(sadd(scpy("warn"), get_int(v_errnr)), scpy("Warning"), scpy(v_message));
  swrite((var2=snew(var2, sadd(sadd(sadd(sadd(scon(scon(scon(sadd(scpy("Warning "), get_int(v_errnr)), " in "), v_cmodule), ": "), rtn_tag((var1=snew(var1, scon(sadd(scon(scon(scpy("a href=\""), v_cmodule), ".u.html#warn"), get_int(v_errnr)), "\""))))), rtn_notag(v_message)), rtn_tag("/a")), rtn_tag("br")))), v_logfile); wline(v_logfile);
  rtn_flush(v_logfile);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  if (v_message!=0) {free(v_message); v_message=0;}
}
 
 
long int rtn_tbl_get_table_table(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return 0;
  return *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+0);
}
 
void rtn_tbl_put_table_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.table\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+0)=v_val;
}
 
void rtn_tbl_add_table_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.table\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+0)+=v_val;
}
 
void rtn_tbl_sub_table_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("Error in subtraction from field table.table\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+0)-=v_val;
}
 
char *rtn_tbl_get_table_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return 0;
  return *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+4);
}
 
void rtn_tbl_put_table_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.name\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+4)=v_val;
}
 
void rtn_tbl_add_table_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.name\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+4)= 
  sadd(*(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+4), v_val);
}
 
int rtn_tbl_get_table_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return -1;
  return *(int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+8);
}
 
void rtn_tbl_put_table_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.kind\n");
    return;
  }
  *(int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+8)=v_val;
}
 
void rtn_tbl_add_table_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.kind\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+8)+=v_val;
}
 
void rtn_tbl_sub_table_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("Error in subtraction from field table.kind\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+8)-=v_val;
}
 
char *rtn_tbl_get_table_module(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return 0;
  return *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+12);
}
 
void rtn_tbl_put_table_module(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.module\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+12)=v_val;
}
 
void rtn_tbl_add_table_module(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.module\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+12)= 
  sadd(*(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+12), v_val);
}
 
char *rtn_tbl_get_table_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return 0;
  return *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+16);
}
 
void rtn_tbl_put_table_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.use\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+16)=v_val;
}
 
void rtn_tbl_add_table_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.use\n");
    return;
  }
  *(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+16)= 
  sadd(*(char**)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+16), v_val);
}
 
long int rtn_tbl_get_table_size(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) return null;
  return *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+20);
}
 
void rtn_tbl_put_table_size(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in filling field table.size\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+20)=v_val;
}
 
void rtn_tbl_add_table_size(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("error in adding to field table.size\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+20)+=v_val;
}
 
void rtn_tbl_sub_table_size(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[8].len) {
    printf("Error in subtraction from field table.size\n");
    return;
  }
  *(long int*)(u_table[8].ptr[v_rec/250]+(v_rec%250)*u_table[8].size+20)-=v_val;
}
 
struct pointer rtn_tbl_search_table(long int v_p_table) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 12, 1);
  newptr(&v_ptr, 12, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(12)+1);
    v_idx=rtn_getpointer(v_curr, 0, 12);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_table_table(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(12);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 12)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 12);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_table_table(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 12);
  }
  delptr(&v_idx, 12);
  delptr(&v_ptr, 12);
  return v_ptr;
  delptr(&v_idx, 12);
  delptr(&v_ptr, 12);
}
 
 
struct pointer rtn_tbl_search_tablename(char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 13, 1);
  newptr(&v_ptr, 13, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(13)+1);
    v_idx=rtn_getpointer(v_curr, 0, 13);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_table_name(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(13);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 13)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 13);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_table_name(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 13);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 13);
  delptr(&v_ptr, 13);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 13);
  delptr(&v_ptr, 13);
}
 
 
struct pointer rtn_tbl_add_table(struct pointer v_new) {
  struct pointer v_idx_table={-1, -1, -1};
  struct pointer v_idx_tablename={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_table, 12, 1);
  newptr(&v_idx_tablename, 13, 1);
  newptr(&v_last, 12, 1);
  rtn_tbl_put_table_table(v_new.rec, 999999999);
  v_idx_table=rtn_tbl_search_table(rtn_tbl_get_table_table(v_new.rec));
  if (v_idx_table.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(12), rtn_maxleaf(rtn_maxbranch(12), 12), 12);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_table, 12);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_table_table(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_table_table(v_new.rec, rtn_tbl_get_table_table(v_last.rec)+1);
  }
  v_idx_tablename=rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_new.rec)));
  rtn_addindex(v_idx_table, rtn_tablelen(8)-1, 12);
  rtn_addindex(v_idx_tablename, rtn_tablelen(8)-1, 13);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scon(sadd(scpy("add table(8):"), scpy(get_sort(rtn_tbl_get_table_table(v_new.rec)))), "|"), rtn_tbl_get_table_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_table_kind(v_new.rec), "public local")), "|"), rtn_tbl_get_table_module(v_new.rec)), "|"), rtn_tbl_get_table_use(v_new.rec)), "|"), get_int(rtn_tbl_get_table_size(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 12);
    delptr(&v_idx_table, 12);
    delptr(&v_idx_tablename, 13);
    delptr(&v_last, 12);
    return rtn_getpointer(0, 0, 12);
  }
  delptr(&v_new, 12);
  delptr(&v_idx_table, 12);
  delptr(&v_idx_tablename, 13);
  delptr(&v_last, 12);
  return rtn_ptrplus1(v_last, 12);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 12);
  delptr(&v_idx_table, 12);
  delptr(&v_idx_tablename, 13);
  delptr(&v_last, 12);
}
 
 
void rtn_tbl_delete_table(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 12, 1);
  newptr(&v_chk, 12, 1);
  newptr(&v_del, 12, 1);
  v_del=rtn_getrecptr(v_delrec, 8);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scon(sadd(scpy("delete table(8):"), scpy(get_sort(rtn_tbl_get_table_table(v_del.rec)))), "|"), rtn_tbl_get_table_name(v_del.rec)), "|"), get_enum(rtn_tbl_get_table_kind(v_del.rec), "public local")), "|"), rtn_tbl_get_table_module(v_del.rec)), "|"), rtn_tbl_get_table_use(v_del.rec)), "|"), get_int(rtn_tbl_get_table_size(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_table(rtn_tbl_get_table_table(v_del.rec));
  rtn_deleteindex(v_chk, 12);
  v_chk=rtn_tbl_search_table(rtn_tbl_get_table_table(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_del.rec))), 13);
  rtn_tbl_put_table_name(v_del.rec, 0);
  rtn_tbl_put_table_module(v_del.rec, 0);
  rtn_tbl_put_table_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 8)!=rtn_tablelen(8)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(8)-1, 12);
    rtn_changeindex(rtn_tbl_search_table(rtn_tbl_get_table_table(v_last.rec)), v_delrec, 12);
    rtn_changeindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_last.rec))), v_delrec, 13);
  }
  rtn_deleterecord(v_delrec, 8);
  if (v_chk.branch==-1) {
    delptr(&v_last, 12);
    delptr(&v_chk, 12);
    delptr(&v_del, 12);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 12);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_table_table(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 8);
    rtn_deleteindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_chk.rec))), 13);
    rtn_tbl_sub_table_table(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_chk.rec))), v_rec, 13);
    v_chk=rtn_ptrplus1(v_chk, 12);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 12);
  delptr(&v_chk, 12);
  delptr(&v_del, 12);
}
 
 
struct pointer rtn_tbl_update_table(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 12, 1);
  newptr(&v_del, 12, 1);
  v_del=rtn_getrecptr(v_rec, 8);
  v_new=rtn_tbl_search_table(rtn_tbl_get_table_table(v_del.rec));
  rtn_deleteindex(v_new, 12);
  rtn_deleteindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_del.rec))), 13);
  rtn_deleterecord(v_rec, 8);
  rtn_addindex(rtn_tbl_search_table(rtn_tbl_get_table_table(v_new.rec)), rtn_getrec(v_new, 12), 12);
  rtn_addindex(rtn_tbl_search_tablename(scpy(rtn_tbl_get_table_name(v_new.rec))), rtn_getrec(v_new, 12), 13);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 8);
  }
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scon(sadd(scpy("update table:"), scpy(get_sort(rtn_tbl_get_table_table(v_new.rec)))), "|"), rtn_tbl_get_table_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_table_kind(v_new.rec), "public local")), "|"), rtn_tbl_get_table_module(v_new.rec)), "|"), rtn_tbl_get_table_use(v_new.rec)), "|"), get_int(rtn_tbl_get_table_size(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 12);
  delptr(&v_del, 12);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 12);
  delptr(&v_del, 12);
}
 
 
void rtn_tbl_clear_table() {
  
  long int r=0;
  long int branch;
  while (r < u_table[8].len) {
    if (*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+4)!=0) {free(*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+4)); *(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+4)=0;}
    if (*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+12)!=0) {free(*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+12)); *(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+12)=0;}
    if (*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+16)!=0) {free(*(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+16)); *(char**)(u_table[8].ptr[r/250]+(r%250)*u_table[8].size+16)=0;}
    r++;
  }
  free(u_table[8].ptr);
  u_table[8].ptr=0;
  u_table[8].len=0;
  for(branch=0; branch < u_index[12].scale; branch++)
  { free(u_index[12].ptr[branch]);
  }
  free(u_index[12].len);
  free(u_index[12].ptr);
  u_index[12].scale=0;
  u_index[12].len=0;
  u_index[12].ptr=0;
  for(branch=0; branch < u_index[13].scale; branch++)
  { free(u_index[13].ptr[branch]);
  }
  free(u_index[13].len);
  free(u_index[13].ptr);
  u_index[13].scale=0;
  u_index[13].len=0;
  u_index[13].ptr=0;
  fprintf(v_log, "clear table(8)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_table() {
  
  return u_table[8].len;
}
 
void rtn_tbl_init_table() {
  
  u_table[8].len=0;
  u_table[8].size=24;
  u_table[8].ptr=0;
  u_index[12].tbl=8;
  u_index[12].scale=0;
  u_index[12].len=0;
  u_index[12].ptr=0;
  u_index[12].ptrs=0;
  u_index[12].padm=0;
  u_index[13].tbl=8;
  u_index[13].scale=0;
  u_index[13].len=0;
  u_index[13].ptr=0;
  u_index[13].ptrs=0;
  u_index[13].padm=0;
}
 
void rtn_tbl_write_table(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 12, 0);
  rtn_write(rtn_tbl_get_table_table(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_table_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_table_kind(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_table_module(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_table_use(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_table_size(v_ptr.rec), v_stream);
  delptr(&v_ptr, 12);
}
 
 
struct pointer rtn_tbl_read_table(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 12, 0);
  v_new=rtn_addrecord(8);
  rtn_tbl_put_table_table(v_new.rec, 0);
  rtn_tbl_put_table_name(v_new.rec, 0);
  rtn_tbl_put_table_kind(v_new.rec, -1);
  rtn_tbl_put_table_module(v_new.rec, 0);
  rtn_tbl_put_table_use(v_new.rec, 0);
  rtn_tbl_put_table_size(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_table_table(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_table_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_table_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_table_module(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_table_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_table_size(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_table(v_new);
  v_dbstate=0;
  delptr(&v_new, 12);
  return v_new;
  delptr(&v_new, 12);
}
 
 
long int rtn_tbl_get_field_table(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return null;
  return *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+0);
}
 
void rtn_tbl_put_field_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.table\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+0)=v_val;
}
 
void rtn_tbl_add_field_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.table\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+0)+=v_val;
}
 
void rtn_tbl_sub_field_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("Error in subtraction from field field.table\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+0)-=v_val;
}
 
long int rtn_tbl_get_field_field(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+4);
}
 
void rtn_tbl_put_field_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.field\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+4)=v_val;
}
 
void rtn_tbl_add_field_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.field\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+4)+=v_val;
}
 
void rtn_tbl_sub_field_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("Error in subtraction from field field.field\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+4)-=v_val;
}
 
char *rtn_tbl_get_field_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+8);
}
 
void rtn_tbl_put_field_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.name\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+8)=v_val;
}
 
void rtn_tbl_add_field_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.name\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+8)= 
  sadd(*(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+8), v_val);
}
 
char *rtn_tbl_get_field_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+12);
}
 
void rtn_tbl_put_field_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.type\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+12)=v_val;
}
 
void rtn_tbl_add_field_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.type\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+12)= 
  sadd(*(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+12), v_val);
}
 
char *rtn_tbl_get_field_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+16);
}
 
void rtn_tbl_put_field_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.data\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+16)=v_val;
}
 
void rtn_tbl_add_field_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.data\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+16)= 
  sadd(*(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+16), v_val);
}
 
char *rtn_tbl_get_field_dflt(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+20);
}
 
void rtn_tbl_put_field_dflt(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.dflt\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+20)=v_val;
}
 
void rtn_tbl_add_field_dflt(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.dflt\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+20)= 
  sadd(*(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+20), v_val);
}
 
char *rtn_tbl_get_field_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return 0;
  return *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+24);
}
 
void rtn_tbl_put_field_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.use\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+24)=v_val;
}
 
void rtn_tbl_add_field_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.use\n");
    return;
  }
  *(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+24)= 
  sadd(*(char**)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+24), v_val);
}
 
long int rtn_tbl_get_field_position(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) return null;
  return *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+28);
}
 
void rtn_tbl_put_field_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in filling field field.position\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+28)=v_val;
}
 
void rtn_tbl_add_field_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("error in adding to field field.position\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+28)+=v_val;
}
 
void rtn_tbl_sub_field_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[9].len) {
    printf("Error in subtraction from field field.position\n");
    return;
  }
  *(long int*)(u_table[9].ptr[v_rec/250]+(v_rec%250)*u_table[9].size+28)-=v_val;
}
 
struct pointer rtn_tbl_search_field(long int v_p_table, long int v_p_field) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 14, 1);
  newptr(&v_ptr, 14, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(14)+1);
    v_idx=rtn_getpointer(v_curr, 0, 14);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_field_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_field, rtn_tbl_get_field_field(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(14);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 14)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 14);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_field_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_field, rtn_tbl_get_field_field(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 14);
  }
  delptr(&v_idx, 14);
  delptr(&v_ptr, 14);
  return v_ptr;
  delptr(&v_idx, 14);
  delptr(&v_ptr, 14);
}
 
 
struct pointer rtn_tbl_search_fieldname(long int v_p_table, char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 15, 1);
  newptr(&v_ptr, 15, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(15)+1);
    v_idx=rtn_getpointer(v_curr, 0, 15);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_field_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_name, rtn_tbl_get_field_name(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(15);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 15)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 15);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_field_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_name, rtn_tbl_get_field_name(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 15);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 15);
  delptr(&v_ptr, 15);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 15);
  delptr(&v_ptr, 15);
}
 
 
struct pointer rtn_tbl_add_field(struct pointer v_new) {
  struct pointer v_idx_field={-1, -1, -1};
  struct pointer v_idx_fieldname={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_field, 14, 1);
  newptr(&v_idx_fieldname, 15, 1);
  newptr(&v_last, 14, 1);
  rtn_tbl_put_field_field(v_new.rec, 999999999);
  v_idx_field=rtn_tbl_search_field(rtn_tbl_get_field_table(v_new.rec), rtn_tbl_get_field_field(v_new.rec));
  if (v_idx_field.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(14), rtn_maxleaf(rtn_maxbranch(14), 14), 14);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_field, 14);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_field_table(v_last.rec)!=rtn_tbl_get_field_table(v_new.rec))) {
    rtn_tbl_put_field_field(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_field_field(v_new.rec, rtn_tbl_get_field_field(v_last.rec)+1);
  }
  v_idx_fieldname=rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_new.rec), scpy(rtn_tbl_get_field_name(v_new.rec)));
  rtn_addindex(v_idx_field, rtn_tablelen(9)-1, 14);
  rtn_addindex(v_idx_fieldname, rtn_tablelen(9)-1, 15);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("add field(9):"), get_int(rtn_tbl_get_field_table(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_field_field(v_new.rec)))), "|"), rtn_tbl_get_field_name(v_new.rec)), "|"), rtn_tbl_get_field_type(v_new.rec)), "|"), rtn_tbl_get_field_data(v_new.rec)), "|"), rtn_tbl_get_field_dflt(v_new.rec)), "|"), rtn_tbl_get_field_use(v_new.rec)), "|"), get_int(rtn_tbl_get_field_position(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 14);
    delptr(&v_idx_field, 14);
    delptr(&v_idx_fieldname, 15);
    delptr(&v_last, 14);
    return rtn_getpointer(0, 0, 14);
  }
  delptr(&v_new, 14);
  delptr(&v_idx_field, 14);
  delptr(&v_idx_fieldname, 15);
  delptr(&v_last, 14);
  return rtn_ptrplus1(v_last, 14);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 14);
  delptr(&v_idx_field, 14);
  delptr(&v_idx_fieldname, 15);
  delptr(&v_last, 14);
}
 
 
void rtn_tbl_delete_field(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 14, 1);
  newptr(&v_chk, 14, 1);
  newptr(&v_del, 14, 1);
  v_del=rtn_getrecptr(v_delrec, 9);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("delete field(9):"), get_int(rtn_tbl_get_field_table(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_field_field(v_del.rec)))), "|"), rtn_tbl_get_field_name(v_del.rec)), "|"), rtn_tbl_get_field_type(v_del.rec)), "|"), rtn_tbl_get_field_data(v_del.rec)), "|"), rtn_tbl_get_field_dflt(v_del.rec)), "|"), rtn_tbl_get_field_use(v_del.rec)), "|"), get_int(rtn_tbl_get_field_position(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_field(rtn_tbl_get_field_table(v_del.rec), rtn_tbl_get_field_field(v_del.rec));
  rtn_deleteindex(v_chk, 14);
  v_chk=rtn_tbl_search_field(rtn_tbl_get_field_table(v_del.rec), rtn_tbl_get_field_field(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_del.rec), scpy(rtn_tbl_get_field_name(v_del.rec))), 15);
  rtn_tbl_put_field_name(v_del.rec, 0);
  rtn_tbl_put_field_type(v_del.rec, 0);
  rtn_tbl_put_field_data(v_del.rec, 0);
  rtn_tbl_put_field_dflt(v_del.rec, 0);
  rtn_tbl_put_field_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 9)!=rtn_tablelen(9)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(9)-1, 14);
    rtn_changeindex(rtn_tbl_search_field(rtn_tbl_get_field_table(v_last.rec), rtn_tbl_get_field_field(v_last.rec)), v_delrec, 14);
    rtn_changeindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_last.rec), scpy(rtn_tbl_get_field_name(v_last.rec))), v_delrec, 15);
  }
  rtn_deleterecord(v_delrec, 9);
  if (v_chk.branch==-1) {
    delptr(&v_last, 14);
    delptr(&v_chk, 14);
    delptr(&v_del, 14);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 14);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_field_field(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 9);
    rtn_deleteindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_chk.rec), scpy(rtn_tbl_get_field_name(v_chk.rec))), 15);
    rtn_tbl_sub_field_field(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_chk.rec), scpy(rtn_tbl_get_field_name(v_chk.rec))), v_rec, 15);
    v_chk=rtn_ptrplus1(v_chk, 14);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 14);
  delptr(&v_chk, 14);
  delptr(&v_del, 14);
}
 
 
struct pointer rtn_tbl_update_field(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 14, 1);
  newptr(&v_del, 14, 1);
  v_del=rtn_getrecptr(v_rec, 9);
  v_new=rtn_tbl_search_field(rtn_tbl_get_field_table(v_del.rec), rtn_tbl_get_field_field(v_del.rec));
  rtn_deleteindex(v_new, 14);
  rtn_deleteindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_del.rec), scpy(rtn_tbl_get_field_name(v_del.rec))), 15);
  rtn_deleterecord(v_rec, 9);
  rtn_addindex(rtn_tbl_search_field(rtn_tbl_get_field_table(v_new.rec), rtn_tbl_get_field_field(v_new.rec)), rtn_getrec(v_new, 14), 14);
  rtn_addindex(rtn_tbl_search_fieldname(rtn_tbl_get_field_table(v_new.rec), scpy(rtn_tbl_get_field_name(v_new.rec))), rtn_getrec(v_new, 14), 15);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 9);
  }
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("update field:"), get_int(rtn_tbl_get_field_table(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_field_field(v_new.rec)))), "|"), rtn_tbl_get_field_name(v_new.rec)), "|"), rtn_tbl_get_field_type(v_new.rec)), "|"), rtn_tbl_get_field_data(v_new.rec)), "|"), rtn_tbl_get_field_dflt(v_new.rec)), "|"), rtn_tbl_get_field_use(v_new.rec)), "|"), get_int(rtn_tbl_get_field_position(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 14);
  delptr(&v_del, 14);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 14);
  delptr(&v_del, 14);
}
 
 
void rtn_tbl_clear_field() {
  
  long int r=0;
  long int branch;
  while (r < u_table[9].len) {
    if (*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+8)!=0) {free(*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+8)); *(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+8)=0;}
    if (*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+12)!=0) {free(*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+12)); *(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+12)=0;}
    if (*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+16)!=0) {free(*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+16)); *(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+16)=0;}
    if (*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+20)!=0) {free(*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+20)); *(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+20)=0;}
    if (*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+24)!=0) {free(*(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+24)); *(char**)(u_table[9].ptr[r/250]+(r%250)*u_table[9].size+24)=0;}
    r++;
  }
  free(u_table[9].ptr);
  u_table[9].ptr=0;
  u_table[9].len=0;
  for(branch=0; branch < u_index[14].scale; branch++)
  { free(u_index[14].ptr[branch]);
  }
  free(u_index[14].len);
  free(u_index[14].ptr);
  u_index[14].scale=0;
  u_index[14].len=0;
  u_index[14].ptr=0;
  for(branch=0; branch < u_index[15].scale; branch++)
  { free(u_index[15].ptr[branch]);
  }
  free(u_index[15].len);
  free(u_index[15].ptr);
  u_index[15].scale=0;
  u_index[15].len=0;
  u_index[15].ptr=0;
  fprintf(v_log, "clear field(9)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_field() {
  
  return u_table[9].len;
}
 
void rtn_tbl_init_field() {
  
  u_table[9].len=0;
  u_table[9].size=32;
  u_table[9].ptr=0;
  u_index[14].tbl=9;
  u_index[14].scale=0;
  u_index[14].len=0;
  u_index[14].ptr=0;
  u_index[14].ptrs=0;
  u_index[14].padm=0;
  u_index[15].tbl=9;
  u_index[15].scale=0;
  u_index[15].len=0;
  u_index[15].ptr=0;
  u_index[15].ptrs=0;
  u_index[15].padm=0;
}
 
void rtn_tbl_write_field(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 14, 0);
  rtn_write(rtn_tbl_get_field_table(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_field_field(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_field_name(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_field_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_field_data(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_field_dflt(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_field_use(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_field_position(v_ptr.rec), v_stream);
  delptr(&v_ptr, 14);
}
 
 
struct pointer rtn_tbl_read_field(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 14, 0);
  v_new=rtn_addrecord(9);
  rtn_tbl_put_field_table(v_new.rec, null);
  rtn_tbl_put_field_field(v_new.rec, 0);
  rtn_tbl_put_field_name(v_new.rec, 0);
  rtn_tbl_put_field_type(v_new.rec, 0);
  rtn_tbl_put_field_data(v_new.rec, 0);
  rtn_tbl_put_field_dflt(v_new.rec, 0);
  rtn_tbl_put_field_use(v_new.rec, 0);
  rtn_tbl_put_field_position(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_field_table(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_field_field(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_field_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_field_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_field_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_field_dflt(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_field_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_field_position(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_field(v_new);
  v_dbstate=0;
  delptr(&v_new, 14);
  return v_new;
  delptr(&v_new, 14);
}
 
 
long int rtn_tbl_get_index_index(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return 0;
  return *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+0);
}
 
void rtn_tbl_put_index_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.index\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+0)=v_val;
}
 
void rtn_tbl_add_index_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.index\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+0)+=v_val;
}
 
void rtn_tbl_sub_index_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("Error in subtraction from field index.index\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+0)-=v_val;
}
 
long int rtn_tbl_get_index_table(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return null;
  return *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+4);
}
 
void rtn_tbl_put_index_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.table\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+4)=v_val;
}
 
void rtn_tbl_add_index_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.table\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+4)+=v_val;
}
 
void rtn_tbl_sub_index_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("Error in subtraction from field index.table\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+4)-=v_val;
}
 
char *rtn_tbl_get_index_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return 0;
  return *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+8);
}
 
void rtn_tbl_put_index_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.name\n");
    return;
  }
  *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+8)=v_val;
}
 
void rtn_tbl_add_index_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.name\n");
    return;
  }
  *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+8)= 
  sadd(*(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+8), v_val);
}
 
int rtn_tbl_get_index_unique(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return -1;
  return *(int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+12);
}
 
void rtn_tbl_put_index_unique(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.unique\n");
    return;
  }
  *(int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+12)=v_val;
}
 
void rtn_tbl_add_index_unique(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.unique\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+12)+=v_val;
}
 
void rtn_tbl_sub_index_unique(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("Error in subtraction from field index.unique\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+12)-=v_val;
}
 
int rtn_tbl_get_index_complete(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return -1;
  return *(int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+16);
}
 
void rtn_tbl_put_index_complete(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.complete\n");
    return;
  }
  *(int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+16)=v_val;
}
 
void rtn_tbl_add_index_complete(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.complete\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+16)+=v_val;
}
 
void rtn_tbl_sub_index_complete(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("Error in subtraction from field index.complete\n");
    return;
  }
  *(long int*)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+16)-=v_val;
}
 
char *rtn_tbl_get_index_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) return 0;
  return *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+20);
}
 
void rtn_tbl_put_index_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in filling field index.use\n");
    return;
  }
  *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+20)=v_val;
}
 
void rtn_tbl_add_index_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[10].len) {
    printf("error in adding to field index.use\n");
    return;
  }
  *(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+20)= 
  sadd(*(char**)(u_table[10].ptr[v_rec/250]+(v_rec%250)*u_table[10].size+20), v_val);
}
 
struct pointer rtn_tbl_search_index(long int v_p_index) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 16, 1);
  newptr(&v_ptr, 16, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(16)+1);
    v_idx=rtn_getpointer(v_curr, 0, 16);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_index, rtn_tbl_get_index_index(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(16);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 16)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 16);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_index, rtn_tbl_get_index_index(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 16);
  }
  delptr(&v_idx, 16);
  delptr(&v_ptr, 16);
  return v_ptr;
  delptr(&v_idx, 16);
  delptr(&v_ptr, 16);
}
 
 
struct pointer rtn_tbl_search_indextable(long int v_p_table, long int v_p_index) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 17, 1);
  newptr(&v_ptr, 17, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(17)+1);
    v_idx=rtn_getpointer(v_curr, 0, 17);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_index_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_index, rtn_tbl_get_index_index(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(17);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 17)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 17);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_index_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_index, rtn_tbl_get_index_index(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 17);
  }
  delptr(&v_idx, 17);
  delptr(&v_ptr, 17);
  return v_ptr;
  delptr(&v_idx, 17);
  delptr(&v_ptr, 17);
}
 
 
struct pointer rtn_tbl_search_indexname(char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 18, 1);
  newptr(&v_ptr, 18, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(18)+1);
    v_idx=rtn_getpointer(v_curr, 0, 18);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_index_name(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(18);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 18)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 18);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_index_name(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 18);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 18);
  delptr(&v_ptr, 18);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 18);
  delptr(&v_ptr, 18);
}
 
 
struct pointer rtn_tbl_add_index(struct pointer v_new) {
  struct pointer v_idx_index={-1, -1, -1};
  struct pointer v_idx_indextable={-1, -1, -1};
  struct pointer v_idx_indexname={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_index, 16, 1);
  newptr(&v_idx_indextable, 17, 1);
  newptr(&v_idx_indexname, 18, 1);
  newptr(&v_last, 16, 1);
  rtn_tbl_put_index_index(v_new.rec, 999999999);
  v_idx_index=rtn_tbl_search_index(rtn_tbl_get_index_index(v_new.rec));
  if (v_idx_index.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(16), rtn_maxleaf(rtn_maxbranch(16), 16), 16);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_index, 16);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_index_index(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_index_index(v_new.rec, rtn_tbl_get_index_index(v_last.rec)+1);
  }
  v_idx_indextable=rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_new.rec), rtn_tbl_get_index_index(v_new.rec));
  v_idx_indexname=rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_new.rec)));
  rtn_addindex(v_idx_index, rtn_tablelen(10)-1, 16);
  rtn_addindex(v_idx_indextable, rtn_tablelen(10)-1, 17);
  rtn_addindex(v_idx_indexname, rtn_tablelen(10)-1, 18);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(sadd(scpy("add index(10):"), scpy(get_sort(rtn_tbl_get_index_index(v_new.rec)))), "|"), get_int(rtn_tbl_get_index_table(v_new.rec))), "|"), rtn_tbl_get_index_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_index_unique(v_new.rec), "yes no")), "|"), get_enum(rtn_tbl_get_index_complete(v_new.rec), "yes no")), "|"), rtn_tbl_get_index_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 16);
    delptr(&v_idx_index, 16);
    delptr(&v_idx_indextable, 17);
    delptr(&v_idx_indexname, 18);
    delptr(&v_last, 16);
    return rtn_getpointer(0, 0, 16);
  }
  delptr(&v_new, 16);
  delptr(&v_idx_index, 16);
  delptr(&v_idx_indextable, 17);
  delptr(&v_idx_indexname, 18);
  delptr(&v_last, 16);
  return rtn_ptrplus1(v_last, 16);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 16);
  delptr(&v_idx_index, 16);
  delptr(&v_idx_indextable, 17);
  delptr(&v_idx_indexname, 18);
  delptr(&v_last, 16);
}
 
 
void rtn_tbl_delete_index(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 16, 1);
  newptr(&v_chk, 16, 1);
  newptr(&v_del, 16, 1);
  v_del=rtn_getrecptr(v_delrec, 10);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(sadd(scpy("delete index(10):"), scpy(get_sort(rtn_tbl_get_index_index(v_del.rec)))), "|"), get_int(rtn_tbl_get_index_table(v_del.rec))), "|"), rtn_tbl_get_index_name(v_del.rec)), "|"), get_enum(rtn_tbl_get_index_unique(v_del.rec), "yes no")), "|"), get_enum(rtn_tbl_get_index_complete(v_del.rec), "yes no")), "|"), rtn_tbl_get_index_use(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_index(rtn_tbl_get_index_index(v_del.rec));
  rtn_deleteindex(v_chk, 16);
  v_chk=rtn_tbl_search_index(rtn_tbl_get_index_index(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_del.rec), rtn_tbl_get_index_index(v_del.rec)), 17);
  rtn_deleteindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_del.rec))), 18);
  rtn_tbl_put_index_name(v_del.rec, 0);
  rtn_tbl_put_index_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 10)!=rtn_tablelen(10)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(10)-1, 16);
    rtn_changeindex(rtn_tbl_search_index(rtn_tbl_get_index_index(v_last.rec)), v_delrec, 16);
    rtn_changeindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_last.rec), rtn_tbl_get_index_index(v_last.rec)), v_delrec, 17);
    rtn_changeindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_last.rec))), v_delrec, 18);
  }
  rtn_deleterecord(v_delrec, 10);
  if (v_chk.branch==-1) {
    delptr(&v_last, 16);
    delptr(&v_chk, 16);
    delptr(&v_del, 16);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 16);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_index_index(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 10);
    rtn_deleteindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_chk.rec), rtn_tbl_get_index_index(v_chk.rec)), 17);
    rtn_deleteindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_chk.rec))), 18);
    rtn_tbl_sub_index_index(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_chk.rec), rtn_tbl_get_index_index(v_chk.rec)), v_rec, 17);
    rtn_addindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_chk.rec))), v_rec, 18);
    v_chk=rtn_ptrplus1(v_chk, 16);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 16);
  delptr(&v_chk, 16);
  delptr(&v_del, 16);
}
 
 
struct pointer rtn_tbl_update_index(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 16, 1);
  newptr(&v_del, 16, 1);
  v_del=rtn_getrecptr(v_rec, 10);
  v_new=rtn_tbl_search_index(rtn_tbl_get_index_index(v_del.rec));
  rtn_deleteindex(v_new, 16);
  rtn_deleteindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_del.rec), rtn_tbl_get_index_index(v_del.rec)), 17);
  rtn_deleteindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_del.rec))), 18);
  rtn_deleterecord(v_rec, 10);
  rtn_addindex(rtn_tbl_search_index(rtn_tbl_get_index_index(v_new.rec)), rtn_getrec(v_new, 16), 16);
  rtn_addindex(rtn_tbl_search_indextable(rtn_tbl_get_index_table(v_new.rec), rtn_tbl_get_index_index(v_new.rec)), rtn_getrec(v_new, 16), 17);
  rtn_addindex(rtn_tbl_search_indexname(scpy(rtn_tbl_get_index_name(v_new.rec))), rtn_getrec(v_new, 16), 18);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 10);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(sadd(scpy("update index:"), scpy(get_sort(rtn_tbl_get_index_index(v_new.rec)))), "|"), get_int(rtn_tbl_get_index_table(v_new.rec))), "|"), rtn_tbl_get_index_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_index_unique(v_new.rec), "yes no")), "|"), get_enum(rtn_tbl_get_index_complete(v_new.rec), "yes no")), "|"), rtn_tbl_get_index_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 16);
  delptr(&v_del, 16);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 16);
  delptr(&v_del, 16);
}
 
 
void rtn_tbl_clear_index() {
  
  long int r=0;
  long int branch;
  while (r < u_table[10].len) {
    if (*(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+8)!=0) {free(*(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+8)); *(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+8)=0;}
    if (*(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+20)!=0) {free(*(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+20)); *(char**)(u_table[10].ptr[r/250]+(r%250)*u_table[10].size+20)=0;}
    r++;
  }
  free(u_table[10].ptr);
  u_table[10].ptr=0;
  u_table[10].len=0;
  for(branch=0; branch < u_index[16].scale; branch++)
  { free(u_index[16].ptr[branch]);
  }
  free(u_index[16].len);
  free(u_index[16].ptr);
  u_index[16].scale=0;
  u_index[16].len=0;
  u_index[16].ptr=0;
  for(branch=0; branch < u_index[17].scale; branch++)
  { free(u_index[17].ptr[branch]);
  }
  free(u_index[17].len);
  free(u_index[17].ptr);
  u_index[17].scale=0;
  u_index[17].len=0;
  u_index[17].ptr=0;
  for(branch=0; branch < u_index[18].scale; branch++)
  { free(u_index[18].ptr[branch]);
  }
  free(u_index[18].len);
  free(u_index[18].ptr);
  u_index[18].scale=0;
  u_index[18].len=0;
  u_index[18].ptr=0;
  fprintf(v_log, "clear index(10)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_index() {
  
  return u_table[10].len;
}
 
void rtn_tbl_init_index() {
  
  u_table[10].len=0;
  u_table[10].size=24;
  u_table[10].ptr=0;
  u_index[16].tbl=10;
  u_index[16].scale=0;
  u_index[16].len=0;
  u_index[16].ptr=0;
  u_index[16].ptrs=0;
  u_index[16].padm=0;
  u_index[17].tbl=10;
  u_index[17].scale=0;
  u_index[17].len=0;
  u_index[17].ptr=0;
  u_index[17].ptrs=0;
  u_index[17].padm=0;
  u_index[18].tbl=10;
  u_index[18].scale=0;
  u_index[18].len=0;
  u_index[18].ptr=0;
  u_index[18].ptrs=0;
  u_index[18].padm=0;
}
 
void rtn_tbl_write_index(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 16, 0);
  rtn_write(rtn_tbl_get_index_index(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_index_table(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_index_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_index_unique(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_index_complete(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_index_use(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 16);
}
 
 
struct pointer rtn_tbl_read_index(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 16, 0);
  v_new=rtn_addrecord(10);
  rtn_tbl_put_index_index(v_new.rec, 0);
  rtn_tbl_put_index_table(v_new.rec, null);
  rtn_tbl_put_index_name(v_new.rec, 0);
  rtn_tbl_put_index_unique(v_new.rec, -1);
  rtn_tbl_put_index_complete(v_new.rec, -1);
  rtn_tbl_put_index_use(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_index_index(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_index_table(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_index_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_index_unique(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_index_complete(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_index_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_index(v_new);
  v_dbstate=0;
  delptr(&v_new, 16);
  return v_new;
  delptr(&v_new, 16);
}
 
 
long int rtn_tbl_get_ifield_index(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) return null;
  return *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+0);
}
 
void rtn_tbl_put_ifield_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in filling field ifield.index\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+0)=v_val;
}
 
void rtn_tbl_add_ifield_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in adding to field ifield.index\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+0)+=v_val;
}
 
void rtn_tbl_sub_ifield_index(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("Error in subtraction from field ifield.index\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+0)-=v_val;
}
 
long int rtn_tbl_get_ifield_ifield(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) return 0;
  return *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+4);
}
 
void rtn_tbl_put_ifield_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in filling field ifield.ifield\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+4)=v_val;
}
 
void rtn_tbl_add_ifield_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in adding to field ifield.ifield\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+4)+=v_val;
}
 
void rtn_tbl_sub_ifield_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("Error in subtraction from field ifield.ifield\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+4)-=v_val;
}
 
long int rtn_tbl_get_ifield_table(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) return null;
  return *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+8);
}
 
void rtn_tbl_put_ifield_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in filling field ifield.table\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+8)=v_val;
}
 
void rtn_tbl_add_ifield_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in adding to field ifield.table\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+8)+=v_val;
}
 
void rtn_tbl_sub_ifield_table(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("Error in subtraction from field ifield.table\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+8)-=v_val;
}
 
long int rtn_tbl_get_ifield_field(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) return null;
  return *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+12);
}
 
void rtn_tbl_put_ifield_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in filling field ifield.field\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+12)=v_val;
}
 
void rtn_tbl_add_ifield_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("error in adding to field ifield.field\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+12)+=v_val;
}
 
void rtn_tbl_sub_ifield_field(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[11].len) {
    printf("Error in subtraction from field ifield.field\n");
    return;
  }
  *(long int*)(u_table[11].ptr[v_rec/250]+(v_rec%250)*u_table[11].size+12)-=v_val;
}
 
struct pointer rtn_tbl_search_ifield(long int v_p_index, long int v_p_ifield) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 19, 1);
  newptr(&v_ptr, 19, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(19)+1);
    v_idx=rtn_getpointer(v_curr, 0, 19);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_index, rtn_tbl_get_ifield_index(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_ifield, rtn_tbl_get_ifield_ifield(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(19);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 19)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 19);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_index, rtn_tbl_get_ifield_index(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_ifield, rtn_tbl_get_ifield_ifield(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 19);
  }
  delptr(&v_idx, 19);
  delptr(&v_ptr, 19);
  return v_ptr;
  delptr(&v_idx, 19);
  delptr(&v_ptr, 19);
}
 
 
struct pointer rtn_tbl_search_ifsearch(long int v_p_table, long int v_p_field, long int v_p_index) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 20, 1);
  newptr(&v_ptr, 20, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(20)+1);
    v_idx=rtn_getpointer(v_curr, 0, 20);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_ifield_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_field, rtn_tbl_get_ifield_field(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_index, rtn_tbl_get_ifield_index(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(20);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 20)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 20);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_table, rtn_tbl_get_ifield_table(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_field, rtn_tbl_get_ifield_field(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_index, rtn_tbl_get_ifield_index(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 20);
  }
  delptr(&v_idx, 20);
  delptr(&v_ptr, 20);
  return v_ptr;
  delptr(&v_idx, 20);
  delptr(&v_ptr, 20);
}
 
 
struct pointer rtn_tbl_add_ifield(struct pointer v_new) {
  struct pointer v_idx_ifield={-1, -1, -1};
  struct pointer v_idx_ifsearch={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_ifield, 19, 1);
  newptr(&v_idx_ifsearch, 20, 1);
  newptr(&v_last, 19, 1);
  rtn_tbl_put_ifield_ifield(v_new.rec, 999999999);
  v_idx_ifield=rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_new.rec), rtn_tbl_get_ifield_ifield(v_new.rec));
  if (v_idx_ifield.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(19), rtn_maxleaf(rtn_maxbranch(19), 19), 19);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_ifield, 19);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_ifield_index(v_last.rec)!=rtn_tbl_get_ifield_index(v_new.rec))) {
    rtn_tbl_put_ifield_ifield(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_ifield_ifield(v_new.rec, rtn_tbl_get_ifield_ifield(v_last.rec)+1);
  }
  v_idx_ifsearch=rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_new.rec), rtn_tbl_get_ifield_field(v_new.rec), rtn_tbl_get_ifield_index(v_new.rec));
  rtn_addindex(v_idx_ifield, rtn_tablelen(11)-1, 19);
  rtn_addindex(v_idx_ifsearch, rtn_tablelen(11)-1, 20);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("add ifield(11):"), get_int(rtn_tbl_get_ifield_index(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_ifield_ifield(v_new.rec)))), "|"), get_int(rtn_tbl_get_ifield_table(v_new.rec))), "|"), get_int(rtn_tbl_get_ifield_field(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 19);
    delptr(&v_idx_ifield, 19);
    delptr(&v_idx_ifsearch, 20);
    delptr(&v_last, 19);
    return rtn_getpointer(0, 0, 19);
  }
  delptr(&v_new, 19);
  delptr(&v_idx_ifield, 19);
  delptr(&v_idx_ifsearch, 20);
  delptr(&v_last, 19);
  return rtn_ptrplus1(v_last, 19);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 19);
  delptr(&v_idx_ifield, 19);
  delptr(&v_idx_ifsearch, 20);
  delptr(&v_last, 19);
}
 
 
void rtn_tbl_delete_ifield(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 19, 1);
  newptr(&v_chk, 19, 1);
  newptr(&v_del, 19, 1);
  v_del=rtn_getrecptr(v_delrec, 11);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("delete ifield(11):"), get_int(rtn_tbl_get_ifield_index(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_ifield_ifield(v_del.rec)))), "|"), get_int(rtn_tbl_get_ifield_table(v_del.rec))), "|"), get_int(rtn_tbl_get_ifield_field(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_del.rec), rtn_tbl_get_ifield_ifield(v_del.rec));
  rtn_deleteindex(v_chk, 19);
  v_chk=rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_del.rec), rtn_tbl_get_ifield_ifield(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_del.rec), rtn_tbl_get_ifield_field(v_del.rec), rtn_tbl_get_ifield_index(v_del.rec)), 20);
  if (rtn_getrec(v_del, 11)!=rtn_tablelen(11)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(11)-1, 19);
    rtn_changeindex(rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_last.rec), rtn_tbl_get_ifield_ifield(v_last.rec)), v_delrec, 19);
    rtn_changeindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_last.rec), rtn_tbl_get_ifield_field(v_last.rec), rtn_tbl_get_ifield_index(v_last.rec)), v_delrec, 20);
  }
  rtn_deleterecord(v_delrec, 11);
  if (v_chk.branch==-1) {
    delptr(&v_last, 19);
    delptr(&v_chk, 19);
    delptr(&v_del, 19);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 19);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_ifield_ifield(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 11);
    rtn_deleteindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_chk.rec), rtn_tbl_get_ifield_field(v_chk.rec), rtn_tbl_get_ifield_index(v_chk.rec)), 20);
    rtn_tbl_sub_ifield_ifield(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_chk.rec), rtn_tbl_get_ifield_field(v_chk.rec), rtn_tbl_get_ifield_index(v_chk.rec)), v_rec, 20);
    v_chk=rtn_ptrplus1(v_chk, 19);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 19);
  delptr(&v_chk, 19);
  delptr(&v_del, 19);
}
 
 
struct pointer rtn_tbl_update_ifield(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 19, 1);
  newptr(&v_del, 19, 1);
  v_del=rtn_getrecptr(v_rec, 11);
  v_new=rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_del.rec), rtn_tbl_get_ifield_ifield(v_del.rec));
  rtn_deleteindex(v_new, 19);
  rtn_deleteindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_del.rec), rtn_tbl_get_ifield_field(v_del.rec), rtn_tbl_get_ifield_index(v_del.rec)), 20);
  rtn_deleterecord(v_rec, 11);
  rtn_addindex(rtn_tbl_search_ifield(rtn_tbl_get_ifield_index(v_new.rec), rtn_tbl_get_ifield_ifield(v_new.rec)), rtn_getrec(v_new, 19), 19);
  rtn_addindex(rtn_tbl_search_ifsearch(rtn_tbl_get_ifield_table(v_new.rec), rtn_tbl_get_ifield_field(v_new.rec), rtn_tbl_get_ifield_index(v_new.rec)), rtn_getrec(v_new, 19), 20);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 11);
  }
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("update ifield:"), get_int(rtn_tbl_get_ifield_index(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_ifield_ifield(v_new.rec)))), "|"), get_int(rtn_tbl_get_ifield_table(v_new.rec))), "|"), get_int(rtn_tbl_get_ifield_field(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 19);
  delptr(&v_del, 19);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 19);
  delptr(&v_del, 19);
}
 
 
void rtn_tbl_clear_ifield() {
  
  long int r=0;
  long int branch;
  while (r < u_table[11].len) {
    r++;
  }
  free(u_table[11].ptr);
  u_table[11].ptr=0;
  u_table[11].len=0;
  for(branch=0; branch < u_index[19].scale; branch++)
  { free(u_index[19].ptr[branch]);
  }
  free(u_index[19].len);
  free(u_index[19].ptr);
  u_index[19].scale=0;
  u_index[19].len=0;
  u_index[19].ptr=0;
  for(branch=0; branch < u_index[20].scale; branch++)
  { free(u_index[20].ptr[branch]);
  }
  free(u_index[20].len);
  free(u_index[20].ptr);
  u_index[20].scale=0;
  u_index[20].len=0;
  u_index[20].ptr=0;
  fprintf(v_log, "clear ifield(11)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_ifield() {
  
  return u_table[11].len;
}
 
void rtn_tbl_init_ifield() {
  
  u_table[11].len=0;
  u_table[11].size=16;
  u_table[11].ptr=0;
  u_index[19].tbl=11;
  u_index[19].scale=0;
  u_index[19].len=0;
  u_index[19].ptr=0;
  u_index[19].ptrs=0;
  u_index[19].padm=0;
  u_index[20].tbl=11;
  u_index[20].scale=0;
  u_index[20].len=0;
  u_index[20].ptr=0;
  u_index[20].ptrs=0;
  u_index[20].padm=0;
}
 
void rtn_tbl_write_ifield(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 19, 0);
  rtn_write(rtn_tbl_get_ifield_index(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_ifield_ifield(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_ifield_table(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_ifield_field(v_ptr.rec), v_stream);
  delptr(&v_ptr, 19);
}
 
 
struct pointer rtn_tbl_read_ifield(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 19, 0);
  v_new=rtn_addrecord(11);
  rtn_tbl_put_ifield_index(v_new.rec, null);
  rtn_tbl_put_ifield_ifield(v_new.rec, 0);
  rtn_tbl_put_ifield_table(v_new.rec, null);
  rtn_tbl_put_ifield_field(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_ifield_index(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_ifield_ifield(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_ifield_table(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_ifield_field(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_ifield(v_new);
  v_dbstate=0;
  delptr(&v_new, 19);
  return v_new;
  delptr(&v_new, 19);
}
 
 
char *rtn_find_index(int v_what) {
  struct pointer v_in={-1, -1, -1};
  struct pointer v_table={-1, -1, -1};
  char *var1=0;
  newptr(&v_in, 18, 0);
  v_in=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_in.branch==-1) {
      v_in=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_in.rec), v_keyword)==0) {
      break;
    }
    v_in=rtn_ptrplus1(v_in, 18);
  }
  if (v_in.branch!=-1) {
    newptr(&v_table, 12, 0);
    v_table=rtn_tbl_search_table(rtn_tbl_get_index_table(v_in.rec));
    while (1) {
      if ((v_table.branch==-1) || ((rtn_tbl_get_table_table(v_table.rec)>rtn_tbl_get_index_table(v_in.rec)))) {
        v_table=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_table_table(v_table.rec)==rtn_tbl_get_index_table(v_in.rec) && scmp(rtn_tbl_get_table_name(v_table.rec), rtn_tbl_get_index_name(v_in.rec))==0) {
        break;
      }
      v_table=rtn_ptrplus1(v_table, 12);
    }
    if (v_what==1 && !(v_table.branch!=-1)) {
      rtn_puterror(scpy("Expecting to find the name of a table"));
    }
    rtn_scankeyword();
    var1=snew(var1, scpy(rtn_tbl_get_index_name(v_in.rec)));
    delptr(&v_in, 18);
    delptr(&v_table, 12);
    return var1;
  }
  else {
    if (v_what==1) {
      rtn_puterror(scpy("Expecting a name of a table"));
    }
    else {
      rtn_puterror(scpy("Expecting an index name"));
    }
  }
  var1=snew(var1, get_int(0));
  delptr(&v_in, 18);
  delptr(&v_table, 12);
  return var1;
  delptr(&v_in, 18);
  delptr(&v_table, 12);
}
 
long int v_cparagraph=0;
long int v_cchapter=0;
 
long int rtn_tbl_get_chapter_module(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) return null;
  return *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+0);
}
 
void rtn_tbl_put_chapter_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in filling field chapter.module\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+0)=v_val;
}
 
void rtn_tbl_add_chapter_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in adding to field chapter.module\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+0)+=v_val;
}
 
void rtn_tbl_sub_chapter_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("Error in subtraction from field chapter.module\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+0)-=v_val;
}
 
long int rtn_tbl_get_chapter_chapter(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) return 0;
  return *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+4);
}
 
void rtn_tbl_put_chapter_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in filling field chapter.chapter\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+4)=v_val;
}
 
void rtn_tbl_add_chapter_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in adding to field chapter.chapter\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+4)+=v_val;
}
 
void rtn_tbl_sub_chapter_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("Error in subtraction from field chapter.chapter\n");
    return;
  }
  *(long int*)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+4)-=v_val;
}
 
char *rtn_tbl_get_chapter_title(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) return 0;
  return *(char**)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+8);
}
 
void rtn_tbl_put_chapter_title(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in filling field chapter.title\n");
    return;
  }
  *(char**)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+8)=v_val;
}
 
void rtn_tbl_add_chapter_title(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[12].len) {
    printf("error in adding to field chapter.title\n");
    return;
  }
  *(char**)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+8)= 
  sadd(*(char**)(u_table[12].ptr[v_rec/250]+(v_rec%250)*u_table[12].size+8), v_val);
}
 
struct pointer rtn_tbl_search_chapter(long int v_p_module, long int v_p_chapter) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 21, 1);
  newptr(&v_ptr, 21, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(21)+1);
    v_idx=rtn_getpointer(v_curr, 0, 21);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_chapter_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_chapter, rtn_tbl_get_chapter_chapter(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(21);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 21)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 21);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_chapter_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_chapter, rtn_tbl_get_chapter_chapter(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 21);
  }
  delptr(&v_idx, 21);
  delptr(&v_ptr, 21);
  return v_ptr;
  delptr(&v_idx, 21);
  delptr(&v_ptr, 21);
}
 
 
struct pointer rtn_tbl_add_chapter(struct pointer v_new) {
  struct pointer v_idx_chapter={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_chapter, 21, 1);
  newptr(&v_last, 21, 1);
  rtn_tbl_put_chapter_chapter(v_new.rec, 999999999);
  v_idx_chapter=rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_new.rec), rtn_tbl_get_chapter_chapter(v_new.rec));
  if (v_idx_chapter.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(21), rtn_maxleaf(rtn_maxbranch(21), 21), 21);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_chapter, 21);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_chapter_module(v_last.rec)!=rtn_tbl_get_chapter_module(v_new.rec))) {
    rtn_tbl_put_chapter_chapter(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_chapter_chapter(v_new.rec, rtn_tbl_get_chapter_chapter(v_last.rec)+1);
  }
  rtn_addindex(v_idx_chapter, rtn_tablelen(12)-1, 21);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("add chapter(12):"), get_int(rtn_tbl_get_chapter_module(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_new.rec)))), "|"), rtn_tbl_get_chapter_title(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 21);
    delptr(&v_idx_chapter, 21);
    delptr(&v_last, 21);
    return rtn_getpointer(0, 0, 21);
  }
  delptr(&v_new, 21);
  delptr(&v_idx_chapter, 21);
  delptr(&v_last, 21);
  return rtn_ptrplus1(v_last, 21);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 21);
  delptr(&v_idx_chapter, 21);
  delptr(&v_last, 21);
}
 
 
void rtn_tbl_delete_chapter(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 21, 1);
  newptr(&v_chk, 21, 1);
  newptr(&v_del, 21, 1);
  v_del=rtn_getrecptr(v_delrec, 12);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("delete chapter(12):"), get_int(rtn_tbl_get_chapter_module(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_del.rec)))), "|"), rtn_tbl_get_chapter_title(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_del.rec), rtn_tbl_get_chapter_chapter(v_del.rec));
  rtn_deleteindex(v_chk, 21);
  v_chk=rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_del.rec), rtn_tbl_get_chapter_chapter(v_del.rec)+1);
  rtn_tbl_put_chapter_title(v_del.rec, 0);
  if (rtn_getrec(v_del, 12)!=rtn_tablelen(12)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(12)-1, 21);
    rtn_changeindex(rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_last.rec), rtn_tbl_get_chapter_chapter(v_last.rec)), v_delrec, 21);
  }
  rtn_deleterecord(v_delrec, 12);
  if (v_chk.branch==-1) {
    delptr(&v_last, 21);
    delptr(&v_chk, 21);
    delptr(&v_del, 21);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 21);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_chapter_chapter(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 12);
    rtn_tbl_sub_chapter_chapter(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 21);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 21);
  delptr(&v_chk, 21);
  delptr(&v_del, 21);
}
 
 
struct pointer rtn_tbl_update_chapter(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 21, 1);
  newptr(&v_del, 21, 1);
  v_del=rtn_getrecptr(v_rec, 12);
  v_new=rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_del.rec), rtn_tbl_get_chapter_chapter(v_del.rec));
  rtn_deleteindex(v_new, 21);
  rtn_deleterecord(v_rec, 12);
  rtn_addindex(rtn_tbl_search_chapter(rtn_tbl_get_chapter_module(v_new.rec), rtn_tbl_get_chapter_chapter(v_new.rec)), rtn_getrec(v_new, 21), 21);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 12);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("update chapter:"), get_int(rtn_tbl_get_chapter_module(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_new.rec)))), "|"), rtn_tbl_get_chapter_title(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 21);
  delptr(&v_del, 21);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 21);
  delptr(&v_del, 21);
}
 
 
void rtn_tbl_clear_chapter() {
  
  long int r=0;
  long int branch;
  while (r < u_table[12].len) {
    if (*(char**)(u_table[12].ptr[r/250]+(r%250)*u_table[12].size+8)!=0) {free(*(char**)(u_table[12].ptr[r/250]+(r%250)*u_table[12].size+8)); *(char**)(u_table[12].ptr[r/250]+(r%250)*u_table[12].size+8)=0;}
    r++;
  }
  free(u_table[12].ptr);
  u_table[12].ptr=0;
  u_table[12].len=0;
  for(branch=0; branch < u_index[21].scale; branch++)
  { free(u_index[21].ptr[branch]);
  }
  free(u_index[21].len);
  free(u_index[21].ptr);
  u_index[21].scale=0;
  u_index[21].len=0;
  u_index[21].ptr=0;
  fprintf(v_log, "clear chapter(12)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_chapter() {
  
  return u_table[12].len;
}
 
void rtn_tbl_init_chapter() {
  
  u_table[12].len=0;
  u_table[12].size=12;
  u_table[12].ptr=0;
  u_index[21].tbl=12;
  u_index[21].scale=0;
  u_index[21].len=0;
  u_index[21].ptr=0;
  u_index[21].ptrs=0;
  u_index[21].padm=0;
}
 
void rtn_tbl_write_chapter(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 21, 0);
  rtn_write(rtn_tbl_get_chapter_module(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_chapter_chapter(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_chapter_title(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 21);
}
 
 
struct pointer rtn_tbl_read_chapter(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 21, 0);
  v_new=rtn_addrecord(12);
  rtn_tbl_put_chapter_module(v_new.rec, null);
  rtn_tbl_put_chapter_chapter(v_new.rec, 0);
  rtn_tbl_put_chapter_title(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_chapter_module(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_chapter_chapter(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_chapter_title(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_chapter(v_new);
  v_dbstate=0;
  delptr(&v_new, 21);
  return v_new;
  delptr(&v_new, 21);
}
 
 
long int rtn_tbl_get_paragraph_paragraph(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return 0;
  return *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+0);
}
 
void rtn_tbl_put_paragraph_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.paragraph\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+0)=v_val;
}
 
void rtn_tbl_add_paragraph_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.paragraph\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+0)+=v_val;
}
 
void rtn_tbl_sub_paragraph_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("Error in subtraction from field paragraph.paragraph\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+0)-=v_val;
}
 
long int rtn_tbl_get_paragraph_module(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return null;
  return *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+4);
}
 
void rtn_tbl_put_paragraph_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.module\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+4)=v_val;
}
 
void rtn_tbl_add_paragraph_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.module\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+4)+=v_val;
}
 
void rtn_tbl_sub_paragraph_module(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("Error in subtraction from field paragraph.module\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+4)-=v_val;
}
 
long int rtn_tbl_get_paragraph_chapter(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return null;
  return *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+8);
}
 
void rtn_tbl_put_paragraph_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.chapter\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+8)=v_val;
}
 
void rtn_tbl_add_paragraph_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.chapter\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+8)+=v_val;
}
 
void rtn_tbl_sub_paragraph_chapter(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("Error in subtraction from field paragraph.chapter\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+8)-=v_val;
}
 
int rtn_tbl_get_paragraph_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return -1;
  return *(int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+12);
}
 
void rtn_tbl_put_paragraph_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.kind\n");
    return;
  }
  *(int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+12)=v_val;
}
 
void rtn_tbl_add_paragraph_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.kind\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+12)+=v_val;
}
 
void rtn_tbl_sub_paragraph_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("Error in subtraction from field paragraph.kind\n");
    return;
  }
  *(long int*)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+12)-=v_val;
}
 
char *rtn_tbl_get_paragraph_heading(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return 0;
  return *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+16);
}
 
void rtn_tbl_put_paragraph_heading(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.heading\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+16)=v_val;
}
 
void rtn_tbl_add_paragraph_heading(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.heading\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+16)= 
  sadd(*(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+16), v_val);
}
 
char *rtn_tbl_get_paragraph_picture(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return 0;
  return *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+20);
}
 
void rtn_tbl_put_paragraph_picture(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.picture\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+20)=v_val;
}
 
void rtn_tbl_add_paragraph_picture(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.picture\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+20)= 
  sadd(*(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+20), v_val);
}
 
char *rtn_tbl_get_paragraph_text(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) return 0;
  return *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+24);
}
 
void rtn_tbl_put_paragraph_text(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in filling field paragraph.text\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+24)=v_val;
}
 
void rtn_tbl_add_paragraph_text(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[13].len) {
    printf("error in adding to field paragraph.text\n");
    return;
  }
  *(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+24)= 
  sadd(*(char**)(u_table[13].ptr[v_rec/250]+(v_rec%250)*u_table[13].size+24), v_val);
}
 
struct pointer rtn_tbl_search_paragraph(long int v_p_paragraph) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 22, 1);
  newptr(&v_ptr, 22, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(22)+1);
    v_idx=rtn_getpointer(v_curr, 0, 22);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_paragraph_paragraph(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(22);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 22)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 22);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_paragraph_paragraph(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 22);
  }
  delptr(&v_idx, 22);
  delptr(&v_ptr, 22);
  return v_ptr;
  delptr(&v_idx, 22);
  delptr(&v_ptr, 22);
}
 
 
struct pointer rtn_tbl_search_paragraphchapter(long int v_p_module, long int v_p_chapter, long int v_p_paragraph) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 23, 1);
  newptr(&v_ptr, 23, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(23)+1);
    v_idx=rtn_getpointer(v_curr, 0, 23);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_paragraph_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_chapter, rtn_tbl_get_paragraph_chapter(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_paragraph_paragraph(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(23);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 23)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 23);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_module, rtn_tbl_get_paragraph_module(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_chapter, rtn_tbl_get_paragraph_chapter(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_paragraph_paragraph(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 23);
  }
  delptr(&v_idx, 23);
  delptr(&v_ptr, 23);
  return v_ptr;
  delptr(&v_idx, 23);
  delptr(&v_ptr, 23);
}
 
 
struct pointer rtn_tbl_add_paragraph(struct pointer v_new) {
  struct pointer v_idx_paragraph={-1, -1, -1};
  struct pointer v_idx_paragraphchapter={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_paragraph, 22, 1);
  newptr(&v_idx_paragraphchapter, 23, 1);
  newptr(&v_last, 22, 1);
  rtn_tbl_put_paragraph_paragraph(v_new.rec, 999999999);
  v_idx_paragraph=rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_new.rec));
  if (v_idx_paragraph.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(22), rtn_maxleaf(rtn_maxbranch(22), 22), 22);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_paragraph, 22);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_paragraph_paragraph(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_paragraph_paragraph(v_new.rec, rtn_tbl_get_paragraph_paragraph(v_last.rec)+1);
  }
  v_idx_paragraphchapter=rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_new.rec), rtn_tbl_get_paragraph_chapter(v_new.rec), rtn_tbl_get_paragraph_paragraph(v_new.rec));
  rtn_addindex(v_idx_paragraph, rtn_tablelen(13)-1, 22);
  rtn_addindex(v_idx_paragraphchapter, rtn_tablelen(13)-1, 23);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("add paragraph(13):"), scpy(get_sort(rtn_tbl_get_paragraph_paragraph(v_new.rec)))), "|"), get_int(rtn_tbl_get_paragraph_module(v_new.rec))), "|"), get_int(rtn_tbl_get_paragraph_chapter(v_new.rec))), "|"), get_enum(rtn_tbl_get_paragraph_kind(v_new.rec), "Text Picture List Code Def")), "|"), rtn_tbl_get_paragraph_heading(v_new.rec)), "|"), rtn_tbl_get_paragraph_picture(v_new.rec)), "|"), rtn_tbl_get_paragraph_text(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 22);
    delptr(&v_idx_paragraph, 22);
    delptr(&v_idx_paragraphchapter, 23);
    delptr(&v_last, 22);
    return rtn_getpointer(0, 0, 22);
  }
  delptr(&v_new, 22);
  delptr(&v_idx_paragraph, 22);
  delptr(&v_idx_paragraphchapter, 23);
  delptr(&v_last, 22);
  return rtn_ptrplus1(v_last, 22);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 22);
  delptr(&v_idx_paragraph, 22);
  delptr(&v_idx_paragraphchapter, 23);
  delptr(&v_last, 22);
}
 
 
void rtn_tbl_delete_paragraph(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 22, 1);
  newptr(&v_chk, 22, 1);
  newptr(&v_del, 22, 1);
  v_del=rtn_getrecptr(v_delrec, 13);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("delete paragraph(13):"), scpy(get_sort(rtn_tbl_get_paragraph_paragraph(v_del.rec)))), "|"), get_int(rtn_tbl_get_paragraph_module(v_del.rec))), "|"), get_int(rtn_tbl_get_paragraph_chapter(v_del.rec))), "|"), get_enum(rtn_tbl_get_paragraph_kind(v_del.rec), "Text Picture List Code Def")), "|"), rtn_tbl_get_paragraph_heading(v_del.rec)), "|"), rtn_tbl_get_paragraph_picture(v_del.rec)), "|"), rtn_tbl_get_paragraph_text(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_del.rec));
  rtn_deleteindex(v_chk, 22);
  v_chk=rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_del.rec), rtn_tbl_get_paragraph_chapter(v_del.rec), rtn_tbl_get_paragraph_paragraph(v_del.rec)), 23);
  rtn_tbl_put_paragraph_heading(v_del.rec, 0);
  rtn_tbl_put_paragraph_picture(v_del.rec, 0);
  rtn_tbl_put_paragraph_text(v_del.rec, 0);
  if (rtn_getrec(v_del, 13)!=rtn_tablelen(13)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(13)-1, 22);
    rtn_changeindex(rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_last.rec)), v_delrec, 22);
    rtn_changeindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_last.rec), rtn_tbl_get_paragraph_chapter(v_last.rec), rtn_tbl_get_paragraph_paragraph(v_last.rec)), v_delrec, 23);
  }
  rtn_deleterecord(v_delrec, 13);
  if (v_chk.branch==-1) {
    delptr(&v_last, 22);
    delptr(&v_chk, 22);
    delptr(&v_del, 22);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 22);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_paragraph_paragraph(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 13);
    rtn_deleteindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_chk.rec), rtn_tbl_get_paragraph_chapter(v_chk.rec), rtn_tbl_get_paragraph_paragraph(v_chk.rec)), 23);
    rtn_tbl_sub_paragraph_paragraph(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_chk.rec), rtn_tbl_get_paragraph_chapter(v_chk.rec), rtn_tbl_get_paragraph_paragraph(v_chk.rec)), v_rec, 23);
    v_chk=rtn_ptrplus1(v_chk, 22);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 22);
  delptr(&v_chk, 22);
  delptr(&v_del, 22);
}
 
 
struct pointer rtn_tbl_update_paragraph(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 22, 1);
  newptr(&v_del, 22, 1);
  v_del=rtn_getrecptr(v_rec, 13);
  v_new=rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_del.rec));
  rtn_deleteindex(v_new, 22);
  rtn_deleteindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_del.rec), rtn_tbl_get_paragraph_chapter(v_del.rec), rtn_tbl_get_paragraph_paragraph(v_del.rec)), 23);
  rtn_deleterecord(v_rec, 13);
  rtn_addindex(rtn_tbl_search_paragraph(rtn_tbl_get_paragraph_paragraph(v_new.rec)), rtn_getrec(v_new, 22), 22);
  rtn_addindex(rtn_tbl_search_paragraphchapter(rtn_tbl_get_paragraph_module(v_new.rec), rtn_tbl_get_paragraph_chapter(v_new.rec), rtn_tbl_get_paragraph_paragraph(v_new.rec)), rtn_getrec(v_new, 22), 23);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 13);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("update paragraph:"), scpy(get_sort(rtn_tbl_get_paragraph_paragraph(v_new.rec)))), "|"), get_int(rtn_tbl_get_paragraph_module(v_new.rec))), "|"), get_int(rtn_tbl_get_paragraph_chapter(v_new.rec))), "|"), get_enum(rtn_tbl_get_paragraph_kind(v_new.rec), "Text Picture List Code Def")), "|"), rtn_tbl_get_paragraph_heading(v_new.rec)), "|"), rtn_tbl_get_paragraph_picture(v_new.rec)), "|"), rtn_tbl_get_paragraph_text(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 22);
  delptr(&v_del, 22);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 22);
  delptr(&v_del, 22);
}
 
 
void rtn_tbl_clear_paragraph() {
  
  long int r=0;
  long int branch;
  while (r < u_table[13].len) {
    if (*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+16)!=0) {free(*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+16)); *(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+16)=0;}
    if (*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+20)!=0) {free(*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+20)); *(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+20)=0;}
    if (*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+24)!=0) {free(*(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+24)); *(char**)(u_table[13].ptr[r/250]+(r%250)*u_table[13].size+24)=0;}
    r++;
  }
  free(u_table[13].ptr);
  u_table[13].ptr=0;
  u_table[13].len=0;
  for(branch=0; branch < u_index[22].scale; branch++)
  { free(u_index[22].ptr[branch]);
  }
  free(u_index[22].len);
  free(u_index[22].ptr);
  u_index[22].scale=0;
  u_index[22].len=0;
  u_index[22].ptr=0;
  for(branch=0; branch < u_index[23].scale; branch++)
  { free(u_index[23].ptr[branch]);
  }
  free(u_index[23].len);
  free(u_index[23].ptr);
  u_index[23].scale=0;
  u_index[23].len=0;
  u_index[23].ptr=0;
  fprintf(v_log, "clear paragraph(13)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_paragraph() {
  
  return u_table[13].len;
}
 
void rtn_tbl_init_paragraph() {
  
  u_table[13].len=0;
  u_table[13].size=28;
  u_table[13].ptr=0;
  u_index[22].tbl=13;
  u_index[22].scale=0;
  u_index[22].len=0;
  u_index[22].ptr=0;
  u_index[22].ptrs=0;
  u_index[22].padm=0;
  u_index[23].tbl=13;
  u_index[23].scale=0;
  u_index[23].len=0;
  u_index[23].ptr=0;
  u_index[23].ptrs=0;
  u_index[23].padm=0;
}
 
void rtn_tbl_write_paragraph(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 22, 0);
  rtn_write(rtn_tbl_get_paragraph_paragraph(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_paragraph_module(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_paragraph_chapter(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_paragraph_kind(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_paragraph_heading(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_paragraph_picture(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_paragraph_text(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 22);
}
 
 
struct pointer rtn_tbl_read_paragraph(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 22, 0);
  v_new=rtn_addrecord(13);
  rtn_tbl_put_paragraph_paragraph(v_new.rec, 0);
  rtn_tbl_put_paragraph_module(v_new.rec, null);
  rtn_tbl_put_paragraph_chapter(v_new.rec, null);
  rtn_tbl_put_paragraph_kind(v_new.rec, -1);
  rtn_tbl_put_paragraph_heading(v_new.rec, 0);
  rtn_tbl_put_paragraph_picture(v_new.rec, 0);
  rtn_tbl_put_paragraph_text(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_paragraph_paragraph(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_paragraph_module(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_paragraph_chapter(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_paragraph_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_paragraph_heading(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_paragraph_picture(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_paragraph_text(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_paragraph(v_new);
  v_dbstate=0;
  delptr(&v_new, 22);
  return v_new;
  delptr(&v_new, 22);
}
 
 
long int rtn_tbl_get_list_paragraph(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) return null;
  return *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+0);
}
 
void rtn_tbl_put_list_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in filling field list.paragraph\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+0)=v_val;
}
 
void rtn_tbl_add_list_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in adding to field list.paragraph\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+0)+=v_val;
}
 
void rtn_tbl_sub_list_paragraph(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("Error in subtraction from field list.paragraph\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+0)-=v_val;
}
 
long int rtn_tbl_get_list_item(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) return 0;
  return *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+4);
}
 
void rtn_tbl_put_list_item(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in filling field list.item\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+4)=v_val;
}
 
void rtn_tbl_add_list_item(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in adding to field list.item\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+4)+=v_val;
}
 
void rtn_tbl_sub_list_item(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("Error in subtraction from field list.item\n");
    return;
  }
  *(long int*)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+4)-=v_val;
}
 
char *rtn_tbl_get_list_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) return 0;
  return *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+8);
}
 
void rtn_tbl_put_list_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in filling field list.name\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+8)=v_val;
}
 
void rtn_tbl_add_list_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in adding to field list.name\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+8)= 
  sadd(*(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+8), v_val);
}
 
char *rtn_tbl_get_list_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) return 0;
  return *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+12);
}
 
void rtn_tbl_put_list_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in filling field list.type\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+12)=v_val;
}
 
void rtn_tbl_add_list_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in adding to field list.type\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+12)= 
  sadd(*(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+12), v_val);
}
 
char *rtn_tbl_get_list_value(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) return 0;
  return *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+16);
}
 
void rtn_tbl_put_list_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in filling field list.value\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+16)=v_val;
}
 
void rtn_tbl_add_list_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[14].len) {
    printf("error in adding to field list.value\n");
    return;
  }
  *(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+16)= 
  sadd(*(char**)(u_table[14].ptr[v_rec/250]+(v_rec%250)*u_table[14].size+16), v_val);
}
 
struct pointer rtn_tbl_search_list(long int v_p_paragraph, long int v_p_item) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 24, 1);
  newptr(&v_ptr, 24, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(24)+1);
    v_idx=rtn_getpointer(v_curr, 0, 24);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_list_paragraph(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_item, rtn_tbl_get_list_item(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(24);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 24)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 24);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_paragraph, rtn_tbl_get_list_paragraph(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_item, rtn_tbl_get_list_item(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 24);
  }
  delptr(&v_idx, 24);
  delptr(&v_ptr, 24);
  return v_ptr;
  delptr(&v_idx, 24);
  delptr(&v_ptr, 24);
}
 
 
struct pointer rtn_tbl_add_list(struct pointer v_new) {
  struct pointer v_idx_list={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_list, 24, 1);
  newptr(&v_last, 24, 1);
  rtn_tbl_put_list_item(v_new.rec, 999999999);
  v_idx_list=rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_new.rec), rtn_tbl_get_list_item(v_new.rec));
  if (v_idx_list.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(24), rtn_maxleaf(rtn_maxbranch(24), 24), 24);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_list, 24);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_list_paragraph(v_last.rec)!=rtn_tbl_get_list_paragraph(v_new.rec))) {
    rtn_tbl_put_list_item(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_list_item(v_new.rec, rtn_tbl_get_list_item(v_last.rec)+1);
  }
  rtn_addindex(v_idx_list, rtn_tablelen(14)-1, 24);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("add list(14):"), get_int(rtn_tbl_get_list_paragraph(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_list_item(v_new.rec)))), "|"), rtn_tbl_get_list_name(v_new.rec)), "|"), rtn_tbl_get_list_type(v_new.rec)), "|"), rtn_tbl_get_list_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 24);
    delptr(&v_idx_list, 24);
    delptr(&v_last, 24);
    return rtn_getpointer(0, 0, 24);
  }
  delptr(&v_new, 24);
  delptr(&v_idx_list, 24);
  delptr(&v_last, 24);
  return rtn_ptrplus1(v_last, 24);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 24);
  delptr(&v_idx_list, 24);
  delptr(&v_last, 24);
}
 
 
void rtn_tbl_delete_list(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 24, 1);
  newptr(&v_chk, 24, 1);
  newptr(&v_del, 24, 1);
  v_del=rtn_getrecptr(v_delrec, 14);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("delete list(14):"), get_int(rtn_tbl_get_list_paragraph(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_list_item(v_del.rec)))), "|"), rtn_tbl_get_list_name(v_del.rec)), "|"), rtn_tbl_get_list_type(v_del.rec)), "|"), rtn_tbl_get_list_value(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_del.rec), rtn_tbl_get_list_item(v_del.rec));
  rtn_deleteindex(v_chk, 24);
  v_chk=rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_del.rec), rtn_tbl_get_list_item(v_del.rec)+1);
  rtn_tbl_put_list_name(v_del.rec, 0);
  rtn_tbl_put_list_type(v_del.rec, 0);
  rtn_tbl_put_list_value(v_del.rec, 0);
  if (rtn_getrec(v_del, 14)!=rtn_tablelen(14)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(14)-1, 24);
    rtn_changeindex(rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_last.rec), rtn_tbl_get_list_item(v_last.rec)), v_delrec, 24);
  }
  rtn_deleterecord(v_delrec, 14);
  if (v_chk.branch==-1) {
    delptr(&v_last, 24);
    delptr(&v_chk, 24);
    delptr(&v_del, 24);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 24);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_list_item(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 14);
    rtn_tbl_sub_list_item(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 24);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 24);
  delptr(&v_chk, 24);
  delptr(&v_del, 24);
}
 
 
struct pointer rtn_tbl_update_list(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 24, 1);
  newptr(&v_del, 24, 1);
  v_del=rtn_getrecptr(v_rec, 14);
  v_new=rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_del.rec), rtn_tbl_get_list_item(v_del.rec));
  rtn_deleteindex(v_new, 24);
  rtn_deleterecord(v_rec, 14);
  rtn_addindex(rtn_tbl_search_list(rtn_tbl_get_list_paragraph(v_new.rec), rtn_tbl_get_list_item(v_new.rec)), rtn_getrec(v_new, 24), 24);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 14);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("update list:"), get_int(rtn_tbl_get_list_paragraph(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_list_item(v_new.rec)))), "|"), rtn_tbl_get_list_name(v_new.rec)), "|"), rtn_tbl_get_list_type(v_new.rec)), "|"), rtn_tbl_get_list_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 24);
  delptr(&v_del, 24);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 24);
  delptr(&v_del, 24);
}
 
 
void rtn_tbl_clear_list() {
  
  long int r=0;
  long int branch;
  while (r < u_table[14].len) {
    if (*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+8)!=0) {free(*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+8)); *(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+8)=0;}
    if (*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+12)!=0) {free(*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+12)); *(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+12)=0;}
    if (*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+16)!=0) {free(*(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+16)); *(char**)(u_table[14].ptr[r/250]+(r%250)*u_table[14].size+16)=0;}
    r++;
  }
  free(u_table[14].ptr);
  u_table[14].ptr=0;
  u_table[14].len=0;
  for(branch=0; branch < u_index[24].scale; branch++)
  { free(u_index[24].ptr[branch]);
  }
  free(u_index[24].len);
  free(u_index[24].ptr);
  u_index[24].scale=0;
  u_index[24].len=0;
  u_index[24].ptr=0;
  fprintf(v_log, "clear list(14)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_list() {
  
  return u_table[14].len;
}
 
void rtn_tbl_init_list() {
  
  u_table[14].len=0;
  u_table[14].size=20;
  u_table[14].ptr=0;
  u_index[24].tbl=14;
  u_index[24].scale=0;
  u_index[24].len=0;
  u_index[24].ptr=0;
  u_index[24].ptrs=0;
  u_index[24].padm=0;
}
 
void rtn_tbl_write_list(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 24, 0);
  rtn_write(rtn_tbl_get_list_paragraph(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_list_item(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_list_name(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_list_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_list_value(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 24);
}
 
 
struct pointer rtn_tbl_read_list(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 24, 0);
  v_new=rtn_addrecord(14);
  rtn_tbl_put_list_paragraph(v_new.rec, null);
  rtn_tbl_put_list_item(v_new.rec, 0);
  rtn_tbl_put_list_name(v_new.rec, 0);
  rtn_tbl_put_list_type(v_new.rec, 0);
  rtn_tbl_put_list_value(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_list_paragraph(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_list_item(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_list_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_list_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_list_value(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_list(v_new);
  v_dbstate=0;
  delptr(&v_new, 24);
  return v_new;
  delptr(&v_new, 24);
}
 
 
void rtn_remaining_text() {
  char *var1=0;
  struct pointer v_p0={-1, -1, -1};
  if (rtn_length((var1=snew(var1, rtn_trim(v_scanstring))))>0) {
    newptr(&v_p0, 22, 0);
    v_p0=rtn_tbl_search_paragraph(v_cparagraph);
    while (1) {
      if ((v_p0.branch==-1) || ((rtn_tbl_get_paragraph_paragraph(v_p0.rec)>v_cparagraph))) {
        v_p0=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_paragraph_paragraph(v_p0.rec)==v_cparagraph) {
        break;
      }
      v_p0=rtn_ptrplus1(v_p0, 22);
    }
    if (v_p0.branch!=-1) {
      v_p0=rtn_cpyrecord(v_p0, 13);
      v_dbstate=2;
      rtn_tbl_put_paragraph_text(v_p0.rec, rtn_trim(v_scanstring));
      v_dbstate=3;
      v_p0=rtn_tbl_update_paragraph(rtn_getrec(rtn_recalcptr(v_p0, 22), 13));
      v_dbstate=0;
      v_scanstring=snew(v_scanstring, 0);
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_p0, 22);
}
 
 
void rtn_scan_moduleheader() {
  struct pointer v_m1={-1, -1, -1};
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  struct pointer v_c1={-1, -1, -1};
  struct pointer v_p1={-1, -1, -1};
  rtn_do_scan(scpy("module"));
  if ((v_scantype!=1) || (scmp(v_scantag, "module")!=0)) {
    rtn_putwarning(scon(scon(scon(sadd(scpy("Expecting start of module but found "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " '"), v_scantag), "'"));
  }
  newptr(&v_m1, 5, 0);
  v_m1=rtn_addrecord(4);
  rtn_tbl_put_module_module(v_m1.rec, 0);
  rtn_tbl_put_module_name(v_m1.rec, 0);
  rtn_tbl_put_module_title(v_m1.rec, 0);
  rtn_tbl_put_module_author(v_m1.rec, 0);
  rtn_tbl_put_module_revision(v_m1.rec, 0);
  rtn_tbl_put_module_URL(v_m1.rec, 0);
  rtn_tbl_put_module_maintainer(v_m1.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_module_name(v_m1.rec, scpy(v_cmodule));
  newptr(&v_s, 1, 0);
  c_s=1;
  v_s=rtn_getpointer(0, 0, 1);
  while (1) {
    if (v_s.branch==-1) {
      break;
    }
    if (scmp(rtn_tbl_get_scan_key(v_s.rec), "title")==0) {
      rtn_tbl_put_module_title(v_m1.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
    }
    else {
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "author")==0) {
        rtn_tbl_put_module_author(v_m1.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_s.rec), "revision")==0) {
          rtn_tbl_put_module_revision(v_m1.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
        }
        else {
          if (scmp(rtn_tbl_get_scan_key(v_s.rec), "maintainer")==0) {
            rtn_tbl_put_module_maintainer(v_m1.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
          }
          else {
            if (scmp(rtn_tbl_get_scan_key(v_s.rec), "URL")==0) {
              rtn_tbl_put_module_URL(v_m1.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
            }
            else {
              rtn_putwarning(scon(scon(scpy("Unknown key '"), rtn_tbl_get_scan_key(v_s.rec)), "' to a module"));
            }
          }
        }
      }
    }
    c_s+=1;
    if (v_s.branch==-1) {
      v_s=rtn_getpointer(0, 0, 1);
    }
    else {
      v_s=rtn_ptrplus1(v_s, 1);
    }
  }
  v_m1=rtn_tbl_add_module(v_m1);
  v_dbstate=0;
  newptr(&v_c1, 21, 0);
  v_c1=rtn_addrecord(12);
  rtn_tbl_put_chapter_module(v_c1.rec, null);
  rtn_tbl_put_chapter_chapter(v_c1.rec, 0);
  rtn_tbl_put_chapter_title(v_c1.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_chapter_module(v_c1.rec, rtn_tbl_get_module_module(v_m1.rec));
  rtn_tbl_put_chapter_title(v_c1.rec, scpy("Preface"));
  v_c1=rtn_tbl_add_chapter(v_c1);
  v_dbstate=0;
  v_cchapter=rtn_tbl_get_chapter_chapter(v_c1.rec);
  newptr(&v_p1, 22, 0);
  v_p1=rtn_addrecord(13);
  rtn_tbl_put_paragraph_paragraph(v_p1.rec, 0);
  rtn_tbl_put_paragraph_module(v_p1.rec, null);
  rtn_tbl_put_paragraph_chapter(v_p1.rec, null);
  rtn_tbl_put_paragraph_kind(v_p1.rec, -1);
  rtn_tbl_put_paragraph_heading(v_p1.rec, 0);
  rtn_tbl_put_paragraph_picture(v_p1.rec, 0);
  rtn_tbl_put_paragraph_text(v_p1.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_paragraph_module(v_p1.rec, rtn_tbl_get_module_module(v_m1.rec));
  rtn_tbl_put_paragraph_chapter(v_p1.rec, v_cchapter);
  v_p1=rtn_tbl_add_paragraph(v_p1);
  v_dbstate=0;
  v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p1.rec);
  delptr(&v_m1, 5);
  delptr(&v_s, 1);
  delptr(&v_c1, 21);
  delptr(&v_p1, 22);
}
 
 
void rtn_scan_documentation() {
  struct pointer v_m1={-1, -1, -1};
  struct pointer v_c1={-1, -1, -1};
  struct pointer v_s1={-1, -1, -1};
  long int c_s1=0;
  struct pointer v_p4={-1, -1, -1};
  struct pointer v_m2={-1, -1, -1};
  struct pointer v_p0={-1, -1, -1};
  struct pointer v_s2={-1, -1, -1};
  long int c_s2=0;
  char *var1=0;
  struct pointer v_l3={-1, -1, -1};
  struct pointer v_s3={-1, -1, -1};
  long int c_s3=0;
  struct pointer v_m3={-1, -1, -1};
  struct pointer v_p1={-1, -1, -1};
  struct pointer v_s4={-1, -1, -1};
  long int c_s4=0;
  struct pointer v_m4={-1, -1, -1};
  struct pointer v_p2={-1, -1, -1};
  struct pointer v_s5={-1, -1, -1};
  long int c_s5=0;
  char *v_str=0;
  long int c_str=0;
  struct pointer v_l1={-1, -1, -1};
  char *v_str1=0;
  long int c_str1=0;
  struct pointer v_l4={-1, -1, -1};
  struct pointer v_l2={-1, -1, -1};
  if (v_scantype==1 && scmp(v_scantag, "chapter")==0) {
    newptr(&v_m1, 5, 0);
    v_m1=rtn_tbl_search_module(null);
    while (1) {
      if (v_m1.branch==-1) {
        v_m1=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_module_name(v_m1.rec), v_cmodule)==0) {
        break;
      }
      v_m1=rtn_ptrplus1(v_m1, 5);
    }
    if (!(v_m1.branch!=-1)) {
      rtn_puterror(scpy("Cannot find current module"));
    }
    v_tagfound=1;
    newptr(&v_c1, 21, 0);
    v_c1=rtn_addrecord(12);
    rtn_tbl_put_chapter_module(v_c1.rec, null);
    rtn_tbl_put_chapter_chapter(v_c1.rec, 0);
    rtn_tbl_put_chapter_title(v_c1.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_chapter_module(v_c1.rec, rtn_tbl_get_module_module(v_m1.rec));
    newptr(&v_s1, 1, 0);
    c_s1=1;
    v_s1=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s1.branch==-1) {
        break;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s1.rec), "title")==0) {
        rtn_tbl_put_chapter_title(v_c1.rec, scpy(rtn_tbl_get_scan_value(v_s1.rec)));
      }
      else {
        rtn_putwarning(scon(scon(scpy("Unknown key '"), rtn_tbl_get_scan_key(v_s1.rec)), "' to a chapter"));
      }
      c_s1+=1;
      if (v_s1.branch==-1) {
        v_s1=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s1=rtn_ptrplus1(v_s1, 1);
      }
    }
    v_c1=rtn_tbl_add_chapter(v_c1);
    v_dbstate=0;
    v_cchapter=rtn_tbl_get_chapter_chapter(v_c1.rec);
    newptr(&v_p4, 22, 0);
    v_p4=rtn_addrecord(13);
    rtn_tbl_put_paragraph_paragraph(v_p4.rec, 0);
    rtn_tbl_put_paragraph_module(v_p4.rec, null);
    rtn_tbl_put_paragraph_chapter(v_p4.rec, null);
    rtn_tbl_put_paragraph_kind(v_p4.rec, -1);
    rtn_tbl_put_paragraph_heading(v_p4.rec, 0);
    rtn_tbl_put_paragraph_picture(v_p4.rec, 0);
    rtn_tbl_put_paragraph_text(v_p4.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_paragraph_module(v_p4.rec, rtn_tbl_get_module_module(v_m1.rec));
    rtn_tbl_put_paragraph_chapter(v_p4.rec, v_cchapter);
    v_p4=rtn_tbl_add_paragraph(v_p4);
    v_dbstate=0;
    v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p4.rec);
  }
  else {
    if (v_scantype==2 && scmp(v_scantag, "chapter")==0) {
      rtn_remaining_text();
      v_tagfound=1;
      v_cchapter=0;
    }
    else {
      if (v_scantype==1 && scmp(v_scantag, "list")==0) {
        rtn_remaining_text();
        newptr(&v_m2, 5, 0);
        v_m2=rtn_tbl_search_module(null);
        while (1) {
          if (v_m2.branch==-1) {
            v_m2=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_module_name(v_m2.rec), v_cmodule)==0) {
            break;
          }
          v_m2=rtn_ptrplus1(v_m2, 5);
        }
        if (!(v_m2.branch!=-1)) {
          rtn_puterror(scpy("Cannot find current module"));
        }
        v_tagfound=1;
        newptr(&v_p0, 22, 0);
        v_p0=rtn_addrecord(13);
        rtn_tbl_put_paragraph_paragraph(v_p0.rec, 0);
        rtn_tbl_put_paragraph_module(v_p0.rec, null);
        rtn_tbl_put_paragraph_chapter(v_p0.rec, null);
        rtn_tbl_put_paragraph_kind(v_p0.rec, -1);
        rtn_tbl_put_paragraph_heading(v_p0.rec, 0);
        rtn_tbl_put_paragraph_picture(v_p0.rec, 0);
        rtn_tbl_put_paragraph_text(v_p0.rec, 0);
        v_dbstate=1;
        rtn_tbl_put_paragraph_kind(v_p0.rec, 2);
        rtn_tbl_put_paragraph_module(v_p0.rec, rtn_tbl_get_module_module(v_m2.rec));
        rtn_tbl_put_paragraph_chapter(v_p0.rec, v_cchapter);
        newptr(&v_s2, 1, 0);
        c_s2=1;
        v_s2=rtn_getpointer(0, 0, 1);
        while (1) {
          if (v_s2.branch==-1) {
            break;
          }
          if (scmp(rtn_tbl_get_scan_key(v_s2.rec), "heading")==0) {
            rtn_tbl_put_paragraph_heading(v_p0.rec, scpy(rtn_tbl_get_scan_value(v_s2.rec)));
          }
          else {
            rtn_putwarning(scon(scon(scpy("Unknown keyword '"), rtn_tbl_get_scan_key(v_s2.rec)), "' found"));
          }
          c_s2+=1;
          if (v_s2.branch==-1) {
            v_s2=rtn_getpointer(0, 0, 1);
          }
          else {
            v_s2=rtn_ptrplus1(v_s2, 1);
          }
        }
        v_p0=rtn_tbl_add_paragraph(v_p0);
        v_dbstate=0;
        v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p0.rec);
        rtn_do_scan(scpy("list item"));
        if (rtn_length((var1=snew(var1, rtn_trim(v_scanstring))))>0) {
          rtn_putwarning(scon(sadd(scpy("Text '"), rtn_trim(v_scanstring)), "' skipped"));
        }
        while (1) {
          if (v_scantype==2 && scmp(v_scantag, "list")==0) {
            break;
          }
          if (v_scantype==1 && scmp(v_scantag, "item")==0) {
            newptr(&v_l3, 24, 0);
            v_l3=rtn_addrecord(14);
            rtn_tbl_put_list_paragraph(v_l3.rec, null);
            rtn_tbl_put_list_item(v_l3.rec, 0);
            rtn_tbl_put_list_name(v_l3.rec, 0);
            rtn_tbl_put_list_type(v_l3.rec, 0);
            rtn_tbl_put_list_value(v_l3.rec, 0);
            v_dbstate=1;
            rtn_tbl_put_list_paragraph(v_l3.rec, v_cparagraph);
            newptr(&v_s3, 1, 0);
            c_s3=1;
            v_s3=rtn_getpointer(0, 0, 1);
            while (1) {
              if (v_s3.branch==-1) {
                break;
              }
              if (scmp(rtn_tbl_get_scan_key(v_s3.rec), "name")==0) {
                rtn_tbl_put_list_name(v_l3.rec, scpy(rtn_tbl_get_scan_value(v_s3.rec)));
              }
              else {
                rtn_putwarning(scon(scon(scpy("Unknown keyword '"), rtn_tbl_get_scan_key(v_s3.rec)), "' found"));
              }
              c_s3+=1;
              if (v_s3.branch==-1) {
                v_s3=rtn_getpointer(0, 0, 1);
              }
              else {
                v_s3=rtn_ptrplus1(v_s3, 1);
              }
            }
            v_l3=rtn_tbl_add_list(v_l3);
            v_dbstate=0;
          }
          else {
            rtn_puterror(scon(scon(scon(sadd(scpy("Unknown "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " '"), v_scantag), "'"));
            break;
          }
          rtn_do_scan(scpy("list item"));
          v_l3=rtn_cpyrecord(v_l3, 14);
          v_dbstate=2;
          rtn_tbl_put_list_value(v_l3.rec, rtn_trim(v_scanstring));
          v_dbstate=3;
          v_l3=rtn_tbl_update_list(rtn_getrec(rtn_recalcptr(v_l3, 24), 14));
          v_dbstate=0;
          v_scanstring=snew(v_scanstring, 0);
        }
        if ((v_scantype!=2) || (scmp(v_scantag, "list")!=0)) {
          rtn_putwarning(scon(scon(scon(sadd(scpy("List not normally ended found "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " '"), v_scantag), "'"));
        }
      }
      else {
        if (v_scantype==1 && scmp(v_scantag, "sub")==0) {
          rtn_remaining_text();
          v_tagfound=1;
          newptr(&v_m3, 5, 0);
          v_m3=rtn_tbl_search_module(null);
          while (1) {
            if (v_m3.branch==-1) {
              v_m3=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_module_name(v_m3.rec), v_cmodule)==0) {
              break;
            }
            v_m3=rtn_ptrplus1(v_m3, 5);
          }
          if (!(v_m3.branch!=-1)) {
            rtn_puterror(scpy("Cannot find current module"));
          }
          newptr(&v_p1, 22, 0);
          v_p1=rtn_addrecord(13);
          rtn_tbl_put_paragraph_paragraph(v_p1.rec, 0);
          rtn_tbl_put_paragraph_module(v_p1.rec, null);
          rtn_tbl_put_paragraph_chapter(v_p1.rec, null);
          rtn_tbl_put_paragraph_kind(v_p1.rec, -1);
          rtn_tbl_put_paragraph_heading(v_p1.rec, 0);
          rtn_tbl_put_paragraph_picture(v_p1.rec, 0);
          rtn_tbl_put_paragraph_text(v_p1.rec, 0);
          v_dbstate=1;
          rtn_tbl_put_paragraph_kind(v_p1.rec, 0);
          rtn_tbl_put_paragraph_module(v_p1.rec, rtn_tbl_get_module_module(v_m3.rec));
          rtn_tbl_put_paragraph_chapter(v_p1.rec, v_cchapter);
          newptr(&v_s4, 1, 0);
          c_s4=1;
          v_s4=rtn_getpointer(0, 0, 1);
          while (1) {
            if (v_s4.branch==-1) {
              break;
            }
            if (scmp(rtn_tbl_get_scan_key(v_s4.rec), "title")==0) {
              rtn_tbl_put_paragraph_heading(v_p1.rec, scpy(rtn_tbl_get_scan_value(v_s4.rec)));
            }
            else {
              rtn_putwarning(scon(scon(scpy("Unknown keyword '"), rtn_tbl_get_scan_key(v_s4.rec)), "' found"));
            }
            c_s4+=1;
            if (v_s4.branch==-1) {
              v_s4=rtn_getpointer(0, 0, 1);
            }
            else {
              v_s4=rtn_ptrplus1(v_s4, 1);
            }
          }
          v_p1=rtn_tbl_add_paragraph(v_p1);
          v_dbstate=0;
          v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p1.rec);
        }
        else {
          if (v_scantype==1 && scmp(v_scantag, "syntax")==0) {
            rtn_remaining_text();
            v_tagfound=1;
            newptr(&v_m4, 5, 0);
            v_m4=rtn_tbl_search_module(null);
            while (1) {
              if (v_m4.branch==-1) {
                v_m4=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_module_name(v_m4.rec), v_cmodule)==0) {
                break;
              }
              v_m4=rtn_ptrplus1(v_m4, 5);
            }
            if (!(v_m4.branch!=-1)) {
              rtn_puterror(scpy("Cannot find current module"));
            }
            newptr(&v_p2, 22, 0);
            v_p2=rtn_addrecord(13);
            rtn_tbl_put_paragraph_paragraph(v_p2.rec, 0);
            rtn_tbl_put_paragraph_module(v_p2.rec, null);
            rtn_tbl_put_paragraph_chapter(v_p2.rec, null);
            rtn_tbl_put_paragraph_kind(v_p2.rec, -1);
            rtn_tbl_put_paragraph_heading(v_p2.rec, 0);
            rtn_tbl_put_paragraph_picture(v_p2.rec, 0);
            rtn_tbl_put_paragraph_text(v_p2.rec, 0);
            v_dbstate=1;
            rtn_tbl_put_paragraph_kind(v_p2.rec, 3);
            rtn_tbl_put_paragraph_module(v_p2.rec, rtn_tbl_get_module_module(v_m4.rec));
            rtn_tbl_put_paragraph_chapter(v_p2.rec, v_cchapter);
            newptr(&v_s5, 1, 0);
            c_s5=1;
            v_s5=rtn_getpointer(0, 0, 1);
            while (1) {
              if (v_s5.branch==-1) {
                break;
              }
              if (scmp(rtn_tbl_get_scan_key(v_s5.rec), "heading")==0) {
                rtn_tbl_put_paragraph_heading(v_p2.rec, scpy(rtn_tbl_get_scan_value(v_s5.rec)));
              }
              else {
                rtn_putwarning(scon(scon(scpy("Unknown keyword '"), rtn_tbl_get_scan_key(v_s5.rec)), "' found"));
              }
              c_s5+=1;
              if (v_s5.branch==-1) {
                v_s5=rtn_getpointer(0, 0, 1);
              }
              else {
                v_s5=rtn_ptrplus1(v_s5, 1);
              }
            }
            v_p2=rtn_tbl_add_paragraph(v_p2);
            v_dbstate=0;
            v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p2.rec);
            rtn_do_scan(scpy("description syntax"));
            c_str=1;
            {int spp=0; if (v_str!=0) free(v_str); v_str=0; while (spp>=0) {if (spp<0) break; v_str=isep(&spp, (var1=snew(var1, rtn_mid(v_scanstring, 2, 999))), rtn_char(10));
              newptr(&v_l1, 24, 0);
              v_l1=rtn_addrecord(14);
              rtn_tbl_put_list_paragraph(v_l1.rec, null);
              rtn_tbl_put_list_item(v_l1.rec, 0);
              rtn_tbl_put_list_name(v_l1.rec, 0);
              rtn_tbl_put_list_type(v_l1.rec, 0);
              rtn_tbl_put_list_value(v_l1.rec, 0);
              v_dbstate=1;
              rtn_tbl_put_list_paragraph(v_l1.rec, rtn_tbl_get_paragraph_paragraph(v_p2.rec));
              rtn_tbl_put_list_name(v_l1.rec, scpy(v_str));
              v_l1=rtn_tbl_add_list(v_l1);
              v_dbstate=0;
              c_str+=1;
            }}
            v_scanstring=snew(v_scanstring, 0);
            if (scmp(v_scantag, "description")==0) {
              rtn_do_scan(scpy("syntax"));
              c_str1=1;
              {int spp=0; if (v_str1!=0) free(v_str1); v_str1=0; while (spp>=0) {if (spp<0) break; v_str1=isep(&spp, (var1=snew(var1, rtn_mid(v_scanstring, 2, 999))), rtn_char(10));
                newptr(&v_l4, 24, 0);
                v_l4=rtn_tbl_search_list(v_cparagraph, c_str1);
                while (1) {
                  if ((v_l4.branch==-1) || ((rtn_tbl_get_list_paragraph(v_l4.rec)>v_cparagraph && rtn_tbl_get_list_item(v_l4.rec)>c_str1))) {
                    v_l4=rtn_nullpointer();
                    break;
                  }
                  if (rtn_tbl_get_list_paragraph(v_l4.rec)==v_cparagraph && rtn_tbl_get_list_item(v_l4.rec)==c_str1) {
                    break;
                  }
                  v_l4=rtn_ptrplus1(v_l4, 24);
                }
                if (v_l4.branch!=-1) {
                  v_l4=rtn_cpyrecord(v_l4, 14);
                  v_dbstate=2;
                  rtn_tbl_put_list_value(v_l4.rec, scpy(v_str1));
                  v_dbstate=3;
                  v_l4=rtn_tbl_update_list(rtn_getrec(rtn_recalcptr(v_l4, 24), 14));
                  v_dbstate=0;
                }
                else {
                  newptr(&v_l2, 24, 0);
                  v_l2=rtn_addrecord(14);
                  rtn_tbl_put_list_paragraph(v_l2.rec, null);
                  rtn_tbl_put_list_item(v_l2.rec, 0);
                  rtn_tbl_put_list_name(v_l2.rec, 0);
                  rtn_tbl_put_list_type(v_l2.rec, 0);
                  rtn_tbl_put_list_value(v_l2.rec, 0);
                  v_dbstate=1;
                  rtn_tbl_put_list_paragraph(v_l2.rec, v_cparagraph);
                  rtn_tbl_put_list_value(v_l2.rec, scpy(v_str1));
                  v_l2=rtn_tbl_add_list(v_l2);
                  v_dbstate=0;
                }
                c_str1+=1;
              }}
              v_scanstring=snew(v_scanstring, 0);
            }
            if ((v_scantype!=2) || (scmp(v_scantag, "syntax")!=0)) {
              rtn_putwarning(scon(scon(scon(sadd(scpy("Cannot find end of syntax found "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " '"), v_scantag), "'"));
            }
          }
        }
      }
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_m1, 5);
  delptr(&v_c1, 21);
  delptr(&v_s1, 1);
  delptr(&v_p4, 22);
  delptr(&v_m2, 5);
  delptr(&v_p0, 22);
  delptr(&v_s2, 1);
  delptr(&v_l3, 24);
  delptr(&v_s3, 1);
  delptr(&v_m3, 5);
  delptr(&v_p1, 22);
  delptr(&v_s4, 1);
  delptr(&v_m4, 5);
  delptr(&v_p2, 22);
  delptr(&v_s5, 1);
  delptr(&v_l1, 24);
  delptr(&v_l4, 24);
  delptr(&v_l2, 24);
}
 
 
void rtn_list_documentation() {
  FILE *v_o1=0;
  struct pointer v_c0={-1, -1, -1};
  long int c_c0=0;
  char *var1=0;
  struct pointer v_p0={-1, -1, -1};
  long int c_p0=0;
  struct pointer v_l0={-1, -1, -1};
  long int c_l0=0;
  v_o1=rtn_create("documentation.txt");
  swrite("Table: chapter", v_o1); wline(v_o1);
  newptr(&v_c0, 21, 0);
  c_c0=1;
  v_c0=rtn_getpointer(0, 0, 21);
  while (1) {
    if (v_c0.branch==-1) {
      break;
    }
    swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy(" '"), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_c0.rec)))), "', '"), get_int(rtn_tbl_get_chapter_module(v_c0.rec))), "', '"), rtn_tbl_get_chapter_title(v_c0.rec)), "'"))), v_o1); wline(v_o1);
    c_c0+=1;
    if (v_c0.branch==-1) {
      v_c0=rtn_getpointer(0, 0, 21);
    }
    else {
      v_c0=rtn_ptrplus1(v_c0, 21);
    }
  }
  swrite(" ", v_o1); wline(v_o1);
  swrite("Table: paragraph", v_o1); wline(v_o1);
  newptr(&v_p0, 23, 0);
  c_p0=1;
  v_p0=rtn_getpointer(0, 0, 23);
  while (1) {
    if (v_p0.branch==-1) {
      break;
    }
    swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scpy(" '"), scpy(get_sort(rtn_tbl_get_paragraph_paragraph(v_p0.rec)))), "', '"), get_int(rtn_tbl_get_paragraph_chapter(v_p0.rec))), "', '"), get_enum(rtn_tbl_get_paragraph_kind(v_p0.rec), "Text Picture List Code Def")), "', '"), rtn_tbl_get_paragraph_heading(v_p0.rec)), "', '"), rtn_tbl_get_paragraph_text(v_p0.rec)), "'"))), v_o1); wline(v_o1);
    c_p0+=1;
    if (v_p0.branch==-1) {
      v_p0=rtn_getpointer(0, 0, 23);
    }
    else {
      v_p0=rtn_ptrplus1(v_p0, 23);
    }
  }
  swrite(" ", v_o1); wline(v_o1);
  swrite("Table: list", v_o1); wline(v_o1);
  newptr(&v_l0, 24, 0);
  c_l0=1;
  v_l0=rtn_getpointer(0, 0, 24);
  while (1) {
    if (v_l0.branch==-1) {
      break;
    }
    swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scon(sadd(scpy(" '"), get_int(rtn_tbl_get_list_paragraph(v_l0.rec))), "', '"), scpy(get_sort(rtn_tbl_get_list_item(v_l0.rec)))), "', '"), rtn_tbl_get_list_name(v_l0.rec)), "', '"), rtn_tbl_get_list_value(v_l0.rec)), "'"))), v_o1); wline(v_o1);
    c_l0+=1;
    if (v_l0.branch==-1) {
      v_l0=rtn_getpointer(0, 0, 24);
    }
    else {
      v_l0=rtn_ptrplus1(v_l0, 24);
    }
  }
  rtn_close(v_o1);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_c0, 21);
  delptr(&v_p0, 23);
  delptr(&v_l0, 24);
}
 
 
void rtn_doc_def(char *v_name, char *v_type, char *v_use) {
  struct pointer v_p={-1, -1, -1};
  struct pointer v_m1={-1, -1, -1};
  struct pointer v_p1={-1, -1, -1};
  struct pointer v_l={-1, -1, -1};
  newptr(&v_p, 22, 0);
  v_p=rtn_tbl_search_paragraph(v_cparagraph);
  while (1) {
    if ((v_p.branch==-1) || ((rtn_tbl_get_paragraph_paragraph(v_p.rec)>v_cparagraph))) {
      v_p=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_paragraph_paragraph(v_p.rec)==v_cparagraph && rtn_tbl_get_paragraph_kind(v_p.rec)==4) {
      break;
    }
    v_p=rtn_ptrplus1(v_p, 22);
  }
  if (!(v_p.branch!=-1)) {
    newptr(&v_m1, 5, 0);
    v_m1=rtn_tbl_search_module(null);
    while (1) {
      if (v_m1.branch==-1) {
        v_m1=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_module_name(v_m1.rec), v_cmodule)==0) {
        break;
      }
      v_m1=rtn_ptrplus1(v_m1, 5);
    }
    if (!(v_m1.branch!=-1)) {
      rtn_puterror(scpy("Cannot find current module"));
    }
    newptr(&v_p1, 22, 0);
    v_p1=rtn_addrecord(13);
    rtn_tbl_put_paragraph_paragraph(v_p1.rec, 0);
    rtn_tbl_put_paragraph_module(v_p1.rec, null);
    rtn_tbl_put_paragraph_chapter(v_p1.rec, null);
    rtn_tbl_put_paragraph_kind(v_p1.rec, -1);
    rtn_tbl_put_paragraph_heading(v_p1.rec, 0);
    rtn_tbl_put_paragraph_picture(v_p1.rec, 0);
    rtn_tbl_put_paragraph_text(v_p1.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_paragraph_module(v_p1.rec, rtn_tbl_get_module_module(v_m1.rec));
    rtn_tbl_put_paragraph_chapter(v_p1.rec, v_cchapter);
    rtn_tbl_put_paragraph_kind(v_p1.rec, 4);
    v_p1=rtn_tbl_add_paragraph(v_p1);
    v_dbstate=0;
    v_cparagraph=rtn_tbl_get_paragraph_paragraph(v_p1.rec);
  }
  newptr(&v_l, 24, 0);
  v_l=rtn_addrecord(14);
  rtn_tbl_put_list_paragraph(v_l.rec, null);
  rtn_tbl_put_list_item(v_l.rec, 0);
  rtn_tbl_put_list_name(v_l.rec, 0);
  rtn_tbl_put_list_type(v_l.rec, 0);
  rtn_tbl_put_list_value(v_l.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_list_paragraph(v_l.rec, v_cparagraph);
  rtn_tbl_put_list_name(v_l.rec, scpy(v_name));
  rtn_tbl_put_list_type(v_l.rec, scpy(v_type));
  rtn_tbl_put_list_value(v_l.rec, scpy(v_use));
  v_l=rtn_tbl_add_list(v_l);
  v_dbstate=0;
  if (v_name!=0) {free(v_name); v_name=0;}
  if (v_type!=0) {free(v_type); v_type=0;}
  if (v_use!=0) {free(v_use); v_use=0;}
  delptr(&v_p, 22);
  delptr(&v_m1, 5);
  delptr(&v_p1, 22);
  delptr(&v_l, 24);
}
 
 
void rtn_export_website() {
  FILE *v_o=0;
  long int v_prevchp=0;
  long int v_nextchp=0;
  long int v_maxchap=0;
  struct pointer v_m={-1, -1, -1};
  long int c_m=0;
  struct pointer v_testch={-1, -1, -1};
  char *var1=0;
  struct pointer v_c0={-1, -1, -1};
  long int c_c0=0;
  char *var2=0;
  struct pointer v_c1={-1, -1, -1};
  long int c_c1=0;
  struct pointer v_p={-1, -1, -1};
  long int c_p=0;
  struct pointer v_l={-1, -1, -1};
  long int c_l=0;
  newptr(&v_m, 5, 0);
  c_m=1;
  v_m=rtn_getpointer(0, 0, 5);
  while (1) {
    if (v_m.branch==-1) {
      break;
    }
    newptr(&v_testch, 21, 0);
    v_testch=rtn_tbl_search_chapter(rtn_tbl_get_module_module(v_m.rec), 2);
    while (1) {
      if ((v_testch.branch==-1) || ((rtn_tbl_get_chapter_module(v_testch.rec)>rtn_tbl_get_module_module(v_m.rec) && rtn_tbl_get_chapter_chapter(v_testch.rec)>2))) {
        v_testch=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_chapter_module(v_testch.rec)==rtn_tbl_get_module_module(v_m.rec) && rtn_tbl_get_chapter_chapter(v_testch.rec)==2) {
        break;
      }
      v_testch=rtn_ptrplus1(v_testch, 21);
    }
    if (v_testch.branch!=-1) {
      v_o=rtn_create((var1=snew(var1, scon(scpy(rtn_tbl_get_module_name(v_m.rec)), ".html"))));
      swrite((var1=snew(var1, rtn_tag("HTML"))), v_o); wline(v_o);
      swrite((var1=snew(var1, rtn_tag("BODY TEXT=\"#000000\" BGCOLOR=\"#ffffff\" VLINK=\"#0\" LINK=\"#0\""))), v_o); wline(v_o);
      swrite((var1=snew(var1, sadd(scpy(rtn_tbl_get_module_title(v_m.rec)), rtn_tag("br")))), v_o); wline(v_o);
      swrite((var1=snew(var1, sadd(scon(rtn_tag("H1"), "Table of Contents"), rtn_tag("/H1")))), v_o); wline(v_o);
      newptr(&v_c0, 21, 0);
      c_c0=1;
      v_c0=rtn_tbl_search_chapter(rtn_tbl_get_module_module(v_m.rec), null);
      while (1) {
        if ((v_c0.branch==-1) || ((rtn_tbl_get_chapter_module(v_c0.rec)>rtn_tbl_get_module_module(v_m.rec)))) {
          break;
        }
        if (rtn_tbl_get_chapter_module(v_c0.rec)==rtn_tbl_get_module_module(v_m.rec)) {
          swrite((var2=snew(var2, sadd(sadd(scon(sadd(scon(scpy(get_sort(rtn_tbl_get_chapter_chapter(v_c0.rec))), " "), rtn_tag((var1=snew(var1, scon(sadd(scon(scpy("a href=\""), rtn_tbl_get_module_name(v_m.rec)), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_c0.rec)))), ".html\""))))), rtn_tbl_get_chapter_title(v_c0.rec)), rtn_tag("/a")), rtn_tag("br")))), v_o); wline(v_o);
          if (v_maxchap<rtn_tbl_get_chapter_chapter(v_c0.rec)) {
            v_maxchap=rtn_tbl_get_chapter_chapter(v_c0.rec);
          }
          c_c0+=1;
        }
        if (v_c0.branch==-1) {
          v_c0=rtn_getpointer(0, 0, 21);
        }
        else {
          v_c0=rtn_ptrplus1(v_c0, 21);
        }
      }
      c_c0-=1;
      swrite((var1=snew(var1, sadd(rtn_tag("/BODY"), rtn_tag("/HTML")))), v_o); wline(v_o);
      rtn_close(v_o);
    }
    newptr(&v_c1, 21, 0);
    c_c1=1;
    v_c1=rtn_tbl_search_chapter(rtn_tbl_get_module_module(v_m.rec), null);
    while (1) {
      if ((v_c1.branch==-1) || ((rtn_tbl_get_chapter_module(v_c1.rec)>rtn_tbl_get_module_module(v_m.rec)))) {
        break;
      }
      if (rtn_tbl_get_chapter_module(v_c1.rec)==rtn_tbl_get_module_module(v_m.rec)) {
        if (v_testch.branch!=-1) {
          v_o=rtn_create((var1=snew(var1, scon(sadd(scpy(rtn_tbl_get_module_name(v_m.rec)), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_c1.rec)))), ".html"))));
        }
        else {
          v_o=rtn_create((var1=snew(var1, scon(scpy(rtn_tbl_get_module_name(v_m.rec)), ".html"))));
        }
        swrite((var1=snew(var1, rtn_tag("HTML"))), v_o); wline(v_o);
        swrite((var1=snew(var1, rtn_tag("BODY TEXT=\"#000000\" BGCOLOR=\"#ffffff\" VLINK=\"#0\" LINK=\"#0\""))), v_o); wline(v_o);
        swrite((var1=snew(var1, sadd(rtn_tag("table"), rtn_tag("tr")))), v_o); wline(v_o);
        if (v_testch.branch!=-1) {
          swrite((var2=snew(var2, sadd(sadd(sadd(sadd(rtn_tag("td"), rtn_tag((var1=snew(var1, scon(scon(scpy("a href=\""), rtn_tbl_get_module_name(v_m.rec)), ".html\""))))), rtn_tag("IMG src=\"up30.gif\"")), rtn_tag("/a")), rtn_tag("/td")))), v_o); wline(v_o);
          if (rtn_tbl_get_chapter_chapter(v_c1.rec)>1) {
            v_prevchp=rtn_tbl_get_chapter_chapter(v_c1.rec)-1;
            swrite((var2=snew(var2, sadd(sadd(sadd(sadd(rtn_tag("td"), rtn_tag((var1=snew(var1, scon(sadd(scon(scpy("a href=\""), rtn_tbl_get_module_name(v_m.rec)), get_int(v_prevchp)), ".html\""))))), rtn_tag("IMG src=\"left30.gif\"")), rtn_tag("/a")), rtn_tag("/td")))), v_o); wline(v_o);
          }
        }
        if (v_testch.branch!=-1) {
          swrite((var1=snew(var1, sadd(scon(rtn_tag("td"), rtn_tbl_get_module_title(v_m.rec)), rtn_tag("/td")))), v_o); wline(v_o);
        }
        if (rtn_tbl_get_chapter_chapter(v_c1.rec)<v_maxchap && v_testch.branch!=-1) {
          v_nextchp=rtn_tbl_get_chapter_chapter(v_c1.rec)+1;
          swrite((var2=snew(var2, sadd(sadd(sadd(sadd(rtn_tag("td"), rtn_tag((var1=snew(var1, scon(sadd(scon(scpy("a href=\""), rtn_tbl_get_module_name(v_m.rec)), get_int(v_nextchp)), ".html\""))))), rtn_tag("IMG src=\"right30.gif\"")), rtn_tag("/a")), rtn_tag("/td")))), v_o); wline(v_o);
        }
        swrite((var1=snew(var1, sadd(rtn_tag("/tr"), rtn_tag("/table")))), v_o); wline(v_o);
        if (v_testch.branch!=-1) {
          swrite((var1=snew(var1, sadd(scon(scon(sadd(rtn_tag("H1"), scpy(get_sort(rtn_tbl_get_chapter_chapter(v_c1.rec)))), " : "), rtn_tbl_get_chapter_title(v_c1.rec)), rtn_tag("/H1")))), v_o); wline(v_o);
        }
        else {
          if (scmp(rtn_tbl_get_module_name(v_m.rec), "index")==0) {
            swrite((var1=snew(var1, sadd(scon(rtn_tag("H1"), rtn_tbl_get_module_title(v_m.rec)), rtn_tag("/H1")))), v_o); wline(v_o);
          }
          else {
            swrite((var1=snew(var1, sadd(scon(scon(scon(rtn_tag("H1"), rtn_tbl_get_module_name(v_m.rec)), ": "), rtn_tbl_get_module_title(v_m.rec)), rtn_tag("/H1")))), v_o); wline(v_o);
          }
        }
        newptr(&v_p, 23, 0);
        c_p=1;
        v_p=rtn_tbl_search_paragraphchapter(null, null, null);
        while (1) {
          if (v_p.branch==-1) {
            break;
          }
          if (rtn_tbl_get_paragraph_module(v_p.rec)==rtn_tbl_get_module_module(v_m.rec) && rtn_tbl_get_paragraph_chapter(v_p.rec)==rtn_tbl_get_chapter_chapter(v_c1.rec)) {
            if (rtn_tbl_get_paragraph_heading(v_p.rec)!=0) {
              swrite((var1=snew(var1, sadd(scon(rtn_tag("H3"), rtn_tbl_get_paragraph_heading(v_p.rec)), rtn_tag("/H3")))), v_o); wline(v_o);
            }
            if (((rtn_tbl_get_paragraph_kind(v_p.rec)==2) || (rtn_tbl_get_paragraph_kind(v_p.rec)==3)) || (rtn_tbl_get_paragraph_kind(v_p.rec)==4)) {
              swrite((var1=snew(var1, rtn_tag("table cellspacing=0"))), v_o); wline(v_o);
              newptr(&v_l, 24, 0);
              c_l=1;
              v_l=rtn_tbl_search_list(rtn_tbl_get_paragraph_paragraph(v_p.rec), null);
              while (1) {
                if ((v_l.branch==-1) || ((rtn_tbl_get_list_paragraph(v_l.rec)>rtn_tbl_get_paragraph_paragraph(v_p.rec)))) {
                  break;
                }
                if (rtn_tbl_get_list_paragraph(v_l.rec)==rtn_tbl_get_paragraph_paragraph(v_p.rec)) {
                  swrite((var1=snew(var1, rtn_tag("tr valign=top"))), v_o);
                  if (rtn_tbl_get_paragraph_kind(v_p.rec)==2) {
                    swrite((var1=snew(var1, sadd(sadd(rtn_tag("td"), rtn_tag("IMG SRC=\"pointer.gif\"")), rtn_tag("/td")))), v_o); wline(v_o);
                  }
                  if (rtn_tbl_get_paragraph_kind(v_p.rec)==3) {
                    swrite((var2=snew(var2, sadd(sadd(sadd(sadd(rtn_tag("td"), rtn_tag("FONT face=\"Courier\" size=2")), rtn_notag((var1=snew(var1, scon(scpy(rtn_tbl_get_list_name(v_l.rec)), " "))))), rtn_tag("/FONT")), rtn_tag("/td")))), v_o);
                  }
                  else {
                    if (rtn_tbl_get_paragraph_kind(v_p.rec)==4) {
                      swrite((var1=snew(var1, sadd(sadd(scon(rtn_tag("td"), rtn_tbl_get_list_name(v_l.rec)), rtn_notag(" ")), rtn_tag("/td")))), v_o);
                      swrite((var1=snew(var1, sadd(sadd(scon(rtn_tag("td"), rtn_tbl_get_list_type(v_l.rec)), rtn_notag(" ")), rtn_tag("/td")))), v_o);
                    }
                    else {
                      if (rtn_tbl_get_list_name(v_l.rec)!=0) {
                        swrite((var2=snew(var2, sadd(sadd(rtn_tag("td"), rtn_notag((var1=snew(var1, scon(scpy(rtn_tbl_get_list_name(v_l.rec)), " "))))), rtn_tag("/td")))), v_o);
                      }
                    }
                  }
                  swrite((var1=snew(var1, sadd(scon(rtn_tag("td"), rtn_tbl_get_list_value(v_l.rec)), rtn_tag("/td")))), v_o);
                  swrite((var1=snew(var1, rtn_tag("/tr"))), v_o); wline(v_o);
                  c_l+=1;
                }
                if (v_l.branch==-1) {
                  v_l=rtn_getpointer(0, 0, 24);
                }
                else {
                  v_l=rtn_ptrplus1(v_l, 24);
                }
              }
              c_l-=1;
              swrite((var1=snew(var1, rtn_tag("/table"))), v_o); wline(v_o);
            }
            if (rtn_tbl_get_paragraph_text(v_p.rec)!=0) {
              swrite((var1=snew(var1, rtn_trim(rtn_tbl_get_paragraph_text(v_p.rec)))), v_o); wline(v_o);
            }
            if (((rtn_tbl_get_paragraph_kind(v_p.rec)==0 && rtn_length((var1=snew(var1, rtn_trim(rtn_tbl_get_paragraph_text(v_p.rec)))))>0)) || (rtn_tbl_get_paragraph_kind(v_p.rec)==2)) {
              swrite((var1=snew(var1, rtn_tag("br"))), v_o);
            }
            c_p+=1;
          }
          if (v_p.branch==-1) {
            v_p=rtn_getpointer(0, 0, 23);
          }
          else {
            v_p=rtn_ptrplus1(v_p, 23);
          }
        }
        c_p-=1;
        swrite((var1=snew(var1, sadd(rtn_tag("/BODY"), rtn_tag("/HTML")))), v_o); wline(v_o);
        rtn_close(v_o);
        c_c1+=1;
      }
      if (v_c1.branch==-1) {
        v_c1=rtn_getpointer(0, 0, 21);
      }
      else {
        v_c1=rtn_ptrplus1(v_c1, 21);
      }
    }
    c_c1-=1;
    c_m+=1;
    if (v_m.branch==-1) {
      v_m=rtn_getpointer(0, 0, 5);
    }
    else {
      v_m=rtn_ptrplus1(v_m, 5);
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_m, 5);
  delptr(&v_testch, 21);
  delptr(&v_c0, 21);
  delptr(&v_c1, 21);
  delptr(&v_p, 23);
  delptr(&v_l, 24);
}
 
 
char *rtn_tbl_get_opdef_op(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) return 0;
  return *(char**)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+0);
}
 
void rtn_tbl_put_opdef_op(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in filling field opdef.op\n");
    return;
  }
  *(char**)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+0)=v_val;
}
 
void rtn_tbl_add_opdef_op(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in adding to field opdef.op\n");
    return;
  }
  *(char**)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+0)= 
  sadd(*(char**)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+0), v_val);
}
 
int rtn_tbl_get_opdef_left(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) return -1;
  return *(int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+4);
}
 
void rtn_tbl_put_opdef_left(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in filling field opdef.left\n");
    return;
  }
  *(int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+4)=v_val;
}
 
void rtn_tbl_add_opdef_left(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in adding to field opdef.left\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+4)+=v_val;
}
 
void rtn_tbl_sub_opdef_left(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("Error in subtraction from field opdef.left\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+4)-=v_val;
}
 
int rtn_tbl_get_opdef_right(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) return -1;
  return *(int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+8);
}
 
void rtn_tbl_put_opdef_right(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in filling field opdef.right\n");
    return;
  }
  *(int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+8)=v_val;
}
 
void rtn_tbl_add_opdef_right(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in adding to field opdef.right\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+8)+=v_val;
}
 
void rtn_tbl_sub_opdef_right(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("Error in subtraction from field opdef.right\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+8)-=v_val;
}
 
long int rtn_tbl_get_opdef_level(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) return null;
  return *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+12);
}
 
void rtn_tbl_put_opdef_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in filling field opdef.level\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+12)=v_val;
}
 
void rtn_tbl_add_opdef_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("error in adding to field opdef.level\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+12)+=v_val;
}
 
void rtn_tbl_sub_opdef_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[15].len) {
    printf("Error in subtraction from field opdef.level\n");
    return;
  }
  *(long int*)(u_table[15].ptr[v_rec/250]+(v_rec%250)*u_table[15].size+12)-=v_val;
}
 
struct pointer rtn_tbl_search_opdef(char *v_p_op) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 25, 1);
  newptr(&v_ptr, 25, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(25)+1);
    v_idx=rtn_getpointer(v_curr, 0, 25);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_op, rtn_tbl_get_opdef_op(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(25);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 25)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 25);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_op, rtn_tbl_get_opdef_op(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 25);
  }
  if (v_p_op!=0) {free(v_p_op); v_p_op=0;}
  delptr(&v_idx, 25);
  delptr(&v_ptr, 25);
  return v_ptr;
  if (v_p_op!=0) {free(v_p_op); v_p_op=0;}
  delptr(&v_idx, 25);
  delptr(&v_ptr, 25);
}
 
 
struct pointer rtn_tbl_search_oplevel(long int v_p_level, char *v_p_op) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 26, 1);
  newptr(&v_ptr, 26, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(26)+1);
    v_idx=rtn_getpointer(v_curr, 0, 26);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_level, rtn_tbl_get_opdef_level(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_op, rtn_tbl_get_opdef_op(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(26);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 26)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 26);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_level, rtn_tbl_get_opdef_level(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_op, rtn_tbl_get_opdef_op(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 26);
  }
  if (v_p_op!=0) {free(v_p_op); v_p_op=0;}
  delptr(&v_idx, 26);
  delptr(&v_ptr, 26);
  return v_ptr;
  if (v_p_op!=0) {free(v_p_op); v_p_op=0;}
  delptr(&v_idx, 26);
  delptr(&v_ptr, 26);
}
 
 
struct pointer rtn_tbl_add_opdef(struct pointer v_new) {
  struct pointer v_idx_opdef={-1, -1, -1};
  struct pointer v_idx_oplevel={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_opdef, 25, 1);
  newptr(&v_idx_oplevel, 26, 1);
  newptr(&v_last, 25, 1);
  v_idx_opdef=rtn_tbl_search_opdef(scpy(rtn_tbl_get_opdef_op(v_new.rec)));
  if (v_idx_opdef.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(25), rtn_maxleaf(rtn_maxbranch(25), 25), 25);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_opdef, 25);
  }
  v_idx_oplevel=rtn_tbl_search_oplevel(rtn_tbl_get_opdef_level(v_new.rec), scpy(rtn_tbl_get_opdef_op(v_new.rec)));
  rtn_addindex(v_idx_opdef, rtn_tablelen(15)-1, 25);
  rtn_addindex(v_idx_oplevel, rtn_tablelen(15)-1, 26);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(scon(scpy("add opdef(15):"), rtn_tbl_get_opdef_op(v_new.rec)), "|"), get_enum(rtn_tbl_get_opdef_left(v_new.rec), "no yes")), "|"), get_enum(rtn_tbl_get_opdef_right(v_new.rec), "no yes")), "|"), get_int(rtn_tbl_get_opdef_level(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 25);
    delptr(&v_idx_opdef, 25);
    delptr(&v_idx_oplevel, 26);
    delptr(&v_last, 25);
    return rtn_getpointer(0, 0, 25);
  }
  delptr(&v_new, 25);
  delptr(&v_idx_opdef, 25);
  delptr(&v_idx_oplevel, 26);
  delptr(&v_last, 25);
  return rtn_ptrplus1(v_last, 25);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 25);
  delptr(&v_idx_opdef, 25);
  delptr(&v_idx_oplevel, 26);
  delptr(&v_last, 25);
}
 
 
void rtn_tbl_delete_opdef(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 25, 1);
  newptr(&v_chk, 25, 1);
  newptr(&v_del, 25, 1);
  v_del=rtn_getrecptr(v_delrec, 15);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(scon(scpy("delete opdef(15):"), rtn_tbl_get_opdef_op(v_del.rec)), "|"), get_enum(rtn_tbl_get_opdef_left(v_del.rec), "no yes")), "|"), get_enum(rtn_tbl_get_opdef_right(v_del.rec), "no yes")), "|"), get_int(rtn_tbl_get_opdef_level(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_opdef(scpy(rtn_tbl_get_opdef_op(v_del.rec)));
  rtn_deleteindex(v_chk, 25);
  rtn_deleteindex(rtn_tbl_search_oplevel(rtn_tbl_get_opdef_level(v_del.rec), scpy(rtn_tbl_get_opdef_op(v_del.rec))), 26);
  rtn_tbl_put_opdef_op(v_del.rec, 0);
  if (rtn_getrec(v_del, 15)!=rtn_tablelen(15)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(15)-1, 25);
    rtn_changeindex(rtn_tbl_search_opdef(scpy(rtn_tbl_get_opdef_op(v_last.rec))), v_delrec, 25);
    rtn_changeindex(rtn_tbl_search_oplevel(rtn_tbl_get_opdef_level(v_last.rec), scpy(rtn_tbl_get_opdef_op(v_last.rec))), v_delrec, 26);
  }
  rtn_deleterecord(v_delrec, 15);
  if (v_chk.branch==-1) {
    delptr(&v_last, 25);
    delptr(&v_chk, 25);
    delptr(&v_del, 25);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 25);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 25);
  delptr(&v_chk, 25);
  delptr(&v_del, 25);
}
 
 
struct pointer rtn_tbl_update_opdef(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 25, 1);
  newptr(&v_del, 25, 1);
  v_del=rtn_getrecptr(v_rec, 15);
  v_new=rtn_tbl_search_opdef(scpy(rtn_tbl_get_opdef_op(v_del.rec)));
  rtn_deleteindex(v_new, 25);
  rtn_deleteindex(rtn_tbl_search_oplevel(rtn_tbl_get_opdef_level(v_del.rec), scpy(rtn_tbl_get_opdef_op(v_del.rec))), 26);
  rtn_deleterecord(v_rec, 15);
  rtn_addindex(rtn_tbl_search_opdef(scpy(rtn_tbl_get_opdef_op(v_new.rec))), rtn_getrec(v_new, 25), 25);
  rtn_addindex(rtn_tbl_search_oplevel(rtn_tbl_get_opdef_level(v_new.rec), scpy(rtn_tbl_get_opdef_op(v_new.rec))), rtn_getrec(v_new, 25), 26);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 15);
  }
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(scon(scpy("update opdef:"), rtn_tbl_get_opdef_op(v_new.rec)), "|"), get_enum(rtn_tbl_get_opdef_left(v_new.rec), "no yes")), "|"), get_enum(rtn_tbl_get_opdef_right(v_new.rec), "no yes")), "|"), get_int(rtn_tbl_get_opdef_level(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 25);
  delptr(&v_del, 25);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 25);
  delptr(&v_del, 25);
}
 
 
void rtn_tbl_clear_opdef() {
  
  long int r=0;
  long int branch;
  while (r < u_table[15].len) {
    if (*(char**)(u_table[15].ptr[r/250]+(r%250)*u_table[15].size+0)!=0) {free(*(char**)(u_table[15].ptr[r/250]+(r%250)*u_table[15].size+0)); *(char**)(u_table[15].ptr[r/250]+(r%250)*u_table[15].size+0)=0;}
    r++;
  }
  free(u_table[15].ptr);
  u_table[15].ptr=0;
  u_table[15].len=0;
  for(branch=0; branch < u_index[25].scale; branch++)
  { free(u_index[25].ptr[branch]);
  }
  free(u_index[25].len);
  free(u_index[25].ptr);
  u_index[25].scale=0;
  u_index[25].len=0;
  u_index[25].ptr=0;
  for(branch=0; branch < u_index[26].scale; branch++)
  { free(u_index[26].ptr[branch]);
  }
  free(u_index[26].len);
  free(u_index[26].ptr);
  u_index[26].scale=0;
  u_index[26].len=0;
  u_index[26].ptr=0;
  fprintf(v_log, "clear opdef(15)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_opdef() {
  
  return u_table[15].len;
}
 
void rtn_tbl_init_opdef() {
  
  u_table[15].len=0;
  u_table[15].size=16;
  u_table[15].ptr=0;
  u_index[25].tbl=15;
  u_index[25].scale=0;
  u_index[25].len=0;
  u_index[25].ptr=0;
  u_index[25].ptrs=0;
  u_index[25].padm=0;
  u_index[26].tbl=15;
  u_index[26].scale=0;
  u_index[26].len=0;
  u_index[26].ptr=0;
  u_index[26].ptrs=0;
  u_index[26].padm=0;
}
 
void rtn_tbl_write_opdef(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 25, 0);
  rtn_write(iscan(rtn_tbl_get_opdef_op(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_opdef_left(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_opdef_right(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_opdef_level(v_ptr.rec), v_stream);
  delptr(&v_ptr, 25);
}
 
 
struct pointer rtn_tbl_read_opdef(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 25, 0);
  v_new=rtn_addrecord(15);
  rtn_tbl_put_opdef_op(v_new.rec, 0);
  rtn_tbl_put_opdef_left(v_new.rec, -1);
  rtn_tbl_put_opdef_right(v_new.rec, -1);
  rtn_tbl_put_opdef_level(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_opdef_op(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_opdef_left(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_opdef_right(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_opdef_level(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_opdef(v_new);
  v_dbstate=0;
  delptr(&v_new, 25);
  return v_new;
  delptr(&v_new, 25);
}
 
 
char *rtn_tbl_get_type_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) return 0;
  return *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+0);
}
 
void rtn_tbl_put_type_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in filling field type.name\n");
    return;
  }
  *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+0)=v_val;
}
 
void rtn_tbl_add_type_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in adding to field type.name\n");
    return;
  }
  *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+0)= 
  sadd(*(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+0), v_val);
}
 
long int rtn_tbl_get_type_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) return 0;
  return *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+4);
}
 
void rtn_tbl_put_type_type(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in filling field type.type\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+4)=v_val;
}
 
void rtn_tbl_add_type_type(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in adding to field type.type\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+4)+=v_val;
}
 
void rtn_tbl_sub_type_type(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("Error in subtraction from field type.type\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+4)-=v_val;
}
 
char *rtn_tbl_get_type_define(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) return 0;
  return *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+8);
}
 
void rtn_tbl_put_type_define(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in filling field type.define\n");
    return;
  }
  *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+8)=v_val;
}
 
void rtn_tbl_add_type_define(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in adding to field type.define\n");
    return;
  }
  *(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+8)= 
  sadd(*(char**)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+8), v_val);
}
 
int rtn_tbl_get_type_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) return -1;
  return *(int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+12);
}
 
void rtn_tbl_put_type_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in filling field type.kind\n");
    return;
  }
  *(int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+12)=v_val;
}
 
void rtn_tbl_add_type_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in adding to field type.kind\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+12)+=v_val;
}
 
void rtn_tbl_sub_type_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("Error in subtraction from field type.kind\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+12)-=v_val;
}
 
long int rtn_tbl_get_type_length(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) return null;
  return *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+16);
}
 
void rtn_tbl_put_type_length(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in filling field type.length\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+16)=v_val;
}
 
void rtn_tbl_add_type_length(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("error in adding to field type.length\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+16)+=v_val;
}
 
void rtn_tbl_sub_type_length(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[16].len) {
    printf("Error in subtraction from field type.length\n");
    return;
  }
  *(long int*)(u_table[16].ptr[v_rec/250]+(v_rec%250)*u_table[16].size+16)-=v_val;
}
 
struct pointer rtn_tbl_search_type(long int v_p_type) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 27, 1);
  newptr(&v_ptr, 27, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(27)+1);
    v_idx=rtn_getpointer(v_curr, 0, 27);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_type, rtn_tbl_get_type_type(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(27);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 27)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 27);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_type, rtn_tbl_get_type_type(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 27);
  }
  delptr(&v_idx, 27);
  delptr(&v_ptr, 27);
  return v_ptr;
  delptr(&v_idx, 27);
  delptr(&v_ptr, 27);
}
 
 
struct pointer rtn_tbl_search_typename(char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 28, 1);
  newptr(&v_ptr, 28, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(28)+1);
    v_idx=rtn_getpointer(v_curr, 0, 28);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_type_name(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(28);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 28)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 28);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_type_name(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 28);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 28);
  delptr(&v_ptr, 28);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 28);
  delptr(&v_ptr, 28);
}
 
 
struct pointer rtn_tbl_add_type(struct pointer v_new) {
  struct pointer v_idx_type={-1, -1, -1};
  struct pointer v_idx_typename={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_type, 27, 1);
  newptr(&v_idx_typename, 28, 1);
  newptr(&v_last, 27, 1);
  rtn_tbl_put_type_type(v_new.rec, 999999999);
  v_idx_type=rtn_tbl_search_type(rtn_tbl_get_type_type(v_new.rec));
  if (v_idx_type.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(27), rtn_maxleaf(rtn_maxbranch(27), 27), 27);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_type, 27);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_type_type(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_type_type(v_new.rec, rtn_tbl_get_type_type(v_last.rec)+1);
  }
  v_idx_typename=rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_new.rec)));
  rtn_addindex(v_idx_type, rtn_tablelen(16)-1, 27);
  rtn_addindex(v_idx_typename, rtn_tablelen(16)-1, 28);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(scon(scpy("add type(16):"), rtn_tbl_get_type_name(v_new.rec)), "|"), scpy(get_sort(rtn_tbl_get_type_type(v_new.rec)))), "|"), rtn_tbl_get_type_define(v_new.rec)), "|"), get_enum(rtn_tbl_get_type_kind(v_new.rec), "full onlyparm")), "|"), get_int(rtn_tbl_get_type_length(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 27);
    delptr(&v_idx_type, 27);
    delptr(&v_idx_typename, 28);
    delptr(&v_last, 27);
    return rtn_getpointer(0, 0, 27);
  }
  delptr(&v_new, 27);
  delptr(&v_idx_type, 27);
  delptr(&v_idx_typename, 28);
  delptr(&v_last, 27);
  return rtn_ptrplus1(v_last, 27);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 27);
  delptr(&v_idx_type, 27);
  delptr(&v_idx_typename, 28);
  delptr(&v_last, 27);
}
 
 
void rtn_tbl_delete_type(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 27, 1);
  newptr(&v_chk, 27, 1);
  newptr(&v_del, 27, 1);
  v_del=rtn_getrecptr(v_delrec, 16);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(scon(scpy("delete type(16):"), rtn_tbl_get_type_name(v_del.rec)), "|"), scpy(get_sort(rtn_tbl_get_type_type(v_del.rec)))), "|"), rtn_tbl_get_type_define(v_del.rec)), "|"), get_enum(rtn_tbl_get_type_kind(v_del.rec), "full onlyparm")), "|"), get_int(rtn_tbl_get_type_length(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_type(rtn_tbl_get_type_type(v_del.rec));
  rtn_deleteindex(v_chk, 27);
  v_chk=rtn_tbl_search_type(rtn_tbl_get_type_type(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_del.rec))), 28);
  rtn_tbl_put_type_name(v_del.rec, 0);
  rtn_tbl_put_type_define(v_del.rec, 0);
  if (rtn_getrec(v_del, 16)!=rtn_tablelen(16)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(16)-1, 27);
    rtn_changeindex(rtn_tbl_search_type(rtn_tbl_get_type_type(v_last.rec)), v_delrec, 27);
    rtn_changeindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_last.rec))), v_delrec, 28);
  }
  rtn_deleterecord(v_delrec, 16);
  if (v_chk.branch==-1) {
    delptr(&v_last, 27);
    delptr(&v_chk, 27);
    delptr(&v_del, 27);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 27);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_type_type(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 16);
    rtn_deleteindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_chk.rec))), 28);
    rtn_tbl_sub_type_type(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_chk.rec))), v_rec, 28);
    v_chk=rtn_ptrplus1(v_chk, 27);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 27);
  delptr(&v_chk, 27);
  delptr(&v_del, 27);
}
 
 
struct pointer rtn_tbl_update_type(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 27, 1);
  newptr(&v_del, 27, 1);
  v_del=rtn_getrecptr(v_rec, 16);
  v_new=rtn_tbl_search_type(rtn_tbl_get_type_type(v_del.rec));
  rtn_deleteindex(v_new, 27);
  rtn_deleteindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_del.rec))), 28);
  rtn_deleterecord(v_rec, 16);
  rtn_addindex(rtn_tbl_search_type(rtn_tbl_get_type_type(v_new.rec)), rtn_getrec(v_new, 27), 27);
  rtn_addindex(rtn_tbl_search_typename(scpy(rtn_tbl_get_type_name(v_new.rec))), rtn_getrec(v_new, 27), 28);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 16);
  }
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(scon(scon(sadd(scon(scon(scpy("update type:"), rtn_tbl_get_type_name(v_new.rec)), "|"), scpy(get_sort(rtn_tbl_get_type_type(v_new.rec)))), "|"), rtn_tbl_get_type_define(v_new.rec)), "|"), get_enum(rtn_tbl_get_type_kind(v_new.rec), "full onlyparm")), "|"), get_int(rtn_tbl_get_type_length(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 27);
  delptr(&v_del, 27);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 27);
  delptr(&v_del, 27);
}
 
 
void rtn_tbl_clear_type() {
  
  long int r=0;
  long int branch;
  while (r < u_table[16].len) {
    if (*(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+0)!=0) {free(*(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+0)); *(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+0)=0;}
    if (*(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+8)!=0) {free(*(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+8)); *(char**)(u_table[16].ptr[r/250]+(r%250)*u_table[16].size+8)=0;}
    r++;
  }
  free(u_table[16].ptr);
  u_table[16].ptr=0;
  u_table[16].len=0;
  for(branch=0; branch < u_index[27].scale; branch++)
  { free(u_index[27].ptr[branch]);
  }
  free(u_index[27].len);
  free(u_index[27].ptr);
  u_index[27].scale=0;
  u_index[27].len=0;
  u_index[27].ptr=0;
  for(branch=0; branch < u_index[28].scale; branch++)
  { free(u_index[28].ptr[branch]);
  }
  free(u_index[28].len);
  free(u_index[28].ptr);
  u_index[28].scale=0;
  u_index[28].len=0;
  u_index[28].ptr=0;
  fprintf(v_log, "clear type(16)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_type() {
  
  return u_table[16].len;
}
 
void rtn_tbl_init_type() {
  
  u_table[16].len=0;
  u_table[16].size=20;
  u_table[16].ptr=0;
  u_index[27].tbl=16;
  u_index[27].scale=0;
  u_index[27].len=0;
  u_index[27].ptr=0;
  u_index[27].ptrs=0;
  u_index[27].padm=0;
  u_index[28].tbl=16;
  u_index[28].scale=0;
  u_index[28].len=0;
  u_index[28].ptr=0;
  u_index[28].ptrs=0;
  u_index[28].padm=0;
}
 
void rtn_tbl_write_type(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 27, 0);
  rtn_write(iscan(rtn_tbl_get_type_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_type_type(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_type_define(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_type_kind(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_type_length(v_ptr.rec), v_stream);
  delptr(&v_ptr, 27);
}
 
 
struct pointer rtn_tbl_read_type(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 27, 0);
  v_new=rtn_addrecord(16);
  rtn_tbl_put_type_name(v_new.rec, 0);
  rtn_tbl_put_type_type(v_new.rec, 0);
  rtn_tbl_put_type_define(v_new.rec, 0);
  rtn_tbl_put_type_kind(v_new.rec, -1);
  rtn_tbl_put_type_length(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_type_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_type_type(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_type_define(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_type_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_type_length(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_type(v_new);
  v_dbstate=0;
  delptr(&v_new, 27);
  return v_new;
  delptr(&v_new, 27);
}
 
 
char *rtn_tbl_get_action_ident(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+0);
}
 
void rtn_tbl_put_action_ident(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.ident\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+0)=v_val;
}
 
void rtn_tbl_add_action_ident(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.ident\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+0)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+0), v_val);
}
 
long int rtn_tbl_get_action_action(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+4);
}
 
void rtn_tbl_put_action_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.action\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+4)=v_val;
}
 
void rtn_tbl_add_action_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.action\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+4)+=v_val;
}
 
void rtn_tbl_sub_action_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("Error in subtraction from field action.action\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+4)-=v_val;
}
 
char *rtn_tbl_get_action_left(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+8);
}
 
void rtn_tbl_put_action_left(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.left\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+8)=v_val;
}
 
void rtn_tbl_add_action_left(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.left\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+8)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+8), v_val);
}
 
char *rtn_tbl_get_action_op(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+12);
}
 
void rtn_tbl_put_action_op(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.op\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+12)=v_val;
}
 
void rtn_tbl_add_action_op(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.op\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+12)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+12), v_val);
}
 
char *rtn_tbl_get_action_right(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+16);
}
 
void rtn_tbl_put_action_right(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.right\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+16)=v_val;
}
 
void rtn_tbl_add_action_right(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.right\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+16)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+16), v_val);
}
 
long int rtn_tbl_get_action_parms(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return null;
  return *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+20);
}
 
void rtn_tbl_put_action_parms(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.parms\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+20)=v_val;
}
 
void rtn_tbl_add_action_parms(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.parms\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+20)+=v_val;
}
 
void rtn_tbl_sub_action_parms(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("Error in subtraction from field action.parms\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+20)-=v_val;
}
 
int rtn_tbl_get_action_cleft(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return -1;
  return *(int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+24);
}
 
void rtn_tbl_put_action_cleft(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.cleft\n");
    return;
  }
  *(int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+24)=v_val;
}
 
void rtn_tbl_add_action_cleft(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.cleft\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+24)+=v_val;
}
 
void rtn_tbl_sub_action_cleft(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("Error in subtraction from field action.cleft\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+24)-=v_val;
}
 
int rtn_tbl_get_action_cright(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return -1;
  return *(int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+28);
}
 
void rtn_tbl_put_action_cright(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.cright\n");
    return;
  }
  *(int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+28)=v_val;
}
 
void rtn_tbl_add_action_cright(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.cright\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+28)+=v_val;
}
 
void rtn_tbl_sub_action_cright(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("Error in subtraction from field action.cright\n");
    return;
  }
  *(long int*)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+28)-=v_val;
}
 
char *rtn_tbl_get_action_result(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+32);
}
 
void rtn_tbl_put_action_result(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.result\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+32)=v_val;
}
 
void rtn_tbl_add_action_result(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.result\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+32)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+32), v_val);
}
 
char *rtn_tbl_get_action_codefront(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+36);
}
 
void rtn_tbl_put_action_codefront(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.codefront\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+36)=v_val;
}
 
void rtn_tbl_add_action_codefront(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.codefront\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+36)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+36), v_val);
}
 
char *rtn_tbl_get_action_codeback(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+40);
}
 
void rtn_tbl_put_action_codeback(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.codeback\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+40)=v_val;
}
 
void rtn_tbl_add_action_codeback(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.codeback\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+40)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+40), v_val);
}
 
char *rtn_tbl_get_action_replace(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) return 0;
  return *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+44);
}
 
void rtn_tbl_put_action_replace(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in filling field action.replace\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+44)=v_val;
}
 
void rtn_tbl_add_action_replace(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[17].len) {
    printf("error in adding to field action.replace\n");
    return;
  }
  *(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+44)= 
  sadd(*(char**)(u_table[17].ptr[v_rec/250]+(v_rec%250)*u_table[17].size+44), v_val);
}
 
struct pointer rtn_tbl_search_action(long int v_p_action) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 29, 1);
  newptr(&v_ptr, 29, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(29)+1);
    v_idx=rtn_getpointer(v_curr, 0, 29);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(29);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 29)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 29);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 29);
  }
  delptr(&v_idx, 29);
  delptr(&v_ptr, 29);
  return v_ptr;
  delptr(&v_idx, 29);
  delptr(&v_ptr, 29);
}
 
 
struct pointer rtn_tbl_search_actionget(char *v_p_ident) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 30, 1);
  newptr(&v_ptr, 30, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(30)+1);
    v_idx=rtn_getpointer(v_curr, 0, 30);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_ident, rtn_tbl_get_action_ident(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(30);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 30)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 30);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_ident, rtn_tbl_get_action_ident(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 30);
  }
  if (v_p_ident!=0) {free(v_p_ident); v_p_ident=0;}
  delptr(&v_idx, 30);
  delptr(&v_ptr, 30);
  return v_ptr;
  if (v_p_ident!=0) {free(v_p_ident); v_p_ident=0;}
  delptr(&v_idx, 30);
  delptr(&v_ptr, 30);
}
 
 
struct pointer rtn_tbl_search_actionleft(char *v_p_left, long int v_p_action) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 31, 1);
  newptr(&v_ptr, 31, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(31)+1);
    v_idx=rtn_getpointer(v_curr, 0, 31);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_left, rtn_tbl_get_action_left(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(31);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 31)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 31);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_left, rtn_tbl_get_action_left(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 31);
  }
  if (v_p_left!=0) {free(v_p_left); v_p_left=0;}
  delptr(&v_idx, 31);
  delptr(&v_ptr, 31);
  return v_ptr;
  if (v_p_left!=0) {free(v_p_left); v_p_left=0;}
  delptr(&v_idx, 31);
  delptr(&v_ptr, 31);
}
 
 
struct pointer rtn_tbl_search_actionright(char *v_p_right, long int v_p_action) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 32, 1);
  newptr(&v_ptr, 32, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(32)+1);
    v_idx=rtn_getpointer(v_curr, 0, 32);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_right, rtn_tbl_get_action_right(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(32);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 32)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 32);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_right, rtn_tbl_get_action_right(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_action, rtn_tbl_get_action_action(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 32);
  }
  if (v_p_right!=0) {free(v_p_right); v_p_right=0;}
  delptr(&v_idx, 32);
  delptr(&v_ptr, 32);
  return v_ptr;
  if (v_p_right!=0) {free(v_p_right); v_p_right=0;}
  delptr(&v_idx, 32);
  delptr(&v_ptr, 32);
}
 
 
struct pointer rtn_tbl_add_action(struct pointer v_new) {
  struct pointer v_idx_action={-1, -1, -1};
  struct pointer v_idx_actionget={-1, -1, -1};
  struct pointer v_idx_actionleft={-1, -1, -1};
  struct pointer v_idx_actionright={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_action, 29, 1);
  newptr(&v_idx_actionget, 30, 1);
  newptr(&v_idx_actionleft, 31, 1);
  newptr(&v_idx_actionright, 32, 1);
  newptr(&v_last, 29, 1);
  rtn_tbl_put_action_action(v_new.rec, 999999999);
  v_idx_action=rtn_tbl_search_action(rtn_tbl_get_action_action(v_new.rec));
  if (v_idx_action.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(29), rtn_maxleaf(rtn_maxbranch(29), 29), 29);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_action, 29);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_action_action(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_action_action(v_new.rec, rtn_tbl_get_action_action(v_last.rec)+1);
  }
  v_idx_actionget=rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_new.rec)));
  v_idx_actionleft=rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_new.rec)), rtn_tbl_get_action_action(v_new.rec));
  v_idx_actionright=rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_new.rec)), rtn_tbl_get_action_action(v_new.rec));
  rtn_addindex(v_idx_action, rtn_tablelen(17)-1, 29);
  rtn_addindex(v_idx_actionget, rtn_tablelen(17)-1, 30);
  rtn_addindex(v_idx_actionleft, rtn_tablelen(17)-1, 31);
  rtn_addindex(v_idx_actionright, rtn_tablelen(17)-1, 32);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("add action(17):"), rtn_tbl_get_action_ident(v_new.rec)), "|"), scpy(get_sort(rtn_tbl_get_action_action(v_new.rec)))), "|"), rtn_tbl_get_action_left(v_new.rec)), "|"), rtn_tbl_get_action_op(v_new.rec)), "|"), rtn_tbl_get_action_right(v_new.rec)), "|"), get_int(rtn_tbl_get_action_parms(v_new.rec))), "|"), get_enum(rtn_tbl_get_action_cleft(v_new.rec), "true false")), "|"), get_enum(rtn_tbl_get_action_cright(v_new.rec), "true false")), "|"), rtn_tbl_get_action_result(v_new.rec)), "|"), rtn_tbl_get_action_codefront(v_new.rec)), "|"), rtn_tbl_get_action_codeback(v_new.rec)), "|"), rtn_tbl_get_action_replace(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 29);
    delptr(&v_idx_action, 29);
    delptr(&v_idx_actionget, 30);
    delptr(&v_idx_actionleft, 31);
    delptr(&v_idx_actionright, 32);
    delptr(&v_last, 29);
    return rtn_getpointer(0, 0, 29);
  }
  delptr(&v_new, 29);
  delptr(&v_idx_action, 29);
  delptr(&v_idx_actionget, 30);
  delptr(&v_idx_actionleft, 31);
  delptr(&v_idx_actionright, 32);
  delptr(&v_last, 29);
  return rtn_ptrplus1(v_last, 29);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 29);
  delptr(&v_idx_action, 29);
  delptr(&v_idx_actionget, 30);
  delptr(&v_idx_actionleft, 31);
  delptr(&v_idx_actionright, 32);
  delptr(&v_last, 29);
}
 
 
void rtn_tbl_delete_action(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 29, 1);
  newptr(&v_chk, 29, 1);
  newptr(&v_del, 29, 1);
  v_del=rtn_getrecptr(v_delrec, 17);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("delete action(17):"), rtn_tbl_get_action_ident(v_del.rec)), "|"), scpy(get_sort(rtn_tbl_get_action_action(v_del.rec)))), "|"), rtn_tbl_get_action_left(v_del.rec)), "|"), rtn_tbl_get_action_op(v_del.rec)), "|"), rtn_tbl_get_action_right(v_del.rec)), "|"), get_int(rtn_tbl_get_action_parms(v_del.rec))), "|"), get_enum(rtn_tbl_get_action_cleft(v_del.rec), "true false")), "|"), get_enum(rtn_tbl_get_action_cright(v_del.rec), "true false")), "|"), rtn_tbl_get_action_result(v_del.rec)), "|"), rtn_tbl_get_action_codefront(v_del.rec)), "|"), rtn_tbl_get_action_codeback(v_del.rec)), "|"), rtn_tbl_get_action_replace(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_action(rtn_tbl_get_action_action(v_del.rec));
  rtn_deleteindex(v_chk, 29);
  v_chk=rtn_tbl_search_action(rtn_tbl_get_action_action(v_del.rec)+1);
  rtn_deleteindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_del.rec))), 30);
  rtn_deleteindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_del.rec)), rtn_tbl_get_action_action(v_del.rec)), 31);
  rtn_deleteindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_del.rec)), rtn_tbl_get_action_action(v_del.rec)), 32);
  rtn_tbl_put_action_ident(v_del.rec, 0);
  rtn_tbl_put_action_left(v_del.rec, 0);
  rtn_tbl_put_action_op(v_del.rec, 0);
  rtn_tbl_put_action_right(v_del.rec, 0);
  rtn_tbl_put_action_result(v_del.rec, 0);
  rtn_tbl_put_action_codefront(v_del.rec, 0);
  rtn_tbl_put_action_codeback(v_del.rec, 0);
  rtn_tbl_put_action_replace(v_del.rec, 0);
  if (rtn_getrec(v_del, 17)!=rtn_tablelen(17)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(17)-1, 29);
    rtn_changeindex(rtn_tbl_search_action(rtn_tbl_get_action_action(v_last.rec)), v_delrec, 29);
    rtn_changeindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_last.rec))), v_delrec, 30);
    rtn_changeindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_last.rec)), rtn_tbl_get_action_action(v_last.rec)), v_delrec, 31);
    rtn_changeindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_last.rec)), rtn_tbl_get_action_action(v_last.rec)), v_delrec, 32);
  }
  rtn_deleterecord(v_delrec, 17);
  if (v_chk.branch==-1) {
    delptr(&v_last, 29);
    delptr(&v_chk, 29);
    delptr(&v_del, 29);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 29);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_action_action(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 17);
    rtn_deleteindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_chk.rec))), 30);
    rtn_deleteindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_chk.rec)), rtn_tbl_get_action_action(v_chk.rec)), 31);
    rtn_deleteindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_chk.rec)), rtn_tbl_get_action_action(v_chk.rec)), 32);
    rtn_tbl_sub_action_action(v_chk.rec, 1);
    rtn_addindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_chk.rec))), v_rec, 30);
    rtn_addindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_chk.rec)), rtn_tbl_get_action_action(v_chk.rec)), v_rec, 31);
    rtn_addindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_chk.rec)), rtn_tbl_get_action_action(v_chk.rec)), v_rec, 32);
    v_chk=rtn_ptrplus1(v_chk, 29);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 29);
  delptr(&v_chk, 29);
  delptr(&v_del, 29);
}
 
 
struct pointer rtn_tbl_update_action(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 29, 1);
  newptr(&v_del, 29, 1);
  v_del=rtn_getrecptr(v_rec, 17);
  v_new=rtn_tbl_search_action(rtn_tbl_get_action_action(v_del.rec));
  rtn_deleteindex(v_new, 29);
  rtn_deleteindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_del.rec))), 30);
  rtn_deleteindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_del.rec)), rtn_tbl_get_action_action(v_del.rec)), 31);
  rtn_deleteindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_del.rec)), rtn_tbl_get_action_action(v_del.rec)), 32);
  rtn_deleterecord(v_rec, 17);
  rtn_addindex(rtn_tbl_search_action(rtn_tbl_get_action_action(v_new.rec)), rtn_getrec(v_new, 29), 29);
  rtn_addindex(rtn_tbl_search_actionget(scpy(rtn_tbl_get_action_ident(v_new.rec))), rtn_getrec(v_new, 29), 30);
  rtn_addindex(rtn_tbl_search_actionleft(scpy(rtn_tbl_get_action_left(v_new.rec)), rtn_tbl_get_action_action(v_new.rec)), rtn_getrec(v_new, 29), 31);
  rtn_addindex(rtn_tbl_search_actionright(scpy(rtn_tbl_get_action_right(v_new.rec)), rtn_tbl_get_action_action(v_new.rec)), rtn_getrec(v_new, 29), 32);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 17);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("update action:"), rtn_tbl_get_action_ident(v_new.rec)), "|"), scpy(get_sort(rtn_tbl_get_action_action(v_new.rec)))), "|"), rtn_tbl_get_action_left(v_new.rec)), "|"), rtn_tbl_get_action_op(v_new.rec)), "|"), rtn_tbl_get_action_right(v_new.rec)), "|"), get_int(rtn_tbl_get_action_parms(v_new.rec))), "|"), get_enum(rtn_tbl_get_action_cleft(v_new.rec), "true false")), "|"), get_enum(rtn_tbl_get_action_cright(v_new.rec), "true false")), "|"), rtn_tbl_get_action_result(v_new.rec)), "|"), rtn_tbl_get_action_codefront(v_new.rec)), "|"), rtn_tbl_get_action_codeback(v_new.rec)), "|"), rtn_tbl_get_action_replace(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 29);
  delptr(&v_del, 29);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 29);
  delptr(&v_del, 29);
}
 
 
void rtn_tbl_clear_action() {
  
  long int r=0;
  long int branch;
  while (r < u_table[17].len) {
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+0)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+0)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+0)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+8)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+8)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+8)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+12)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+12)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+12)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+16)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+16)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+16)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+32)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+32)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+32)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+36)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+36)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+36)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+40)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+40)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+40)=0;}
    if (*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+44)!=0) {free(*(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+44)); *(char**)(u_table[17].ptr[r/250]+(r%250)*u_table[17].size+44)=0;}
    r++;
  }
  free(u_table[17].ptr);
  u_table[17].ptr=0;
  u_table[17].len=0;
  for(branch=0; branch < u_index[29].scale; branch++)
  { free(u_index[29].ptr[branch]);
  }
  free(u_index[29].len);
  free(u_index[29].ptr);
  u_index[29].scale=0;
  u_index[29].len=0;
  u_index[29].ptr=0;
  for(branch=0; branch < u_index[30].scale; branch++)
  { free(u_index[30].ptr[branch]);
  }
  free(u_index[30].len);
  free(u_index[30].ptr);
  u_index[30].scale=0;
  u_index[30].len=0;
  u_index[30].ptr=0;
  for(branch=0; branch < u_index[31].scale; branch++)
  { free(u_index[31].ptr[branch]);
  }
  free(u_index[31].len);
  free(u_index[31].ptr);
  u_index[31].scale=0;
  u_index[31].len=0;
  u_index[31].ptr=0;
  for(branch=0; branch < u_index[32].scale; branch++)
  { free(u_index[32].ptr[branch]);
  }
  free(u_index[32].len);
  free(u_index[32].ptr);
  u_index[32].scale=0;
  u_index[32].len=0;
  u_index[32].ptr=0;
  fprintf(v_log, "clear action(17)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_action() {
  
  return u_table[17].len;
}
 
void rtn_tbl_init_action() {
  
  u_table[17].len=0;
  u_table[17].size=48;
  u_table[17].ptr=0;
  u_index[29].tbl=17;
  u_index[29].scale=0;
  u_index[29].len=0;
  u_index[29].ptr=0;
  u_index[29].ptrs=0;
  u_index[29].padm=0;
  u_index[30].tbl=17;
  u_index[30].scale=0;
  u_index[30].len=0;
  u_index[30].ptr=0;
  u_index[30].ptrs=0;
  u_index[30].padm=0;
  u_index[31].tbl=17;
  u_index[31].scale=0;
  u_index[31].len=0;
  u_index[31].ptr=0;
  u_index[31].ptrs=0;
  u_index[31].padm=0;
  u_index[32].tbl=17;
  u_index[32].scale=0;
  u_index[32].len=0;
  u_index[32].ptr=0;
  u_index[32].ptrs=0;
  u_index[32].padm=0;
}
 
void rtn_tbl_write_action(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 29, 0);
  rtn_write(iscan(rtn_tbl_get_action_ident(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_action_action(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_left(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_op(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_right(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_action_parms(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_action_cleft(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_action_cright(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_result(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_codefront(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_codeback(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_action_replace(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 29);
}
 
 
struct pointer rtn_tbl_read_action(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 29, 0);
  v_new=rtn_addrecord(17);
  rtn_tbl_put_action_ident(v_new.rec, 0);
  rtn_tbl_put_action_action(v_new.rec, 0);
  rtn_tbl_put_action_left(v_new.rec, 0);
  rtn_tbl_put_action_op(v_new.rec, 0);
  rtn_tbl_put_action_right(v_new.rec, 0);
  rtn_tbl_put_action_parms(v_new.rec, null);
  rtn_tbl_put_action_cleft(v_new.rec, -1);
  rtn_tbl_put_action_cright(v_new.rec, -1);
  rtn_tbl_put_action_result(v_new.rec, 0);
  rtn_tbl_put_action_codefront(v_new.rec, 0);
  rtn_tbl_put_action_codeback(v_new.rec, 0);
  rtn_tbl_put_action_replace(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_action_ident(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_action(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_action_left(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_op(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_right(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_parms(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_action_cleft(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_action_cright(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_action_result(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_codefront(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_codeback(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_action_replace(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_action(v_new);
  v_dbstate=0;
  delptr(&v_new, 29);
  return v_new;
  delptr(&v_new, 29);
}
 
 
long int rtn_tbl_get_code_routine(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return null;
  return *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+0);
}
 
void rtn_tbl_put_code_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.routine\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+0)=v_val;
}
 
void rtn_tbl_add_code_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.routine\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+0)+=v_val;
}
 
void rtn_tbl_sub_code_routine(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("Error in subtraction from field code.routine\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+0)-=v_val;
}
 
int rtn_tbl_get_code_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return -1;
  return *(int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+4);
}
 
void rtn_tbl_put_code_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.kind\n");
    return;
  }
  *(int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+4)=v_val;
}
 
void rtn_tbl_add_code_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.kind\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+4)+=v_val;
}
 
void rtn_tbl_sub_code_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("Error in subtraction from field code.kind\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+4)-=v_val;
}
 
long int rtn_tbl_get_code_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return 0;
  return *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+8);
}
 
void rtn_tbl_put_code_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.order\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+8)=v_val;
}
 
void rtn_tbl_add_code_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.order\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+8)+=v_val;
}
 
void rtn_tbl_sub_code_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("Error in subtraction from field code.order\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+8)-=v_val;
}
 
long int rtn_tbl_get_code_action(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return null;
  return *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+12);
}
 
void rtn_tbl_put_code_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.action\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+12)=v_val;
}
 
void rtn_tbl_add_code_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.action\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+12)+=v_val;
}
 
void rtn_tbl_sub_code_action(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("Error in subtraction from field code.action\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+12)-=v_val;
}
 
long int rtn_tbl_get_code_block(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return null;
  return *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+16);
}
 
void rtn_tbl_put_code_block(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.block\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+16)=v_val;
}
 
void rtn_tbl_add_code_block(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.block\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+16)+=v_val;
}
 
void rtn_tbl_sub_code_block(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("Error in subtraction from field code.block\n");
    return;
  }
  *(long int*)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+16)-=v_val;
}
 
char *rtn_tbl_get_code_par(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return 0;
  return *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+20);
}
 
void rtn_tbl_put_code_par(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.par\n");
    return;
  }
  *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+20)=v_val;
}
 
void rtn_tbl_add_code_par(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.par\n");
    return;
  }
  *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+20)= 
  sadd(*(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+20), v_val);
}
 
char *rtn_tbl_get_code_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) return 0;
  return *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+24);
}
 
void rtn_tbl_put_code_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in filling field code.data\n");
    return;
  }
  *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+24)=v_val;
}
 
void rtn_tbl_add_code_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[18].len) {
    printf("error in adding to field code.data\n");
    return;
  }
  *(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+24)= 
  sadd(*(char**)(u_table[18].ptr[v_rec/250]+(v_rec%250)*u_table[18].size+24), v_val);
}
 
struct pointer rtn_tbl_search_code(long int v_p_routine, int v_p_kind, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 33, 1);
  newptr(&v_ptr, 33, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(33)+1);
    v_idx=rtn_getpointer(v_curr, 0, 33);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_code_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_kind, rtn_tbl_get_code_kind(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_code_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(33);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 33)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 33);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_routine, rtn_tbl_get_code_routine(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_kind, rtn_tbl_get_code_kind(v_idx.rec));
    }
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_code_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 33);
  }
  delptr(&v_idx, 33);
  delptr(&v_ptr, 33);
  return v_ptr;
  delptr(&v_idx, 33);
  delptr(&v_ptr, 33);
}
 
 
struct pointer rtn_tbl_add_code(struct pointer v_new) {
  struct pointer v_idx_code={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_code, 33, 1);
  newptr(&v_last, 33, 1);
  rtn_tbl_put_code_order(v_new.rec, 999999999);
  v_idx_code=rtn_tbl_search_code(rtn_tbl_get_code_routine(v_new.rec), rtn_tbl_get_code_kind(v_new.rec), rtn_tbl_get_code_order(v_new.rec));
  if (v_idx_code.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(33), rtn_maxleaf(rtn_maxbranch(33), 33), 33);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_code, 33);
  }
  if (((v_last.branch==-1) || (rtn_tbl_get_code_routine(v_last.rec)!=rtn_tbl_get_code_routine(v_new.rec))) || (rtn_tbl_get_code_kind(v_last.rec)!=rtn_tbl_get_code_kind(v_new.rec))) {
    rtn_tbl_put_code_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_code_order(v_new.rec, rtn_tbl_get_code_order(v_last.rec)+1);
  }
  rtn_addindex(v_idx_code, rtn_tablelen(18)-1, 33);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("add code(18):"), get_int(rtn_tbl_get_code_routine(v_new.rec))), "|"), get_enum(rtn_tbl_get_code_kind(v_new.rec), "define normal free")), "|"), scpy(get_sort(rtn_tbl_get_code_order(v_new.rec)))), "|"), get_int(rtn_tbl_get_code_action(v_new.rec))), "|"), get_int(rtn_tbl_get_code_block(v_new.rec))), "|"), rtn_tbl_get_code_par(v_new.rec)), "|"), rtn_tbl_get_code_data(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 33);
    delptr(&v_idx_code, 33);
    delptr(&v_last, 33);
    return rtn_getpointer(0, 0, 33);
  }
  delptr(&v_new, 33);
  delptr(&v_idx_code, 33);
  delptr(&v_last, 33);
  return rtn_ptrplus1(v_last, 33);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 33);
  delptr(&v_idx_code, 33);
  delptr(&v_last, 33);
}
 
 
void rtn_tbl_delete_code(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 33, 1);
  newptr(&v_chk, 33, 1);
  newptr(&v_del, 33, 1);
  v_del=rtn_getrecptr(v_delrec, 18);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("delete code(18):"), get_int(rtn_tbl_get_code_routine(v_del.rec))), "|"), get_enum(rtn_tbl_get_code_kind(v_del.rec), "define normal free")), "|"), scpy(get_sort(rtn_tbl_get_code_order(v_del.rec)))), "|"), get_int(rtn_tbl_get_code_action(v_del.rec))), "|"), get_int(rtn_tbl_get_code_block(v_del.rec))), "|"), rtn_tbl_get_code_par(v_del.rec)), "|"), rtn_tbl_get_code_data(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_code(rtn_tbl_get_code_routine(v_del.rec), rtn_tbl_get_code_kind(v_del.rec), rtn_tbl_get_code_order(v_del.rec));
  rtn_deleteindex(v_chk, 33);
  v_chk=rtn_tbl_search_code(rtn_tbl_get_code_routine(v_del.rec), rtn_tbl_get_code_kind(v_del.rec), rtn_tbl_get_code_order(v_del.rec)+1);
  rtn_tbl_put_code_par(v_del.rec, 0);
  rtn_tbl_put_code_data(v_del.rec, 0);
  if (rtn_getrec(v_del, 18)!=rtn_tablelen(18)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(18)-1, 33);
    rtn_changeindex(rtn_tbl_search_code(rtn_tbl_get_code_routine(v_last.rec), rtn_tbl_get_code_kind(v_last.rec), rtn_tbl_get_code_order(v_last.rec)), v_delrec, 33);
  }
  rtn_deleterecord(v_delrec, 18);
  if (v_chk.branch==-1) {
    delptr(&v_last, 33);
    delptr(&v_chk, 33);
    delptr(&v_del, 33);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 33);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_code_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 18);
    rtn_tbl_sub_code_order(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 33);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 33);
  delptr(&v_chk, 33);
  delptr(&v_del, 33);
}
 
 
struct pointer rtn_tbl_update_code(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 33, 1);
  newptr(&v_del, 33, 1);
  v_del=rtn_getrecptr(v_rec, 18);
  v_new=rtn_tbl_search_code(rtn_tbl_get_code_routine(v_del.rec), rtn_tbl_get_code_kind(v_del.rec), rtn_tbl_get_code_order(v_del.rec));
  rtn_deleteindex(v_new, 33);
  rtn_deleterecord(v_rec, 18);
  rtn_addindex(rtn_tbl_search_code(rtn_tbl_get_code_routine(v_new.rec), rtn_tbl_get_code_kind(v_new.rec), rtn_tbl_get_code_order(v_new.rec)), rtn_getrec(v_new, 33), 33);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 18);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("update code:"), get_int(rtn_tbl_get_code_routine(v_new.rec))), "|"), get_enum(rtn_tbl_get_code_kind(v_new.rec), "define normal free")), "|"), scpy(get_sort(rtn_tbl_get_code_order(v_new.rec)))), "|"), get_int(rtn_tbl_get_code_action(v_new.rec))), "|"), get_int(rtn_tbl_get_code_block(v_new.rec))), "|"), rtn_tbl_get_code_par(v_new.rec)), "|"), rtn_tbl_get_code_data(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 33);
  delptr(&v_del, 33);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 33);
  delptr(&v_del, 33);
}
 
 
void rtn_tbl_clear_code() {
  
  long int r=0;
  long int branch;
  while (r < u_table[18].len) {
    if (*(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+20)!=0) {free(*(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+20)); *(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+20)=0;}
    if (*(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+24)!=0) {free(*(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+24)); *(char**)(u_table[18].ptr[r/250]+(r%250)*u_table[18].size+24)=0;}
    r++;
  }
  free(u_table[18].ptr);
  u_table[18].ptr=0;
  u_table[18].len=0;
  for(branch=0; branch < u_index[33].scale; branch++)
  { free(u_index[33].ptr[branch]);
  }
  free(u_index[33].len);
  free(u_index[33].ptr);
  u_index[33].scale=0;
  u_index[33].len=0;
  u_index[33].ptr=0;
  fprintf(v_log, "clear code(18)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_code() {
  
  return u_table[18].len;
}
 
void rtn_tbl_init_code() {
  
  u_table[18].len=0;
  u_table[18].size=28;
  u_table[18].ptr=0;
  u_index[33].tbl=18;
  u_index[33].scale=0;
  u_index[33].len=0;
  u_index[33].ptr=0;
  u_index[33].ptrs=0;
  u_index[33].padm=0;
}
 
void rtn_tbl_write_code(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 33, 0);
  rtn_write(rtn_tbl_get_code_routine(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_code_kind(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_code_order(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_code_action(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_code_block(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_code_par(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_code_data(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 33);
}
 
 
struct pointer rtn_tbl_read_code(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 33, 0);
  v_new=rtn_addrecord(18);
  rtn_tbl_put_code_routine(v_new.rec, null);
  rtn_tbl_put_code_kind(v_new.rec, -1);
  rtn_tbl_put_code_order(v_new.rec, 0);
  rtn_tbl_put_code_action(v_new.rec, null);
  rtn_tbl_put_code_block(v_new.rec, null);
  rtn_tbl_put_code_par(v_new.rec, 0);
  rtn_tbl_put_code_data(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_code_routine(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_code_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_code_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_code_action(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_code_block(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_code_par(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_code_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_code(v_new);
  v_dbstate=0;
  delptr(&v_new, 33);
  return v_new;
  delptr(&v_new, 33);
}
 
 
char *rtn_tbl_get_reserved_keyword(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) return 0;
  return *(char**)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+0);
}
 
void rtn_tbl_put_reserved_keyword(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) {
    printf("error in filling field reserved.keyword\n");
    return;
  }
  *(char**)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+0)=v_val;
}
 
void rtn_tbl_add_reserved_keyword(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) {
    printf("error in adding to field reserved.keyword\n");
    return;
  }
  *(char**)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+0)= 
  sadd(*(char**)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+0), v_val);
}
 
int rtn_tbl_get_reserved_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) return -1;
  return *(int*)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+4);
}
 
void rtn_tbl_put_reserved_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) {
    printf("error in filling field reserved.type\n");
    return;
  }
  *(int*)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+4)=v_val;
}
 
void rtn_tbl_add_reserved_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) {
    printf("error in adding to field reserved.type\n");
    return;
  }
  *(long int*)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+4)+=v_val;
}
 
void rtn_tbl_sub_reserved_type(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[19].len) {
    printf("Error in subtraction from field reserved.type\n");
    return;
  }
  *(long int*)(u_table[19].ptr[v_rec/250]+(v_rec%250)*u_table[19].size+4)-=v_val;
}
 
struct pointer rtn_tbl_search_reserved(char *v_p_keyword, int v_p_type) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 34, 1);
  newptr(&v_ptr, 34, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(34)+1);
    v_idx=rtn_getpointer(v_curr, 0, 34);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_keyword, rtn_tbl_get_reserved_keyword(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_type, rtn_tbl_get_reserved_type(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(34);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 34)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 34);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_keyword, rtn_tbl_get_reserved_keyword(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_type, rtn_tbl_get_reserved_type(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 34);
  }
  if (v_p_keyword!=0) {free(v_p_keyword); v_p_keyword=0;}
  delptr(&v_idx, 34);
  delptr(&v_ptr, 34);
  return v_ptr;
  if (v_p_keyword!=0) {free(v_p_keyword); v_p_keyword=0;}
  delptr(&v_idx, 34);
  delptr(&v_ptr, 34);
}
 
 
struct pointer rtn_tbl_add_reserved(struct pointer v_new) {
  struct pointer v_idx_reserved={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_reserved, 34, 1);
  newptr(&v_last, 34, 1);
  v_idx_reserved=rtn_tbl_search_reserved(scpy(rtn_tbl_get_reserved_keyword(v_new.rec)), rtn_tbl_get_reserved_type(v_new.rec));
  if (v_idx_reserved.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(34), rtn_maxleaf(rtn_maxbranch(34), 34), 34);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_reserved, 34);
  }
  rtn_addindex(v_idx_reserved, rtn_tablelen(19)-1, 34);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("add reserved(19):"), rtn_tbl_get_reserved_keyword(v_new.rec)), "|"), get_enum(rtn_tbl_get_reserved_type(v_new.rec), "routine field")), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 34);
    delptr(&v_idx_reserved, 34);
    delptr(&v_last, 34);
    return rtn_getpointer(0, 0, 34);
  }
  delptr(&v_new, 34);
  delptr(&v_idx_reserved, 34);
  delptr(&v_last, 34);
  return rtn_ptrplus1(v_last, 34);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 34);
  delptr(&v_idx_reserved, 34);
  delptr(&v_last, 34);
}
 
 
void rtn_tbl_delete_reserved(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 34, 1);
  newptr(&v_chk, 34, 1);
  newptr(&v_del, 34, 1);
  v_del=rtn_getrecptr(v_delrec, 19);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("delete reserved(19):"), rtn_tbl_get_reserved_keyword(v_del.rec)), "|"), get_enum(rtn_tbl_get_reserved_type(v_del.rec), "routine field")), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_reserved(scpy(rtn_tbl_get_reserved_keyword(v_del.rec)), rtn_tbl_get_reserved_type(v_del.rec));
  rtn_deleteindex(v_chk, 34);
  rtn_tbl_put_reserved_keyword(v_del.rec, 0);
  if (rtn_getrec(v_del, 19)!=rtn_tablelen(19)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(19)-1, 34);
    rtn_changeindex(rtn_tbl_search_reserved(scpy(rtn_tbl_get_reserved_keyword(v_last.rec)), rtn_tbl_get_reserved_type(v_last.rec)), v_delrec, 34);
  }
  rtn_deleterecord(v_delrec, 19);
  if (v_chk.branch==-1) {
    delptr(&v_last, 34);
    delptr(&v_chk, 34);
    delptr(&v_del, 34);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 34);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 34);
  delptr(&v_chk, 34);
  delptr(&v_del, 34);
}
 
 
struct pointer rtn_tbl_update_reserved(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 34, 1);
  newptr(&v_del, 34, 1);
  v_del=rtn_getrecptr(v_rec, 19);
  v_new=rtn_tbl_search_reserved(scpy(rtn_tbl_get_reserved_keyword(v_del.rec)), rtn_tbl_get_reserved_type(v_del.rec));
  rtn_deleteindex(v_new, 34);
  rtn_deleterecord(v_rec, 19);
  rtn_addindex(rtn_tbl_search_reserved(scpy(rtn_tbl_get_reserved_keyword(v_new.rec)), rtn_tbl_get_reserved_type(v_new.rec)), rtn_getrec(v_new, 34), 34);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 19);
  }
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("update reserved:"), rtn_tbl_get_reserved_keyword(v_new.rec)), "|"), get_enum(rtn_tbl_get_reserved_type(v_new.rec), "routine field")), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 34);
  delptr(&v_del, 34);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 34);
  delptr(&v_del, 34);
}
 
 
void rtn_tbl_clear_reserved() {
  
  long int r=0;
  long int branch;
  while (r < u_table[19].len) {
    if (*(char**)(u_table[19].ptr[r/250]+(r%250)*u_table[19].size+0)!=0) {free(*(char**)(u_table[19].ptr[r/250]+(r%250)*u_table[19].size+0)); *(char**)(u_table[19].ptr[r/250]+(r%250)*u_table[19].size+0)=0;}
    r++;
  }
  free(u_table[19].ptr);
  u_table[19].ptr=0;
  u_table[19].len=0;
  for(branch=0; branch < u_index[34].scale; branch++)
  { free(u_index[34].ptr[branch]);
  }
  free(u_index[34].len);
  free(u_index[34].ptr);
  u_index[34].scale=0;
  u_index[34].len=0;
  u_index[34].ptr=0;
  fprintf(v_log, "clear reserved(19)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_reserved() {
  
  return u_table[19].len;
}
 
void rtn_tbl_init_reserved() {
  
  u_table[19].len=0;
  u_table[19].size=8;
  u_table[19].ptr=0;
  u_index[34].tbl=19;
  u_index[34].scale=0;
  u_index[34].len=0;
  u_index[34].ptr=0;
  u_index[34].ptrs=0;
  u_index[34].padm=0;
}
 
void rtn_tbl_write_reserved(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 34, 0);
  rtn_write(iscan(rtn_tbl_get_reserved_keyword(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_reserved_type(v_ptr.rec), v_stream);
  delptr(&v_ptr, 34);
}
 
 
struct pointer rtn_tbl_read_reserved(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 34, 0);
  v_new=rtn_addrecord(19);
  rtn_tbl_put_reserved_keyword(v_new.rec, 0);
  rtn_tbl_put_reserved_type(v_new.rec, -1);
  v_dbstate=1;
  rtn_tbl_put_reserved_keyword(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_reserved_type(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_reserved(v_new);
  v_dbstate=0;
  delptr(&v_new, 34);
  return v_new;
  delptr(&v_new, 34);
}
 
char *v_ctype=0;
char *v_cdata=0;
char *v_cvarname=0;
char *v_cdbtbl=0;
char *v_cdbfld=0;
 
void rtn_get_operations() {
  struct pointer v_opdef={-1, -1, -1};
  rtn_scankeyword();
  while (1) {
    if (v_keyword==0) {
      break;
    }
    newptr(&v_opdef, 25, 0);
    v_opdef=rtn_addrecord(15);
    rtn_tbl_put_opdef_op(v_opdef.rec, 0);
    rtn_tbl_put_opdef_left(v_opdef.rec, -1);
    rtn_tbl_put_opdef_right(v_opdef.rec, -1);
    rtn_tbl_put_opdef_level(v_opdef.rec, null);
    v_dbstate=1;
    if (scmp(v_keyword, "type")==0) {
      rtn_scankeyword();
      rtn_tbl_put_opdef_left(v_opdef.rec, 1);
    }
    else {
      rtn_tbl_put_opdef_left(v_opdef.rec, 0);
    }
    if (((scmp(v_keyword, "and")==0) || (scmp(v_keyword, "or")==0)) || (scmp(v_keyword, "not")==0)) {
      rtn_tbl_put_opdef_op(v_opdef.rec, scpy(v_keyword));
      rtn_scankeyword();
    }
    else {
      if (!(rtn_isalpha(v_keyword))) {
        rtn_tbl_put_opdef_op(v_opdef.rec, scpy(v_keyword));
        rtn_scankeyword();
        if (!(rtn_isalpha(v_keyword)) && scmp(v_keyword, ":")!=0) {
          rtn_tbl_add_opdef_op(v_opdef.rec, scpy(v_keyword));
          rtn_scankeyword();
        }
      }
    }
    if (scmp(v_keyword, "type")==0) {
      rtn_scankeyword();
      rtn_tbl_put_opdef_right(v_opdef.rec, 1);
    }
    else {
      rtn_tbl_put_opdef_right(v_opdef.rec, 0);
    }
    if (scmp(v_keyword, ":")==0) {
      rtn_scankeyword();
    }
    else {
      rtn_putwarning(scpy("Expected to find ':'"));
    }
    if (rtn_isnumber(v_keyword)) {
      rtn_tbl_put_opdef_level(v_opdef.rec, iscan(v_keyword));
    }
    else {
      rtn_putwarning(scon(scon(scpy("Expected to find level of operation '"), rtn_tbl_get_opdef_op(v_opdef.rec)), "'"));
    }
    rtn_scankeyword();
    v_opdef=rtn_tbl_add_opdef(v_opdef);
    v_dbstate=0;
  }
  delptr(&v_opdef, 25);
}
 
 
void rtn_get_action() {
  long int v_p=0;
  struct pointer v_a={-1, -1, -1};
  char *v_id=0;
  long int c_id=0;
  rtn_scankeyword();
  while (1) {
    if (v_keyword==0 && v_keywstr==0) {
      break;
    }
    if (v_keyword!=0) {
      rtn_putwarning(scon(scon(scpy("Found unexpected keyword '"), v_keyword), "' expecting string"));
    }
    else {
      newptr(&v_a, 29, 0);
      v_a=rtn_addrecord(17);
      rtn_tbl_put_action_ident(v_a.rec, 0);
      rtn_tbl_put_action_action(v_a.rec, 0);
      rtn_tbl_put_action_left(v_a.rec, 0);
      rtn_tbl_put_action_op(v_a.rec, 0);
      rtn_tbl_put_action_right(v_a.rec, 0);
      rtn_tbl_put_action_parms(v_a.rec, null);
      rtn_tbl_put_action_cleft(v_a.rec, -1);
      rtn_tbl_put_action_cright(v_a.rec, -1);
      rtn_tbl_put_action_result(v_a.rec, 0);
      rtn_tbl_put_action_codefront(v_a.rec, 0);
      rtn_tbl_put_action_codeback(v_a.rec, 0);
      rtn_tbl_put_action_replace(v_a.rec, 0);
      v_dbstate=1;
      rtn_tbl_put_action_ident(v_a.rec, scpy(v_keywstr));
      rtn_tbl_put_action_cleft(v_a.rec, 1);
      rtn_tbl_put_action_cright(v_a.rec, 1);
      rtn_tbl_put_action_parms(v_a.rec, 0);
      v_p=1;
      c_id=1;
      {int spp=0; if (v_id!=0) free(v_id); v_id=0; while (spp>=0) {if (spp<0) break; v_id=isep(&spp, v_keywstr, " ");
        if (v_p==1 && !(rtn_isalpha(v_id))) {
          v_p+=1;
        }
        switch (v_p) {
          case 1: 
          rtn_tbl_put_action_left(v_a.rec, scpy(v_id));
          break;
          case 2: 
          rtn_tbl_put_action_op(v_a.rec, scpy(v_id));
          break;
          case 3: 
          rtn_tbl_put_action_right(v_a.rec, scpy(v_id));
        }
        v_p+=1;
        c_id+=1;
      }}
      if (v_p<4) {
        rtn_tbl_put_action_right(v_a.rec, scpy(rtn_tbl_get_action_op(v_a.rec)));
        rtn_tbl_put_action_op(v_a.rec, scpy(rtn_tbl_get_action_left(v_a.rec)));
        rtn_tbl_put_action_left(v_a.rec, 0);
      }
      rtn_scankeyword();
      if (v_keyword==0 && v_keywstr!=0) {
        rtn_tbl_put_action_codefront(v_a.rec, scpy(v_keywstr));
        rtn_scankeyword();
      }
      if (v_keyword==0 && v_keywstr!=0) {
        rtn_tbl_put_action_codeback(v_a.rec, scpy(v_keywstr));
        rtn_scankeyword();
      }
      if (v_keyword!=0 && rtn_isnumber(v_keyword)) {
        rtn_tbl_put_action_parms(v_a.rec, iscan(v_keyword));
        rtn_scankeyword();
      }
      if (v_keyword!=0 && rtn_isalpha(v_keyword)) {
        rtn_tbl_put_action_result(v_a.rec, scpy(v_keyword));
        rtn_scankeyword();
      }
      v_a=rtn_tbl_add_action(v_a);
      v_dbstate=0;
      if (scmp(v_keyword, ".")!=0) {
        rtn_putwarning(scpy("Expected to find '.' after each action definition"));
      }
      else {
        rtn_scankeyword();
      }
    }
  }
  delptr(&v_a, 29);
}
 
 
void rtn_doc_types() {
  long int v_oldlvl=0;
  char *var1=0;
  struct pointer v_ol={-1, -1, -1};
  long int c_ol=0;
  char *var2=0;
  struct pointer v_a_t={-1, -1, -1};
  long int c_a_t=0;
  swrite((var1=snew(var1, sadd(scpy("Defined operations"), rtn_tag("br")))), v_logfile); wline(v_logfile);
  newptr(&v_ol, 26, 0);
  c_ol=1;
  v_ol=rtn_getpointer(0, 0, 26);
  while (1) {
    if (v_ol.branch==-1) {
      break;
    }
    if (v_oldlvl!=rtn_tbl_get_opdef_level(v_ol.rec)) {
      v_oldlvl=rtn_tbl_get_opdef_level(v_ol.rec);
      swrite((var1=snew(var1, sadd(sadd(scpy("Level "), get_int(rtn_tbl_get_opdef_level(v_ol.rec))), rtn_tag("br")))), v_logfile); wline(v_logfile);
    }
    swrite((var2=snew(var2, sadd(rtn_notag((var1=snew(var1, sadd(scon(scon(scon(get_enum(rtn_tbl_get_opdef_left(v_ol.rec), "no yes"), " "), rtn_tbl_get_opdef_op(v_ol.rec)), " "), get_enum(rtn_tbl_get_opdef_right(v_ol.rec), "no yes"))))), rtn_tag("br")))), v_logfile); wline(v_logfile);
    c_ol+=1;
    if (v_ol.branch==-1) {
      v_ol=rtn_getpointer(0, 0, 26);
    }
    else {
      v_ol=rtn_ptrplus1(v_ol, 26);
    }
  }
  swrite((var1=snew(var1, rtn_tag("br"))), v_logfile); wline(v_logfile);
  swrite((var1=snew(var1, sadd(scpy("Defined separate actions"), rtn_tag("br")))), v_logfile); wline(v_logfile);
  newptr(&v_a_t, 30, 0);
  c_a_t=1;
  v_a_t=rtn_getpointer(0, 0, 30);
  while (1) {
    if (v_a_t.branch==-1) {
      break;
    }
    swrite((var2=snew(var2, rtn_notag((var1=snew(var1, scon(scon(sadd(scon(scpy(rtn_tbl_get_action_ident(v_a_t.rec)), " "), get_int(rtn_tbl_get_action_parms(v_a_t.rec))), " "), rtn_tbl_get_action_result(v_a_t.rec))))))), v_logfile);
    if (rtn_tbl_get_action_replace(v_a_t.rec)!=0) {
      swrite((var2=snew(var2, rtn_notag((var1=snew(var1, scon(scon(scpy(" ["), rtn_tbl_get_action_replace(v_a_t.rec)), "]")))))), v_logfile);
    }
    if (rtn_tbl_get_action_cleft(v_a_t.rec)==0) {
      swrite(" cleft", v_logfile);
    }
    if (rtn_tbl_get_action_cright(v_a_t.rec)==0) {
      swrite(" cright", v_logfile);
    }
    swrite((var1=snew(var1, rtn_tag("br"))), v_logfile); wline(v_logfile);
    c_a_t+=1;
    if (v_a_t.branch==-1) {
      v_a_t=rtn_getpointer(0, 0, 30);
    }
    else {
      v_a_t=rtn_ptrplus1(v_a_t, 30);
    }
  }
  swrite((var1=snew(var1, rtn_tag("br"))), v_logfile); wline(v_logfile);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_ol, 26);
  delptr(&v_a_t, 30);
}
 
 
void rtn_calc_operation() {
  struct pointer v_a={-1, -1, -1};
  long int c_a=0;
  struct pointer v_l={-1, -1, -1};
  long int c_l=0;
  struct pointer v_cl={-1, -1, -1};
  char *var1=0;
  struct pointer v_nl={-1, -1, -1};
  struct pointer v_r={-1, -1, -1};
  long int c_r=0;
  struct pointer v_cr={-1, -1, -1};
  char *var2=0;
  struct pointer v_nr={-1, -1, -1};
  newptr(&v_a, 29, 0);
  c_a=1;
  v_a=rtn_getpointer(0, 0, 29);
  while (1) {
    if (v_a.branch==-1) {
      break;
    }
    if (scmp(rtn_tbl_get_action_op(v_a.rec), "->")==0) {
      newptr(&v_l, 31, 0);
      c_l=1;
      v_l=rtn_tbl_search_actionleft(0, null);
      while (1) {
        if (v_l.branch==-1) {
          break;
        }
        if (scmp(rtn_tbl_get_action_left(v_l.rec), rtn_tbl_get_action_right(v_a.rec))==0 && rtn_tbl_get_action_cleft(v_l.rec)==1 && scmp(rtn_tbl_get_action_op(v_l.rec), "->")!=0 && scmp(rtn_tbl_get_action_right(v_l.rec), "null")!=0) {
          newptr(&v_cl, 30, 0);
          v_cl=rtn_tbl_search_actionget(scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_a.rec)), " "), rtn_tbl_get_action_op(v_l.rec)), " "), rtn_tbl_get_action_right(v_l.rec)));
          while (1) {
            if ((v_cl.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_cl.rec), (var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_a.rec)), " "), rtn_tbl_get_action_op(v_l.rec)), " "), rtn_tbl_get_action_right(v_l.rec)))))>0))) {
              v_cl=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_cl.rec), (var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_a.rec)), " "), rtn_tbl_get_action_op(v_l.rec)), " "), rtn_tbl_get_action_right(v_l.rec)))))==0) {
              break;
            }
            v_cl=rtn_ptrplus1(v_cl, 30);
          }
          if (!(v_cl.branch!=-1)) {
            newptr(&v_nl, 29, 0);
            v_nl=rtn_addrecord(17);
            rtn_tbl_put_action_ident(v_nl.rec, 0);
            rtn_tbl_put_action_action(v_nl.rec, 0);
            rtn_tbl_put_action_left(v_nl.rec, 0);
            rtn_tbl_put_action_op(v_nl.rec, 0);
            rtn_tbl_put_action_right(v_nl.rec, 0);
            rtn_tbl_put_action_parms(v_nl.rec, null);
            rtn_tbl_put_action_cleft(v_nl.rec, -1);
            rtn_tbl_put_action_cright(v_nl.rec, -1);
            rtn_tbl_put_action_result(v_nl.rec, 0);
            rtn_tbl_put_action_codefront(v_nl.rec, 0);
            rtn_tbl_put_action_codeback(v_nl.rec, 0);
            rtn_tbl_put_action_replace(v_nl.rec, 0);
            v_dbstate=1;
            rtn_tbl_put_action_ident(v_nl.rec, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_a.rec)), " "), rtn_tbl_get_action_op(v_l.rec)), " "), rtn_tbl_get_action_right(v_l.rec)));
            rtn_tbl_put_action_left(v_nl.rec, scpy(rtn_tbl_get_action_left(v_a.rec)));
            rtn_tbl_put_action_cleft(v_nl.rec, 0);
            rtn_tbl_put_action_op(v_nl.rec, scpy(rtn_tbl_get_action_op(v_l.rec)));
            rtn_tbl_put_action_right(v_nl.rec, scpy(rtn_tbl_get_action_right(v_l.rec)));
            rtn_tbl_put_action_cright(v_nl.rec, rtn_tbl_get_action_cright(v_l.rec));
            if (rtn_tbl_get_action_replace(v_l.rec)!=0) {
              rtn_tbl_put_action_replace(v_nl.rec, scpy(rtn_tbl_get_action_replace(v_l.rec)));
            }
            else {
              rtn_tbl_put_action_replace(v_nl.rec, scpy(rtn_tbl_get_action_ident(v_l.rec)));
            }
            rtn_tbl_put_action_result(v_nl.rec, scpy(rtn_tbl_get_action_result(v_l.rec)));
            rtn_tbl_put_action_parms(v_nl.rec, rtn_tbl_get_action_parms(v_l.rec));
            v_nl=rtn_tbl_add_action(v_nl);
            v_dbstate=0;
          }
          c_l+=1;
        }
        if (v_l.branch==-1) {
          v_l=rtn_getpointer(0, 0, 31);
        }
        else {
          v_l=rtn_ptrplus1(v_l, 31);
        }
      }
      c_l-=1;
      newptr(&v_r, 32, 0);
      c_r=1;
      v_r=rtn_tbl_search_actionright(0, null);
      while (1) {
        if (v_r.branch==-1) {
          break;
        }
        if (scmp(rtn_tbl_get_action_right(v_r.rec), rtn_tbl_get_action_right(v_a.rec))==0 && rtn_tbl_get_action_cright(v_r.rec)==1 && scmp(rtn_tbl_get_action_op(v_r.rec), "->")!=0 && scmp(rtn_tbl_get_action_op(v_r.rec), "free")!=0) {
          newptr(&v_cr, 30, 0);
          v_cr=rtn_tbl_search_actionget(rtn_trim((var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_r.rec)), " "), rtn_tbl_get_action_op(v_r.rec)), " "), rtn_tbl_get_action_left(v_a.rec))))));
          while (1) {
            if ((v_cr.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_cr.rec), (var2=snew(var2, rtn_trim((var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_r.rec)), " "), rtn_tbl_get_action_op(v_r.rec)), " "), rtn_tbl_get_action_left(v_a.rec))))))))>0))) {
              v_cr=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_cr.rec), (var2=snew(var2, rtn_trim((var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_r.rec)), " "), rtn_tbl_get_action_op(v_r.rec)), " "), rtn_tbl_get_action_left(v_a.rec))))))))==0) {
              break;
            }
            v_cr=rtn_ptrplus1(v_cr, 30);
          }
          if (!(v_cr.branch!=-1)) {
            newptr(&v_nr, 29, 0);
            v_nr=rtn_addrecord(17);
            rtn_tbl_put_action_ident(v_nr.rec, 0);
            rtn_tbl_put_action_action(v_nr.rec, 0);
            rtn_tbl_put_action_left(v_nr.rec, 0);
            rtn_tbl_put_action_op(v_nr.rec, 0);
            rtn_tbl_put_action_right(v_nr.rec, 0);
            rtn_tbl_put_action_parms(v_nr.rec, null);
            rtn_tbl_put_action_cleft(v_nr.rec, -1);
            rtn_tbl_put_action_cright(v_nr.rec, -1);
            rtn_tbl_put_action_result(v_nr.rec, 0);
            rtn_tbl_put_action_codefront(v_nr.rec, 0);
            rtn_tbl_put_action_codeback(v_nr.rec, 0);
            rtn_tbl_put_action_replace(v_nr.rec, 0);
            v_dbstate=1;
            rtn_tbl_put_action_ident(v_nr.rec, rtn_trim((var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_action_left(v_r.rec)), " "), rtn_tbl_get_action_op(v_r.rec)), " "), rtn_tbl_get_action_left(v_a.rec))))));
            rtn_tbl_put_action_left(v_nr.rec, scpy(rtn_tbl_get_action_left(v_r.rec)));
            rtn_tbl_put_action_cleft(v_nr.rec, rtn_tbl_get_action_cleft(v_r.rec));
            rtn_tbl_put_action_op(v_nr.rec, scpy(rtn_tbl_get_action_op(v_r.rec)));
            rtn_tbl_put_action_right(v_nr.rec, scpy(rtn_tbl_get_action_left(v_a.rec)));
            rtn_tbl_put_action_cright(v_nr.rec, 0);
            if (rtn_tbl_get_action_replace(v_r.rec)!=0) {
              rtn_tbl_put_action_replace(v_nr.rec, scpy(rtn_tbl_get_action_replace(v_r.rec)));
            }
            else {
              rtn_tbl_put_action_replace(v_nr.rec, scpy(rtn_tbl_get_action_ident(v_r.rec)));
            }
            rtn_tbl_put_action_result(v_nr.rec, scpy(rtn_tbl_get_action_result(v_r.rec)));
            rtn_tbl_put_action_parms(v_nr.rec, rtn_tbl_get_action_parms(v_r.rec));
            v_nr=rtn_tbl_add_action(v_nr);
            v_dbstate=0;
          }
          c_r+=1;
        }
        if (v_r.branch==-1) {
          v_r=rtn_getpointer(0, 0, 32);
        }
        else {
          v_r=rtn_ptrplus1(v_r, 32);
        }
      }
      c_r-=1;
    }
    c_a+=1;
    if (v_a.branch==-1) {
      v_a=rtn_getpointer(0, 0, 29);
    }
    else {
      v_a=rtn_ptrplus1(v_a, 29);
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_a, 29);
  delptr(&v_l, 31);
  delptr(&v_cl, 30);
  delptr(&v_nl, 29);
  delptr(&v_r, 32);
  delptr(&v_cr, 30);
  delptr(&v_nr, 29);
}
 
 
void rtn_get_reserved(char *v_type) {
  struct pointer v_reserved={-1, -1, -1};
  rtn_scankeyword();
  while (1) {
    if (v_keyword==0) {
      break;
    }
    newptr(&v_reserved, 34, 0);
    v_reserved=rtn_addrecord(19);
    rtn_tbl_put_reserved_keyword(v_reserved.rec, 0);
    rtn_tbl_put_reserved_type(v_reserved.rec, -1);
    v_dbstate=1;
    rtn_tbl_put_reserved_keyword(v_reserved.rec, scpy(v_keyword));
    rtn_tbl_put_reserved_type(v_reserved.rec, ienum(v_type, "routine field"));
    v_reserved=rtn_tbl_add_reserved(v_reserved);
    v_dbstate=0;
    rtn_scankeyword();
  }
  delptr(&v_reserved, 34);
}
 
 
char rtn_is_reserved(char *v_check, int v_type) {
  struct pointer v_reserved={-1, -1, -1};
  newptr(&v_reserved, 34, 0);
  v_reserved=rtn_tbl_search_reserved(scpy(v_check), -1);
  while (1) {
    if ((v_reserved.branch==-1) || ((scmp(rtn_tbl_get_reserved_keyword(v_reserved.rec), v_check)>0))) {
      v_reserved=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_reserved_keyword(v_reserved.rec), v_check)==0 && rtn_tbl_get_reserved_type(v_reserved.rec)==v_type) {
      break;
    }
    v_reserved=rtn_ptrplus1(v_reserved, 34);
  }
  delptr(&v_reserved, 34);
  return v_reserved.branch!=-1;
  delptr(&v_reserved, 34);
}
 
 
void rtn_scan_type() {
  struct pointer v_type={-1, -1, -1};
  struct pointer v_s={-1, -1, -1};
  struct pointer v_ds={-1, -1, -1};
  struct pointer v_ls={-1, -1, -1};
  if (scmp(v_scantag, "operations")==0 && v_scantype==1) {
    v_tagfound=1;
    rtn_get_operations();
    rtn_do_scan(scpy("operations"));
    if ((scmp(v_scantag, "operations")!=0) || (v_scantype!=2)) {
      rtn_putwarning(scpy("Expecting end of operations definition"));
    }
  }
  else {
    if (scmp(v_scantag, "reserved_keywords")==0 && v_scantype==1) {
      v_tagfound=1;
      rtn_get_reserved("routine");
      rtn_do_scan(scpy("reserved_keywords"));
      if ((scmp(v_scantag, "reserved_keywords")!=0) || (v_scantype!=2)) {
        rtn_putwarning(scpy("Expected end of reserved_keywords"));
      }
    }
    else {
      if (scmp(v_scantag, "reserved_fields")==0 && v_scantype==1) {
        v_tagfound=1;
        rtn_get_reserved("fields");
        rtn_do_scan(scpy("reserved_fields"));
        if ((scmp(v_scantag, "reserved_fields")!=0) || (v_scantype!=2)) {
          rtn_putwarning(scpy("Expected end of reserved_fields"));
        }
      }
      else {
        if (scmp(v_scantag, "actions")==0 && v_scantype==1) {
          v_tagfound=1;
          while (1) {
            rtn_get_action();
            rtn_do_scan(scpy("actions type"));
            if (v_scantype==2 && scmp(v_scantag, "actions")==0) {
              break;
            }
            if (scmp(v_scantag, "type")==0 && v_scantype==1) {
              newptr(&v_type, 27, 0);
              v_type=rtn_addrecord(16);
              rtn_tbl_put_type_name(v_type.rec, 0);
              rtn_tbl_put_type_type(v_type.rec, 0);
              rtn_tbl_put_type_define(v_type.rec, 0);
              rtn_tbl_put_type_kind(v_type.rec, -1);
              rtn_tbl_put_type_length(v_type.rec, null);
              v_dbstate=1;
              newptr(&v_s, 1, 0);
              v_s=rtn_tbl_search_scan(null);
              while (1) {
                if (v_s.branch==-1) {
                  v_s=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_scan_key(v_s.rec), "name")==0) {
                  break;
                }
                v_s=rtn_ptrplus1(v_s, 1);
              }
              if (v_s.branch!=-1) {
                rtn_tbl_put_type_name(v_type.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
              }
              else {
                rtn_putwarning(scpy("Cannot find name of new type"));
              }
              newptr(&v_ds, 1, 0);
              v_ds=rtn_tbl_search_scan(null);
              while (1) {
                if (v_ds.branch==-1) {
                  v_ds=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_scan_key(v_ds.rec), "define")==0) {
                  break;
                }
                v_ds=rtn_ptrplus1(v_ds, 1);
              }
              if (v_ds.branch!=-1) {
                rtn_tbl_put_type_define(v_type.rec, scpy(rtn_tbl_get_scan_value(v_ds.rec)));
                swrite(rtn_tbl_get_scan_value(v_ds.rec), v_c); wline(v_c);
              }
              newptr(&v_ls, 1, 0);
              v_ls=rtn_tbl_search_scan(null);
              while (1) {
                if (v_ls.branch==-1) {
                  v_ls=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_scan_key(v_ls.rec), "length")==0) {
                  break;
                }
                v_ls=rtn_ptrplus1(v_ls, 1);
              }
              if (v_ls.branch!=-1) {
                rtn_tbl_put_type_length(v_type.rec, iscan(rtn_tbl_get_scan_value(v_ls.rec)));
              }
              v_type=rtn_tbl_add_type(v_type);
              v_dbstate=0;
              rtn_doc_def(scon(scpy("Type : "), rtn_tbl_get_type_name(v_type.rec)), 0, sadd(scpy("length : "), get_int(rtn_tbl_get_type_length(v_type.rec))));
            }
            else {
              rtn_putwarning(scon(scon(scpy("Unkown tag '"), v_scantag), "' found"));
              break;
            }
          }
          rtn_calc_operation();
        }
      }
    }
  }
  delptr(&v_type, 27);
  delptr(&v_s, 1);
  delptr(&v_ds, 1);
  delptr(&v_ls, 1);
}
 
 
char *rtn_typereplace(char *v_code, char *v_parameter, char *v_leftstr, char *v_rightstr, char *v_data) {
  char *v_r=0;
  char v_lu=0;
  char v_ru=0;
  char *v_f=0;
  long int c_f=0;
  char *var1=0;
  v_lu=0;
  v_ru=0;
  c_f=1;
  {int spp=0; if (v_f!=0) free(v_f); v_f=0; while (spp>=0) {if (spp<0) break; v_f=isep(&spp, v_code, "#");
    if (c_f==1) {
      v_r=snew(v_r, scpy(v_f));
    }
    else {
      if (scmp((var1=snew(var1, rtn_left(v_f, 1))), "1")==0) {
        v_r=sadd(v_r, sadd(scpy(v_leftstr), rtn_mid(v_f, 2, 9999)));
        v_lu=1;
      }
      else {
        if (scmp((var1=snew(var1, rtn_left(v_f, 1))), "2")==0) {
          v_r=sadd(v_r, sadd(scpy(v_rightstr), rtn_mid(v_f, 2, 9999)));
          v_ru=1;
        }
        else {
          if (scmp((var1=snew(var1, rtn_left(v_f, 1))), "d")==0) {
            v_r=sadd(v_r, sadd(scpy(v_data), rtn_mid(v_f, 2, 9999)));
          }
          else {
            if (scmp((var1=snew(var1, rtn_left(v_f, 1))), "p")==0) {
              v_r=sadd(v_r, sadd(scpy(v_parameter), rtn_mid(v_f, 2, 9999)));
            }
          }
        }
      }
    }
    c_f+=1;
  }}
  if (v_leftstr!=0 && !(v_lu)) {
    rtn_putwarning(scon(scon(scpy("Left side to definition '"), v_code), "' given but not used"));
  }
  if (v_rightstr!=0 && !(v_ru)) {
    rtn_putwarning(scon(scon(scpy("Right side to definition '"), v_code), "' given but not used"));
  }
  var1=snew(var1, scpy(v_r));
  if (v_code!=0) {free(v_code); v_code=0;}
  if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
  if (v_leftstr!=0) {free(v_leftstr); v_leftstr=0;}
  if (v_rightstr!=0) {free(v_rightstr); v_rightstr=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  return var1;
  if (var1!=0) {free(var1); var1=0;}
  if (v_code!=0) {free(v_code); v_code=0;}
  if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
  if (v_leftstr!=0) {free(v_leftstr); v_leftstr=0;}
  if (v_rightstr!=0) {free(v_rightstr); v_rightstr=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
}
 
long int v_lastcode=0;
long int v_highstore=0;
 
char *rtn_tbl_get_freevar_variable(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) return 0;
  return *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+0);
}
 
void rtn_tbl_put_freevar_variable(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in filling field freevar.variable\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+0)=v_val;
}
 
void rtn_tbl_add_freevar_variable(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in adding to field freevar.variable\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+0)= 
  sadd(*(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+0), v_val);
}
 
char *rtn_tbl_get_freevar_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) return 0;
  return *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+4);
}
 
void rtn_tbl_put_freevar_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in filling field freevar.type\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+4)=v_val;
}
 
void rtn_tbl_add_freevar_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in adding to field freevar.type\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+4)= 
  sadd(*(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+4), v_val);
}
 
char *rtn_tbl_get_freevar_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) return 0;
  return *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+8);
}
 
void rtn_tbl_put_freevar_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in filling field freevar.data\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+8)=v_val;
}
 
void rtn_tbl_add_freevar_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[20].len) {
    printf("error in adding to field freevar.data\n");
    return;
  }
  *(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+8)= 
  sadd(*(char**)(u_table[20].ptr[v_rec/250]+(v_rec%250)*u_table[20].size+8), v_val);
}
 
struct pointer rtn_tbl_search_freevar(char *v_p_variable) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 35, 1);
  newptr(&v_ptr, 35, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(35)+1);
    v_idx=rtn_getpointer(v_curr, 0, 35);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_variable, rtn_tbl_get_freevar_variable(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(35);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 35)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 35);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_variable, rtn_tbl_get_freevar_variable(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 35);
  }
  if (v_p_variable!=0) {free(v_p_variable); v_p_variable=0;}
  delptr(&v_idx, 35);
  delptr(&v_ptr, 35);
  return v_ptr;
  if (v_p_variable!=0) {free(v_p_variable); v_p_variable=0;}
  delptr(&v_idx, 35);
  delptr(&v_ptr, 35);
}
 
 
struct pointer rtn_tbl_add_freevar(struct pointer v_new) {
  struct pointer v_idx_freevar={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_freevar, 35, 1);
  newptr(&v_last, 35, 1);
  v_idx_freevar=rtn_tbl_search_freevar(scpy(rtn_tbl_get_freevar_variable(v_new.rec)));
  if (v_idx_freevar.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(35), rtn_maxleaf(rtn_maxbranch(35), 35), 35);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_freevar, 35);
  }
  rtn_addindex(v_idx_freevar, rtn_tablelen(20)-1, 35);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("add freevar(20):"), rtn_tbl_get_freevar_variable(v_new.rec)), "|"), rtn_tbl_get_freevar_type(v_new.rec)), "|"), rtn_tbl_get_freevar_data(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 35);
    delptr(&v_idx_freevar, 35);
    delptr(&v_last, 35);
    return rtn_getpointer(0, 0, 35);
  }
  delptr(&v_new, 35);
  delptr(&v_idx_freevar, 35);
  delptr(&v_last, 35);
  return rtn_ptrplus1(v_last, 35);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 35);
  delptr(&v_idx_freevar, 35);
  delptr(&v_last, 35);
}
 
 
void rtn_tbl_delete_freevar(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 35, 1);
  newptr(&v_chk, 35, 1);
  newptr(&v_del, 35, 1);
  v_del=rtn_getrecptr(v_delrec, 20);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("delete freevar(20):"), rtn_tbl_get_freevar_variable(v_del.rec)), "|"), rtn_tbl_get_freevar_type(v_del.rec)), "|"), rtn_tbl_get_freevar_data(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_freevar(scpy(rtn_tbl_get_freevar_variable(v_del.rec)));
  rtn_deleteindex(v_chk, 35);
  rtn_tbl_put_freevar_variable(v_del.rec, 0);
  rtn_tbl_put_freevar_type(v_del.rec, 0);
  rtn_tbl_put_freevar_data(v_del.rec, 0);
  if (rtn_getrec(v_del, 20)!=rtn_tablelen(20)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(20)-1, 35);
    rtn_changeindex(rtn_tbl_search_freevar(scpy(rtn_tbl_get_freevar_variable(v_last.rec))), v_delrec, 35);
  }
  rtn_deleterecord(v_delrec, 20);
  if (v_chk.branch==-1) {
    delptr(&v_last, 35);
    delptr(&v_chk, 35);
    delptr(&v_del, 35);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 35);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 35);
  delptr(&v_chk, 35);
  delptr(&v_del, 35);
}
 
 
struct pointer rtn_tbl_update_freevar(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 35, 1);
  newptr(&v_del, 35, 1);
  v_del=rtn_getrecptr(v_rec, 20);
  v_new=rtn_tbl_search_freevar(scpy(rtn_tbl_get_freevar_variable(v_del.rec)));
  rtn_deleteindex(v_new, 35);
  rtn_deleterecord(v_rec, 20);
  rtn_addindex(rtn_tbl_search_freevar(scpy(rtn_tbl_get_freevar_variable(v_new.rec))), rtn_getrec(v_new, 35), 35);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 20);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("update freevar:"), rtn_tbl_get_freevar_variable(v_new.rec)), "|"), rtn_tbl_get_freevar_type(v_new.rec)), "|"), rtn_tbl_get_freevar_data(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 35);
  delptr(&v_del, 35);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 35);
  delptr(&v_del, 35);
}
 
 
void rtn_tbl_clear_freevar() {
  
  long int r=0;
  long int branch;
  while (r < u_table[20].len) {
    if (*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+0)!=0) {free(*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+0)); *(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+0)=0;}
    if (*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+4)!=0) {free(*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+4)); *(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+4)=0;}
    if (*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+8)!=0) {free(*(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+8)); *(char**)(u_table[20].ptr[r/250]+(r%250)*u_table[20].size+8)=0;}
    r++;
  }
  free(u_table[20].ptr);
  u_table[20].ptr=0;
  u_table[20].len=0;
  for(branch=0; branch < u_index[35].scale; branch++)
  { free(u_index[35].ptr[branch]);
  }
  free(u_index[35].len);
  free(u_index[35].ptr);
  u_index[35].scale=0;
  u_index[35].len=0;
  u_index[35].ptr=0;
  fprintf(v_log, "clear freevar(20)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_freevar() {
  
  return u_table[20].len;
}
 
void rtn_tbl_init_freevar() {
  
  u_table[20].len=0;
  u_table[20].size=12;
  u_table[20].ptr=0;
  u_index[35].tbl=20;
  u_index[35].scale=0;
  u_index[35].len=0;
  u_index[35].ptr=0;
  u_index[35].ptrs=0;
  u_index[35].padm=0;
}
 
void rtn_tbl_write_freevar(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 35, 0);
  rtn_write(iscan(rtn_tbl_get_freevar_variable(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_freevar_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_freevar_data(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 35);
}
 
 
struct pointer rtn_tbl_read_freevar(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 35, 0);
  v_new=rtn_addrecord(20);
  rtn_tbl_put_freevar_variable(v_new.rec, 0);
  rtn_tbl_put_freevar_type(v_new.rec, 0);
  rtn_tbl_put_freevar_data(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_freevar_variable(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_freevar_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_freevar_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_freevar(v_new);
  v_dbstate=0;
  delptr(&v_new, 35);
  return v_new;
  delptr(&v_new, 35);
}
 
 
void rtn_addcode(long int v_action, char *v_parameter, char *v_data) {
  struct pointer v_a={-1, -1, -1};
  struct pointer v_freevar={-1, -1, -1};
  struct pointer v_cd={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_dix={-1, -1, -1};
  struct pointer v_numb={-1, -1, -1};
  struct pointer v_np={-1, -1, -1};
  newptr(&v_a, 29, 0);
  v_a=rtn_tbl_search_action(v_action);
  while (1) {
    if ((v_a.branch==-1) || ((rtn_tbl_get_action_action(v_a.rec)>v_action))) {
      v_a=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_action_action(v_a.rec)==v_action) {
      break;
    }
    v_a=rtn_ptrplus1(v_a, 29);
  }
  if (!(v_a.branch!=-1)) {
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 29);
    delptr(&v_freevar, 35);
    delptr(&v_cd, 33);
    delptr(&v_idx, 18);
    delptr(&v_dix, 18);
    delptr(&v_numb, 29);
    delptr(&v_np, 29);
    return;
  }
  if (scmp(rtn_tbl_get_action_op(v_a.rec), "free")==0 && scmp(v_data, "free")!=0) {
    newptr(&v_freevar, 35, 0);
    v_freevar=rtn_addrecord(20);
    rtn_tbl_put_freevar_variable(v_freevar.rec, 0);
    rtn_tbl_put_freevar_type(v_freevar.rec, 0);
    rtn_tbl_put_freevar_data(v_freevar.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_freevar_variable(v_freevar.rec, scpy(v_parameter));
    rtn_tbl_put_freevar_type(v_freevar.rec, scpy(rtn_tbl_get_action_right(v_a.rec)));
    v_freevar=rtn_tbl_add_freevar(v_freevar);
    v_dbstate=0;
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 29);
    delptr(&v_freevar, 35);
    delptr(&v_cd, 33);
    delptr(&v_idx, 18);
    delptr(&v_dix, 18);
    delptr(&v_numb, 29);
    delptr(&v_np, 29);
    return;
  }
  newptr(&v_cd, 33, 0);
  v_cd=rtn_addrecord(18);
  rtn_tbl_put_code_routine(v_cd.rec, null);
  rtn_tbl_put_code_kind(v_cd.rec, -1);
  rtn_tbl_put_code_order(v_cd.rec, 0);
  rtn_tbl_put_code_action(v_cd.rec, null);
  rtn_tbl_put_code_block(v_cd.rec, null);
  rtn_tbl_put_code_par(v_cd.rec, 0);
  rtn_tbl_put_code_data(v_cd.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_code_block(v_cd.rec, 0);
  rtn_tbl_put_code_action(v_cd.rec, v_action);
  rtn_tbl_put_code_routine(v_cd.rec, v_croutine);
  rtn_tbl_put_code_par(v_cd.rec, scpy(v_parameter));
  rtn_tbl_put_code_data(v_cd.rec, scpy(v_data));
  if (scmp(rtn_tbl_get_action_op(v_a.rec), "define")==0) {
    rtn_tbl_put_code_kind(v_cd.rec, 0);
  }
  else {
    if (scmp(v_data, "free")==0 && scmp(rtn_tbl_get_action_op(v_a.rec), "free")==0) {
      rtn_tbl_put_code_kind(v_cd.rec, 2);
      newptr(&v_idx, 18, 0);
      v_idx=rtn_tbl_search_indexname(0);
      while (1) {
        if (v_idx.branch==-1) {
          v_idx=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_cindex)==0) {
          break;
        }
        v_idx=rtn_ptrplus1(v_idx, 18);
      }
      if (v_idx.branch!=-1) {
        rtn_tbl_put_code_data(v_cd.rec, scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec))));
      }
    }
    else {
      rtn_tbl_put_code_kind(v_cd.rec, 1);
    }
  }
  v_cd=rtn_tbl_add_code(v_cd);
  v_dbstate=0;
  if (rtn_tbl_get_code_kind(v_cd.rec)==0 && scmp(rtn_tbl_get_action_ident(v_a.rec), "define pointer")==0) {
    newptr(&v_dix, 18, 0);
    v_dix=rtn_tbl_search_indexname(0);
    while (1) {
      if (v_dix.branch==-1) {
        v_dix=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_index_name(v_dix.rec), v_cindex)==0) {
        break;
      }
      v_dix=rtn_ptrplus1(v_dix, 18);
    }
    if (v_dix.branch!=-1) {
      newptr(&v_numb, 29, 0);
      v_numb=rtn_tbl_search_action(null);
      while (1) {
        if (v_numb.branch==-1) {
          v_numb=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_numb.rec), "number")==0) {
          break;
        }
        v_numb=rtn_ptrplus1(v_numb, 29);
      }
      if (v_numb.branch!=-1) {
        rtn_addcode(rtn_tbl_get_action_action(v_numb.rec), get_int(v_specrout), 0);
      }
      newptr(&v_np, 29, 0);
      v_np=rtn_tbl_search_action(null);
      while (1) {
        if (v_np.branch==-1) {
          v_np=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_np.rec), "new pointer")==0) {
          break;
        }
        v_np=rtn_ptrplus1(v_np, 29);
      }
      if (v_np.branch!=-1) {
        rtn_addcode(rtn_tbl_get_action_action(v_np.rec), scpy(v_parameter), scpy(get_sort(rtn_tbl_get_index_index(v_dix.rec))));
      }
    }
  }
  if (rtn_tbl_get_code_kind(v_cd.rec)==1) {
    v_lastcode=rtn_tbl_get_code_order(v_cd.rec);
  }
  if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  delptr(&v_a, 29);
  delptr(&v_freevar, 35);
  delptr(&v_cd, 33);
  delptr(&v_idx, 18);
  delptr(&v_dix, 18);
  delptr(&v_numb, 29);
  delptr(&v_np, 29);
}
 
 
void rtn_addactioncode(char *v_action, char *v_warning, char *v_parameter, char *v_data) {
  struct pointer v_a={-1, -1, -1};
  struct pointer v_freevar={-1, -1, -1};
  struct pointer v_cd={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_dix={-1, -1, -1};
  struct pointer v_numb={-1, -1, -1};
  struct pointer v_np={-1, -1, -1};
  newptr(&v_a, 30, 0);
  v_a=rtn_tbl_search_actionget(scpy(v_action));
  while (1) {
    if ((v_a.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_a.rec), v_action)>0))) {
      v_a=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_action_ident(v_a.rec), v_action)==0) {
      break;
    }
    v_a=rtn_ptrplus1(v_a, 30);
  }
  if (!(v_a.branch!=-1)) {
    if (v_warning!=0) {
      rtn_puterror(scon(scon(scon(scpy(v_warning), " ("), v_action), ")"));
    }
    if (v_action!=0) {free(v_action); v_action=0;}
    if (v_warning!=0) {free(v_warning); v_warning=0;}
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 30);
    delptr(&v_freevar, 35);
    delptr(&v_cd, 33);
    delptr(&v_idx, 18);
    delptr(&v_dix, 18);
    delptr(&v_numb, 29);
    delptr(&v_np, 29);
    return;
  }
  if (scmp(rtn_tbl_get_action_op(v_a.rec), "free")==0 && scmp(v_data, "free")!=0) {
    newptr(&v_freevar, 35, 0);
    v_freevar=rtn_addrecord(20);
    rtn_tbl_put_freevar_variable(v_freevar.rec, 0);
    rtn_tbl_put_freevar_type(v_freevar.rec, 0);
    rtn_tbl_put_freevar_data(v_freevar.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_freevar_variable(v_freevar.rec, scpy(v_parameter));
    rtn_tbl_put_freevar_type(v_freevar.rec, scpy(rtn_tbl_get_action_right(v_a.rec)));
    v_freevar=rtn_tbl_add_freevar(v_freevar);
    v_dbstate=0;
    if (v_action!=0) {free(v_action); v_action=0;}
    if (v_warning!=0) {free(v_warning); v_warning=0;}
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 30);
    delptr(&v_freevar, 35);
    delptr(&v_cd, 33);
    delptr(&v_idx, 18);
    delptr(&v_dix, 18);
    delptr(&v_numb, 29);
    delptr(&v_np, 29);
    return;
  }
  newptr(&v_cd, 33, 0);
  v_cd=rtn_addrecord(18);
  rtn_tbl_put_code_routine(v_cd.rec, null);
  rtn_tbl_put_code_kind(v_cd.rec, -1);
  rtn_tbl_put_code_order(v_cd.rec, 0);
  rtn_tbl_put_code_action(v_cd.rec, null);
  rtn_tbl_put_code_block(v_cd.rec, null);
  rtn_tbl_put_code_par(v_cd.rec, 0);
  rtn_tbl_put_code_data(v_cd.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_code_block(v_cd.rec, 0);
  rtn_tbl_put_code_data(v_cd.rec, scpy(v_data));
  if (scmp(rtn_tbl_get_action_op(v_a.rec), "define")==0) {
    rtn_tbl_put_code_kind(v_cd.rec, 0);
  }
  else {
    if (scmp(v_data, "free")==0 && scmp(rtn_tbl_get_action_op(v_a.rec), "free")==0) {
      rtn_tbl_put_code_kind(v_cd.rec, 2);
      newptr(&v_idx, 18, 0);
      v_idx=rtn_tbl_search_indexname(0);
      while (1) {
        if (v_idx.branch==-1) {
          v_idx=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_cindex)==0) {
          break;
        }
        v_idx=rtn_ptrplus1(v_idx, 18);
      }
      if (v_idx.branch!=-1) {
        rtn_tbl_put_code_data(v_cd.rec, scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec))));
      }
    }
    else {
      rtn_tbl_put_code_kind(v_cd.rec, 1);
    }
  }
  rtn_tbl_put_code_action(v_cd.rec, rtn_tbl_get_action_action(v_a.rec));
  rtn_tbl_put_code_routine(v_cd.rec, v_croutine);
  rtn_tbl_put_code_par(v_cd.rec, scpy(v_parameter));
  v_cd=rtn_tbl_add_code(v_cd);
  v_dbstate=0;
  if (rtn_tbl_get_code_kind(v_cd.rec)==0 && scmp(rtn_tbl_get_action_ident(v_a.rec), "define pointer")==0) {
    newptr(&v_dix, 18, 0);
    v_dix=rtn_tbl_search_indexname(0);
    while (1) {
      if (v_dix.branch==-1) {
        v_dix=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_index_name(v_dix.rec), v_cindex)==0) {
        break;
      }
      v_dix=rtn_ptrplus1(v_dix, 18);
    }
    if (v_dix.branch!=-1) {
      newptr(&v_numb, 29, 0);
      v_numb=rtn_tbl_search_action(null);
      while (1) {
        if (v_numb.branch==-1) {
          v_numb=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_numb.rec), "number")==0) {
          break;
        }
        v_numb=rtn_ptrplus1(v_numb, 29);
      }
      if (v_numb.branch!=-1) {
        rtn_addcode(rtn_tbl_get_action_action(v_numb.rec), get_int(v_specrout), 0);
      }
      newptr(&v_np, 29, 0);
      v_np=rtn_tbl_search_action(null);
      while (1) {
        if (v_np.branch==-1) {
          v_np=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_np.rec), "new pointer")==0) {
          break;
        }
        v_np=rtn_ptrplus1(v_np, 29);
      }
      if (v_np.branch!=-1) {
        rtn_addcode(rtn_tbl_get_action_action(v_np.rec), scpy(v_parameter), scpy(get_sort(rtn_tbl_get_index_index(v_dix.rec))));
      }
    }
  }
  if (rtn_tbl_get_code_kind(v_cd.rec)==1) {
    v_lastcode=rtn_tbl_get_code_order(v_cd.rec);
  }
  if (v_action!=0) {free(v_action); v_action=0;}
  if (v_warning!=0) {free(v_warning); v_warning=0;}
  if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  delptr(&v_a, 30);
  delptr(&v_freevar, 35);
  delptr(&v_cd, 33);
  delptr(&v_idx, 18);
  delptr(&v_dix, 18);
  delptr(&v_numb, 29);
  delptr(&v_np, 29);
}
 
 
void rtn_addinsertcode(long int v_position, char *v_action, char *v_warning, char *v_parameter, char *v_data) {
  long int v_pos=0;
  struct pointer v_a={-1, -1, -1};
  struct pointer v_freevar={-1, -1, -1};
  struct pointer v_ncd={-1, -1, -1};
  struct pointer v_fromcode={-1, -1, -1};
  struct pointer v_tocode={-1, -1, -1};
  struct pointer v_cd={-1, -1, -1};
  newptr(&v_a, 30, 0);
  v_a=rtn_tbl_search_actionget(scpy(v_action));
  while (1) {
    if ((v_a.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_a.rec), v_action)>0))) {
      v_a=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_action_ident(v_a.rec), v_action)==0) {
      break;
    }
    v_a=rtn_ptrplus1(v_a, 30);
  }
  if (!(v_a.branch!=-1)) {
    if (v_warning!=0) {
      rtn_puterror(scpy(v_warning));
    }
    if (v_action!=0) {free(v_action); v_action=0;}
    if (v_warning!=0) {free(v_warning); v_warning=0;}
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 30);
    delptr(&v_freevar, 35);
    delptr(&v_ncd, 33);
    delptr(&v_fromcode, 33);
    delptr(&v_tocode, 33);
    delptr(&v_cd, 33);
    return;
  }
  if (scmp(rtn_tbl_get_action_op(v_a.rec), "free")==0 && scmp(v_data, "free")!=0) {
    newptr(&v_freevar, 35, 0);
    v_freevar=rtn_addrecord(20);
    rtn_tbl_put_freevar_variable(v_freevar.rec, 0);
    rtn_tbl_put_freevar_type(v_freevar.rec, 0);
    rtn_tbl_put_freevar_data(v_freevar.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_freevar_variable(v_freevar.rec, scpy(v_parameter));
    rtn_tbl_put_freevar_type(v_freevar.rec, scpy(rtn_tbl_get_action_right(v_a.rec)));
    v_freevar=rtn_tbl_add_freevar(v_freevar);
    v_dbstate=0;
    if (v_action!=0) {free(v_action); v_action=0;}
    if (v_warning!=0) {free(v_warning); v_warning=0;}
    if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
    if (v_data!=0) {free(v_data); v_data=0;}
    delptr(&v_a, 30);
    delptr(&v_freevar, 35);
    delptr(&v_ncd, 33);
    delptr(&v_fromcode, 33);
    delptr(&v_tocode, 33);
    delptr(&v_cd, 33);
    return;
  }
  newptr(&v_ncd, 33, 0);
  v_ncd=rtn_addrecord(18);
  rtn_tbl_put_code_routine(v_ncd.rec, null);
  rtn_tbl_put_code_kind(v_ncd.rec, -1);
  rtn_tbl_put_code_order(v_ncd.rec, 0);
  rtn_tbl_put_code_action(v_ncd.rec, null);
  rtn_tbl_put_code_block(v_ncd.rec, null);
  rtn_tbl_put_code_par(v_ncd.rec, 0);
  rtn_tbl_put_code_data(v_ncd.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_code_block(v_ncd.rec, 0);
  rtn_tbl_put_code_routine(v_ncd.rec, v_croutine);
  rtn_tbl_put_code_kind(v_ncd.rec, 1);
  v_ncd=rtn_tbl_add_code(v_ncd);
  v_dbstate=0;
  v_lastcode=rtn_tbl_get_code_order(v_ncd.rec);
  v_pos=v_lastcode;
  while (1) {
    v_pos-=1;
    if (v_pos<v_position) {
      break;
    }
    newptr(&v_fromcode, 33, 0);
    v_fromcode=rtn_tbl_search_code(v_croutine, -1, null);
    while (1) {
      if ((v_fromcode.branch==-1) || ((rtn_tbl_get_code_routine(v_fromcode.rec)>v_croutine))) {
        v_fromcode=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_code_routine(v_fromcode.rec)==v_croutine && rtn_tbl_get_code_kind(v_fromcode.rec)==1 && rtn_tbl_get_code_order(v_fromcode.rec)==v_pos) {
        break;
      }
      v_fromcode=rtn_ptrplus1(v_fromcode, 33);
    }
    newptr(&v_tocode, 33, 0);
    v_tocode=rtn_tbl_search_code(v_croutine, -1, null);
    while (1) {
      if ((v_tocode.branch==-1) || ((rtn_tbl_get_code_routine(v_tocode.rec)>v_croutine))) {
        v_tocode=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_code_routine(v_tocode.rec)==v_croutine && rtn_tbl_get_code_kind(v_tocode.rec)==1 && rtn_tbl_get_code_order(v_tocode.rec)==v_pos+1) {
        break;
      }
      v_tocode=rtn_ptrplus1(v_tocode, 33);
    }
    v_tocode=rtn_cpyrecord(v_tocode, 18);
    v_dbstate=2;
    rtn_tbl_put_code_action(v_tocode.rec, rtn_tbl_get_code_action(v_fromcode.rec));
    rtn_tbl_put_code_par(v_tocode.rec, scpy(rtn_tbl_get_code_par(v_fromcode.rec)));
    rtn_tbl_put_code_block(v_tocode.rec, rtn_tbl_get_code_block(v_fromcode.rec));
    rtn_tbl_put_code_data(v_tocode.rec, scpy(rtn_tbl_get_code_data(v_fromcode.rec)));
    v_dbstate=3;
    v_tocode=rtn_tbl_update_code(rtn_getrec(rtn_recalcptr(v_tocode, 33), 18));
    v_dbstate=0;
  }
  newptr(&v_cd, 33, 0);
  v_cd=rtn_tbl_search_code(v_croutine, -1, null);
  while (1) {
    if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_croutine))) {
      v_cd=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_code_routine(v_cd.rec)==v_croutine && rtn_tbl_get_code_kind(v_cd.rec)==1 && rtn_tbl_get_code_order(v_cd.rec)==v_position) {
      break;
    }
    v_cd=rtn_ptrplus1(v_cd, 33);
  }
  if (v_cd.branch!=-1) {
    v_cd=rtn_cpyrecord(v_cd, 18);
    v_dbstate=2;
    rtn_tbl_put_code_action(v_cd.rec, rtn_tbl_get_action_action(v_a.rec));
    rtn_tbl_put_code_block(v_cd.rec, 0);
    rtn_tbl_put_code_par(v_cd.rec, scpy(v_parameter));
    rtn_tbl_put_code_data(v_cd.rec, scpy(v_data));
    v_dbstate=3;
    v_cd=rtn_tbl_update_code(rtn_getrec(rtn_recalcptr(v_cd, 33), 18));
    v_dbstate=0;
  }
  if (v_action!=0) {free(v_action); v_action=0;}
  if (v_warning!=0) {free(v_warning); v_warning=0;}
  if (v_parameter!=0) {free(v_parameter); v_parameter=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  delptr(&v_a, 30);
  delptr(&v_freevar, 35);
  delptr(&v_ncd, 33);
  delptr(&v_fromcode, 33);
  delptr(&v_tocode, 33);
  delptr(&v_cd, 33);
}
 
 
void rtn_freevariables() {
  struct pointer v_fv={-1, -1, -1};
  long int c_fv=0;
  struct pointer v_a={-1, -1, -1};
  char *var1=0;
  struct pointer v_cd={-1, -1, -1};
  newptr(&v_fv, 35, 0);
  c_fv=1;
  v_fv=rtn_getpointer(0, 0, 35);
  while (1) {
    if (v_fv.branch==-1) {
      break;
    }
    newptr(&v_a, 30, 0);
    v_a=rtn_tbl_search_actionget(scon(scpy("free "), rtn_tbl_get_freevar_type(v_fv.rec)));
    while (1) {
      if ((v_a.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_a.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_freevar_type(v_fv.rec)))))>0))) {
        v_a=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_action_ident(v_a.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_freevar_type(v_fv.rec)))))==0) {
        break;
      }
      v_a=rtn_ptrplus1(v_a, 30);
    }
    if (!(v_a.branch!=-1)) {
      rtn_puterror(scpy("Error in variable free system"));
      delptr(&v_fv, 35);
      delptr(&v_a, 30);
      delptr(&v_cd, 33);
      return;
    }
    newptr(&v_cd, 33, 0);
    v_cd=rtn_addrecord(18);
    rtn_tbl_put_code_routine(v_cd.rec, null);
    rtn_tbl_put_code_kind(v_cd.rec, -1);
    rtn_tbl_put_code_order(v_cd.rec, 0);
    rtn_tbl_put_code_action(v_cd.rec, null);
    rtn_tbl_put_code_block(v_cd.rec, null);
    rtn_tbl_put_code_par(v_cd.rec, 0);
    rtn_tbl_put_code_data(v_cd.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_code_block(v_cd.rec, 0);
    rtn_tbl_put_code_routine(v_cd.rec, v_croutine);
    rtn_tbl_put_code_kind(v_cd.rec, 1);
    rtn_tbl_put_code_action(v_cd.rec, rtn_tbl_get_action_action(v_a.rec));
    rtn_tbl_put_code_par(v_cd.rec, scpy(rtn_tbl_get_freevar_variable(v_fv.rec)));
    rtn_tbl_put_code_data(v_cd.rec, 0);
    v_cd=rtn_tbl_add_code(v_cd);
    v_dbstate=0;
    c_fv+=1;
    if (v_fv.branch==-1) {
      v_fv=rtn_getpointer(0, 0, 35);
    }
    else {
      v_fv=rtn_ptrplus1(v_fv, 35);
    }
  }
  rtn_tbl_clear_freevar();
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_fv, 35);
  delptr(&v_a, 30);
  delptr(&v_cd, 33);
}
 
 
long int rtn_tbl_get_codestore_store(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) return 0;
  return *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+0);
}
 
void rtn_tbl_put_codestore_store(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("error in filling field codestore.store\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+0)=v_val;
}
 
void rtn_tbl_add_codestore_store(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("error in adding to field codestore.store\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+0)+=v_val;
}
 
void rtn_tbl_sub_codestore_store(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("Error in subtraction from field codestore.store\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+0)-=v_val;
}
 
long int rtn_tbl_get_codestore_position(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) return null;
  return *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+4);
}
 
void rtn_tbl_put_codestore_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("error in filling field codestore.position\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+4)=v_val;
}
 
void rtn_tbl_add_codestore_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("error in adding to field codestore.position\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+4)+=v_val;
}
 
void rtn_tbl_sub_codestore_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[21].len) {
    printf("Error in subtraction from field codestore.position\n");
    return;
  }
  *(long int*)(u_table[21].ptr[v_rec/250]+(v_rec%250)*u_table[21].size+4)-=v_val;
}
 
struct pointer rtn_tbl_search_codestore(long int v_p_store) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 36, 1);
  newptr(&v_ptr, 36, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(36)+1);
    v_idx=rtn_getpointer(v_curr, 0, 36);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_store, rtn_tbl_get_codestore_store(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(36);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 36)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 36);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_store, rtn_tbl_get_codestore_store(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 36);
  }
  delptr(&v_idx, 36);
  delptr(&v_ptr, 36);
  return v_ptr;
  delptr(&v_idx, 36);
  delptr(&v_ptr, 36);
}
 
 
struct pointer rtn_tbl_add_codestore(struct pointer v_new) {
  struct pointer v_idx_codestore={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_codestore, 36, 1);
  newptr(&v_last, 36, 1);
  rtn_tbl_put_codestore_store(v_new.rec, 999999999);
  v_idx_codestore=rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_new.rec));
  if (v_idx_codestore.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(36), rtn_maxleaf(rtn_maxbranch(36), 36), 36);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_codestore, 36);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_codestore_store(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_codestore_store(v_new.rec, rtn_tbl_get_codestore_store(v_last.rec)+1);
  }
  rtn_addindex(v_idx_codestore, rtn_tablelen(21)-1, 36);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("add codestore(21):"), scpy(get_sort(rtn_tbl_get_codestore_store(v_new.rec)))), "|"), get_int(rtn_tbl_get_codestore_position(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 36);
    delptr(&v_idx_codestore, 36);
    delptr(&v_last, 36);
    return rtn_getpointer(0, 0, 36);
  }
  delptr(&v_new, 36);
  delptr(&v_idx_codestore, 36);
  delptr(&v_last, 36);
  return rtn_ptrplus1(v_last, 36);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 36);
  delptr(&v_idx_codestore, 36);
  delptr(&v_last, 36);
}
 
 
void rtn_tbl_delete_codestore(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 36, 1);
  newptr(&v_chk, 36, 1);
  newptr(&v_del, 36, 1);
  v_del=rtn_getrecptr(v_delrec, 21);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("delete codestore(21):"), scpy(get_sort(rtn_tbl_get_codestore_store(v_del.rec)))), "|"), get_int(rtn_tbl_get_codestore_position(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_del.rec));
  rtn_deleteindex(v_chk, 36);
  v_chk=rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_del.rec)+1);
  if (rtn_getrec(v_del, 21)!=rtn_tablelen(21)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(21)-1, 36);
    rtn_changeindex(rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_last.rec)), v_delrec, 36);
  }
  rtn_deleterecord(v_delrec, 21);
  if (v_chk.branch==-1) {
    delptr(&v_last, 36);
    delptr(&v_chk, 36);
    delptr(&v_del, 36);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 36);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_codestore_store(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 21);
    rtn_tbl_sub_codestore_store(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 36);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 36);
  delptr(&v_chk, 36);
  delptr(&v_del, 36);
}
 
 
struct pointer rtn_tbl_update_codestore(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 36, 1);
  newptr(&v_del, 36, 1);
  v_del=rtn_getrecptr(v_rec, 21);
  v_new=rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_del.rec));
  rtn_deleteindex(v_new, 36);
  rtn_deleterecord(v_rec, 21);
  rtn_addindex(rtn_tbl_search_codestore(rtn_tbl_get_codestore_store(v_new.rec)), rtn_getrec(v_new, 36), 36);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 21);
  }
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("update codestore:"), scpy(get_sort(rtn_tbl_get_codestore_store(v_new.rec)))), "|"), get_int(rtn_tbl_get_codestore_position(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 36);
  delptr(&v_del, 36);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 36);
  delptr(&v_del, 36);
}
 
 
void rtn_tbl_clear_codestore() {
  
  long int r=0;
  long int branch;
  while (r < u_table[21].len) {
    r++;
  }
  free(u_table[21].ptr);
  u_table[21].ptr=0;
  u_table[21].len=0;
  for(branch=0; branch < u_index[36].scale; branch++)
  { free(u_index[36].ptr[branch]);
  }
  free(u_index[36].len);
  free(u_index[36].ptr);
  u_index[36].scale=0;
  u_index[36].len=0;
  u_index[36].ptr=0;
  fprintf(v_log, "clear codestore(21)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_codestore() {
  
  return u_table[21].len;
}
 
void rtn_tbl_init_codestore() {
  
  u_table[21].len=0;
  u_table[21].size=8;
  u_table[21].ptr=0;
  u_index[36].tbl=21;
  u_index[36].scale=0;
  u_index[36].len=0;
  u_index[36].ptr=0;
  u_index[36].ptrs=0;
  u_index[36].padm=0;
}
 
void rtn_tbl_write_codestore(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 36, 0);
  rtn_write(rtn_tbl_get_codestore_store(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_codestore_position(v_ptr.rec), v_stream);
  delptr(&v_ptr, 36);
}
 
 
struct pointer rtn_tbl_read_codestore(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 36, 0);
  v_new=rtn_addrecord(21);
  rtn_tbl_put_codestore_store(v_new.rec, 0);
  rtn_tbl_put_codestore_position(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_codestore_store(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_codestore_position(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_codestore(v_new);
  v_dbstate=0;
  delptr(&v_new, 36);
  return v_new;
  delptr(&v_new, 36);
}
 
 
void rtn_storecode() {
  struct pointer v_codestore={-1, -1, -1};
  newptr(&v_codestore, 36, 0);
  v_codestore=rtn_addrecord(21);
  rtn_tbl_put_codestore_store(v_codestore.rec, 0);
  rtn_tbl_put_codestore_position(v_codestore.rec, null);
  v_dbstate=1;
  rtn_tbl_put_codestore_position(v_codestore.rec, v_lastcode);
  v_codestore=rtn_tbl_add_codestore(v_codestore);
  v_dbstate=0;
  v_highstore=rtn_tbl_get_codestore_store(v_codestore.rec);
  delptr(&v_codestore, 36);
}
 
 
long int rtn_getcode() {
  long int v_getc=0;
  struct pointer v_codestore={-1, -1, -1};
  struct pointer v_m={-1, -1, -1};
  long int c_m=0;
  newptr(&v_codestore, 36, 0);
  v_codestore=rtn_tbl_search_codestore(v_highstore);
  while (1) {
    if ((v_codestore.branch==-1) || ((rtn_tbl_get_codestore_store(v_codestore.rec)>v_highstore))) {
      v_codestore=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_codestore_store(v_codestore.rec)==v_highstore) {
      break;
    }
    v_codestore=rtn_ptrplus1(v_codestore, 36);
  }
  if (!(v_codestore.branch!=-1)) {
    delptr(&v_codestore, 36);
    delptr(&v_m, 36);
    return null;
  }
  v_getc=rtn_tbl_get_codestore_position(v_codestore.rec);
  rtn_tbl_delete_codestore(rtn_getrec(v_codestore, 36));
  if (v_codestore.rec!=rtn_nullpointer().rec) {
    v_highstore=rtn_tbl_get_codestore_store(v_codestore.rec);
  }
  else {
    v_highstore=0;
    newptr(&v_m, 36, 0);
    c_m=1;
    v_m=rtn_getpointer(0, 0, 36);
    while (1) {
      if (v_m.branch==-1) {
        break;
      }
      if (rtn_tbl_get_codestore_store(v_m.rec)>v_highstore) {
        v_highstore=rtn_tbl_get_codestore_store(v_m.rec);
      }
      c_m+=1;
      if (v_m.branch==-1) {
        v_m=rtn_getpointer(0, 0, 36);
      }
      else {
        v_m=rtn_ptrplus1(v_m, 36);
      }
    }
  }
  delptr(&v_codestore, 36);
  delptr(&v_m, 36);
  return v_getc;
  delptr(&v_codestore, 36);
  delptr(&v_m, 36);
}
 
 
void rtn_endblockcode() {
  long int v_order=0;
  struct pointer v_cd={-1, -1, -1};
  v_order=rtn_getcode();
  newptr(&v_cd, 33, 0);
  v_cd=rtn_tbl_search_code(v_croutine, -1, null);
  while (1) {
    if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_croutine))) {
      v_cd=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_code_routine(v_cd.rec)==v_croutine && rtn_tbl_get_code_kind(v_cd.rec)==1 && rtn_tbl_get_code_order(v_cd.rec)==v_order) {
      break;
    }
    v_cd=rtn_ptrplus1(v_cd, 33);
  }
  if (v_cd.branch!=-1) {
    v_cd=rtn_cpyrecord(v_cd, 18);
    v_dbstate=2;
    rtn_tbl_put_code_block(v_cd.rec, v_lastcode);
    v_dbstate=3;
    v_cd=rtn_tbl_update_code(rtn_getrec(rtn_recalcptr(v_cd, 33), 18));
    v_dbstate=0;
  }
  else {
    rtn_putwarning(scon(sadd(scpy("Stored code '"), get_int(v_order)), "' for block calculation not found"));
  }
  delptr(&v_cd, 33);
}
 
 
char *rtn_tbl_get_variable_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return 0;
  return *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+0);
}
 
void rtn_tbl_put_variable_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.name\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+0)=v_val;
}
 
void rtn_tbl_add_variable_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.name\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+0)= 
  sadd(*(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+0), v_val);
}
 
int rtn_tbl_get_variable_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return -1;
  return *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+4);
}
 
void rtn_tbl_put_variable_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.kind\n");
    return;
  }
  *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+4)=v_val;
}
 
void rtn_tbl_add_variable_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.kind\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+4)+=v_val;
}
 
void rtn_tbl_sub_variable_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("Error in subtraction from field variable.kind\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+4)-=v_val;
}
 
char *rtn_tbl_get_variable_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return 0;
  return *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+8);
}
 
void rtn_tbl_put_variable_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.type\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+8)=v_val;
}
 
void rtn_tbl_add_variable_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.type\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+8)= 
  sadd(*(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+8), v_val);
}
 
char *rtn_tbl_get_variable_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return 0;
  return *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+12);
}
 
void rtn_tbl_put_variable_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.data\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+12)=v_val;
}
 
void rtn_tbl_add_variable_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.data\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+12)= 
  sadd(*(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+12), v_val);
}
 
int rtn_tbl_get_variable_claimed(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return -1;
  return *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+16);
}
 
void rtn_tbl_put_variable_claimed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.claimed\n");
    return;
  }
  *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+16)=v_val;
}
 
void rtn_tbl_add_variable_claimed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.claimed\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+16)+=v_val;
}
 
void rtn_tbl_sub_variable_claimed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("Error in subtraction from field variable.claimed\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+16)-=v_val;
}
 
int rtn_tbl_get_variable_allowed(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return -1;
  return *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+20);
}
 
void rtn_tbl_put_variable_allowed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.allowed\n");
    return;
  }
  *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+20)=v_val;
}
 
void rtn_tbl_add_variable_allowed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.allowed\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+20)+=v_val;
}
 
void rtn_tbl_sub_variable_allowed(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("Error in subtraction from field variable.allowed\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+20)-=v_val;
}
 
int rtn_tbl_get_variable_usage(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return -1;
  return *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+24);
}
 
void rtn_tbl_put_variable_usage(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.usage\n");
    return;
  }
  *(int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+24)=v_val;
}
 
void rtn_tbl_add_variable_usage(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.usage\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+24)+=v_val;
}
 
void rtn_tbl_sub_variable_usage(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("Error in subtraction from field variable.usage\n");
    return;
  }
  *(long int*)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+24)-=v_val;
}
 
char *rtn_tbl_get_variable_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) return 0;
  return *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+28);
}
 
void rtn_tbl_put_variable_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in filling field variable.use\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+28)=v_val;
}
 
void rtn_tbl_add_variable_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[22].len) {
    printf("error in adding to field variable.use\n");
    return;
  }
  *(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+28)= 
  sadd(*(char**)(u_table[22].ptr[v_rec/250]+(v_rec%250)*u_table[22].size+28), v_val);
}
 
struct pointer rtn_tbl_search_variable(char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 37, 1);
  newptr(&v_ptr, 37, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(37)+1);
    v_idx=rtn_getpointer(v_curr, 0, 37);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_variable_name(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(37);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 37)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 37);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_variable_name(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 37);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 37);
  delptr(&v_ptr, 37);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 37);
  delptr(&v_ptr, 37);
}
 
 
struct pointer rtn_tbl_add_variable(struct pointer v_new) {
  struct pointer v_idx_variable={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_variable, 37, 1);
  newptr(&v_last, 37, 1);
  v_idx_variable=rtn_tbl_search_variable(scpy(rtn_tbl_get_variable_name(v_new.rec)));
  if (v_idx_variable.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(37), rtn_maxleaf(rtn_maxbranch(37), 37), 37);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_variable, 37);
  }
  rtn_addindex(v_idx_variable, rtn_tablelen(22)-1, 37);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("add variable(22):"), rtn_tbl_get_variable_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_variable_kind(v_new.rec), "database parameter local table indicator")), "|"), rtn_tbl_get_variable_type(v_new.rec)), "|"), rtn_tbl_get_variable_data(v_new.rec)), "|"), get_enum(rtn_tbl_get_variable_claimed(v_new.rec), "yes no")), "|"), get_enum(rtn_tbl_get_variable_allowed(v_new.rec), "all readonly")), "|"), get_enum(rtn_tbl_get_variable_usage(v_new.rec), "none read write both")), "|"), rtn_tbl_get_variable_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 37);
    delptr(&v_idx_variable, 37);
    delptr(&v_last, 37);
    return rtn_getpointer(0, 0, 37);
  }
  delptr(&v_new, 37);
  delptr(&v_idx_variable, 37);
  delptr(&v_last, 37);
  return rtn_ptrplus1(v_last, 37);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 37);
  delptr(&v_idx_variable, 37);
  delptr(&v_last, 37);
}
 
 
void rtn_tbl_delete_variable(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 37, 1);
  newptr(&v_chk, 37, 1);
  newptr(&v_del, 37, 1);
  v_del=rtn_getrecptr(v_delrec, 22);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("delete variable(22):"), rtn_tbl_get_variable_name(v_del.rec)), "|"), get_enum(rtn_tbl_get_variable_kind(v_del.rec), "database parameter local table indicator")), "|"), rtn_tbl_get_variable_type(v_del.rec)), "|"), rtn_tbl_get_variable_data(v_del.rec)), "|"), get_enum(rtn_tbl_get_variable_claimed(v_del.rec), "yes no")), "|"), get_enum(rtn_tbl_get_variable_allowed(v_del.rec), "all readonly")), "|"), get_enum(rtn_tbl_get_variable_usage(v_del.rec), "none read write both")), "|"), rtn_tbl_get_variable_use(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_variable(scpy(rtn_tbl_get_variable_name(v_del.rec)));
  rtn_deleteindex(v_chk, 37);
  rtn_tbl_put_variable_name(v_del.rec, 0);
  rtn_tbl_put_variable_type(v_del.rec, 0);
  rtn_tbl_put_variable_data(v_del.rec, 0);
  rtn_tbl_put_variable_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 22)!=rtn_tablelen(22)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(22)-1, 37);
    rtn_changeindex(rtn_tbl_search_variable(scpy(rtn_tbl_get_variable_name(v_last.rec))), v_delrec, 37);
  }
  rtn_deleterecord(v_delrec, 22);
  if (v_chk.branch==-1) {
    delptr(&v_last, 37);
    delptr(&v_chk, 37);
    delptr(&v_del, 37);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 37);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 37);
  delptr(&v_chk, 37);
  delptr(&v_del, 37);
}
 
 
struct pointer rtn_tbl_update_variable(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 37, 1);
  newptr(&v_del, 37, 1);
  v_del=rtn_getrecptr(v_rec, 22);
  v_new=rtn_tbl_search_variable(scpy(rtn_tbl_get_variable_name(v_del.rec)));
  rtn_deleteindex(v_new, 37);
  rtn_deleterecord(v_rec, 22);
  rtn_addindex(rtn_tbl_search_variable(scpy(rtn_tbl_get_variable_name(v_new.rec))), rtn_getrec(v_new, 37), 37);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 22);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scon(sadd(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("update variable:"), rtn_tbl_get_variable_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_variable_kind(v_new.rec), "database parameter local table indicator")), "|"), rtn_tbl_get_variable_type(v_new.rec)), "|"), rtn_tbl_get_variable_data(v_new.rec)), "|"), get_enum(rtn_tbl_get_variable_claimed(v_new.rec), "yes no")), "|"), get_enum(rtn_tbl_get_variable_allowed(v_new.rec), "all readonly")), "|"), get_enum(rtn_tbl_get_variable_usage(v_new.rec), "none read write both")), "|"), rtn_tbl_get_variable_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 37);
  delptr(&v_del, 37);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 37);
  delptr(&v_del, 37);
}
 
 
void rtn_tbl_clear_variable() {
  
  long int r=0;
  long int branch;
  while (r < u_table[22].len) {
    if (*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+0)!=0) {free(*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+0)); *(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+0)=0;}
    if (*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+8)!=0) {free(*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+8)); *(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+8)=0;}
    if (*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+12)!=0) {free(*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+12)); *(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+12)=0;}
    if (*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+28)!=0) {free(*(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+28)); *(char**)(u_table[22].ptr[r/250]+(r%250)*u_table[22].size+28)=0;}
    r++;
  }
  free(u_table[22].ptr);
  u_table[22].ptr=0;
  u_table[22].len=0;
  for(branch=0; branch < u_index[37].scale; branch++)
  { free(u_index[37].ptr[branch]);
  }
  free(u_index[37].len);
  free(u_index[37].ptr);
  u_index[37].scale=0;
  u_index[37].len=0;
  u_index[37].ptr=0;
  fprintf(v_log, "clear variable(22)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_variable() {
  
  return u_table[22].len;
}
 
void rtn_tbl_init_variable() {
  
  u_table[22].len=0;
  u_table[22].size=32;
  u_table[22].ptr=0;
  u_index[37].tbl=22;
  u_index[37].scale=0;
  u_index[37].len=0;
  u_index[37].ptr=0;
  u_index[37].ptrs=0;
  u_index[37].padm=0;
}
 
void rtn_tbl_write_variable(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 37, 0);
  rtn_write(iscan(rtn_tbl_get_variable_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_variable_kind(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_variable_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_variable_data(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_variable_claimed(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_variable_allowed(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_variable_usage(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_variable_use(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 37);
}
 
 
struct pointer rtn_tbl_read_variable(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 37, 0);
  v_new=rtn_addrecord(22);
  rtn_tbl_put_variable_name(v_new.rec, 0);
  rtn_tbl_put_variable_kind(v_new.rec, -1);
  rtn_tbl_put_variable_type(v_new.rec, 0);
  rtn_tbl_put_variable_data(v_new.rec, 0);
  rtn_tbl_put_variable_claimed(v_new.rec, -1);
  rtn_tbl_put_variable_allowed(v_new.rec, -1);
  rtn_tbl_put_variable_usage(v_new.rec, -1);
  rtn_tbl_put_variable_use(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_variable_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_variable_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_variable_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_variable_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_variable_claimed(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_variable_allowed(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_variable_usage(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_variable_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_variable(v_new);
  v_dbstate=0;
  delptr(&v_new, 37);
  return v_new;
  delptr(&v_new, 37);
}
 
 
char *rtn_tbl_get_global_name(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) return 0;
  return *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+0);
}
 
void rtn_tbl_put_global_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in filling field global.name\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+0)=v_val;
}
 
void rtn_tbl_add_global_name(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in adding to field global.name\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+0)= 
  sadd(*(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+0), v_val);
}
 
int rtn_tbl_get_global_kind(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) return -1;
  return *(int*)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+4);
}
 
void rtn_tbl_put_global_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in filling field global.kind\n");
    return;
  }
  *(int*)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+4)=v_val;
}
 
void rtn_tbl_add_global_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in adding to field global.kind\n");
    return;
  }
  *(long int*)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+4)+=v_val;
}
 
void rtn_tbl_sub_global_kind(long int v_rec, int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("Error in subtraction from field global.kind\n");
    return;
  }
  *(long int*)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+4)-=v_val;
}
 
char *rtn_tbl_get_global_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) return 0;
  return *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+8);
}
 
void rtn_tbl_put_global_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in filling field global.type\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+8)=v_val;
}
 
void rtn_tbl_add_global_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in adding to field global.type\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+8)= 
  sadd(*(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+8), v_val);
}
 
char *rtn_tbl_get_global_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) return 0;
  return *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+12);
}
 
void rtn_tbl_put_global_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in filling field global.data\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+12)=v_val;
}
 
void rtn_tbl_add_global_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in adding to field global.data\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+12)= 
  sadd(*(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+12), v_val);
}
 
char *rtn_tbl_get_global_use(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) return 0;
  return *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+16);
}
 
void rtn_tbl_put_global_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in filling field global.use\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+16)=v_val;
}
 
void rtn_tbl_add_global_use(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[23].len) {
    printf("error in adding to field global.use\n");
    return;
  }
  *(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+16)= 
  sadd(*(char**)(u_table[23].ptr[v_rec/250]+(v_rec%250)*u_table[23].size+16), v_val);
}
 
struct pointer rtn_tbl_search_global(char *v_p_name) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 38, 1);
  newptr(&v_ptr, 38, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(38)+1);
    v_idx=rtn_getpointer(v_curr, 0, 38);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_global_name(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(38);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 38)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 38);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check1(v_p_name, rtn_tbl_get_global_name(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 38);
  }
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 38);
  delptr(&v_ptr, 38);
  return v_ptr;
  if (v_p_name!=0) {free(v_p_name); v_p_name=0;}
  delptr(&v_idx, 38);
  delptr(&v_ptr, 38);
}
 
 
struct pointer rtn_tbl_add_global(struct pointer v_new) {
  struct pointer v_idx_global={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_global, 38, 1);
  newptr(&v_last, 38, 1);
  v_idx_global=rtn_tbl_search_global(scpy(rtn_tbl_get_global_name(v_new.rec)));
  if (v_idx_global.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(38), rtn_maxleaf(rtn_maxbranch(38), 38), 38);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_global, 38);
  }
  rtn_addindex(v_idx_global, rtn_tablelen(23)-1, 38);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("add global(23):"), rtn_tbl_get_global_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_global_kind(v_new.rec), "general local")), "|"), rtn_tbl_get_global_type(v_new.rec)), "|"), rtn_tbl_get_global_data(v_new.rec)), "|"), rtn_tbl_get_global_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 38);
    delptr(&v_idx_global, 38);
    delptr(&v_last, 38);
    return rtn_getpointer(0, 0, 38);
  }
  delptr(&v_new, 38);
  delptr(&v_idx_global, 38);
  delptr(&v_last, 38);
  return rtn_ptrplus1(v_last, 38);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 38);
  delptr(&v_idx_global, 38);
  delptr(&v_last, 38);
}
 
 
void rtn_tbl_delete_global(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 38, 1);
  newptr(&v_chk, 38, 1);
  newptr(&v_del, 38, 1);
  v_del=rtn_getrecptr(v_delrec, 23);
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("delete global(23):"), rtn_tbl_get_global_name(v_del.rec)), "|"), get_enum(rtn_tbl_get_global_kind(v_del.rec), "general local")), "|"), rtn_tbl_get_global_type(v_del.rec)), "|"), rtn_tbl_get_global_data(v_del.rec)), "|"), rtn_tbl_get_global_use(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_global(scpy(rtn_tbl_get_global_name(v_del.rec)));
  rtn_deleteindex(v_chk, 38);
  rtn_tbl_put_global_name(v_del.rec, 0);
  rtn_tbl_put_global_type(v_del.rec, 0);
  rtn_tbl_put_global_data(v_del.rec, 0);
  rtn_tbl_put_global_use(v_del.rec, 0);
  if (rtn_getrec(v_del, 23)!=rtn_tablelen(23)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(23)-1, 38);
    rtn_changeindex(rtn_tbl_search_global(scpy(rtn_tbl_get_global_name(v_last.rec))), v_delrec, 38);
  }
  rtn_deleterecord(v_delrec, 23);
  if (v_chk.branch==-1) {
    delptr(&v_last, 38);
    delptr(&v_chk, 38);
    delptr(&v_del, 38);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 38);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 38);
  delptr(&v_chk, 38);
  delptr(&v_del, 38);
}
 
 
struct pointer rtn_tbl_update_global(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 38, 1);
  newptr(&v_del, 38, 1);
  v_del=rtn_getrecptr(v_rec, 23);
  v_new=rtn_tbl_search_global(scpy(rtn_tbl_get_global_name(v_del.rec)));
  rtn_deleteindex(v_new, 38);
  rtn_deleterecord(v_rec, 23);
  rtn_addindex(rtn_tbl_search_global(scpy(rtn_tbl_get_global_name(v_new.rec))), rtn_getrec(v_new, 38), 38);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 23);
  }
  swrite((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(sadd(scon(scon(scpy("update global:"), rtn_tbl_get_global_name(v_new.rec)), "|"), get_enum(rtn_tbl_get_global_kind(v_new.rec), "general local")), "|"), rtn_tbl_get_global_type(v_new.rec)), "|"), rtn_tbl_get_global_data(v_new.rec)), "|"), rtn_tbl_get_global_use(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 38);
  delptr(&v_del, 38);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 38);
  delptr(&v_del, 38);
}
 
 
void rtn_tbl_clear_global() {
  
  long int r=0;
  long int branch;
  while (r < u_table[23].len) {
    if (*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+0)!=0) {free(*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+0)); *(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+0)=0;}
    if (*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+8)!=0) {free(*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+8)); *(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+8)=0;}
    if (*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+12)!=0) {free(*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+12)); *(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+12)=0;}
    if (*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+16)!=0) {free(*(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+16)); *(char**)(u_table[23].ptr[r/250]+(r%250)*u_table[23].size+16)=0;}
    r++;
  }
  free(u_table[23].ptr);
  u_table[23].ptr=0;
  u_table[23].len=0;
  for(branch=0; branch < u_index[38].scale; branch++)
  { free(u_index[38].ptr[branch]);
  }
  free(u_index[38].len);
  free(u_index[38].ptr);
  u_index[38].scale=0;
  u_index[38].len=0;
  u_index[38].ptr=0;
  fprintf(v_log, "clear global(23)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_global() {
  
  return u_table[23].len;
}
 
void rtn_tbl_init_global() {
  
  u_table[23].len=0;
  u_table[23].size=20;
  u_table[23].ptr=0;
  u_index[38].tbl=23;
  u_index[38].scale=0;
  u_index[38].len=0;
  u_index[38].ptr=0;
  u_index[38].ptrs=0;
  u_index[38].padm=0;
}
 
void rtn_tbl_write_global(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 38, 0);
  rtn_write(iscan(rtn_tbl_get_global_name(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_global_kind(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_global_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_global_data(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_global_use(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 38);
}
 
 
struct pointer rtn_tbl_read_global(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 38, 0);
  v_new=rtn_addrecord(23);
  rtn_tbl_put_global_name(v_new.rec, 0);
  rtn_tbl_put_global_kind(v_new.rec, -1);
  rtn_tbl_put_global_type(v_new.rec, 0);
  rtn_tbl_put_global_data(v_new.rec, 0);
  rtn_tbl_put_global_use(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_global_name(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_global_kind(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_global_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_global_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_global_use(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_global(v_new);
  v_dbstate=0;
  delptr(&v_new, 38);
  return v_new;
  delptr(&v_new, 38);
}
 
 
void rtn_table_fields(char *v_field, char *v_index) {
  struct pointer v_cidx={-1, -1, -1};
  struct pointer v_cfld={-1, -1, -1};
  long int c_cfld=0;
  struct pointer v_vfld={-1, -1, -1};
  struct pointer v_ff={-1, -1, -1};
  struct pointer v_fnf={-1, -1, -1};
  struct pointer v_nf={-1, -1, -1};
  newptr(&v_cidx, 16, 0);
  v_cidx=rtn_tbl_search_index(null);
  while (1) {
    if (v_cidx.branch==-1) {
      v_cidx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_cidx.rec), v_index)==0) {
      break;
    }
    v_cidx=rtn_ptrplus1(v_cidx, 16);
  }
  if (!(v_cidx.branch!=-1)) {
    rtn_puterror(scon(scon(scpy("Index '"), v_index), "' in error"));
    if (v_field!=0) {free(v_field); v_field=0;}
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_cidx, 16);
    delptr(&v_cfld, 14);
    delptr(&v_vfld, 37);
    delptr(&v_ff, 37);
    delptr(&v_fnf, 37);
    delptr(&v_nf, 37);
    return;
  }
  newptr(&v_cfld, 14, 0);
  c_cfld=1;
  v_cfld=rtn_tbl_search_field(rtn_tbl_get_index_table(v_cidx.rec), null);
  while (1) {
    if ((v_cfld.branch==-1) || ((rtn_tbl_get_field_table(v_cfld.rec)>rtn_tbl_get_index_table(v_cidx.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_cfld.rec)==rtn_tbl_get_index_table(v_cidx.rec)) {
      newptr(&v_vfld, 37, 0);
      v_vfld=rtn_addrecord(22);
      rtn_tbl_put_variable_name(v_vfld.rec, 0);
      rtn_tbl_put_variable_kind(v_vfld.rec, -1);
      rtn_tbl_put_variable_type(v_vfld.rec, 0);
      rtn_tbl_put_variable_data(v_vfld.rec, 0);
      rtn_tbl_put_variable_claimed(v_vfld.rec, -1);
      rtn_tbl_put_variable_allowed(v_vfld.rec, -1);
      rtn_tbl_put_variable_usage(v_vfld.rec, -1);
      rtn_tbl_put_variable_use(v_vfld.rec, 0);
      v_dbstate=1;
      rtn_tbl_put_variable_name(v_vfld.rec, scon(scon(scpy(v_field), "."), rtn_tbl_get_field_name(v_cfld.rec)));
      rtn_tbl_put_variable_type(v_vfld.rec, scpy(rtn_tbl_get_field_type(v_cfld.rec)));
      rtn_tbl_put_variable_data(v_vfld.rec, scpy(rtn_tbl_get_field_data(v_cfld.rec)));
      rtn_tbl_put_variable_usage(v_vfld.rec, 0);
      rtn_tbl_put_variable_kind(v_vfld.rec, 0);
      v_vfld=rtn_tbl_add_variable(v_vfld);
      v_dbstate=0;
      c_cfld+=1;
    }
    if (v_cfld.branch==-1) {
      v_cfld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_cfld=rtn_ptrplus1(v_cfld, 14);
    }
  }
  c_cfld-=1;
  newptr(&v_ff, 37, 0);
  v_ff=rtn_addrecord(22);
  rtn_tbl_put_variable_name(v_ff.rec, 0);
  rtn_tbl_put_variable_kind(v_ff.rec, -1);
  rtn_tbl_put_variable_type(v_ff.rec, 0);
  rtn_tbl_put_variable_data(v_ff.rec, 0);
  rtn_tbl_put_variable_claimed(v_ff.rec, -1);
  rtn_tbl_put_variable_allowed(v_ff.rec, -1);
  rtn_tbl_put_variable_usage(v_ff.rec, -1);
  rtn_tbl_put_variable_use(v_ff.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_variable_name(v_ff.rec, scon(scpy(v_field), ".first"));
  rtn_tbl_put_variable_type(v_ff.rec, scpy("boolean"));
  rtn_tbl_put_variable_data(v_ff.rec, scpy("first"));
  rtn_tbl_put_variable_usage(v_ff.rec, 0);
  rtn_tbl_put_variable_kind(v_ff.rec, 0);
  v_ff=rtn_tbl_add_variable(v_ff);
  v_dbstate=0;
  newptr(&v_fnf, 37, 0);
  v_fnf=rtn_addrecord(22);
  rtn_tbl_put_variable_name(v_fnf.rec, 0);
  rtn_tbl_put_variable_kind(v_fnf.rec, -1);
  rtn_tbl_put_variable_type(v_fnf.rec, 0);
  rtn_tbl_put_variable_data(v_fnf.rec, 0);
  rtn_tbl_put_variable_claimed(v_fnf.rec, -1);
  rtn_tbl_put_variable_allowed(v_fnf.rec, -1);
  rtn_tbl_put_variable_usage(v_fnf.rec, -1);
  rtn_tbl_put_variable_use(v_fnf.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_variable_name(v_fnf.rec, scon(scpy(v_field), ".found"));
  rtn_tbl_put_variable_type(v_fnf.rec, scpy("boolean"));
  rtn_tbl_put_variable_data(v_fnf.rec, scpy("found"));
  rtn_tbl_put_variable_usage(v_fnf.rec, 0);
  rtn_tbl_put_variable_kind(v_fnf.rec, 0);
  v_fnf=rtn_tbl_add_variable(v_fnf);
  v_dbstate=0;
  newptr(&v_nf, 37, 0);
  v_nf=rtn_addrecord(22);
  rtn_tbl_put_variable_name(v_nf.rec, 0);
  rtn_tbl_put_variable_kind(v_nf.rec, -1);
  rtn_tbl_put_variable_type(v_nf.rec, 0);
  rtn_tbl_put_variable_data(v_nf.rec, 0);
  rtn_tbl_put_variable_claimed(v_nf.rec, -1);
  rtn_tbl_put_variable_allowed(v_nf.rec, -1);
  rtn_tbl_put_variable_usage(v_nf.rec, -1);
  rtn_tbl_put_variable_use(v_nf.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_variable_name(v_nf.rec, scon(scpy(v_field), ".recnr"));
  rtn_tbl_put_variable_type(v_nf.rec, scpy("number"));
  rtn_tbl_put_variable_data(v_nf.rec, scpy("recnr"));
  rtn_tbl_put_variable_usage(v_nf.rec, 0);
  rtn_tbl_put_variable_kind(v_nf.rec, 0);
  v_nf=rtn_tbl_add_variable(v_nf);
  v_dbstate=0;
  if (v_field!=0) {free(v_field); v_field=0;}
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_cidx, 16);
  delptr(&v_cfld, 14);
  delptr(&v_vfld, 37);
  delptr(&v_ff, 37);
  delptr(&v_fnf, 37);
  delptr(&v_nf, 37);
}
 
 
char rtn_check_name(char *v_name, char *v_type) {
  struct pointer v_routinename={-1, -1, -1};
  struct pointer v_global={-1, -1, -1};
  struct pointer v_variable={-1, -1, -1};
  struct pointer v_tablename={-1, -1, -1};
  struct pointer v_indexname={-1, -1, -1};
  if (!(rtn_is_keyword(scpy(v_name)))) {
    rtn_puterror(scon(scon(scon(scon(scpy("Unexpected tokens in "), v_type), " '"), v_name), "'"));
  }
  else {
    if (rtn_is_reserved(v_name, ienum("routine", "keyword field"))) {
      rtn_puterror(scon(scon(scon(scpy("Existing reserved keyword '"), v_name), "' found in "), v_type));
    }
    else {
      newptr(&v_routinename, 8, 0);
      v_routinename=rtn_tbl_search_routinename(0, null);
      while (1) {
        if (v_routinename.branch==-1) {
          v_routinename=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_routine_name(v_routinename.rec), v_name)==0) {
          break;
        }
        v_routinename=rtn_ptrplus1(v_routinename, 8);
      }
      if (v_routinename.branch!=-1) {
        rtn_puterror(scon(scon(scon(scpy("Existsing routine name '"), v_name), "' found in "), v_type));
      }
      else {
        newptr(&v_global, 38, 0);
        v_global=rtn_tbl_search_global(0);
        while (1) {
          if (v_global.branch==-1) {
            v_global=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_global_name(v_global.rec), v_name)==0) {
            break;
          }
          v_global=rtn_ptrplus1(v_global, 38);
        }
        if (v_global.branch!=-1) {
          rtn_puterror(scon(scon(scon(scpy("Existing global variable name '"), v_name), "' found in "), v_type));
        }
        else {
          newptr(&v_variable, 37, 0);
          v_variable=rtn_tbl_search_variable(0);
          while (1) {
            if (v_variable.branch==-1) {
              v_variable=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_variable_name(v_variable.rec), v_name)==0) {
              break;
            }
            v_variable=rtn_ptrplus1(v_variable, 37);
          }
          if (v_variable.branch!=-1) {
            rtn_puterror(scon(scon(scon(scpy("Existing variable name '"), v_name), "' found in "), v_type));
          }
          else {
            newptr(&v_tablename, 13, 0);
            v_tablename=rtn_tbl_search_tablename(scpy(v_name));
            while (1) {
              if ((v_tablename.branch==-1) || ((scmp(rtn_tbl_get_table_name(v_tablename.rec), v_name)>0))) {
                v_tablename=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_table_name(v_tablename.rec), v_name)==0) {
                break;
              }
              v_tablename=rtn_ptrplus1(v_tablename, 13);
            }
            if (v_tablename.branch!=-1) {
              rtn_puterror(scon(scon(scon(scpy("Existing table name '"), v_name), "' found in "), v_type));
            }
            else {
              newptr(&v_indexname, 18, 0);
              v_indexname=rtn_tbl_search_indexname(0);
              while (1) {
                if (v_indexname.branch==-1) {
                  v_indexname=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_index_name(v_indexname.rec), v_name)==0) {
                  break;
                }
                v_indexname=rtn_ptrplus1(v_indexname, 18);
              }
              if (v_indexname.branch!=-1) {
                rtn_puterror(scon(scon(scon(scpy("Existing index name '"), v_name), "' found in "), v_type));
              }
              else {
                if (v_name!=0) {free(v_name); v_name=0;}
                if (v_type!=0) {free(v_type); v_type=0;}
                delptr(&v_routinename, 8);
                delptr(&v_global, 38);
                delptr(&v_variable, 37);
                delptr(&v_tablename, 13);
                delptr(&v_indexname, 18);
                return 1;
              }
            }
          }
        }
      }
    }
  }
  if (v_name!=0) {free(v_name); v_name=0;}
  if (v_type!=0) {free(v_type); v_type=0;}
  delptr(&v_routinename, 8);
  delptr(&v_global, 38);
  delptr(&v_variable, 37);
  delptr(&v_tablename, 13);
  delptr(&v_indexname, 18);
  return 0;
  if (v_name!=0) {free(v_name); v_name=0;}
  if (v_type!=0) {free(v_type); v_type=0;}
  delptr(&v_routinename, 8);
  delptr(&v_global, 38);
  delptr(&v_variable, 37);
  delptr(&v_tablename, 13);
  delptr(&v_indexname, 18);
}
 
 
void rtn_scan_variable() {
  char *v_str=0;
  long int v_fldnr=0;
  char v_known=0;
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  struct pointer v_g={-1, -1, -1};
  char *var1=0;
  struct pointer v_td={-1, -1, -1};
  struct pointer v_gc={-1, -1, -1};
  if (scmp(v_scantag, "variable")==0 && v_scantype==3) {
    v_tagfound=1;
    v_fldnr=1;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      v_known=0;
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "name")==0 && v_fldnr==1) {
        v_known=1;
        if (rtn_check_name(scpy(rtn_tbl_get_scan_value(v_s.rec)), scpy("new global variable name"))) {
          newptr(&v_g, 38, 0);
          v_g=rtn_addrecord(23);
          rtn_tbl_put_global_name(v_g.rec, 0);
          rtn_tbl_put_global_kind(v_g.rec, -1);
          rtn_tbl_put_global_type(v_g.rec, 0);
          rtn_tbl_put_global_data(v_g.rec, 0);
          rtn_tbl_put_global_use(v_g.rec, 0);
          v_dbstate=1;
          rtn_tbl_put_global_name(v_g.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
          rtn_tbl_put_global_kind(v_g.rec, 0);
          v_g=rtn_tbl_add_global(v_g);
          v_dbstate=0;
        }
        else {
          delptr(&v_s, 1);
          delptr(&v_g, 38);
          delptr(&v_td, 30);
          delptr(&v_gc, 29);
          return;
        }
        v_fldnr+=1;
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_s.rec), "use")==0) {
          v_known=1;
          v_g=rtn_cpyrecord(v_g, 23);
          v_dbstate=2;
          rtn_tbl_put_global_use(v_g.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
          v_dbstate=3;
          v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
          v_dbstate=0;
        }
        else {
          if (scmp(rtn_tbl_get_scan_key(v_s.rec), "local")==0) {
            v_known=1;
            v_g=rtn_cpyrecord(v_g, 23);
            v_dbstate=2;
            rtn_tbl_put_global_kind(v_g.rec, 1);
            v_dbstate=3;
            v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
            v_dbstate=0;
          }
          else {
            if (scmp(rtn_tbl_get_scan_key(v_s.rec), "type")==0 && v_fldnr==2) {
              v_known=1;
              if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_scan_value(v_s.rec), 1))), "^")==0) {
                v_g=rtn_cpyrecord(v_g, 23);
                v_dbstate=2;
                rtn_tbl_put_global_type(v_g.rec, scpy("pointer"));
                rtn_tbl_put_global_data(v_g.rec, rtn_mid(rtn_tbl_get_scan_value(v_s.rec), 2, 999));
                v_dbstate=3;
                v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
                v_dbstate=0;
                rtn_table_fields(scpy(rtn_tbl_get_global_name(v_g.rec)), scpy(rtn_tbl_get_global_data(v_g.rec)));
              }
              else {
                if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_scan_value(v_s.rec), 1))), "[")==0) {
                  v_g=rtn_cpyrecord(v_g, 23);
                  v_dbstate=2;
                  rtn_tbl_put_global_type(v_g.rec, scpy("enumerate"));
                  if (scmp((var1=snew(var1, rtn_right(rtn_tbl_get_scan_value(v_s.rec), 1))), "]")!=0) {
                    rtn_putwarning(scpy("Expecting ']' at the end of an enumerate type"));
                    rtn_tbl_put_global_data(v_g.rec, rtn_mid(rtn_tbl_get_scan_value(v_s.rec), 2, 999));
                  }
                  else {
                    rtn_tbl_put_global_data(v_g.rec, rtn_mid(rtn_tbl_get_scan_value(v_s.rec), 2, rtn_length(rtn_tbl_get_scan_value(v_s.rec))-2));
                  }
                  v_dbstate=3;
                  v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
                  v_dbstate=0;
                }
                else {
                  newptr(&v_td, 30, 0);
                  v_td=rtn_tbl_search_actionget(scon(scpy("define "), rtn_tbl_get_scan_value(v_s.rec)));
                  while (1) {
                    if ((v_td.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_td.rec), (var1=snew(var1, scon(scpy("define "), rtn_tbl_get_scan_value(v_s.rec)))))>0))) {
                      v_td=rtn_nullpointer();
                      break;
                    }
                    if (scmp(rtn_tbl_get_action_ident(v_td.rec), (var1=snew(var1, scon(scpy("define "), rtn_tbl_get_scan_value(v_s.rec)))))==0) {
                      break;
                    }
                    v_td=rtn_ptrplus1(v_td, 30);
                  }
                  if (v_td.branch!=-1) {
                    v_g=rtn_cpyrecord(v_g, 23);
                    v_dbstate=2;
                    rtn_tbl_put_global_type(v_g.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
                    v_dbstate=3;
                    v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
                    v_dbstate=0;
                  }
                  else {
                    rtn_putwarning(scon(scon(scpy("Unknown type '"), rtn_tbl_get_scan_value(v_s.rec)), "' detected"));
                  }
                }
              }
              v_fldnr+=1;
            }
            else {
              if (v_fldnr==2) {
                v_g=rtn_cpyrecord(v_g, 23);
                v_dbstate=2;
                rtn_tbl_put_global_type(v_g.rec, scpy("string"));
                v_dbstate=3;
                v_g=rtn_tbl_update_global(rtn_getrec(rtn_recalcptr(v_g, 38), 23));
                v_dbstate=0;
                v_fldnr+=1;
              }
              else {
                rtn_puterror(scpy("Cannot read variable definition"));
                delptr(&v_s, 1);
                delptr(&v_g, 38);
                delptr(&v_td, 30);
                delptr(&v_gc, 29);
                return;
              }
            }
          }
        }
      }
      if (!(v_known)) {
        rtn_putwarning(scon(scon(scon(scpy("Unknown field "), rtn_tbl_get_scan_key(v_s.rec)), " in tag "), v_scantag));
      }
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
    newptr(&v_gc, 29, 0);
    v_gc=rtn_tbl_search_action(null);
    while (1) {
      if (v_gc.branch==-1) {
        v_gc=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_action_ident(v_gc.rec), (var1=snew(var1, scon(scpy("define "), rtn_tbl_get_global_type(v_g.rec)))))==0) {
        break;
      }
      v_gc=rtn_ptrplus1(v_gc, 29);
    }
    if (v_gc.branch!=-1) {
      swrite((var1=snew(var1, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_gc.rec)), scon(scpy("v_"), rtn_tbl_get_global_name(v_g.rec)), 0, 0, 0))), v_c); wline(v_c);
    }
    if (rtn_tbl_get_global_kind(v_g.rec)!=1) {
      v_str=snew(v_str, 0);
      if (scmp(rtn_tbl_get_global_type(v_g.rec), "enumerate")==0) {
        v_str=snew(v_str, scon(scon(scpy("["), rtn_tbl_get_global_data(v_g.rec)), "]"));
      }
      else {
        if (scmp(rtn_tbl_get_global_type(v_g.rec), "pointer")==0) {
          v_str=snew(v_str, scon(scpy("^"), rtn_tbl_get_global_data(v_g.rec)));
        }
        else {
          v_str=snew(v_str, scpy(rtn_tbl_get_global_type(v_g.rec)));
        }
      }
      rtn_doc_def(sadd(scon(sadd(scpy("Global "), rtn_tag("b")), rtn_tbl_get_global_name(v_g.rec)), rtn_tag("/b")), scpy(v_str), scpy(rtn_tbl_get_global_use(v_g.rec)));
      rtn_doc_def(0, 0, 0);
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_s, 1);
  delptr(&v_g, 38);
  delptr(&v_td, 30);
  delptr(&v_gc, 29);
}
 
 
void rtn_new_variable() {
  struct pointer v_v={-1, -1, -1};
  struct pointer v_variable={-1, -1, -1};
  struct pointer v_actionget={-1, -1, -1};
  char *var1=0;
  struct pointer v_ctd={-1, -1, -1};
  struct pointer v_fr={-1, -1, -1};
  if (rtn_check_name(scpy(v_keyword), scpy("new variable name"))) {
    newptr(&v_v, 37, 0);
    v_v=rtn_tbl_search_variable(0);
    while (1) {
      if (v_v.branch==-1) {
        v_v=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_variable_name(v_v.rec), v_keyword)==0) {
        break;
      }
      v_v=rtn_ptrplus1(v_v, 37);
    }
    if (v_v.branch!=-1) {
      rtn_puterror(scon(scon(scpy("Double declaration of the variable '"), v_keyword), "'"));
    }
    else {
      newptr(&v_variable, 37, 0);
      v_variable=rtn_addrecord(22);
      rtn_tbl_put_variable_name(v_variable.rec, 0);
      rtn_tbl_put_variable_kind(v_variable.rec, -1);
      rtn_tbl_put_variable_type(v_variable.rec, 0);
      rtn_tbl_put_variable_data(v_variable.rec, 0);
      rtn_tbl_put_variable_claimed(v_variable.rec, -1);
      rtn_tbl_put_variable_allowed(v_variable.rec, -1);
      rtn_tbl_put_variable_usage(v_variable.rec, -1);
      rtn_tbl_put_variable_use(v_variable.rec, 0);
      v_dbstate=1;
      rtn_tbl_put_variable_name(v_variable.rec, scpy(v_keyword));
      rtn_tbl_put_variable_type(v_variable.rec, scpy("string"));
      rtn_tbl_put_variable_kind(v_variable.rec, 2);
      v_variable=rtn_tbl_add_variable(v_variable);
      v_dbstate=0;
    }
    rtn_scankeyword();
    if (scmp(v_keyword, "as")==0) {
      rtn_scankeyword();
      if (scmp(v_keyword, "^")==0) {
        rtn_scankeyword();
        v_variable=rtn_cpyrecord(v_variable, 22);
        v_dbstate=2;
        rtn_tbl_put_variable_type(v_variable.rec, scpy("pointer"));
        rtn_tbl_put_variable_data(v_variable.rec, scpy(v_keyword));
        v_dbstate=3;
        v_variable=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_variable, 37), 22));
        v_dbstate=0;
        rtn_table_fields(scpy(rtn_tbl_get_variable_name(v_variable.rec)), scpy(rtn_tbl_get_variable_data(v_variable.rec)));
        rtn_scankeyword();
      }
      else {
        if (scmp(v_keyword, "[")==0) {
          v_variable=rtn_cpyrecord(v_variable, 22);
          v_dbstate=2;
          rtn_tbl_put_variable_type(v_variable.rec, scpy("enumerate"));
          v_dbstate=3;
          v_variable=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_variable, 37), 22));
          v_dbstate=0;
          rtn_scankeyword();
          while (1) {
            if (scmp(v_keyword, "]")==0) {
              break;
            }
            if (!(rtn_is_keyword(scpy(v_keyword)))) {
              rtn_putwarning(scon(scon(scon(scon(scpy("Unexpected keyword '"), v_keyword), "' in enumerate definition of '"), rtn_tbl_get_variable_name(v_variable.rec)), "'"));
              break;
            }
            v_variable=rtn_cpyrecord(v_variable, 22);
            v_dbstate=2;
            rtn_tbl_add_variable_data(v_variable.rec, scon(scpy(" "), v_keyword));
            v_dbstate=3;
            v_variable=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_variable, 37), 22));
            v_dbstate=0;
            rtn_scankeyword();
          }
          v_variable=rtn_cpyrecord(v_variable, 22);
          v_dbstate=2;
          rtn_tbl_put_variable_data(v_variable.rec, rtn_mid(rtn_tbl_get_variable_data(v_variable.rec), 2, 9999));
          v_dbstate=3;
          v_variable=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_variable, 37), 22));
          v_dbstate=0;
          rtn_scankeyword();
        }
        else {
          newptr(&v_actionget, 30, 0);
          v_actionget=rtn_tbl_search_actionget(scon(scpy("define "), v_keyword));
          while (1) {
            if ((v_actionget.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("define "), v_keyword))))>0))) {
              v_actionget=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("define "), v_keyword))))==0) {
              break;
            }
            v_actionget=rtn_ptrplus1(v_actionget, 30);
          }
          if (v_actionget.branch!=-1) {
            v_variable=rtn_cpyrecord(v_variable, 22);
            v_dbstate=2;
            rtn_tbl_put_variable_type(v_variable.rec, scpy(v_keyword));
            v_dbstate=3;
            v_variable=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_variable, 37), 22));
            v_dbstate=0;
            rtn_scankeyword();
          }
          else {
            rtn_puterror(scon(scon(scon(scon(scpy("Impossible type '"), v_keyword), "' of variable '"), rtn_tbl_get_variable_name(v_variable.rec)), "'"));
          }
        }
      }
      newptr(&v_ctd, 30, 0);
      v_ctd=rtn_tbl_search_actionget(scon(scpy("define "), rtn_tbl_get_variable_type(v_variable.rec)));
      while (1) {
        if ((v_ctd.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_ctd.rec), (var1=snew(var1, scon(scpy("define "), rtn_tbl_get_variable_type(v_variable.rec)))))>0))) {
          v_ctd=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_ctd.rec), (var1=snew(var1, scon(scpy("define "), rtn_tbl_get_variable_type(v_variable.rec)))))==0) {
          break;
        }
        v_ctd=rtn_ptrplus1(v_ctd, 30);
      }
      if (v_ctd.branch!=-1) {
        v_cindex=snew(v_cindex, scpy(rtn_tbl_get_variable_data(v_variable.rec)));
        rtn_addcode(rtn_tbl_get_action_action(v_ctd.rec), scon(scpy("v_"), rtn_tbl_get_variable_name(v_variable.rec)), 0);
      }
      else {
        rtn_putwarning(scon(scon(scpy("Cannot use '"), rtn_tbl_get_variable_type(v_variable.rec)), "' as a type for a variable"));
      }
      newptr(&v_fr, 30, 0);
      v_fr=rtn_tbl_search_actionget(scon(scpy("free "), rtn_tbl_get_variable_type(v_variable.rec)));
      while (1) {
        if ((v_fr.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_fr.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_variable_type(v_variable.rec)))))>0))) {
          v_fr=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_fr.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_variable_type(v_variable.rec)))))==0) {
          break;
        }
        v_fr=rtn_ptrplus1(v_fr, 30);
      }
      if (v_fr.branch!=-1 && rtn_tbl_get_variable_data(v_variable.rec)!=0) {
        v_cindex=snew(v_cindex, scpy(rtn_tbl_get_variable_data(v_variable.rec)));
        rtn_addcode(rtn_tbl_get_action_action(v_fr.rec), scon(scpy("v_"), rtn_tbl_get_variable_name(v_variable.rec)), scpy("free"));
      }
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_v, 37);
  delptr(&v_variable, 37);
  delptr(&v_actionget, 30);
  delptr(&v_ctd, 30);
  delptr(&v_fr, 30);
}
 
 
void rtn_copy_globals(long int v_croutine) {
  struct pointer v_g={-1, -1, -1};
  long int c_g=0;
  struct pointer v_v={-1, -1, -1};
  struct pointer v_p={-1, -1, -1};
  long int c_p=0;
  struct pointer v_pv={-1, -1, -1};
  newptr(&v_g, 38, 0);
  c_g=1;
  v_g=rtn_getpointer(0, 0, 38);
  while (1) {
    if (v_g.branch==-1) {
      break;
    }
    newptr(&v_v, 37, 0);
    v_v=rtn_addrecord(22);
    rtn_tbl_put_variable_name(v_v.rec, 0);
    rtn_tbl_put_variable_kind(v_v.rec, -1);
    rtn_tbl_put_variable_type(v_v.rec, 0);
    rtn_tbl_put_variable_data(v_v.rec, 0);
    rtn_tbl_put_variable_claimed(v_v.rec, -1);
    rtn_tbl_put_variable_allowed(v_v.rec, -1);
    rtn_tbl_put_variable_usage(v_v.rec, -1);
    rtn_tbl_put_variable_use(v_v.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_variable_kind(v_v.rec, ienum("global", "database parameter local table indicator"));
    rtn_tbl_put_variable_name(v_v.rec, scpy(rtn_tbl_get_global_name(v_g.rec)));
    rtn_tbl_put_variable_type(v_v.rec, scpy(rtn_tbl_get_global_type(v_g.rec)));
    rtn_tbl_put_variable_data(v_v.rec, scpy(rtn_tbl_get_global_data(v_g.rec)));
    rtn_tbl_put_variable_claimed(v_v.rec, 1);
    rtn_tbl_put_variable_usage(v_v.rec, 0);
    rtn_tbl_put_variable_use(v_v.rec, scpy(rtn_tbl_get_global_use(v_g.rec)));
    v_v=rtn_tbl_add_variable(v_v);
    v_dbstate=0;
    if (scmp(rtn_tbl_get_variable_type(v_v.rec), "pointer")==0) {
      rtn_table_fields(scpy(rtn_tbl_get_variable_name(v_v.rec)), scpy(rtn_tbl_get_variable_data(v_v.rec)));
    }
    c_g+=1;
    if (v_g.branch==-1) {
      v_g=rtn_getpointer(0, 0, 38);
    }
    else {
      v_g=rtn_ptrplus1(v_g, 38);
    }
  }
  newptr(&v_p, 9, 0);
  c_p=1;
  v_p=rtn_tbl_search_parameter(v_croutine, null);
  while (1) {
    if ((v_p.branch==-1) || ((rtn_tbl_get_parameter_routine(v_p.rec)>v_croutine))) {
      break;
    }
    if (rtn_tbl_get_parameter_routine(v_p.rec)==v_croutine) {
      newptr(&v_pv, 37, 0);
      v_pv=rtn_addrecord(22);
      rtn_tbl_put_variable_name(v_pv.rec, 0);
      rtn_tbl_put_variable_kind(v_pv.rec, -1);
      rtn_tbl_put_variable_type(v_pv.rec, 0);
      rtn_tbl_put_variable_data(v_pv.rec, 0);
      rtn_tbl_put_variable_claimed(v_pv.rec, -1);
      rtn_tbl_put_variable_allowed(v_pv.rec, -1);
      rtn_tbl_put_variable_usage(v_pv.rec, -1);
      rtn_tbl_put_variable_use(v_pv.rec, 0);
      v_dbstate=1;
      rtn_tbl_put_variable_name(v_pv.rec, scpy(rtn_tbl_get_parameter_name(v_p.rec)));
      rtn_tbl_put_variable_type(v_pv.rec, scpy(rtn_tbl_get_parameter_type(v_p.rec)));
      rtn_tbl_put_variable_data(v_pv.rec, scpy(rtn_tbl_get_parameter_data(v_p.rec)));
      rtn_tbl_put_variable_claimed(v_pv.rec, 1);
      rtn_tbl_put_variable_usage(v_pv.rec, 0);
      rtn_tbl_put_variable_kind(v_pv.rec, 1);
      rtn_tbl_put_variable_use(v_pv.rec, scpy(rtn_tbl_get_parameter_use(v_p.rec)));
      v_pv=rtn_tbl_add_variable(v_pv);
      v_dbstate=0;
      c_p+=1;
    }
    if (v_p.branch==-1) {
      v_p=rtn_getpointer(0, 0, 9);
    }
    else {
      v_p=rtn_ptrplus1(v_p, 9);
    }
  }
  c_p-=1;
  delptr(&v_g, 38);
  delptr(&v_v, 37);
  delptr(&v_p, 9);
  delptr(&v_pv, 37);
}
 
 
char rtn_find_variable() {
  struct pointer v_v={-1, -1, -1};
  struct pointer v_nv={-1, -1, -1};
  struct pointer v_index={-1, -1, -1};
  struct pointer v_table={-1, -1, -1};
  struct pointer v_field={-1, -1, -1};
  struct pointer v_actionget={-1, -1, -1};
  char *var1=0;
  newptr(&v_v, 37, 0);
  v_v=rtn_tbl_search_variable(0);
  while (1) {
    if (v_v.branch==-1) {
      v_v=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_variable_name(v_v.rec), v_keyword)==0) {
      break;
    }
    v_v=rtn_ptrplus1(v_v, 37);
  }
  v_cvarname=snew(v_cvarname, scpy(v_keyword));
  if (!(v_v.branch!=-1)) {
    delptr(&v_v, 37);
    delptr(&v_nv, 37);
    delptr(&v_index, 16);
    delptr(&v_table, 12);
    delptr(&v_field, 14);
    delptr(&v_actionget, 30);
    return 0;
  }
  v_cdbtbl=snew(v_cdbtbl, 0);
  v_cdbfld=snew(v_cdbfld, 0);
  rtn_scankeyword();
  while (1) {
    newptr(&v_nv, 37, 0);
    v_nv=rtn_tbl_search_variable(0);
    while (1) {
      if (v_nv.branch==-1) {
        v_nv=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_variable_name(v_nv.rec), v_cvarname)==0) {
        break;
      }
      v_nv=rtn_ptrplus1(v_nv, 37);
    }
    if (!(v_nv.branch!=-1)) {
      rtn_puterror(scon(scon(scpy("Cannot find variable '"), v_cvarname), "'"));
      delptr(&v_v, 37);
      delptr(&v_nv, 37);
      delptr(&v_index, 16);
      delptr(&v_table, 12);
      delptr(&v_field, 14);
      delptr(&v_actionget, 30);
      return 0;
    }
    if (scmp(v_keyword, ".")!=0) {
      break;
    }
    if (scmp(rtn_tbl_get_variable_type(v_nv.rec), "pointer")!=0 && scmp(rtn_tbl_get_variable_data(v_nv.rec), "separate")!=0) {
      rtn_puterror(scpy("Can only read field from pointer"));
      delptr(&v_v, 37);
      delptr(&v_nv, 37);
      delptr(&v_index, 16);
      delptr(&v_table, 12);
      delptr(&v_field, 14);
      delptr(&v_actionget, 30);
      return 0;
    }
    rtn_scankeyword();
    if (scmp(rtn_tbl_get_variable_data(v_nv.rec), "separate")!=0) {
      newptr(&v_index, 16, 0);
      v_index=rtn_tbl_search_index(null);
      while (1) {
        if (v_index.branch==-1) {
          v_index=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_index_name(v_index.rec), rtn_tbl_get_variable_data(v_nv.rec))==0) {
          break;
        }
        v_index=rtn_ptrplus1(v_index, 16);
      }
      if (v_index.branch!=-1) {
        newptr(&v_table, 12, 0);
        v_table=rtn_tbl_search_table(rtn_tbl_get_index_table(v_index.rec));
        while (1) {
          if ((v_table.branch==-1) || ((rtn_tbl_get_table_table(v_table.rec)>rtn_tbl_get_index_table(v_index.rec)))) {
            v_table=rtn_nullpointer();
            break;
          }
          if (rtn_tbl_get_table_table(v_table.rec)==rtn_tbl_get_index_table(v_index.rec)) {
            break;
          }
          v_table=rtn_ptrplus1(v_table, 12);
        }
        if (v_table.branch!=-1) {
          v_cdbtbl=snew(v_cdbtbl, scpy(rtn_tbl_get_table_name(v_table.rec)));
        }
      }
      else {
        rtn_puterror(scon(scon(scpy("Cannot detect index for '"), v_cvarname), "'"));
        delptr(&v_v, 37);
        delptr(&v_nv, 37);
        delptr(&v_index, 16);
        delptr(&v_table, 12);
        delptr(&v_field, 14);
        delptr(&v_actionget, 30);
        return 0;
      }
    }
    if (!(rtn_is_keyword(scpy(v_keyword)))) {
      rtn_puterror(scon(scon(scon(scon(scpy("Scanning impossible field '"), v_keyword), "' after '"), v_cvarname), "'"));
      break;
    }
    if (scmp(v_keyword, "first")==0) {
      v_cvarname=sadd(v_cvarname, scpy(".first"));
      v_cdbtbl=snew(v_cdbtbl, 0);
    }
    else {
      if (scmp(v_keyword, "found")==0) {
        v_cvarname=sadd(v_cvarname, scpy(".found"));
        v_cdbtbl=snew(v_cdbtbl, 0);
      }
      else {
        if (scmp(v_keyword, "recnr")==0) {
          v_cvarname=sadd(v_cvarname, scpy(".recnr"));
          v_cdbtbl=snew(v_cdbtbl, 0);
        }
        else {
          newptr(&v_field, 14, 0);
          v_field=rtn_tbl_search_field(rtn_tbl_get_index_table(v_index.rec), iscan(v_keyword));
          while (1) {
            if ((v_field.branch==-1) || ((rtn_tbl_get_field_table(v_field.rec)>rtn_tbl_get_index_table(v_index.rec) && scmp(rtn_tbl_get_field_name(v_field.rec), v_keyword)>0))) {
              v_field=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_field.rec)==rtn_tbl_get_index_table(v_index.rec) && scmp(rtn_tbl_get_field_name(v_field.rec), v_keyword)==0) {
              break;
            }
            v_field=rtn_ptrplus1(v_field, 14);
          }
          if (v_field.branch!=-1) {
            v_cdbfld=snew(v_cdbfld, scpy(rtn_tbl_get_field_name(v_field.rec)));
          }
          else {
            rtn_puterror(scon(scon(scon(scon(scpy("Cannot find field '"), v_keyword), "' after variable '"), v_cvarname), "'"));
            delptr(&v_v, 37);
            delptr(&v_nv, 37);
            delptr(&v_index, 16);
            delptr(&v_table, 12);
            delptr(&v_field, 14);
            delptr(&v_actionget, 30);
            return 0;
          }
          v_cvarname=sadd(v_cvarname, scon(scpy("."), v_keyword));
        }
      }
    }
    rtn_scankeyword();
  }
  v_ctype=snew(v_ctype, scpy(rtn_tbl_get_variable_type(v_nv.rec)));
  v_cdata=snew(v_cdata, scpy(rtn_tbl_get_variable_data(v_nv.rec)));
  newptr(&v_actionget, 30, 0);
  v_actionget=rtn_tbl_search_actionget(scon(scpy("variable "), v_ctype));
  while (1) {
    if ((v_actionget.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("variable "), v_ctype))))>0))) {
      v_actionget=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("variable "), v_ctype))))==0) {
      break;
    }
    v_actionget=rtn_ptrplus1(v_actionget, 30);
  }
  if (!(v_actionget.branch!=-1)) {
    rtn_puterror(scon(scon(scpy("Cannot read variable '"), rtn_tbl_get_variable_name(v_v.rec)), "' because of it's type"));
  }
  delptr(&v_v, 37);
  delptr(&v_nv, 37);
  delptr(&v_index, 16);
  delptr(&v_table, 12);
  delptr(&v_field, 14);
  delptr(&v_actionget, 30);
  return 1;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_v, 37);
  delptr(&v_nv, 37);
  delptr(&v_index, 16);
  delptr(&v_table, 12);
  delptr(&v_field, 14);
  delptr(&v_actionget, 30);
}
 
 
void rtn_find_ptr(char *v_index) {
  char *v_nvar=0;
  struct pointer v_cidx={-1, -1, -1};
  struct pointer v_v={-1, -1, -1};
  struct pointer v_pvar={-1, -1, -1};
  newptr(&v_cidx, 18, 0);
  v_cidx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_cidx.branch==-1) {
      v_cidx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_cidx.rec), v_index)==0) {
      break;
    }
    v_cidx=rtn_ptrplus1(v_cidx, 18);
  }
  if (!(v_cidx.branch!=-1)) {
    rtn_puterror(scon(scon(scpy("Cannot find index '"), v_index), "'"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_cidx, 18);
    delptr(&v_v, 37);
    delptr(&v_pvar, 37);
    return;
  }
  if (scmp(v_keyword, "as")==0) {
    rtn_scankeyword();
    v_nvar=snew(v_nvar, scpy(v_keyword));
    rtn_scankeyword();
  }
  else {
    v_nvar=snew(v_nvar, scpy(v_index));
  }
  newptr(&v_v, 37, 0);
  v_v=rtn_tbl_search_variable(0);
  while (1) {
    if (v_v.branch==-1) {
      v_v=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_variable_name(v_v.rec), v_nvar)==0) {
      break;
    }
    v_v=rtn_ptrplus1(v_v, 37);
  }
  if (v_v.branch!=-1) {
    v_cvarname=snew(v_cvarname, scpy(v_nvar));
    v_ctype=snew(v_ctype, scpy(rtn_tbl_get_variable_type(v_v.rec)));
    v_cdata=snew(v_cdata, scpy(rtn_tbl_get_variable_data(v_v.rec)));
    if ((scmp(v_ctype, "pointer")!=0) || (scmp(v_cdata, v_index)!=0)) {
      rtn_puterror(scon(scon(scon(scon(scon(scon(scpy("Wrong variable type '"), v_ctype), "' ("), v_cdata), ") found in '"), v_cvarname), "'"));
    }
  }
  else {
    rtn_addactioncode(scpy("define pointer"), scpy("Cannot find the definition of a pointer"), scon(scpy("v_"), v_nvar), 0);
    v_cindex=snew(v_cindex, scpy(v_index));
    rtn_addactioncode(scpy("free pointer"), 0, scon(scpy("v_"), v_nvar), scpy("free"));
    newptr(&v_pvar, 37, 0);
    v_pvar=rtn_addrecord(22);
    rtn_tbl_put_variable_name(v_pvar.rec, 0);
    rtn_tbl_put_variable_kind(v_pvar.rec, -1);
    rtn_tbl_put_variable_type(v_pvar.rec, 0);
    rtn_tbl_put_variable_data(v_pvar.rec, 0);
    rtn_tbl_put_variable_claimed(v_pvar.rec, -1);
    rtn_tbl_put_variable_allowed(v_pvar.rec, -1);
    rtn_tbl_put_variable_usage(v_pvar.rec, -1);
    rtn_tbl_put_variable_use(v_pvar.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_variable_name(v_pvar.rec, scpy(v_nvar));
    rtn_tbl_put_variable_type(v_pvar.rec, scpy("pointer"));
    rtn_tbl_put_variable_data(v_pvar.rec, scpy(v_index));
    rtn_tbl_put_variable_usage(v_pvar.rec, 0);
    rtn_tbl_put_variable_kind(v_pvar.rec, 2);
    v_pvar=rtn_tbl_add_variable(v_pvar);
    v_dbstate=0;
    v_cvarname=snew(v_cvarname, scpy(v_nvar));
    v_ctype=snew(v_ctype, scpy("pointer"));
    v_cdata=snew(v_cdata, scpy(v_index));
    rtn_table_fields(scpy(v_cvarname), scpy(v_cdata));
  }
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_cidx, 18);
  delptr(&v_v, 37);
  delptr(&v_pvar, 37);
}
 
long int v_conversionvar=0;
long int v_maxconversion=0;
long int v_routinelevel=0;
 
long int rtn_tbl_get_para_level(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) return null;
  return *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+0);
}
 
void rtn_tbl_put_para_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in filling field para.level\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+0)=v_val;
}
 
void rtn_tbl_add_para_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in adding to field para.level\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+0)+=v_val;
}
 
void rtn_tbl_sub_para_level(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("Error in subtraction from field para.level\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+0)-=v_val;
}
 
long int rtn_tbl_get_para_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) return 0;
  return *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+4);
}
 
void rtn_tbl_put_para_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in filling field para.order\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+4)=v_val;
}
 
void rtn_tbl_add_para_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in adding to field para.order\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+4)+=v_val;
}
 
void rtn_tbl_sub_para_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("Error in subtraction from field para.order\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+4)-=v_val;
}
 
char *rtn_tbl_get_para_type(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) return 0;
  return *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+8);
}
 
void rtn_tbl_put_para_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in filling field para.type\n");
    return;
  }
  *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+8)=v_val;
}
 
void rtn_tbl_add_para_type(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in adding to field para.type\n");
    return;
  }
  *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+8)= 
  sadd(*(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+8), v_val);
}
 
char *rtn_tbl_get_para_data(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) return 0;
  return *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+12);
}
 
void rtn_tbl_put_para_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in filling field para.data\n");
    return;
  }
  *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+12)=v_val;
}
 
void rtn_tbl_add_para_data(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in adding to field para.data\n");
    return;
  }
  *(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+12)= 
  sadd(*(char**)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+12), v_val);
}
 
long int rtn_tbl_get_para_pos(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) return null;
  return *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+16);
}
 
void rtn_tbl_put_para_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in filling field para.pos\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+16)=v_val;
}
 
void rtn_tbl_add_para_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("error in adding to field para.pos\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+16)+=v_val;
}
 
void rtn_tbl_sub_para_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[24].len) {
    printf("Error in subtraction from field para.pos\n");
    return;
  }
  *(long int*)(u_table[24].ptr[v_rec/250]+(v_rec%250)*u_table[24].size+16)-=v_val;
}
 
struct pointer rtn_tbl_search_para(long int v_p_level, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 39, 1);
  newptr(&v_ptr, 39, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(39)+1);
    v_idx=rtn_getpointer(v_curr, 0, 39);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_level, rtn_tbl_get_para_level(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_para_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(39);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 39)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 39);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_level, rtn_tbl_get_para_level(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_para_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 39);
  }
  delptr(&v_idx, 39);
  delptr(&v_ptr, 39);
  return v_ptr;
  delptr(&v_idx, 39);
  delptr(&v_ptr, 39);
}
 
 
struct pointer rtn_tbl_add_para(struct pointer v_new) {
  struct pointer v_idx_para={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_para, 39, 1);
  newptr(&v_last, 39, 1);
  rtn_tbl_put_para_order(v_new.rec, 999999999);
  v_idx_para=rtn_tbl_search_para(rtn_tbl_get_para_level(v_new.rec), rtn_tbl_get_para_order(v_new.rec));
  if (v_idx_para.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(39), rtn_maxleaf(rtn_maxbranch(39), 39), 39);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_para, 39);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_para_level(v_last.rec)!=rtn_tbl_get_para_level(v_new.rec))) {
    rtn_tbl_put_para_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_para_order(v_new.rec, rtn_tbl_get_para_order(v_last.rec)+1);
  }
  rtn_addindex(v_idx_para, rtn_tablelen(24)-1, 39);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("add para(24):"), get_int(rtn_tbl_get_para_level(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_para_order(v_new.rec)))), "|"), rtn_tbl_get_para_type(v_new.rec)), "|"), rtn_tbl_get_para_data(v_new.rec)), "|"), get_int(rtn_tbl_get_para_pos(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 39);
    delptr(&v_idx_para, 39);
    delptr(&v_last, 39);
    return rtn_getpointer(0, 0, 39);
  }
  delptr(&v_new, 39);
  delptr(&v_idx_para, 39);
  delptr(&v_last, 39);
  return rtn_ptrplus1(v_last, 39);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 39);
  delptr(&v_idx_para, 39);
  delptr(&v_last, 39);
}
 
 
void rtn_tbl_delete_para(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 39, 1);
  newptr(&v_chk, 39, 1);
  newptr(&v_del, 39, 1);
  v_del=rtn_getrecptr(v_delrec, 24);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("delete para(24):"), get_int(rtn_tbl_get_para_level(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_para_order(v_del.rec)))), "|"), rtn_tbl_get_para_type(v_del.rec)), "|"), rtn_tbl_get_para_data(v_del.rec)), "|"), get_int(rtn_tbl_get_para_pos(v_del.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_para(rtn_tbl_get_para_level(v_del.rec), rtn_tbl_get_para_order(v_del.rec));
  rtn_deleteindex(v_chk, 39);
  v_chk=rtn_tbl_search_para(rtn_tbl_get_para_level(v_del.rec), rtn_tbl_get_para_order(v_del.rec)+1);
  rtn_tbl_put_para_type(v_del.rec, 0);
  rtn_tbl_put_para_data(v_del.rec, 0);
  if (rtn_getrec(v_del, 24)!=rtn_tablelen(24)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(24)-1, 39);
    rtn_changeindex(rtn_tbl_search_para(rtn_tbl_get_para_level(v_last.rec), rtn_tbl_get_para_order(v_last.rec)), v_delrec, 39);
  }
  rtn_deleterecord(v_delrec, 24);
  if (v_chk.branch==-1) {
    delptr(&v_last, 39);
    delptr(&v_chk, 39);
    delptr(&v_del, 39);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 39);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_para_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 24);
    rtn_tbl_sub_para_order(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 39);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 39);
  delptr(&v_chk, 39);
  delptr(&v_del, 39);
}
 
 
struct pointer rtn_tbl_update_para(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 39, 1);
  newptr(&v_del, 39, 1);
  v_del=rtn_getrecptr(v_rec, 24);
  v_new=rtn_tbl_search_para(rtn_tbl_get_para_level(v_del.rec), rtn_tbl_get_para_order(v_del.rec));
  rtn_deleteindex(v_new, 39);
  rtn_deleterecord(v_rec, 24);
  rtn_addindex(rtn_tbl_search_para(rtn_tbl_get_para_level(v_new.rec), rtn_tbl_get_para_order(v_new.rec)), rtn_getrec(v_new, 39), 39);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 24);
  }
  swrite((var1=snew(var1, scon(sadd(scon(scon(scon(scon(scon(sadd(scon(sadd(scpy("update para:"), get_int(rtn_tbl_get_para_level(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_para_order(v_new.rec)))), "|"), rtn_tbl_get_para_type(v_new.rec)), "|"), rtn_tbl_get_para_data(v_new.rec)), "|"), get_int(rtn_tbl_get_para_pos(v_new.rec))), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 39);
  delptr(&v_del, 39);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 39);
  delptr(&v_del, 39);
}
 
 
void rtn_tbl_clear_para() {
  
  long int r=0;
  long int branch;
  while (r < u_table[24].len) {
    if (*(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+8)!=0) {free(*(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+8)); *(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+8)=0;}
    if (*(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+12)!=0) {free(*(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+12)); *(char**)(u_table[24].ptr[r/250]+(r%250)*u_table[24].size+12)=0;}
    r++;
  }
  free(u_table[24].ptr);
  u_table[24].ptr=0;
  u_table[24].len=0;
  for(branch=0; branch < u_index[39].scale; branch++)
  { free(u_index[39].ptr[branch]);
  }
  free(u_index[39].len);
  free(u_index[39].ptr);
  u_index[39].scale=0;
  u_index[39].len=0;
  u_index[39].ptr=0;
  fprintf(v_log, "clear para(24)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_para() {
  
  return u_table[24].len;
}
 
void rtn_tbl_init_para() {
  
  u_table[24].len=0;
  u_table[24].size=20;
  u_table[24].ptr=0;
  u_index[39].tbl=24;
  u_index[39].scale=0;
  u_index[39].len=0;
  u_index[39].ptr=0;
  u_index[39].ptrs=0;
  u_index[39].padm=0;
}
 
void rtn_tbl_write_para(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 39, 0);
  rtn_write(rtn_tbl_get_para_level(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_para_order(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_para_type(v_ptr.rec)), v_stream);
  rtn_write(iscan(rtn_tbl_get_para_data(v_ptr.rec)), v_stream);
  rtn_write(rtn_tbl_get_para_pos(v_ptr.rec), v_stream);
  delptr(&v_ptr, 39);
}
 
 
struct pointer rtn_tbl_read_para(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 39, 0);
  v_new=rtn_addrecord(24);
  rtn_tbl_put_para_level(v_new.rec, null);
  rtn_tbl_put_para_order(v_new.rec, 0);
  rtn_tbl_put_para_type(v_new.rec, 0);
  rtn_tbl_put_para_data(v_new.rec, 0);
  rtn_tbl_put_para_pos(v_new.rec, null);
  v_dbstate=1;
  rtn_tbl_put_para_level(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_para_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_para_type(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_para_data(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  rtn_tbl_put_para_pos(v_new.rec, rtn_read(v_stream));
  v_new=rtn_tbl_add_para(v_new);
  v_dbstate=0;
  delptr(&v_new, 39);
  return v_new;
  delptr(&v_new, 39);
}
 
 
void rtn_expression(char *v_type, char *v_data);
 
 
long int rtn_check_conversion(char *v_type, char *v_data, long int v_position) {
  long int v_newc=0;
  struct pointer v_cv={-1, -1, -1};
  char *var1=0;
  v_newc=0;
  if (v_ctype==0) {
    v_ctype=snew(v_ctype, scpy(v_type));
  }
  else {
    if (scmp(v_type, v_ctype)!=0) {
      newptr(&v_cv, 30, 0);
      v_cv=rtn_tbl_search_actionget(scon(scon(scpy(v_ctype), " -> "), v_type));
      while (1) {
        if ((v_cv.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_cv.rec), (var1=snew(var1, scon(scon(scpy(v_ctype), " -> "), v_type))))>0))) {
          v_cv=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_cv.rec), (var1=snew(var1, scon(scon(scpy(v_ctype), " -> "), v_type))))==0) {
          break;
        }
        v_cv=rtn_ptrplus1(v_cv, 30);
      }
      if (v_cv.branch!=-1) {
        if (scmp(v_type, "constr")==0 && scmp(v_ctype, "string")==0) {
          if (v_conversionvar>v_maxconversion) {
            rtn_addactioncode(scon(scpy("define "), v_ctype), scpy("Cannot declare conversion variable"), sadd(scpy("var"), get_int(v_conversionvar)), 0);
            rtn_addactioncode(scon(scpy("free "), v_ctype), scpy("Cannot free conversion variable"), sadd(scpy("var"), get_int(v_conversionvar)), 0);
            v_maxconversion=v_conversionvar;
          }
          if (v_position==0) {
            rtn_addcode(rtn_tbl_get_action_action(v_cv.rec), sadd(scpy("var"), get_int(v_conversionvar)), scpy(v_cdata));
          }
          else {
            rtn_addinsertcode(v_position, scon(scon(scpy(v_ctype), " -> "), v_type), scpy("Conversion not found"), sadd(scpy("var"), get_int(v_conversionvar)), scpy(v_data));
            v_newc+=1;
          }
          v_conversionvar+=1;
        }
        else {
          if (v_position==0) {
            if (scmp(v_type, "enumerate")==0) {
              rtn_addcode(rtn_tbl_get_action_action(v_cv.rec), 0, scpy(v_data));
            }
            else {
              rtn_addcode(rtn_tbl_get_action_action(v_cv.rec), 0, scpy(v_cdata));
            }
          }
          else {
            if (scmp(v_type, "enumerate")==0) {
              rtn_addinsertcode(v_position, scon(scon(scpy(v_ctype), " -> "), v_type), scpy("Conversion not found"), 0, scpy(v_data));
            }
            else {
              rtn_addinsertcode(v_position, scon(scon(scpy(v_ctype), " -> "), v_type), scpy("Conversion not found"), 0, scpy(v_cdata));
            }
            v_newc+=1;
          }
        }
        v_ctype=snew(v_ctype, scpy(v_type));
        v_cdata=snew(v_cdata, scpy(v_data));
      }
      else {
        rtn_puterror(scon(scon(scon(scon(scpy("Unknown conversion from '"), v_ctype), "' to '"), v_type), "'"));
      }
    }
    else {
      if (scmp(v_type, v_ctype)==0 && v_cdata!=0 && v_data!=0 && scmp(v_data, v_cdata)!=0) {
        if (v_position==0) {
          rtn_addactioncode(scon(scpy(v_ctype), " -> string"), scpy("Cannot find correct data conversion"), 0, scpy(v_cdata));
          rtn_addactioncode(scon(scpy("string -> "), v_type), scpy("Cannot find correct data conversion"), 0, scpy(v_data));
        }
        else {
          rtn_addinsertcode(v_position, scon(scpy(v_ctype), " -> string"), scpy("Cannot find correct data conversion"), 0, scpy(v_cdata));
          rtn_addinsertcode(v_position, scon(scpy("string -> "), v_type), scpy("Cannot find correct data conversion"), 0, scpy(v_data));
          v_newc+=2;
        }
        v_cdata=snew(v_cdata, scpy(v_data));
      }
    }
  }
  if (v_type!=0) {free(v_type); v_type=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  delptr(&v_cv, 30);
  return v_newc;
  if (var1!=0) {free(var1); var1=0;}
  if (v_type!=0) {free(v_type); v_type=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
  delptr(&v_cv, 30);
}
 
 
void rtn_get_routine(char *v_fname) {
  char *v_stype=0;
  char *v_sdata=0;
  long int v_last=0;
  long int v_extra=0;
  long int v_lastcheck=0;
  long int v_chk=0;
  struct pointer v_dp={-1, -1, -1};
  long int c_dp=0;
  struct pointer v_np={-1, -1, -1};
  struct pointer v_fn={-1, -1, -1};
  long int c_fn=0;
  struct pointer v_parm={-1, -1, -1};
  long int c_parm=0;
  struct pointer v_p={-1, -1, -1};
  struct pointer v_actionget={-1, -1, -1};
  char *var1=0;
  struct pointer v_finr={-1, -1, -1};
  struct pointer v_par={-1, -1, -1};
  long int c_par=0;
  struct pointer v_pr={-1, -1, -1};
  struct pointer v_cd={-1, -1, -1};
  struct pointer v_ac={-1, -1, -1};
  struct pointer v_pp={-1, -1, -1};
  long int c_pp=0;
  struct pointer v_iscon={-1, -1, -1};
  v_stype=snew(v_stype, scpy(v_ctype));
  v_sdata=snew(v_sdata, scpy(v_cdata));
  newptr(&v_dp, 39, 0);
  c_dp=1;
  v_dp=rtn_tbl_search_para(null, null);
  while (1) {
    if (v_dp.branch==-1) {
      break;
    }
    if (rtn_tbl_get_para_level(v_dp.rec)>=v_routinelevel) {
      rtn_tbl_delete_para(rtn_getrec(v_dp, 39));
      c_dp+=1;
    }
    if (v_dp.branch==-1) {
      v_dp=rtn_getpointer(0, 0, 39);
    }
    else {
      v_dp=rtn_ptrplus1(v_dp, 39);
    }
  }
  c_dp-=1;
  while (1) {
    if (scmp(v_keyword, ")")==0) {
      break;
    }
    v_routinelevel+=1;
    rtn_expression(0, 0);
    v_routinelevel-=1;
    newptr(&v_np, 39, 0);
    v_np=rtn_addrecord(24);
    rtn_tbl_put_para_level(v_np.rec, null);
    rtn_tbl_put_para_order(v_np.rec, 0);
    rtn_tbl_put_para_type(v_np.rec, 0);
    rtn_tbl_put_para_data(v_np.rec, 0);
    rtn_tbl_put_para_pos(v_np.rec, null);
    v_dbstate=1;
    rtn_tbl_put_para_level(v_np.rec, v_routinelevel);
    rtn_tbl_put_para_type(v_np.rec, scpy(v_ctype));
    rtn_tbl_put_para_data(v_np.rec, scpy(v_cdata));
    rtn_tbl_put_para_pos(v_np.rec, v_lastcode+1);
    v_np=rtn_tbl_add_para(v_np);
    v_dbstate=0;
    if (scmp(v_keyword, ",")!=0) {
      break;
    }
    rtn_scankeyword();
  }
  v_ctype=snew(v_ctype, scpy(v_stype));
  v_cdata=snew(v_cdata, scpy(v_sdata));
  v_lastcheck=0;
  v_last=0;
  newptr(&v_fn, 8, 0);
  c_fn=1;
  v_fn=rtn_tbl_search_routinename(0, null);
  while (1) {
    if (v_fn.branch==-1) {
      break;
    }
    if (scmp(rtn_tbl_get_routine_name(v_fn.rec), v_fname)==0) {
      v_chk=1;
      newptr(&v_parm, 9, 0);
      c_parm=1;
      v_parm=rtn_tbl_search_parameter(rtn_tbl_get_routine_order(v_fn.rec), null);
      while (1) {
        if ((v_parm.branch==-1) || ((rtn_tbl_get_parameter_routine(v_parm.rec)>rtn_tbl_get_routine_order(v_fn.rec)))) {
          break;
        }
        if (rtn_tbl_get_parameter_routine(v_parm.rec)==rtn_tbl_get_routine_order(v_fn.rec)) {
          newptr(&v_p, 39, 0);
          v_p=rtn_tbl_search_para(null, null);
          while (1) {
            if (v_p.branch==-1) {
              v_p=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_para_level(v_p.rec)==v_routinelevel && rtn_tbl_get_para_order(v_p.rec)==rtn_tbl_get_parameter_order(v_parm.rec)) {
              break;
            }
            v_p=rtn_ptrplus1(v_p, 39);
          }
          if (!(v_p.branch!=-1)) {
            if (rtn_tbl_get_parameter_defaultvalue(v_parm.rec)==0) {
              v_chk=0;
            }
          }
          else {
            if (scmp(rtn_tbl_get_para_type(v_p.rec), rtn_tbl_get_parameter_type(v_parm.rec))==0) {
              if (scmp(rtn_tbl_get_para_type(v_p.rec), "enumerate")==0) {
                if (scmp(rtn_tbl_get_para_data(v_p.rec), rtn_tbl_get_parameter_data(v_parm.rec))==0) {
                  v_chk=v_chk*4+2;
                }
              }
              else {
                if (scmp(rtn_tbl_get_para_type(v_p.rec), "pointer")==0) {
                  if ((rtn_tbl_get_parameter_data(v_parm.rec)==0) || (scmp(rtn_tbl_get_parameter_data(v_parm.rec), rtn_tbl_get_para_data(v_p.rec))==0)) {
                    v_chk=v_chk*4+2;
                  }
                }
                else {
                  v_chk=v_chk*4+2;
                }
              }
            }
            else {
              if (rtn_tbl_get_para_type(v_p.rec)==0) {
                v_chk=v_chk*4+2;
                v_p=rtn_cpyrecord(v_p, 24);
                v_dbstate=2;
                rtn_tbl_put_para_type(v_p.rec, scpy("null"));
                v_dbstate=3;
                v_p=rtn_tbl_update_para(rtn_getrec(rtn_recalcptr(v_p, 39), 24));
                v_dbstate=0;
              }
              else {
                newptr(&v_actionget, 30, 0);
                v_actionget=rtn_tbl_search_actionget(scon(scon(scpy(rtn_tbl_get_para_type(v_p.rec)), " -> "), rtn_tbl_get_parameter_type(v_parm.rec)));
                while (1) {
                  if ((v_actionget.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scon(scpy(rtn_tbl_get_para_type(v_p.rec)), " -> "), rtn_tbl_get_parameter_type(v_parm.rec)))))>0))) {
                    v_actionget=rtn_nullpointer();
                    break;
                  }
                  if (scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scon(scpy(rtn_tbl_get_para_type(v_p.rec)), " -> "), rtn_tbl_get_parameter_type(v_parm.rec)))))==0) {
                    break;
                  }
                  v_actionget=rtn_ptrplus1(v_actionget, 30);
                }
                if (v_actionget.branch!=-1) {
                  v_chk=v_chk*4+1;
                }
                else {
                  v_chk=0;
                }
              }
            }
          }
          c_parm+=1;
        }
        if (v_parm.branch==-1) {
          v_parm=rtn_getpointer(0, 0, 9);
        }
        else {
          v_parm=rtn_ptrplus1(v_parm, 9);
        }
      }
      c_parm-=1;
      if (v_chk>v_lastcheck) {
        v_lastcheck=v_chk;
        v_last=rtn_tbl_get_routine_order(v_fn.rec);
      }
      c_fn+=1;
    }
    if (v_fn.branch==-1) {
      v_fn=rtn_getpointer(0, 0, 8);
    }
    else {
      v_fn=rtn_ptrplus1(v_fn, 8);
    }
  }
  c_fn-=1;
  newptr(&v_finr, 6, 0);
  v_finr=rtn_tbl_search_routine(v_last);
  while (1) {
    if ((v_finr.branch==-1) || ((rtn_tbl_get_routine_order(v_finr.rec)>v_last))) {
      v_finr=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_routine_order(v_finr.rec)==v_last) {
      break;
    }
    v_finr=rtn_ptrplus1(v_finr, 6);
  }
  if (v_finr.branch!=-1) {
    newptr(&v_par, 9, 0);
    c_par=1;
    v_par=rtn_tbl_search_parameter(v_last, null);
    while (1) {
      if ((v_par.branch==-1) || ((rtn_tbl_get_parameter_routine(v_par.rec)>v_last))) {
        break;
      }
      if (rtn_tbl_get_parameter_routine(v_par.rec)==v_last) {
        v_extra=0;
        newptr(&v_pr, 39, 0);
        v_pr=rtn_tbl_search_para(null, null);
        while (1) {
          if (v_pr.branch==-1) {
            v_pr=rtn_nullpointer();
            break;
          }
          if (rtn_tbl_get_para_level(v_pr.rec)==v_routinelevel && rtn_tbl_get_para_order(v_pr.rec)==rtn_tbl_get_parameter_order(v_par.rec)) {
            break;
          }
          v_pr=rtn_ptrplus1(v_pr, 39);
        }
        if (v_pr.branch!=-1) {
          v_ctype=snew(v_ctype, scpy(rtn_tbl_get_para_type(v_pr.rec)));
          v_cdata=snew(v_cdata, scpy(rtn_tbl_get_para_data(v_pr.rec)));
          if (scmp(v_ctype, "null")==0) {
            newptr(&v_cd, 33, 0);
            v_cd=rtn_tbl_search_code(v_croutine, -1, null);
            while (1) {
              if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_croutine))) {
                v_cd=rtn_nullpointer();
                break;
              }
              if (rtn_tbl_get_code_routine(v_cd.rec)==v_croutine && rtn_tbl_get_code_kind(v_cd.rec)==1 && rtn_tbl_get_code_order(v_cd.rec)==rtn_tbl_get_para_pos(v_pr.rec)-1) {
                break;
              }
              v_cd=rtn_ptrplus1(v_cd, 33);
            }
            if (v_cd.branch!=-1) {
              newptr(&v_ac, 30, 0);
              v_ac=rtn_tbl_search_actionget(scon(scpy("null "), rtn_tbl_get_parameter_type(v_par.rec)));
              while (1) {
                if ((v_ac.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_ac.rec), (var1=snew(var1, scon(scpy("null "), rtn_tbl_get_parameter_type(v_par.rec)))))>0))) {
                  v_ac=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_action_ident(v_ac.rec), (var1=snew(var1, scon(scpy("null "), rtn_tbl_get_parameter_type(v_par.rec)))))==0) {
                  break;
                }
                v_ac=rtn_ptrplus1(v_ac, 30);
              }
              if (v_ac.branch!=-1) {
                v_cd=rtn_cpyrecord(v_cd, 18);
                v_dbstate=2;
                rtn_tbl_put_code_action(v_cd.rec, rtn_tbl_get_action_action(v_ac.rec));
                v_dbstate=3;
                v_cd=rtn_tbl_update_code(rtn_getrec(rtn_recalcptr(v_cd, 33), 18));
                v_dbstate=0;
              }
            }
          }
          else {
            v_extra=rtn_check_conversion(scpy(rtn_tbl_get_parameter_type(v_par.rec)), scpy(rtn_tbl_get_parameter_data(v_par.rec)), rtn_tbl_get_para_pos(v_pr.rec));
          }
          newptr(&v_pp, 39, 0);
          c_pp=1;
          v_pp=rtn_tbl_search_para(null, null);
          while (1) {
            if (v_pp.branch==-1) {
              break;
            }
            if (rtn_tbl_get_para_level(v_pp.rec)==v_routinelevel) {
              v_pp=rtn_cpyrecord(v_pp, 24);
              v_dbstate=2;
              rtn_tbl_add_para_pos(v_pp.rec, v_extra);
              v_dbstate=3;
              v_pp=rtn_tbl_update_para(rtn_getrec(rtn_recalcptr(v_pp, 39), 24));
              v_dbstate=0;
              c_pp+=1;
            }
            if (v_pp.branch==-1) {
              v_pp=rtn_getpointer(0, 0, 39);
            }
            else {
              v_pp=rtn_ptrplus1(v_pp, 39);
            }
          }
          c_pp-=1;
        }
        else {
          newptr(&v_iscon, 29, 0);
          v_iscon=rtn_tbl_search_action(null);
          while (1) {
            if (v_iscon.branch==-1) {
              v_iscon=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_iscon.rec), rtn_tbl_get_parameter_defaultvalue(v_par.rec))==0 && rtn_tbl_get_action_parms(v_iscon.rec)==0) {
              break;
            }
            v_iscon=rtn_ptrplus1(v_iscon, 29);
          }
          if (v_iscon.branch!=-1) {
            rtn_addcode(rtn_tbl_get_action_action(v_iscon.rec), 0, 0);
            v_ctype=snew(v_ctype, scpy(rtn_tbl_get_action_result(v_iscon.rec)));
            v_cdata=snew(v_cdata, 0);
          }
          else {
            rtn_addactioncode(scpy("string"), scpy("Cannot find constant string definition"), scpy(rtn_tbl_get_parameter_defaultvalue(v_par.rec)), 0);
            v_ctype=snew(v_ctype, scpy("constr"));
            v_cdata=snew(v_cdata, 0);
          }
          v_extra=rtn_check_conversion(scpy(rtn_tbl_get_parameter_type(v_par.rec)), scpy(rtn_tbl_get_parameter_data(v_par.rec)), 0);
        }
        c_par+=1;
      }
      if (v_par.branch==-1) {
        v_par=rtn_getpointer(0, 0, 9);
      }
      else {
        v_par=rtn_ptrplus1(v_par, 9);
      }
    }
    c_par-=1;
    rtn_addactioncode(scpy(rtn_tbl_get_routine_function(v_finr.rec)), scpy("Cannot find definition of routine"), 0, 0);
    v_ctype=snew(v_ctype, scpy(rtn_tbl_get_routine_returntype(v_finr.rec)));
    v_cdata=snew(v_cdata, scpy(rtn_tbl_get_routine_returndata(v_finr.rec)));
  }
  else {
    v_ctype=snew(v_ctype, 0);
    v_cdata=snew(v_cdata, 0);
    rtn_putwarning(scon(scon(scpy("Could not find a matching routine for '"), v_fname), "'"));
  }
  if (var1!=0) {free(var1); var1=0;}
  if (v_fname!=0) {free(v_fname); v_fname=0;}
  delptr(&v_dp, 39);
  delptr(&v_np, 39);
  delptr(&v_fn, 8);
  delptr(&v_parm, 9);
  delptr(&v_p, 39);
  delptr(&v_actionget, 30);
  delptr(&v_finr, 6);
  delptr(&v_par, 9);
  delptr(&v_pr, 39);
  delptr(&v_cd, 33);
  delptr(&v_ac, 30);
  delptr(&v_pp, 39);
  delptr(&v_iscon, 29);
}
 
 
char rtn_find_routine() {
  char *v_fnname=0;
  struct pointer v_rn={-1, -1, -1};
  v_routinelevel=1;
  newptr(&v_rn, 8, 0);
  v_rn=rtn_tbl_search_routinename(0, null);
  while (1) {
    if (v_rn.branch==-1) {
      v_rn=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_routine_name(v_rn.rec), v_keyword)==0 && rtn_tbl_get_routine_returntype(v_rn.rec)==0) {
      break;
    }
    v_rn=rtn_ptrplus1(v_rn, 8);
  }
  if (v_rn.branch!=-1) {
    v_fnname=snew(v_fnname, scpy(v_keyword));
    rtn_addtag(scon(scon(scon(scon(scpy("a href=\""), rtn_tbl_get_routine_module(v_rn.rec)), ".html#rtn_"), v_fnname), "\""), scpy("/a"));
    rtn_scankeyword();
    if (scmp(v_keyword, "(")==0) {
      rtn_scankeyword();
      rtn_get_routine(scpy(v_fnname));
      if (scmp(v_keyword, ")")==0) {
        rtn_scankeyword();
      }
      else {
        rtn_putwarning(scpy("Expecting closing bracket"));
      }
    }
    else {
      rtn_get_routine(scpy(v_fnname));
    }
  }
  else {
    delptr(&v_rn, 8);
    return 0;
  }
  delptr(&v_rn, 8);
  return 1;
  delptr(&v_rn, 8);
}
 
 
char rtn_find_function() {
  char *v_fnname=0;
  struct pointer v_rn={-1, -1, -1};
  newptr(&v_rn, 8, 0);
  v_rn=rtn_tbl_search_routinename(0, null);
  while (1) {
    if (v_rn.branch==-1) {
      v_rn=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_routine_name(v_rn.rec), v_keyword)==0 && rtn_tbl_get_routine_returntype(v_rn.rec)!=0) {
      break;
    }
    v_rn=rtn_ptrplus1(v_rn, 8);
  }
  if (v_rn.branch!=-1) {
    v_fnname=snew(v_fnname, scpy(v_keyword));
    rtn_addtag(scon(scon(scon(scon(scpy("a href=\""), rtn_tbl_get_routine_module(v_rn.rec)), ".html#rtn_"), v_fnname), "\""), scpy("/a"));
    rtn_scankeyword();
    if (scmp(v_keyword, "(")==0) {
      rtn_scankeyword();
      rtn_get_routine(scpy(v_fnname));
      if (scmp(v_keyword, ")")==0) {
        rtn_scankeyword();
      }
      else {
        rtn_putwarning(scpy("Expected closing bracket"));
      }
    }
    else {
      rtn_get_routine(scpy(v_fnname));
    }
  }
  else {
    delptr(&v_rn, 8);
    return 0;
  }
  delptr(&v_rn, 8);
  return 1;
  delptr(&v_rn, 8);
}
 
 
void rtn_scan_expression(long int v_level) {
  long int v_tel=0;
  long int v_res=0;
  char *v_ltype=0;
  char *v_ldata=0;
  long int v_lpos=0;
  char v_ready=0;
  char *v_extra=0;
  char *v_coperation=0;
  struct pointer v_clvl={-1, -1, -1};
  char *v_dt=0;
  long int c_dt=0;
  struct pointer v_pst={-1, -1, -1};
  struct pointer v_pstr={-1, -1, -1};
  struct pointer v_vtbl={-1, -1, -1};
  struct pointer v_nulla={-1, -1, -1};
  char *var1=0;
  struct pointer v_cons={-1, -1, -1};
  struct pointer v_l1={-1, -1, -1};
  long int c_l1=0;
  struct pointer v_a={-1, -1, -1};
  struct pointer v_l2={-1, -1, -1};
  long int c_l2=0;
  struct pointer v_l3={-1, -1, -1};
  struct pointer v_ad={-1, -1, -1};
  struct pointer v_ar={-1, -1, -1};
  newptr(&v_clvl, 26, 0);
  v_clvl=rtn_tbl_search_oplevel(null, 0);
  while (1) {
    if (v_clvl.branch==-1) {
      v_clvl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_opdef_level(v_clvl.rec)==v_level) {
      break;
    }
    v_clvl=rtn_ptrplus1(v_clvl, 26);
  }
  if (!(v_clvl.branch!=-1)) {
    if (scmp(v_keyword, "(")==0) {
      rtn_scankeyword();
      rtn_scan_expression(1);
      if (scmp(v_keyword, ")")!=0) {
        rtn_putwarning(scpy("Expected closing ')'"));
      }
      else {
        rtn_addactioncode(scpy("brackets"), scpy("Cannot find definition of brackets"), 0, 0);
        rtn_scankeyword();
      }
    }
    else {
      if (rtn_isnumber(v_keyword)) {
        rtn_addactioncode(scpy("number"), scpy("Cannot find definition of constant number"), scpy(v_keyword), 0);
        v_ctype=snew(v_ctype, scpy("number"));
        v_cdata=snew(v_cdata, 0);
        rtn_scankeyword();
      }
      else {
        if (v_keyword==0) {
          if (scmp(v_ctype, "enumerate")==0) {
            v_tel=0;
            v_res=-1;
            c_dt=1;
            {int spp=0; if (v_dt!=0) free(v_dt); v_dt=0; while (spp>=0) {if (spp<0) break; v_dt=isep(&spp, v_cdata, " ");
              if (scmp(v_dt, v_keywstr)==0) {
                v_res=v_tel;
                break;
              }
              v_tel+=1;
              c_dt+=1;
            }}
            if (v_res==-1) {
              newptr(&v_pst, 30, 0);
              v_pst=rtn_tbl_search_actionget(scpy("string"));
              while (1) {
                if ((v_pst.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_pst.rec), "string")>0))) {
                  v_pst=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_action_ident(v_pst.rec), "string")==0) {
                  break;
                }
                v_pst=rtn_ptrplus1(v_pst, 30);
              }
              if (v_pst.branch!=-1) {
                rtn_addcode(rtn_tbl_get_action_action(v_pst.rec), scpy(v_keywstr), 0);
              }
              v_ctype=snew(v_ctype, scpy("constr"));
              v_cdata=snew(v_cdata, 0);
            }
            else {
              rtn_addactioncode(scpy("number"), scpy("Cannot find definition of constant number"), get_int(v_res), 0);
              v_ctype=snew(v_ctype, scpy("number"));
              v_cdata=snew(v_cdata, 0);
            }
          }
          else {
            newptr(&v_pstr, 30, 0);
            v_pstr=rtn_tbl_search_actionget(scpy("string"));
            while (1) {
              if ((v_pstr.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_pstr.rec), "string")>0))) {
                v_pstr=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_action_ident(v_pstr.rec), "string")==0) {
                break;
              }
              v_pstr=rtn_ptrplus1(v_pstr, 30);
            }
            if (v_pstr.branch!=-1) {
              rtn_addcode(rtn_tbl_get_action_action(v_pstr.rec), scpy(v_keywstr), 0);
            }
            v_ctype=snew(v_ctype, scpy("constr"));
            v_cdata=snew(v_cdata, 0);
          }
          rtn_scankeyword();
        }
        else {
          if (rtn_find_variable()) {
            if (v_cdbfld!=0) {
              v_tel=rtn_findstring(v_cvarname, ".", 1);
              rtn_addactioncode(scpy("variable pointer"), scpy("Internal error on 'variable pointer'"), sadd(scpy("v_"), rtn_left(v_cvarname, v_tel-1)), 0);
              rtn_addactioncode(scpy("pointer -> number"), 0, 0, 0);
              newptr(&v_vtbl, 13, 0);
              v_vtbl=rtn_tbl_search_tablename(scpy(v_cdbtbl));
              while (1) {
                if ((v_vtbl.branch==-1) || ((scmp(rtn_tbl_get_table_name(v_vtbl.rec), v_cdbtbl)>0))) {
                  v_vtbl=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_table_name(v_vtbl.rec), v_cdbtbl)==0) {
                  break;
                }
                v_vtbl=rtn_ptrplus1(v_vtbl, 13);
              }
              if (!(v_vtbl.branch!=-1)) {
                rtn_puterror(scpy("Error on find table"));
                delptr(&v_clvl, 26);
                delptr(&v_pst, 30);
                delptr(&v_pstr, 30);
                delptr(&v_vtbl, 13);
                delptr(&v_nulla, 29);
                delptr(&v_cons, 29);
                delptr(&v_l1, 26);
                delptr(&v_a, 29);
                delptr(&v_l2, 26);
                delptr(&v_l3, 26);
                delptr(&v_ad, 29);
                delptr(&v_ar, 29);
                return;
              }
              rtn_addactioncode(scon(scon(scon(scpy("rtn_tbl_get_"), rtn_tbl_get_table_name(v_vtbl.rec)), "_"), v_cdbfld), 0, 0, 0);
            }
            else {
              if (scmp(v_cdata, "found")==0) {
                v_tel=rtn_findstring(v_cvarname, ".", 1);
                rtn_addactioncode(scpy("variable pointer"), 0, sadd(scpy("v_"), rtn_left(v_cvarname, v_tel-1)), 0);
                rtn_addactioncode(scpy("pointer <> null"), 0, 0, 0);
                v_ctype=snew(v_ctype, scpy("boolean"));
              }
              else {
                if (scmp(v_cdata, "first")==0) {
                  v_tel=rtn_findstring(v_cvarname, ".", 1);
                  rtn_addactioncode(scpy("variable number"), 0, sadd(scpy("c_"), rtn_left(v_cvarname, v_tel-1)), 0);
                  rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
                  rtn_addactioncode(scpy("number = number"), 0, 0, 0);
                  v_ctype=snew(v_ctype, scpy("boolean"));
                }
                else {
                  if (scmp(v_cdata, "recnr")==0) {
                    v_tel=rtn_findstring(v_cvarname, ".", 1);
                    rtn_addactioncode(scpy("variable number"), 0, sadd(scpy("c_"), rtn_left(v_cvarname, v_tel-1)), 0);
                    v_ctype=snew(v_ctype, scpy("number"));
                  }
                  else {
                    rtn_addactioncode(scon(scpy("variable "), v_ctype), scon(scon(scpy("Internal error on 'variable "), v_ctype), "'"), scon(scpy("v_"), v_cvarname), 0);
                  }
                }
              }
            }
            if (scmp(v_ctype, "string")==0) {
              v_ctype=snew(v_ctype, scpy("constr"));
            }
          }
          else {
            if (scmp(v_keyword, "null")==0) {
              rtn_scankeyword();
              if (v_ctype==0) {
                rtn_addactioncode(scpy("null constr"), 0, 0, 0);
              }
              else {
                newptr(&v_nulla, 29, 0);
                v_nulla=rtn_tbl_search_action(null);
                while (1) {
                  if (v_nulla.branch==-1) {
                    v_nulla=rtn_nullpointer();
                    break;
                  }
                  if (scmp(rtn_tbl_get_action_ident(v_nulla.rec), (var1=snew(var1, scon(scpy("null "), v_ctype))))==0) {
                    break;
                  }
                  v_nulla=rtn_ptrplus1(v_nulla, 29);
                }
                if (v_nulla.branch!=-1) {
                  rtn_addcode(rtn_tbl_get_action_action(v_nulla.rec), 0, 0);
                }
                else {
                  rtn_puterror(scon(scon(scpy("Cannot find null definition for type '"), v_ctype), "'"));
                }
              }
            }
            else {
              if (rtn_find_function()) {
              }
              else {
                if (rtn_isalpha(v_keyword)) {
                  newptr(&v_cons, 29, 0);
                  v_cons=rtn_tbl_search_action(null);
                  while (1) {
                    if (v_cons.branch==-1) {
                      v_cons=rtn_nullpointer();
                      break;
                    }
                    if (scmp(rtn_tbl_get_action_ident(v_cons.rec), v_keyword)==0 && rtn_tbl_get_action_result(v_cons.rec)!=0 && rtn_tbl_get_action_parms(v_cons.rec)==0) {
                      break;
                    }
                    v_cons=rtn_ptrplus1(v_cons, 29);
                  }
                  if (v_cons.branch!=-1) {
                    rtn_scankeyword();
                    rtn_addcode(rtn_tbl_get_action_action(v_cons.rec), 0, 0);
                    v_ctype=snew(v_ctype, scpy(rtn_tbl_get_action_result(v_cons.rec)));
                    v_cdata=snew(v_cdata, 0);
                  }
                  else {
                    rtn_puterror(scpy("Incomplete expression"));
                  }
                }
                else {
                  rtn_puterror(scpy("Incomplete expression"));
                }
              }
            }
          }
        }
      }
    }
  }
  else {
    v_ready=0;
    newptr(&v_l1, 26, 0);
    c_l1=1;
    v_l1=rtn_tbl_search_oplevel(null, 0);
    while (1) {
      if (v_l1.branch==-1) {
        break;
      }
      if (rtn_tbl_get_opdef_level(v_l1.rec)==v_level) {
        if (rtn_tbl_get_opdef_left(v_l1.rec)==0 && scmp(rtn_tbl_get_opdef_op(v_l1.rec), v_keyword)==0) {
          rtn_scankeyword();
          rtn_scan_expression(v_level+1);
          newptr(&v_a, 29, 0);
          v_a=rtn_tbl_search_action(null);
          while (1) {
            if (v_a.branch==-1) {
              v_a=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_a.rec), (var1=snew(var1, scon(scon(scpy(rtn_tbl_get_opdef_op(v_l1.rec)), " "), v_ctype))))==0) {
              break;
            }
            v_a=rtn_ptrplus1(v_a, 29);
          }
          if (v_a.branch!=-1) {
            rtn_addcode(rtn_tbl_get_action_action(v_a.rec), 0, scpy(v_cdata));
            v_ctype=snew(v_ctype, scpy(rtn_tbl_get_action_result(v_a.rec)));
          }
          else {
            rtn_puterror(scon(scon(scon(scon(scpy("Operation '"), rtn_tbl_get_opdef_op(v_l1.rec)), "' cannot work with type '"), v_ctype), "'"));
          }
          v_ready=1;
        }
        c_l1+=1;
      }
      if (v_l1.branch==-1) {
        v_l1=rtn_getpointer(0, 0, 26);
      }
      else {
        v_l1=rtn_ptrplus1(v_l1, 26);
      }
    }
    c_l1-=1;
    if (!(v_ready)) {
      rtn_scan_expression(v_level+1);
      while (1) {
        v_ltype=snew(v_ltype, scpy(v_ctype));
        v_ldata=snew(v_ldata, scpy(v_cdata));
        v_ready=0;
        newptr(&v_l2, 26, 0);
        c_l2=1;
        v_l2=rtn_tbl_search_oplevel(null, 0);
        while (1) {
          if (v_l2.branch==-1) {
            break;
          }
          if (rtn_tbl_get_opdef_level(v_l2.rec)==v_level) {
            if (rtn_tbl_get_opdef_left(v_l2.rec)==1 && scmp(rtn_tbl_get_opdef_op(v_l2.rec), v_keyword)==0) {
              v_coperation=snew(v_coperation, scpy(v_keyword));
              rtn_scankeyword();
              newptr(&v_l3, 26, 0);
              v_l3=rtn_tbl_search_oplevel(null, 0);
              while (1) {
                if (v_l3.branch==-1) {
                  v_l3=rtn_nullpointer();
                  break;
                }
                if (rtn_tbl_get_opdef_level(v_l3.rec)==v_level && scmp(rtn_tbl_get_opdef_op(v_l3.rec), (var1=snew(var1, scon(scpy(v_coperation), v_keyword))))==0) {
                  break;
                }
                v_l3=rtn_ptrplus1(v_l3, 26);
              }
              if (v_keyword!=0 && v_l3.branch!=-1) {
                v_coperation=sadd(v_coperation, scpy(v_keyword));
                rtn_scankeyword();
              }
              rtn_storecode();
              rtn_scan_expression(v_level+1);
              v_lpos=rtn_getcode()+1;
              newptr(&v_ad, 29, 0);
              v_ad=rtn_tbl_search_action(null);
              while (1) {
                if (v_ad.branch==-1) {
                  v_ad=rtn_nullpointer();
                  break;
                }
                if (scmp(rtn_tbl_get_action_ident(v_ad.rec), (var1=snew(var1, scon(scon(scon(scon(scpy(v_ltype), " "), v_coperation), " "), v_ctype))))==0) {
                  break;
                }
                v_ad=rtn_ptrplus1(v_ad, 29);
              }
              if (v_ad.branch!=-1) {
                if (rtn_tbl_get_action_replace(v_ad.rec)!=0) {
                  newptr(&v_ar, 29, 0);
                  v_ar=rtn_tbl_search_action(null);
                  while (1) {
                    if (v_ar.branch==-1) {
                      v_ar=rtn_nullpointer();
                      break;
                    }
                    if (scmp(rtn_tbl_get_action_ident(v_ar.rec), rtn_tbl_get_action_replace(v_ad.rec))==0) {
                      break;
                    }
                    v_ar=rtn_ptrplus1(v_ar, 29);
                  }
                  if (scmp(rtn_tbl_get_action_right(v_ar.rec), rtn_tbl_get_action_right(v_ad.rec))!=0) {
                    v_extra=snew(v_extra, get_int(rtn_check_conversion(scpy(rtn_tbl_get_action_right(v_ar.rec)), 0, 0)));
                  }
                  if (scmp(rtn_tbl_get_action_left(v_ar.rec), rtn_tbl_get_action_left(v_ad.rec))!=0) {
                    v_ctype=snew(v_ctype, scpy(v_ltype));
                    v_cdata=snew(v_cdata, scpy(v_ldata));
                    v_extra=snew(v_extra, get_int(rtn_check_conversion(scpy(rtn_tbl_get_action_left(v_ar.rec)), 0, v_lpos)));
                  }
                  rtn_addcode(rtn_tbl_get_action_action(v_ar.rec), 0, scpy(v_cdata));
                }
                else {
                  rtn_addcode(rtn_tbl_get_action_action(v_ad.rec), 0, scpy(v_cdata));
                }
                v_ctype=snew(v_ctype, scpy(rtn_tbl_get_action_result(v_ad.rec)));
              }
              else {
                rtn_puterror(scon(scon(scon(scon(scpy("Operation '"), v_coperation), "' cannot work with type '"), v_ctype), "'"));
              }
              if (scmp(v_ctype, "enumerate")==0) {
                v_cdata=snew(v_cdata, scpy(v_ldata));
              }
              v_ready=1;
            }
            c_l2+=1;
          }
          if (v_l2.branch==-1) {
            v_l2=rtn_getpointer(0, 0, 26);
          }
          else {
            v_l2=rtn_ptrplus1(v_l2, 26);
          }
        }
        c_l2-=1;
        if (scmp(((v_ready)?"true":"false"), ((0)?"true":"false"))==0) {
          break;
        }
      }
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_clvl, 26);
  delptr(&v_pst, 30);
  delptr(&v_pstr, 30);
  delptr(&v_vtbl, 13);
  delptr(&v_nulla, 29);
  delptr(&v_cons, 29);
  delptr(&v_l1, 26);
  delptr(&v_a, 29);
  delptr(&v_l2, 26);
  delptr(&v_l3, 26);
  delptr(&v_ad, 29);
  delptr(&v_ar, 29);
}
 
 
void rtn_expression(char *v_type, char *v_data) {
  long int v_extra=0;
  v_ctype=snew(v_ctype, scpy(v_type));
  v_cdata=snew(v_cdata, scpy(v_data));
  rtn_scan_expression(1);
  if (v_type!=0) {
    v_extra=rtn_check_conversion(scpy(v_type), scpy(v_data), 0);
  }
  if (v_type!=0) {free(v_type); v_type=0;}
  if (v_data!=0) {free(v_data); v_data=0;}
}
 
long int v_stackpointer=0;
 
long int rtn_tbl_get_stack_pos(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) return 0;
  return *(long int*)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+0);
}
 
void rtn_tbl_put_stack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) {
    printf("error in filling field stack.pos\n");
    return;
  }
  *(long int*)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+0)=v_val;
}
 
void rtn_tbl_add_stack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) {
    printf("error in adding to field stack.pos\n");
    return;
  }
  *(long int*)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+0)+=v_val;
}
 
void rtn_tbl_sub_stack_pos(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) {
    printf("Error in subtraction from field stack.pos\n");
    return;
  }
  *(long int*)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+0)-=v_val;
}
 
char *rtn_tbl_get_stack_value(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) return 0;
  return *(char**)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+4);
}
 
void rtn_tbl_put_stack_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) {
    printf("error in filling field stack.value\n");
    return;
  }
  *(char**)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+4)=v_val;
}
 
void rtn_tbl_add_stack_value(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[25].len) {
    printf("error in adding to field stack.value\n");
    return;
  }
  *(char**)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+4)= 
  sadd(*(char**)(u_table[25].ptr[v_rec/250]+(v_rec%250)*u_table[25].size+4), v_val);
}
 
struct pointer rtn_tbl_search_stack(long int v_p_pos) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 40, 1);
  newptr(&v_ptr, 40, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(40)+1);
    v_idx=rtn_getpointer(v_curr, 0, 40);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_pos, rtn_tbl_get_stack_pos(v_idx.rec));
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(40);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 40)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 40);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_pos, rtn_tbl_get_stack_pos(v_idx.rec));
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 40);
  }
  delptr(&v_idx, 40);
  delptr(&v_ptr, 40);
  return v_ptr;
  delptr(&v_idx, 40);
  delptr(&v_ptr, 40);
}
 
 
struct pointer rtn_tbl_add_stack(struct pointer v_new) {
  struct pointer v_idx_stack={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_stack, 40, 1);
  newptr(&v_last, 40, 1);
  rtn_tbl_put_stack_pos(v_new.rec, 999999999);
  v_idx_stack=rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_new.rec));
  if (v_idx_stack.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(40), rtn_maxleaf(rtn_maxbranch(40), 40), 40);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_stack, 40);
  }
  if (v_last.branch==-1) {
    rtn_tbl_put_stack_pos(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_stack_pos(v_new.rec, rtn_tbl_get_stack_pos(v_last.rec)+1);
  }
  rtn_addindex(v_idx_stack, rtn_tablelen(25)-1, 40);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("add stack(25):"), scpy(get_sort(rtn_tbl_get_stack_pos(v_new.rec)))), "|"), rtn_tbl_get_stack_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 40);
    delptr(&v_idx_stack, 40);
    delptr(&v_last, 40);
    return rtn_getpointer(0, 0, 40);
  }
  delptr(&v_new, 40);
  delptr(&v_idx_stack, 40);
  delptr(&v_last, 40);
  return rtn_ptrplus1(v_last, 40);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 40);
  delptr(&v_idx_stack, 40);
  delptr(&v_last, 40);
}
 
 
void rtn_tbl_delete_stack(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 40, 1);
  newptr(&v_chk, 40, 1);
  newptr(&v_del, 40, 1);
  v_del=rtn_getrecptr(v_delrec, 25);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("delete stack(25):"), scpy(get_sort(rtn_tbl_get_stack_pos(v_del.rec)))), "|"), rtn_tbl_get_stack_value(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_del.rec));
  rtn_deleteindex(v_chk, 40);
  v_chk=rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_del.rec)+1);
  rtn_tbl_put_stack_value(v_del.rec, 0);
  if (rtn_getrec(v_del, 25)!=rtn_tablelen(25)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(25)-1, 40);
    rtn_changeindex(rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_last.rec)), v_delrec, 40);
  }
  rtn_deleterecord(v_delrec, 25);
  if (v_chk.branch==-1) {
    delptr(&v_last, 40);
    delptr(&v_chk, 40);
    delptr(&v_del, 40);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 40);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_stack_pos(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 25);
    rtn_tbl_sub_stack_pos(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 40);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 40);
  delptr(&v_chk, 40);
  delptr(&v_del, 40);
}
 
 
struct pointer rtn_tbl_update_stack(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 40, 1);
  newptr(&v_del, 40, 1);
  v_del=rtn_getrecptr(v_rec, 25);
  v_new=rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_del.rec));
  rtn_deleteindex(v_new, 40);
  rtn_deleterecord(v_rec, 25);
  rtn_addindex(rtn_tbl_search_stack(rtn_tbl_get_stack_pos(v_new.rec)), rtn_getrec(v_new, 40), 40);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 25);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("update stack:"), scpy(get_sort(rtn_tbl_get_stack_pos(v_new.rec)))), "|"), rtn_tbl_get_stack_value(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 40);
  delptr(&v_del, 40);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 40);
  delptr(&v_del, 40);
}
 
 
void rtn_tbl_clear_stack() {
  
  long int r=0;
  long int branch;
  while (r < u_table[25].len) {
    if (*(char**)(u_table[25].ptr[r/250]+(r%250)*u_table[25].size+4)!=0) {free(*(char**)(u_table[25].ptr[r/250]+(r%250)*u_table[25].size+4)); *(char**)(u_table[25].ptr[r/250]+(r%250)*u_table[25].size+4)=0;}
    r++;
  }
  free(u_table[25].ptr);
  u_table[25].ptr=0;
  u_table[25].len=0;
  for(branch=0; branch < u_index[40].scale; branch++)
  { free(u_index[40].ptr[branch]);
  }
  free(u_index[40].len);
  free(u_index[40].ptr);
  u_index[40].scale=0;
  u_index[40].len=0;
  u_index[40].ptr=0;
  fprintf(v_log, "clear stack(25)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_stack() {
  
  return u_table[25].len;
}
 
void rtn_tbl_init_stack() {
  
  u_table[25].len=0;
  u_table[25].size=8;
  u_table[25].ptr=0;
  u_index[40].tbl=25;
  u_index[40].scale=0;
  u_index[40].len=0;
  u_index[40].ptr=0;
  u_index[40].ptrs=0;
  u_index[40].padm=0;
}
 
void rtn_tbl_write_stack(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 40, 0);
  rtn_write(rtn_tbl_get_stack_pos(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_stack_value(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 40);
}
 
 
struct pointer rtn_tbl_read_stack(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 40, 0);
  v_new=rtn_addrecord(25);
  rtn_tbl_put_stack_pos(v_new.rec, 0);
  rtn_tbl_put_stack_value(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_stack_pos(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_stack_value(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_stack(v_new);
  v_dbstate=0;
  delptr(&v_new, 40);
  return v_new;
  delptr(&v_new, 40);
}
 
 
long int rtn_tbl_get_endblock_position(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) return null;
  return *(long int*)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+0);
}
 
void rtn_tbl_put_endblock_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) {
    printf("error in filling field endblock.position\n");
    return;
  }
  *(long int*)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+0)=v_val;
}
 
void rtn_tbl_add_endblock_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) {
    printf("error in adding to field endblock.position\n");
    return;
  }
  *(long int*)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+0)+=v_val;
}
 
void rtn_tbl_sub_endblock_position(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) {
    printf("Error in subtraction from field endblock.position\n");
    return;
  }
  *(long int*)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+0)-=v_val;
}
 
char *rtn_tbl_get_endblock_code(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) return 0;
  return *(char**)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+4);
}
 
void rtn_tbl_put_endblock_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) {
    printf("error in filling field endblock.code\n");
    return;
  }
  *(char**)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+4)=v_val;
}
 
void rtn_tbl_add_endblock_code(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[26].len) {
    printf("error in adding to field endblock.code\n");
    return;
  }
  *(char**)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+4)= 
  sadd(*(char**)(u_table[26].ptr[v_rec/250]+(v_rec%250)*u_table[26].size+4), v_val);
}
 
struct pointer rtn_tbl_search_endblock(long int v_p_position, char *v_p_code) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 41, 1);
  newptr(&v_ptr, 41, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(41)+1);
    v_idx=rtn_getpointer(v_curr, 0, 41);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_position, rtn_tbl_get_endblock_position(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_code, rtn_tbl_get_endblock_code(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(41);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 41)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 41);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_position, rtn_tbl_get_endblock_position(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check1(v_p_code, rtn_tbl_get_endblock_code(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 41);
  }
  if (v_p_code!=0) {free(v_p_code); v_p_code=0;}
  delptr(&v_idx, 41);
  delptr(&v_ptr, 41);
  return v_ptr;
  if (v_p_code!=0) {free(v_p_code); v_p_code=0;}
  delptr(&v_idx, 41);
  delptr(&v_ptr, 41);
}
 
 
struct pointer rtn_tbl_add_endblock(struct pointer v_new) {
  struct pointer v_idx_endblock={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_endblock, 41, 1);
  newptr(&v_last, 41, 1);
  v_idx_endblock=rtn_tbl_search_endblock(rtn_tbl_get_endblock_position(v_new.rec), scpy(rtn_tbl_get_endblock_code(v_new.rec)));
  if (v_idx_endblock.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(41), rtn_maxleaf(rtn_maxbranch(41), 41), 41);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_endblock, 41);
  }
  rtn_addindex(v_idx_endblock, rtn_tablelen(26)-1, 41);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("add endblock(26):"), get_int(rtn_tbl_get_endblock_position(v_new.rec))), "|"), rtn_tbl_get_endblock_code(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 41);
    delptr(&v_idx_endblock, 41);
    delptr(&v_last, 41);
    return rtn_getpointer(0, 0, 41);
  }
  delptr(&v_new, 41);
  delptr(&v_idx_endblock, 41);
  delptr(&v_last, 41);
  return rtn_ptrplus1(v_last, 41);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 41);
  delptr(&v_idx_endblock, 41);
  delptr(&v_last, 41);
}
 
 
void rtn_tbl_delete_endblock(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_last, 41, 1);
  newptr(&v_chk, 41, 1);
  newptr(&v_del, 41, 1);
  v_del=rtn_getrecptr(v_delrec, 26);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("delete endblock(26):"), get_int(rtn_tbl_get_endblock_position(v_del.rec))), "|"), rtn_tbl_get_endblock_code(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_endblock(rtn_tbl_get_endblock_position(v_del.rec), scpy(rtn_tbl_get_endblock_code(v_del.rec)));
  rtn_deleteindex(v_chk, 41);
  rtn_tbl_put_endblock_code(v_del.rec, 0);
  if (rtn_getrec(v_del, 26)!=rtn_tablelen(26)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(26)-1, 41);
    rtn_changeindex(rtn_tbl_search_endblock(rtn_tbl_get_endblock_position(v_last.rec), scpy(rtn_tbl_get_endblock_code(v_last.rec))), v_delrec, 41);
  }
  rtn_deleterecord(v_delrec, 26);
  if (v_chk.branch==-1) {
    delptr(&v_last, 41);
    delptr(&v_chk, 41);
    delptr(&v_del, 41);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 41);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 41);
  delptr(&v_chk, 41);
  delptr(&v_del, 41);
}
 
 
struct pointer rtn_tbl_update_endblock(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 41, 1);
  newptr(&v_del, 41, 1);
  v_del=rtn_getrecptr(v_rec, 26);
  v_new=rtn_tbl_search_endblock(rtn_tbl_get_endblock_position(v_del.rec), scpy(rtn_tbl_get_endblock_code(v_del.rec)));
  rtn_deleteindex(v_new, 41);
  rtn_deleterecord(v_rec, 26);
  rtn_addindex(rtn_tbl_search_endblock(rtn_tbl_get_endblock_position(v_new.rec), scpy(rtn_tbl_get_endblock_code(v_new.rec))), rtn_getrec(v_new, 41), 41);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 26);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("update endblock:"), get_int(rtn_tbl_get_endblock_position(v_new.rec))), "|"), rtn_tbl_get_endblock_code(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 41);
  delptr(&v_del, 41);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 41);
  delptr(&v_del, 41);
}
 
 
void rtn_tbl_clear_endblock() {
  
  long int r=0;
  long int branch;
  while (r < u_table[26].len) {
    if (*(char**)(u_table[26].ptr[r/250]+(r%250)*u_table[26].size+4)!=0) {free(*(char**)(u_table[26].ptr[r/250]+(r%250)*u_table[26].size+4)); *(char**)(u_table[26].ptr[r/250]+(r%250)*u_table[26].size+4)=0;}
    r++;
  }
  free(u_table[26].ptr);
  u_table[26].ptr=0;
  u_table[26].len=0;
  for(branch=0; branch < u_index[41].scale; branch++)
  { free(u_index[41].ptr[branch]);
  }
  free(u_index[41].len);
  free(u_index[41].ptr);
  u_index[41].scale=0;
  u_index[41].len=0;
  u_index[41].ptr=0;
  fprintf(v_log, "clear endblock(26)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_endblock() {
  
  return u_table[26].len;
}
 
void rtn_tbl_init_endblock() {
  
  u_table[26].len=0;
  u_table[26].size=8;
  u_table[26].ptr=0;
  u_index[41].tbl=26;
  u_index[41].scale=0;
  u_index[41].len=0;
  u_index[41].ptr=0;
  u_index[41].ptrs=0;
  u_index[41].padm=0;
}
 
void rtn_tbl_write_endblock(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 41, 0);
  rtn_write(rtn_tbl_get_endblock_position(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_endblock_code(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 41);
}
 
 
struct pointer rtn_tbl_read_endblock(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 41, 0);
  v_new=rtn_addrecord(26);
  rtn_tbl_put_endblock_position(v_new.rec, null);
  rtn_tbl_put_endblock_code(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_endblock_position(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_endblock_code(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_endblock(v_new);
  v_dbstate=0;
  delptr(&v_new, 41);
  return v_new;
  delptr(&v_new, 41);
}
 
 
void rtn_stackpush(char *v_value) {
  struct pointer v_stack={-1, -1, -1};
  newptr(&v_stack, 40, 0);
  v_stack=rtn_addrecord(25);
  rtn_tbl_put_stack_pos(v_stack.rec, 0);
  rtn_tbl_put_stack_value(v_stack.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_stack_value(v_stack.rec, scpy(v_value));
  v_stack=rtn_tbl_add_stack(v_stack);
  v_dbstate=0;
  v_stackpointer=rtn_tbl_get_stack_pos(v_stack.rec);
  if (v_value!=0) {free(v_value); v_value=0;}
  delptr(&v_stack, 40);
}
 
 
char *rtn_stackpop() {
  char *v_value=0;
  struct pointer v_stack={-1, -1, -1};
  char *var1=0;
  newptr(&v_stack, 40, 0);
  v_stack=rtn_tbl_search_stack(v_stackpointer);
  while (1) {
    if ((v_stack.branch==-1) || ((rtn_tbl_get_stack_pos(v_stack.rec)>v_stackpointer))) {
      v_stack=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_stack_pos(v_stack.rec)==v_stackpointer) {
      break;
    }
    v_stack=rtn_ptrplus1(v_stack, 40);
  }
  if (!(v_stack.branch!=-1)) {
    rtn_puterror(scpy("Stack error"));
    var1=snew(var1, 0);
    delptr(&v_stack, 40);
    return var1;
  }
  v_value=snew(v_value, scpy(rtn_tbl_get_stack_value(v_stack.rec)));
  rtn_tbl_delete_stack(rtn_getrec(v_stack, 40));
  v_stackpointer-=1;
  var1=snew(var1, scpy(v_value));
  delptr(&v_stack, 40);
  return var1;
  delptr(&v_stack, 40);
}
 
 
char *rtn_normal_string(char *v_str) {
  char *v_nquote=0;
  char *v_nslash=0;
  char *v_nm=0;
  long int c_nm=0;
  char *v_nq=0;
  long int c_nq=0;
  char *var1=0;
  c_nm=1;
  {int spp=0; if (v_nm!=0) free(v_nm); v_nm=0; while (spp>=0) {if (spp<0) break; v_nm=isep(&spp, v_str, "\\");
    if (c_nm==1) {
      v_nslash=snew(v_nslash, scpy(v_nm));
    }
    else {
      v_nslash=sadd(v_nslash, scon(scpy("\\\\"), v_nm));
    }
    c_nm+=1;
  }}
  c_nq=1;
  {int spp=0; if (v_nq!=0) free(v_nq); v_nq=0; while (spp>=0) {if (spp<0) break; v_nq=isep(&spp, v_nslash, "\"");
    if (c_nq==1) {
      v_nquote=snew(v_nquote, scpy(v_nq));
    }
    else {
      v_nquote=sadd(v_nquote, scon(scon(scpy("\\"), "\""), v_nq));
    }
    c_nq+=1;
  }}
  var1=snew(var1, scpy(v_nquote));
  if (v_str!=0) {free(v_str); v_str=0;}
  return var1;
  if (v_str!=0) {free(v_str); v_str=0;}
}
 
 
void rtn_compile() {
  long int v_level=0;
  long int v_plus=0;
  char *v_r=0;
  long int v_parm=0;
  char *v_pleft=0;
  char *v_pright=0;
  long int v_pos=0;
  char v_lastnull=0;
  struct pointer v_cd={-1, -1, -1};
  long int c_cd=0;
  struct pointer v_a={-1, -1, -1};
  struct pointer v_eb={-1, -1, -1};
  struct pointer v_fr={-1, -1, -1};
  long int c_fr=0;
  struct pointer v_fa={-1, -1, -1};
  char *var1=0;
  struct pointer v_na={-1, -1, -1};
  struct pointer v_seb={-1, -1, -1};
  long int c_seb=0;
  v_level=1;
  v_lastnull=0;
  newptr(&v_cd, 33, 0);
  c_cd=1;
  v_cd=rtn_tbl_search_code(v_croutine, -1, null);
  while (1) {
    if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_croutine))) {
      break;
    }
    if (rtn_tbl_get_code_routine(v_cd.rec)==v_croutine) {
      v_plus=0;
      newptr(&v_a, 29, 0);
      v_a=rtn_tbl_search_action(rtn_tbl_get_code_action(v_cd.rec));
      while (1) {
        if ((v_a.branch==-1) || ((rtn_tbl_get_action_action(v_a.rec)>rtn_tbl_get_code_action(v_cd.rec)))) {
          v_a=rtn_nullpointer();
          break;
        }
        if (rtn_tbl_get_action_action(v_a.rec)==rtn_tbl_get_code_action(v_cd.rec)) {
          break;
        }
        v_a=rtn_ptrplus1(v_a, 29);
      }
      if (!(v_a.branch!=-1)) {
        rtn_puterror(scon(sadd(scon(sadd(scpy("Cannot find correct action '"), get_int(rtn_tbl_get_code_action(v_cd.rec))), "' in code '"), scpy(get_sort(rtn_tbl_get_code_order(v_cd.rec)))), "'"));
        delptr(&v_cd, 33);
        delptr(&v_a, 29);
        delptr(&v_eb, 41);
        delptr(&v_fr, 33);
        delptr(&v_fa, 29);
        delptr(&v_na, 30);
        delptr(&v_seb, 41);
        return;
      }
      if (rtn_tbl_get_code_block(v_cd.rec)>0) {
        v_plus+=1;
        newptr(&v_eb, 41, 0);
        v_eb=rtn_addrecord(26);
        rtn_tbl_put_endblock_position(v_eb.rec, null);
        rtn_tbl_put_endblock_code(v_eb.rec, 0);
        v_dbstate=1;
        rtn_tbl_put_endblock_position(v_eb.rec, rtn_tbl_get_code_block(v_cd.rec));
        rtn_tbl_put_endblock_code(v_eb.rec, scpy(rtn_tbl_get_action_codeback(v_a.rec)));
        v_eb=rtn_tbl_add_endblock(v_eb);
        v_dbstate=0;
      }
      if ((scmp(rtn_tbl_get_action_op(v_a.rec), "return")==0) || (scmp(rtn_tbl_get_action_op(v_a.rec), "fnreturn")==0)) {
        newptr(&v_fr, 33, 0);
        c_fr=1;
        v_fr=rtn_tbl_search_code(v_croutine, -1, null);
        while (1) {
          if ((v_fr.branch==-1) || ((rtn_tbl_get_code_routine(v_fr.rec)>v_croutine))) {
            break;
          }
          if (rtn_tbl_get_code_routine(v_fr.rec)==v_croutine && rtn_tbl_get_code_kind(v_fr.rec)==2) {
            newptr(&v_fa, 29, 0);
            v_fa=rtn_tbl_search_action(rtn_tbl_get_code_action(v_fr.rec));
            while (1) {
              if ((v_fa.branch==-1) || ((rtn_tbl_get_action_action(v_fa.rec)>rtn_tbl_get_code_action(v_fr.rec)))) {
                v_fa=rtn_nullpointer();
                break;
              }
              if (rtn_tbl_get_action_action(v_fa.rec)==rtn_tbl_get_code_action(v_fr.rec)) {
                break;
              }
              v_fa=rtn_ptrplus1(v_fa, 29);
            }
            if (v_fa.branch!=-1) {
              swrite((var1=snew(var1, sadd(scpy(rtn_pattern(scpy("  "), v_level)), rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_fa.rec)), scpy(rtn_tbl_get_code_par(v_fr.rec)), 0, 0, scpy(rtn_tbl_get_code_data(v_fr.rec)))))), v_c); wline(v_c);
            }
            c_fr+=1;
          }
          if (v_fr.branch==-1) {
            v_fr=rtn_getpointer(0, 0, 33);
          }
          else {
            v_fr=rtn_ptrplus1(v_fr, 33);
          }
        }
        c_fr-=1;
      }
      if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_action_op(v_a.rec), 4))), "rtn_")==0) {
        v_parm=1;
        v_r=snew(v_r, 0);
        while (1) {
          if (v_parm>rtn_tbl_get_action_parms(v_a.rec)) {
            break;
          }
          v_r=snew(v_r, scon(rtn_stackpop(), v_r));
          v_parm+=1;
          if (v_parm<=rtn_tbl_get_action_parms(v_a.rec)) {
            v_r=snew(v_r, scon(scpy(", "), v_r));
          }
        }
        v_r=snew(v_r, scon(scon(scpy(rtn_tbl_get_action_codefront(v_a.rec)), "("), v_r));
        v_r=sadd(v_r, scon(scpy(")"), rtn_tbl_get_action_codeback(v_a.rec)));
      }
      else {
        if (rtn_tbl_get_action_parms(v_a.rec)==2) {
          v_pright=snew(v_pright, rtn_stackpop());
          v_pleft=snew(v_pleft, rtn_stackpop());
          v_pos=rtn_findstring(rtn_tbl_get_action_ident(v_a.rec), " = ", 1);
          if (v_pos==-1) {
            v_pos=rtn_findstring(rtn_tbl_get_action_ident(v_a.rec), " <> ", 1)+1;
          }
          if (v_pos>2 && v_lastnull) {
            newptr(&v_na, 30, 0);
            v_na=rtn_tbl_search_actionget(scon(rtn_left(rtn_tbl_get_action_ident(v_a.rec), v_pos+2), "null"));
            while (1) {
              if ((v_na.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_na.rec), (var1=snew(var1, scon(rtn_left(rtn_tbl_get_action_ident(v_a.rec), v_pos+2), "null"))))>0))) {
                v_na=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_action_ident(v_na.rec), (var1=snew(var1, scon(rtn_left(rtn_tbl_get_action_ident(v_a.rec), v_pos+2), "null"))))==0) {
                break;
              }
              v_na=rtn_ptrplus1(v_na, 30);
            }
            if (v_na.branch!=-1) {
              v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_na.rec)), scpy(rtn_tbl_get_code_par(v_cd.rec)), scpy(v_pleft), 0, scpy(rtn_tbl_get_code_data(v_cd.rec))));
            }
            else {
              v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_a.rec)), scpy(rtn_tbl_get_code_par(v_cd.rec)), scpy(v_pleft), scpy(v_pright), scpy(rtn_tbl_get_code_data(v_cd.rec))));
            }
          }
          else {
            v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_a.rec)), scpy(rtn_tbl_get_code_par(v_cd.rec)), scpy(v_pleft), scpy(v_pright), scpy(rtn_tbl_get_code_data(v_cd.rec))));
          }
        }
        else {
          if (rtn_tbl_get_action_parms(v_a.rec)==1) {
            v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_a.rec)), scpy(rtn_tbl_get_code_par(v_cd.rec)), rtn_stackpop(), 0, scpy(rtn_tbl_get_code_data(v_cd.rec))));
          }
          else {
            if (scmp(rtn_tbl_get_action_op(v_a.rec), "string")==0) {
              v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_a.rec)), rtn_normal_string(scpy(rtn_tbl_get_code_par(v_cd.rec))), 0, 0, scpy(rtn_tbl_get_code_data(v_cd.rec))));
            }
            else {
              v_r=snew(v_r, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_a.rec)), scpy(rtn_tbl_get_code_par(v_cd.rec)), 0, 0, scpy(rtn_tbl_get_code_data(v_cd.rec))));
            }
          }
        }
      }
      if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_action_ident(v_a.rec), 5))), "null ")==0) {
        v_lastnull=1;
      }
      else {
        v_lastnull=0;
      }
      if (rtn_tbl_get_action_result(v_a.rec)==0) {
        if (v_r!=0) {
          swrite((var1=snew(var1, scon(scpy(rtn_pattern(scpy("  "), v_level)), v_r))), v_c); wline(v_c);
        }
      }
      else {
        rtn_stackpush(scpy(v_r));
      }
      v_level+=v_plus;
      newptr(&v_seb, 41, 0);
      c_seb=1;
      v_seb=rtn_tbl_search_endblock(null, 0);
      while (1) {
        if (v_seb.branch==-1) {
          break;
        }
        if (rtn_tbl_get_endblock_position(v_seb.rec)==rtn_tbl_get_code_order(v_cd.rec)) {
          v_level-=1;
          if (rtn_tbl_get_endblock_code(v_seb.rec)!=0) {
            swrite((var1=snew(var1, scon(scpy(rtn_pattern(scpy("  "), v_level)), rtn_tbl_get_endblock_code(v_seb.rec)))), v_c); wline(v_c);
          }
          rtn_tbl_delete_endblock(rtn_getrec(v_seb, 41));
          c_seb+=1;
        }
        if (v_seb.branch==-1) {
          v_seb=rtn_getpointer(0, 0, 41);
        }
        else {
          v_seb=rtn_ptrplus1(v_seb, 41);
        }
      }
      c_seb-=1;
      c_cd+=1;
    }
    if (v_cd.branch==-1) {
      v_cd=rtn_getpointer(0, 0, 33);
    }
    else {
      v_cd=rtn_ptrplus1(v_cd, 33);
    }
  }
  c_cd-=1;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_cd, 33);
  delptr(&v_a, 29);
  delptr(&v_eb, 41);
  delptr(&v_fr, 33);
  delptr(&v_fa, 29);
  delptr(&v_na, 30);
  delptr(&v_seb, 41);
}
 
 
char *rtn_original_expr(long int v_routine, long int v_from, long int v_till) {
  char *v_cds=0;
  long int v_cnt=0;
  long int v_tbl=0;
  long int v_pos=0;
  long int v_d=0;
  struct pointer v_cd={-1, -1, -1};
  char *var1=0;
  struct pointer v_ac={-1, -1, -1};
  struct pointer v_fld={-1, -1, -1};
  rtn_tbl_clear_stack();
  v_cnt=v_from;
  while (1) {
    newptr(&v_cd, 33, 0);
    v_cd=rtn_tbl_search_code(v_routine, -1, null);
    while (1) {
      if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_routine))) {
        v_cd=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_code_routine(v_cd.rec)==v_routine && rtn_tbl_get_code_kind(v_cd.rec)==1 && rtn_tbl_get_code_order(v_cd.rec)==v_cnt) {
        break;
      }
      v_cd=rtn_ptrplus1(v_cd, 33);
    }
    if (!(v_cd.branch!=-1)) {
      var1=snew(var1, 0);
      delptr(&v_cd, 33);
      delptr(&v_ac, 29);
      delptr(&v_fld, 14);
      return var1;
    }
    newptr(&v_ac, 29, 0);
    v_ac=rtn_tbl_search_action(rtn_tbl_get_code_action(v_cd.rec));
    while (1) {
      if ((v_ac.branch==-1) || ((rtn_tbl_get_action_action(v_ac.rec)>rtn_tbl_get_code_action(v_cd.rec)))) {
        v_ac=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_action_action(v_ac.rec)==rtn_tbl_get_code_action(v_cd.rec)) {
        break;
      }
      v_ac=rtn_ptrplus1(v_ac, 29);
    }
    if (!(v_ac.branch!=-1)) {
      var1=snew(var1, 0);
      delptr(&v_cd, 33);
      delptr(&v_ac, 29);
      delptr(&v_fld, 14);
      return var1;
    }
    if (scmp(rtn_tbl_get_action_op(v_ac.rec), "number")==0) {
      rtn_stackpush(scpy(rtn_tbl_get_code_par(v_cd.rec)));
    }
    else {
      if (scmp(rtn_tbl_get_action_op(v_ac.rec), "string")==0) {
        rtn_stackpush(scon(scon(scpy("\""), rtn_tbl_get_code_par(v_cd.rec)), "\""));
      }
      else {
        if (scmp(rtn_tbl_get_action_op(v_ac.rec), "variable")==0) {
          if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_code_par(v_cd.rec), 2))), "c_")==0) {
            rtn_stackpush(rtn_mid((var1=snew(var1, scon(scpy(rtn_tbl_get_code_par(v_cd.rec)), ".recnr"))), 3, 999));
          }
          else {
            rtn_stackpush(rtn_mid(rtn_tbl_get_code_par(v_cd.rec), 3, 999));
          }
        }
        else {
          if (scmp(rtn_tbl_get_action_op(v_ac.rec), "->")==0) {
          }
          else {
            if (scmp(rtn_tbl_get_action_op(v_ac.rec), "field")==0) {
              v_tbl=iscan(rtn_tbl_get_code_par(v_cd.rec));
              v_pos=iscan(rtn_tbl_get_code_data(v_cd.rec));
              newptr(&v_fld, 14, 0);
              v_fld=rtn_tbl_search_field(v_tbl, null);
              while (1) {
                if ((v_fld.branch==-1) || ((rtn_tbl_get_field_table(v_fld.rec)>v_tbl))) {
                  v_fld=rtn_nullpointer();
                  break;
                }
                if (rtn_tbl_get_field_table(v_fld.rec)==v_tbl && rtn_tbl_get_field_position(v_fld.rec)==v_pos) {
                  break;
                }
                v_fld=rtn_ptrplus1(v_fld, 14);
              }
              v_cds=snew(v_cds, scon(scon(rtn_stackpop(), "."), rtn_tbl_get_field_name(v_fld.rec)));
              rtn_stackpush(scpy(v_cds));
            }
            else {
              if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_action_op(v_ac.rec), 4))), "rtn_")==0) {
                v_d=0;
                v_cds=snew(v_cds, 0);
                while (1) {
                  if (v_d==rtn_tbl_get_action_parms(v_ac.rec)) {
                    break;
                  }
                  if (v_d>0) {
                    v_cds=snew(v_cds, scon(scpy(", "), v_cds));
                  }
                  v_cds=snew(v_cds, scon(rtn_stackpop(), v_cds));
                  v_d+=1;
                }
                rtn_stackpush(scon(scon(scon(rtn_mid(rtn_tbl_get_action_op(v_ac.rec), 5, 999), "("), v_cds), ")"));
              }
              else {
                if (scmp(rtn_tbl_get_action_op(v_ac.rec), "null")==0) {
                  rtn_stackpush(scpy("null"));
                }
                else {
                  v_cds=snew(v_cds, 0);
                  if (rtn_tbl_get_action_right(v_ac.rec)!=0) {
                    v_cds=snew(v_cds, sadd(scpy(" "), rtn_stackpop()));
                  }
                  v_cds=snew(v_cds, scon(scpy(rtn_tbl_get_action_op(v_ac.rec)), v_cds));
                  if (rtn_tbl_get_action_left(v_ac.rec)!=0) {
                    v_cds=snew(v_cds, scon(scon(rtn_stackpop(), " "), v_cds));
                  }
                  rtn_stackpush(scpy(v_cds));
                }
              }
            }
          }
        }
      }
    }
    v_cnt+=1;
    if (v_cnt>v_till) {
      break;
    }
  }
  v_cds=snew(v_cds, rtn_stackpop());
  rtn_tbl_clear_stack();
  var1=snew(var1, scpy(v_cds));
  delptr(&v_cd, 33);
  delptr(&v_ac, 29);
  delptr(&v_fld, 14);
  return var1;
  delptr(&v_cd, 33);
  delptr(&v_ac, 29);
  delptr(&v_fld, 14);
}
 
FILE *v_tf=0;
 
void rtn_doc_table(long int v_table) {
  char *v_str=0;
  struct pointer v_ctb={-1, -1, -1};
  char *var1=0;
  struct pointer v_cfld={-1, -1, -1};
  long int c_cfld=0;
  struct pointer v_cidx={-1, -1, -1};
  long int c_cidx=0;
  struct pointer v_cif={-1, -1, -1};
  long int c_cif=0;
  struct pointer v_ifd={-1, -1, -1};
  newptr(&v_ctb, 12, 0);
  v_ctb=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_ctb.branch==-1) || ((rtn_tbl_get_table_table(v_ctb.rec)>v_table))) {
      v_ctb=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_ctb.rec)==v_table) {
      break;
    }
    v_ctb=rtn_ptrplus1(v_ctb, 12);
  }
  if ((!(v_ctb.branch!=-1)) || (rtn_tbl_get_table_kind(v_ctb.rec)==1)) {
    delptr(&v_ctb, 12);
    delptr(&v_cfld, 14);
    delptr(&v_cidx, 17);
    delptr(&v_cif, 19);
    delptr(&v_ifd, 14);
    return;
  }
  rtn_doc_def(scpy("Table"), sadd(sadd(scon(sadd(rtn_tag("b"), rtn_tag((var1=snew(var1, scon(scon(scpy("A name=\"tbl_"), rtn_tbl_get_table_name(v_ctb.rec)), "\""))))), rtn_tbl_get_table_name(v_ctb.rec)), rtn_tag("/A")), rtn_tag("/b")), scpy(rtn_tbl_get_table_use(v_ctb.rec)));
  newptr(&v_cfld, 14, 0);
  c_cfld=1;
  v_cfld=rtn_tbl_search_field(rtn_tbl_get_table_table(v_ctb.rec), null);
  while (1) {
    if ((v_cfld.branch==-1) || ((rtn_tbl_get_field_table(v_cfld.rec)>rtn_tbl_get_table_table(v_ctb.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_cfld.rec)==rtn_tbl_get_table_table(v_ctb.rec)) {
      v_str=snew(v_str, 0);
      if (scmp(rtn_tbl_get_field_type(v_cfld.rec), "enumerate")==0) {
        v_str=snew(v_str, scon(scon(scpy("["), rtn_tbl_get_field_data(v_cfld.rec)), "] "));
      }
      if (rtn_tbl_get_field_dflt(v_cfld.rec)!=0) {
        v_str=sadd(v_str, scon(scon(scpy("default: '"), rtn_tbl_get_field_dflt(v_cfld.rec)), "' "));
      }
      rtn_doc_def(scon(rtn_notag("   "), rtn_tbl_get_field_name(v_cfld.rec)), scpy(rtn_tbl_get_field_type(v_cfld.rec)), scon(scpy(v_str), rtn_tbl_get_field_use(v_cfld.rec)));
      c_cfld+=1;
    }
    if (v_cfld.branch==-1) {
      v_cfld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_cfld=rtn_ptrplus1(v_cfld, 14);
    }
  }
  c_cfld-=1;
  newptr(&v_cidx, 17, 0);
  c_cidx=1;
  v_cidx=rtn_tbl_search_indextable(null, null);
  while (1) {
    if (v_cidx.branch==-1) {
      break;
    }
    if (rtn_tbl_get_index_table(v_cidx.rec)==rtn_tbl_get_table_table(v_ctb.rec)) {
      v_str=snew(v_str, 0);
      newptr(&v_cif, 19, 0);
      c_cif=1;
      v_cif=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_cidx.rec), null);
      while (1) {
        if ((v_cif.branch==-1) || ((rtn_tbl_get_ifield_index(v_cif.rec)>rtn_tbl_get_index_index(v_cidx.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_cif.rec)==rtn_tbl_get_index_index(v_cidx.rec)) {
          newptr(&v_ifd, 14, 0);
          v_ifd=rtn_tbl_search_field(rtn_tbl_get_table_table(v_ctb.rec), rtn_tbl_get_ifield_field(v_cif.rec));
          while (1) {
            if ((v_ifd.branch==-1) || ((rtn_tbl_get_field_table(v_ifd.rec)>rtn_tbl_get_table_table(v_ctb.rec) && rtn_tbl_get_field_field(v_ifd.rec)>rtn_tbl_get_ifield_field(v_cif.rec)))) {
              v_ifd=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_ifd.rec)==rtn_tbl_get_table_table(v_ctb.rec) && rtn_tbl_get_field_field(v_ifd.rec)==rtn_tbl_get_ifield_field(v_cif.rec)) {
              break;
            }
            v_ifd=rtn_ptrplus1(v_ifd, 14);
          }
          if (v_ifd.branch!=-1) {
            v_str=sadd(v_str, scon(scpy(rtn_tbl_get_field_name(v_ifd.rec)), " "));
          }
          c_cif+=1;
        }
        if (v_cif.branch==-1) {
          v_cif=rtn_getpointer(0, 0, 19);
        }
        else {
          v_cif=rtn_ptrplus1(v_cif, 19);
        }
      }
      c_cif-=1;
      rtn_doc_def(sadd(sadd(rtn_tag("i"), rtn_notag("   index")), rtn_tag("/i")), sadd(scon(rtn_tag("b"), rtn_tbl_get_index_name(v_cidx.rec)), rtn_tag("/b")), scon(scpy(v_str), rtn_tbl_get_index_use(v_cidx.rec)));
      c_cidx+=1;
    }
    if (v_cidx.branch==-1) {
      v_cidx=rtn_getpointer(0, 0, 17);
    }
    else {
      v_cidx=rtn_ptrplus1(v_cidx, 17);
    }
  }
  c_cidx-=1;
  rtn_doc_def(0, 0, 0);
  v_str=snew(v_str, scpy(v_str));
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_ctb, 12);
  delptr(&v_cfld, 14);
  delptr(&v_cidx, 17);
  delptr(&v_cif, 19);
  delptr(&v_ifd, 14);
}
 
 
void rtn_calc_table(long int v_tbl) {
  struct pointer v_tb={-1, -1, -1};
  struct pointer v_fld={-1, -1, -1};
  long int c_fld=0;
  struct pointer v_tp={-1, -1, -1};
  newptr(&v_tb, 12, 0);
  v_tb=rtn_tbl_search_table(v_tbl);
  while (1) {
    if ((v_tb.branch==-1) || ((rtn_tbl_get_table_table(v_tb.rec)>v_tbl))) {
      v_tb=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tb.rec)==v_tbl) {
      break;
    }
    v_tb=rtn_ptrplus1(v_tb, 12);
  }
  if (!(v_tb.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tb, 12);
    delptr(&v_fld, 14);
    delptr(&v_tp, 28);
    return;
  }
  v_tb=rtn_cpyrecord(v_tb, 8);
  v_dbstate=2;
  rtn_tbl_put_table_size(v_tb.rec, 0);
  v_dbstate=3;
  v_tb=rtn_tbl_update_table(rtn_getrec(rtn_recalcptr(v_tb, 12), 8));
  v_dbstate=0;
  newptr(&v_fld, 14, 0);
  c_fld=1;
  v_fld=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tb.rec), null);
  while (1) {
    if ((v_fld.branch==-1) || ((rtn_tbl_get_field_table(v_fld.rec)>rtn_tbl_get_table_table(v_tb.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fld.rec)==rtn_tbl_get_table_table(v_tb.rec)) {
      newptr(&v_tp, 28, 0);
      v_tp=rtn_tbl_search_typename(0);
      while (1) {
        if (v_tp.branch==-1) {
          v_tp=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_type_name(v_tp.rec), rtn_tbl_get_field_type(v_fld.rec))==0) {
          break;
        }
        v_tp=rtn_ptrplus1(v_tp, 28);
      }
      if (v_tp.branch!=-1) {
        v_fld=rtn_cpyrecord(v_fld, 9);
        v_dbstate=2;
        rtn_tbl_put_field_position(v_fld.rec, rtn_tbl_get_table_size(v_tb.rec));
        v_dbstate=3;
        v_fld=rtn_tbl_update_field(rtn_getrec(rtn_recalcptr(v_fld, 14), 9));
        v_dbstate=0;
        v_tb=rtn_cpyrecord(v_tb, 8);
        v_dbstate=2;
        rtn_tbl_add_table_size(v_tb.rec, rtn_tbl_get_type_length(v_tp.rec));
        v_dbstate=3;
        v_tb=rtn_tbl_update_table(rtn_getrec(rtn_recalcptr(v_tb, 12), 8));
        v_dbstate=0;
      }
      else {
        rtn_puterror(scon(scon(scon(scpy("Error gaining length of type "), rtn_tbl_get_field_type(v_fld.rec)), " for field "), rtn_tbl_get_field_name(v_fld.rec)));
      }
      c_fld+=1;
    }
    if (v_fld.branch==-1) {
      v_fld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fld=rtn_ptrplus1(v_fld, 14);
    }
  }
  c_fld-=1;
  delptr(&v_tb, 12);
  delptr(&v_fld, 14);
  delptr(&v_tp, 28);
}
 
 
void rtn_write_search(long int v_table) {
  char *v_heading=0;
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  long int c_idx=0;
  struct pointer v_ifh={-1, -1, -1};
  long int c_ifh=0;
  struct pointer v_fh={-1, -1, -1};
  char *var1=0;
  struct pointer v_if1={-1, -1, -1};
  long int c_if1=0;
  struct pointer v_f1={-1, -1, -1};
  struct pointer v_if2={-1, -1, -1};
  long int c_if2=0;
  struct pointer v_f2={-1, -1, -1};
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 17);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_if1, 19);
    delptr(&v_f1, 14);
    delptr(&v_if2, 19);
    delptr(&v_f2, 14);
    return;
  }
  newptr(&v_idx, 17, 0);
  c_idx=1;
  v_idx=rtn_tbl_search_indextable(null, null);
  while (1) {
    if (v_idx.branch==-1) {
      break;
    }
    if (rtn_tbl_get_index_table(v_idx.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      v_heading=snew(v_heading, scon(scon(scon(scpy("routine name=\"tbl_search_"), rtn_tbl_get_index_name(v_idx.rec)), "\""), rtn_char(10)));
      v_heading=sadd(v_heading, scon(scon(scon(scpy("   type=\"^"), rtn_tbl_get_index_name(v_idx.rec)), "\" "), rtn_char(10)));
      newptr(&v_ifh, 19, 0);
      c_ifh=1;
      v_ifh=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_idx.rec), null);
      while (1) {
        if ((v_ifh.branch==-1) || ((rtn_tbl_get_ifield_index(v_ifh.rec)>rtn_tbl_get_index_index(v_idx.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_ifh.rec)==rtn_tbl_get_index_index(v_idx.rec)) {
          if (!(c_ifh==1)) {
            v_heading=sadd(v_heading, scpy(rtn_char(10)));
          }
          newptr(&v_fh, 14, 0);
          v_fh=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_ifh.rec));
          while (1) {
            if ((v_fh.branch==-1) || ((rtn_tbl_get_field_table(v_fh.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)>rtn_tbl_get_ifield_field(v_ifh.rec)))) {
              v_fh=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)==rtn_tbl_get_ifield_field(v_ifh.rec)) {
              break;
            }
            v_fh=rtn_ptrplus1(v_fh, 14);
          }
          if (!(v_fh.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 17);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_if1, 19);
            delptr(&v_f1, 14);
            delptr(&v_if2, 19);
            delptr(&v_f2, 14);
            return;
          }
          if (scmp(rtn_tbl_get_field_type(v_fh.rec), "enumerate")==0) {
            v_heading=sadd(v_heading, scon(scon(scon(scon(scpy("   parameter=\"p_"), rtn_tbl_get_field_name(v_fh.rec)), "\" type=\"["), rtn_tbl_get_field_data(v_fh.rec)), "]\""));
          }
          else {
            if (scmp(rtn_tbl_get_field_type(v_fh.rec), "sort")==0) {
              v_heading=sadd(v_heading, scon(scon(scpy("   parameter=\"p_"), rtn_tbl_get_field_name(v_fh.rec)), "\" type=\"number\""));
            }
            else {
              v_heading=sadd(v_heading, scon(scon(scon(scon(scpy("   parameter=\"p_"), rtn_tbl_get_field_name(v_fh.rec)), "\" type=\""), rtn_tbl_get_field_type(v_fh.rec)), "\""));
            }
          }
          c_ifh+=1;
        }
        if (v_ifh.branch==-1) {
          v_ifh=rtn_getpointer(0, 0, 19);
        }
        else {
          v_ifh=rtn_ptrplus1(v_ifh, 19);
        }
      }
      c_ifh-=1;
      v_heading=sadd(v_heading, scpy(" special"));
      swrite((var1=snew(var1, rtn_tag(v_heading))), v_tf); wline(v_tf);
      swrite("  var level as byte", v_tf); wline(v_tf);
      swrite("  var curr as number", v_tf); wline(v_tf);
      swrite("  var branch as number", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scpy("  var idx as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scpy("  var ptr as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
      swrite("  var brfnd as boolean", v_tf); wline(v_tf);
      swrite("  var nxt as byte", v_tf); wline(v_tf);
      swrite("  level=1", v_tf); wline(v_tf);
      swrite("  curr=-1", v_tf); wline(v_tf);
      swrite("  branch=-1", v_tf); wline(v_tf);
      swrite("  brfnd=false", v_tf); wline(v_tf);
      swrite("  loop", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    curr=searchindex(curr, level, nxt, maxbranch("), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")+1)"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    idx=getpointer(curr, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
      swrite("    if curr=-1 or idx=null then break endif", v_tf); wline(v_tf);
      swrite("    nxt=0", v_tf); wline(v_tf);
      newptr(&v_if1, 19, 0);
      c_if1=1;
      v_if1=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_idx.rec), null);
      while (1) {
        if ((v_if1.branch==-1) || ((rtn_tbl_get_ifield_index(v_if1.rec)>rtn_tbl_get_index_index(v_idx.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_if1.rec)==rtn_tbl_get_index_index(v_idx.rec)) {
          newptr(&v_f1, 14, 0);
          v_f1=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if1.rec));
          while (1) {
            if ((v_f1.branch==-1) || ((rtn_tbl_get_field_table(v_f1.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_f1.rec)>rtn_tbl_get_ifield_field(v_if1.rec)))) {
              v_f1=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_f1.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_f1.rec)==rtn_tbl_get_ifield_field(v_if1.rec)) {
              break;
            }
            v_f1=rtn_ptrplus1(v_f1, 14);
          }
          if (!(v_f1.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 17);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_if1, 19);
            delptr(&v_f1, 14);
            delptr(&v_if2, 19);
            delptr(&v_f2, 14);
            return;
          }
          if (c_if1==1) {
            swrite((var1=snew(var1, scon(scon(scon(scon(scpy("    nxt=check(p_"), rtn_tbl_get_field_name(v_f1.rec)), ", idx."), rtn_tbl_get_field_name(v_f1.rec)), ")"))), v_tf); wline(v_tf);
          }
          else {
            swrite((var1=snew(var1, scon(scon(scon(scon(scpy("    if nxt=0 then nxt=check(p_"), rtn_tbl_get_field_name(v_f1.rec)), ", idx."), rtn_tbl_get_field_name(v_f1.rec)), ") endif"))), v_tf); wline(v_tf);
          }
          c_if1+=1;
        }
        if (v_if1.branch==-1) {
          v_if1=rtn_getpointer(0, 0, 19);
        }
        else {
          v_if1=rtn_ptrplus1(v_if1, 19);
        }
      }
      c_if1-=1;
      swrite("    if nxt<=0 then branch=curr ptr=idx endif", v_tf); wline(v_tf);
      swrite("    if nxt=0 then brfnd=true endif", v_tf); wline(v_tf);
      swrite("    level+=1", v_tf); wline(v_tf);
      swrite("  do", v_tf); wline(v_tf);
      swrite("  if branch>0 then branch-=1 endif", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  if branch=-1 then branch=maxbranch("), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ") endif"))), v_tf); wline(v_tf);
      swrite("  level=1", v_tf); wline(v_tf);
      swrite("  curr=-1", v_tf); wline(v_tf);
      swrite("  loop", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    curr=searchindex(curr, level, nxt, maxleaf(branch, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")+1)"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    idx=getpointer(branch, curr, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
      swrite("    if curr=-1 or idx=null then break endif", v_tf); wline(v_tf);
      swrite("    nxt=0", v_tf); wline(v_tf);
      newptr(&v_if2, 19, 0);
      c_if2=1;
      v_if2=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_idx.rec), null);
      while (1) {
        if ((v_if2.branch==-1) || ((rtn_tbl_get_ifield_index(v_if2.rec)>rtn_tbl_get_index_index(v_idx.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_if2.rec)==rtn_tbl_get_index_index(v_idx.rec)) {
          newptr(&v_f2, 14, 0);
          v_f2=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if2.rec));
          while (1) {
            if ((v_f2.branch==-1) || ((rtn_tbl_get_field_table(v_f2.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_f2.rec)>rtn_tbl_get_ifield_field(v_if2.rec)))) {
              v_f2=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_f2.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_f2.rec)==rtn_tbl_get_ifield_field(v_if2.rec)) {
              break;
            }
            v_f2=rtn_ptrplus1(v_f2, 14);
          }
          if (!(v_f2.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 17);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_if1, 19);
            delptr(&v_f1, 14);
            delptr(&v_if2, 19);
            delptr(&v_f2, 14);
            return;
          }
          if (c_if2==1) {
            swrite((var1=snew(var1, scon(scon(scon(scon(scpy("    nxt=check(p_"), rtn_tbl_get_field_name(v_f2.rec)), ", idx."), rtn_tbl_get_field_name(v_f2.rec)), ")"))), v_tf); wline(v_tf);
          }
          else {
            swrite((var1=snew(var1, scon(scon(scon(scon(scpy("    if nxt=0 then nxt=check(p_"), rtn_tbl_get_field_name(v_f2.rec)), ", idx."), rtn_tbl_get_field_name(v_f2.rec)), ") endif"))), v_tf); wline(v_tf);
          }
          c_if2+=1;
        }
        if (v_if2.branch==-1) {
          v_if2=rtn_getpointer(0, 0, 19);
        }
        else {
          v_if2=rtn_ptrplus1(v_if2, 19);
        }
      }
      c_if2-=1;
      swrite("    if nxt<=0 then ptr=idx endif", v_tf); wline(v_tf);
      swrite("    level+=1", v_tf); wline(v_tf);
      swrite("  do", v_tf); wline(v_tf);
      swrite("  if brfnd and ptr=null then", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    ptr=getpointer(branch+1, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
      swrite("  endif", v_tf); wline(v_tf);
      swrite("  return ptr", v_tf); wline(v_tf);
      swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
      swrite(" ", v_tf); wline(v_tf);
      c_idx+=1;
    }
    if (v_idx.branch==-1) {
      v_idx=rtn_getpointer(0, 0, 17);
    }
    else {
      v_idx=rtn_ptrplus1(v_idx, 17);
    }
  }
  c_idx-=1;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_tbl, 12);
  delptr(&v_idx, 17);
  delptr(&v_ifh, 19);
  delptr(&v_fh, 14);
  delptr(&v_if1, 19);
  delptr(&v_f1, 14);
  delptr(&v_if2, 19);
  delptr(&v_f2, 14);
}
 
 
void rtn_write_init(long int v_table) {
  struct pointer v_tbl={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_idx={-1, -1, -1};
  long int c_idx=0;
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 16);
    return;
  }
  swrite(" ", v_tf); wline(v_tf);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scpy("routine name=\"tbl_tablelength_"), rtn_tbl_get_table_name(v_tbl.rec)), "\" type=\"number\" system")))))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  return u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len;"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scpy("routine name=\"tbl_init_"), rtn_tbl_get_table_name(v_tbl.rec)), "\" system")))))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len=0;"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("  u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size="), get_int(rtn_tbl_get_table_size(v_tbl.rec))), ";"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr=0;"))), v_tf); wline(v_tf);
  newptr(&v_idx, 16, 0);
  c_idx=1;
  v_idx=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_idx.branch==-1) || ((rtn_tbl_get_index_table(v_idx.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_idx.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].tbl="), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ";"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].scale=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].len=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].ptr=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].ptrs=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "].padm=0;"))), v_tf); wline(v_tf);
      c_idx+=1;
    }
    if (v_idx.branch==-1) {
      v_idx=rtn_getpointer(0, 0, 16);
    }
    else {
      v_idx=rtn_ptrplus1(v_idx, 16);
    }
  }
  c_idx-=1;
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_idx, 16);
}
 
 
void rtn_write_add(long int v_table) {
  char *v_parm=0;
  struct pointer v_tbl={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_id1={-1, -1, -1};
  long int c_id1=0;
  struct pointer v_of={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  long int c_idx=0;
  struct pointer v_ifh={-1, -1, -1};
  long int c_ifh=0;
  struct pointer v_fh={-1, -1, -1};
  struct pointer v_iskey={-1, -1, -1};
  struct pointer v_ifo={-1, -1, -1};
  long int c_ifo=0;
  struct pointer v_fo={-1, -1, -1};
  struct pointer v_ida={-1, -1, -1};
  long int c_ida=0;
  struct pointer v_lf={-1, -1, -1};
  long int c_lf=0;
  struct pointer v_idxkey={-1, -1, -1};
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_id1, 16);
    delptr(&v_of, 14);
    delptr(&v_idx, 16);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_iskey, 16);
    delptr(&v_ifo, 19);
    delptr(&v_fo, 14);
    delptr(&v_ida, 16);
    delptr(&v_lf, 14);
    delptr(&v_idxkey, 16);
    return;
  }
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_add_"), rtn_tbl_get_table_name(v_tbl.rec)), "\""), rtn_char(10)), " type=\"^"), rtn_tbl_get_table_name(v_tbl.rec)), "\" parameter=\"new\" type=\"^"), rtn_tbl_get_table_name(v_tbl.rec)), "\" special")))))), v_tf); wline(v_tf);
  newptr(&v_id1, 16, 0);
  c_id1=1;
  v_id1=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_id1.branch==-1) || ((rtn_tbl_get_index_table(v_id1.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_id1.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(scon(scon(scpy("  var idx_"), rtn_tbl_get_index_name(v_id1.rec)), " as ^"), rtn_tbl_get_index_name(v_id1.rec)))), v_tf); wline(v_tf);
      c_id1+=1;
    }
    if (v_id1.branch==-1) {
      v_id1=rtn_getpointer(0, 0, 16);
    }
    else {
      v_id1=rtn_ptrplus1(v_id1, 16);
    }
  }
  c_id1-=1;
  swrite((var1=snew(var1, scon(scpy("  var last as ^"), rtn_tbl_get_table_name(v_tbl.rec)))), v_tf); wline(v_tf);
  newptr(&v_of, 14, 0);
  v_of=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_of.branch==-1) || ((rtn_tbl_get_field_table(v_of.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      v_of=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_field_table(v_of.rec)==rtn_tbl_get_table_table(v_tbl.rec) && scmp(rtn_tbl_get_field_type(v_of.rec), "sort")==0) {
      break;
    }
    v_of=rtn_ptrplus1(v_of, 14);
  }
  if (v_of.branch!=-1) {
    swrite((var1=snew(var1, scon(scon(scpy("  new."), rtn_tbl_get_field_name(v_of.rec)), "=999999999"))), v_tf); wline(v_tf);
  }
  newptr(&v_idx, 16, 0);
  c_idx=1;
  v_idx=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_idx.branch==-1) || ((rtn_tbl_get_index_table(v_idx.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_idx.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(scon(scon(scon(scpy("  idx_"), rtn_tbl_get_index_name(v_idx.rec)), "=tbl_search_"), rtn_tbl_get_index_name(v_idx.rec)), "("))), v_tf);
      v_parm=snew(v_parm, 0);
      newptr(&v_ifh, 19, 0);
      c_ifh=1;
      v_ifh=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_idx.rec), null);
      while (1) {
        if ((v_ifh.branch==-1) || ((rtn_tbl_get_ifield_index(v_ifh.rec)>rtn_tbl_get_index_index(v_idx.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_ifh.rec)==rtn_tbl_get_index_index(v_idx.rec)) {
          if (!(c_ifh==1)) {
            v_parm=sadd(v_parm, scpy(", "));
          }
          newptr(&v_fh, 14, 0);
          v_fh=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_ifh.rec));
          while (1) {
            if ((v_fh.branch==-1) || ((rtn_tbl_get_field_table(v_fh.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)>rtn_tbl_get_ifield_field(v_ifh.rec)))) {
              v_fh=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)==rtn_tbl_get_ifield_field(v_ifh.rec)) {
              break;
            }
            v_fh=rtn_ptrplus1(v_fh, 14);
          }
          if (!(v_fh.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_id1, 16);
            delptr(&v_of, 14);
            delptr(&v_idx, 16);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_iskey, 16);
            delptr(&v_ifo, 19);
            delptr(&v_fo, 14);
            delptr(&v_ida, 16);
            delptr(&v_lf, 14);
            delptr(&v_idxkey, 16);
            return;
          }
          v_parm=sadd(v_parm, scon(scpy("new."), rtn_tbl_get_field_name(v_fh.rec)));
          c_ifh+=1;
        }
        if (v_ifh.branch==-1) {
          v_ifh=rtn_getpointer(0, 0, 19);
        }
        else {
          v_ifh=rtn_ptrplus1(v_ifh, 19);
        }
      }
      c_ifh-=1;
      swrite((var1=snew(var1, scon(scpy(v_parm), ")"))), v_tf); wline(v_tf);
      newptr(&v_iskey, 16, 0);
      v_iskey=rtn_tbl_search_index(null);
      while (1) {
        if (v_iskey.branch==-1) {
          v_iskey=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_index_name(v_iskey.rec), rtn_tbl_get_table_name(v_tbl.rec))==0 && scmp(rtn_tbl_get_index_name(v_iskey.rec), rtn_tbl_get_index_name(v_idx.rec))==0) {
          break;
        }
        v_iskey=rtn_ptrplus1(v_iskey, 16);
      }
      if (v_iskey.branch!=-1) {
        swrite((var1=snew(var1, scon(scon(scpy("  if idx_"), rtn_tbl_get_index_name(v_idx.rec)), "=null then"))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scon(sadd(scpy("    last=getpointer(maxbranch("), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "), maxleaf(maxbranch("), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
        swrite("  else", v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("    last=ptrmin1(idx_"), rtn_tbl_get_index_name(v_idx.rec)), ", "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
        swrite("  endif", v_tf); wline(v_tf);
        if (scmp(rtn_tbl_get_field_type(v_fh.rec), "sort")==0 && scmp(rtn_tbl_get_index_name(v_idx.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
          v_parm=snew(v_parm, scpy("  if last=null"));
          newptr(&v_ifo, 19, 0);
          c_ifo=1;
          v_ifo=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_idx.rec), null);
          while (1) {
            if ((v_ifo.branch==-1) || ((rtn_tbl_get_ifield_index(v_ifo.rec)>rtn_tbl_get_index_index(v_idx.rec)))) {
              break;
            }
            if (rtn_tbl_get_ifield_index(v_ifo.rec)==rtn_tbl_get_index_index(v_idx.rec)) {
              newptr(&v_fo, 14, 0);
              v_fo=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_ifo.rec));
              while (1) {
                if ((v_fo.branch==-1) || ((rtn_tbl_get_field_table(v_fo.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fo.rec)>rtn_tbl_get_ifield_field(v_ifo.rec)))) {
                  v_fo=rtn_nullpointer();
                  break;
                }
                if (rtn_tbl_get_field_table(v_fo.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fo.rec)==rtn_tbl_get_ifield_field(v_ifo.rec)) {
                  break;
                }
                v_fo=rtn_ptrplus1(v_fo, 14);
              }
              if (!(v_fo.branch!=-1)) {
                rtn_puterror(scpy("Field error"));
                delptr(&v_tbl, 12);
                delptr(&v_id1, 16);
                delptr(&v_of, 14);
                delptr(&v_idx, 16);
                delptr(&v_ifh, 19);
                delptr(&v_fh, 14);
                delptr(&v_iskey, 16);
                delptr(&v_ifo, 19);
                delptr(&v_fo, 14);
                delptr(&v_ida, 16);
                delptr(&v_lf, 14);
                delptr(&v_idxkey, 16);
                return;
              }
              if (scmp(rtn_tbl_get_field_type(v_fo.rec), "sort")!=0) {
                v_parm=sadd(v_parm, scon(scon(scon(scpy(" or last."), rtn_tbl_get_field_name(v_fo.rec)), "<>new."), rtn_tbl_get_field_name(v_fo.rec)));
              }
              c_ifo+=1;
            }
            if (v_ifo.branch==-1) {
              v_ifo=rtn_getpointer(0, 0, 19);
            }
            else {
              v_ifo=rtn_ptrplus1(v_ifo, 19);
            }
          }
          c_ifo-=1;
          swrite((var1=snew(var1, scon(scpy(v_parm), " then"))), v_tf); wline(v_tf);
          swrite((var1=snew(var1, scon(scon(scpy("    new."), rtn_tbl_get_field_name(v_of.rec)), "=1"))), v_tf); wline(v_tf);
          swrite("  else", v_tf); wline(v_tf);
          swrite((var1=snew(var1, scon(scon(scon(scon(scpy("    new."), rtn_tbl_get_field_name(v_of.rec)), "=last."), rtn_tbl_get_field_name(v_of.rec)), "+1"))), v_tf); wline(v_tf);
          swrite("  endif", v_tf); wline(v_tf);
        }
      }
      c_idx+=1;
    }
    if (v_idx.branch==-1) {
      v_idx=rtn_getpointer(0, 0, 16);
    }
    else {
      v_idx=rtn_ptrplus1(v_idx, 16);
    }
  }
  c_idx-=1;
  newptr(&v_ida, 16, 0);
  c_ida=1;
  v_ida=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_ida.branch==-1) || ((rtn_tbl_get_index_table(v_ida.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_ida.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(scon(scpy("  addindex(idx_"), rtn_tbl_get_index_name(v_ida.rec)), ", tablelen("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")-1, "), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), ")"))), v_tf); wline(v_tf);
      c_ida+=1;
    }
    if (v_ida.branch==-1) {
      v_ida=rtn_getpointer(0, 0, 16);
    }
    else {
      v_ida=rtn_ptrplus1(v_ida, 16);
    }
  }
  c_ida-=1;
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("  output \"add "), rtn_tbl_get_table_name(v_tbl.rec)), "("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "):\"+"))), v_tf);
  newptr(&v_lf, 14, 0);
  c_lf=1;
  v_lf=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_lf.branch==-1) || ((rtn_tbl_get_field_table(v_lf.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_lf.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (!(c_lf==1)) {
        swrite("+\"|\"+", v_tf);
      }
      swrite((var1=snew(var1, scon(scpy("new."), rtn_tbl_get_field_name(v_lf.rec)))), v_tf);
      c_lf+=1;
    }
    if (v_lf.branch==-1) {
      v_lf=rtn_getpointer(0, 0, 14);
    }
    else {
      v_lf=rtn_ptrplus1(v_lf, 14);
    }
  }
  c_lf-=1;
  swrite("+\"|\" to log", v_tf); wline(v_tf);
  swrite("  flush(log)", v_tf); wline(v_tf);
  newptr(&v_idxkey, 16, 0);
  v_idxkey=rtn_tbl_search_index(null);
  while (1) {
    if (v_idxkey.branch==-1) {
      v_idxkey=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idxkey.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
      break;
    }
    v_idxkey=rtn_ptrplus1(v_idxkey, 16);
  }
  if (v_idxkey.branch!=-1) {
    swrite((var1=snew(var1, scon(sadd(scpy("  if last=null then return getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idxkey.rec)))), ") endif"))), v_tf); wline(v_tf);
    swrite((var1=snew(var1, scon(sadd(scpy("  return ptrplus1(last, "), scpy(get_sort(rtn_tbl_get_index_index(v_idxkey.rec)))), ")"))), v_tf); wline(v_tf);
  }
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_id1, 16);
  delptr(&v_of, 14);
  delptr(&v_idx, 16);
  delptr(&v_ifh, 19);
  delptr(&v_fh, 14);
  delptr(&v_iskey, 16);
  delptr(&v_ifo, 19);
  delptr(&v_fo, 14);
  delptr(&v_ida, 16);
  delptr(&v_lf, 14);
  delptr(&v_idxkey, 16);
}
 
 
void rtn_write_clear(long int v_table) {
  struct pointer v_tbl={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_fh={-1, -1, -1};
  long int c_fh=0;
  struct pointer v_ac={-1, -1, -1};
  struct pointer v_tc={-1, -1, -1};
  struct pointer v_ida={-1, -1, -1};
  long int c_ida=0;
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_fh, 14);
    delptr(&v_ac, 29);
    delptr(&v_tc, 29);
    delptr(&v_ida, 16);
    return;
  }
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scpy("routine name=\"tbl_clear_"), rtn_tbl_get_table_name(v_tbl.rec)), "\" system")))))), v_tf); wline(v_tf);
  swrite("  long int r=0;", v_tf); wline(v_tf);
  swrite("  long int branch;", v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  while (r < u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len) {"))), v_tf); wline(v_tf);
  newptr(&v_fh, 14, 0);
  c_fh=1;
  v_fh=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fh.branch==-1) || ((rtn_tbl_get_field_table(v_fh.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fh.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      newptr(&v_ac, 29, 0);
      v_ac=rtn_tbl_search_action(null);
      while (1) {
        if (v_ac.branch==-1) {
          v_ac=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_ac.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_field_type(v_fh.rec)))))==0) {
          break;
        }
        v_ac=rtn_ptrplus1(v_ac, 29);
      }
      if (v_ac.branch!=-1) {
        if (scmp(rtn_tbl_get_field_type(v_fh.rec), "text")==0) {
          newptr(&v_tc, 29, 0);
          v_tc=rtn_tbl_search_action(null);
          while (1) {
            if (v_tc.branch==-1) {
              v_tc=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_tc.rec), "free string")==0) {
              break;
            }
            v_tc=rtn_ptrplus1(v_tc, 29);
          }
          swrite((var1=snew(var1, sadd(scpy("    "), rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_tc.rec)), scon(sadd(scon(sadd(scon(sadd(scpy("*(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[r/250]+(r%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fh.rec))), "+4)"), 0, 0, 0)))), v_tf); wline(v_tf);
        }
        else {
          swrite((var1=snew(var1, sadd(scpy("    "), rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_ac.rec)), scon(sadd(scon(sadd(scon(sadd(scpy("*(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[r/250]+(r%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fh.rec))), ")"), 0, 0, 0)))), v_tf); wline(v_tf);
        }
      }
      c_fh+=1;
    }
    if (v_fh.branch==-1) {
      v_fh=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fh=rtn_ptrplus1(v_fh, 14);
    }
  }
  c_fh-=1;
  swrite("    r++;", v_tf); wline(v_tf);
  swrite("  }", v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  free(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr);"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr=0;"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len=0;"))), v_tf); wline(v_tf);
  newptr(&v_ida, 16, 0);
  c_ida=1;
  v_ida=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_ida.branch==-1) || ((rtn_tbl_get_index_table(v_ida.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_ida.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(sadd(scpy("  for(branch=0; branch < u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].scale; branch++)"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  { free(u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].ptr[branch]);"))), v_tf); wline(v_tf);
      swrite("  }", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  free(u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].len);"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  free(u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].ptr);"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].scale=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].len=0;"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  u_index["), scpy(get_sort(rtn_tbl_get_index_index(v_ida.rec)))), "].ptr=0;"))), v_tf); wline(v_tf);
      c_ida+=1;
    }
    if (v_ida.branch==-1) {
      v_ida=rtn_getpointer(0, 0, 16);
    }
    else {
      v_ida=rtn_ptrplus1(v_ida, 16);
    }
  }
  c_ida-=1;
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("  fprintf(v_log, \"clear "), rtn_tbl_get_table_name(v_tbl.rec)), "("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")\\n\");"))), v_tf); wline(v_tf);
  swrite("  fflush(v_log);", v_tf); wline(v_tf);
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_fh, 14);
  delptr(&v_ac, 29);
  delptr(&v_tc, 29);
  delptr(&v_ida, 16);
}
 
 
void rtn_write_fields(long int v_table) {
  char *v_nullval=0;
  char *v_typestr=0;
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_fld={-1, -1, -1};
  long int c_fld=0;
  struct pointer v_anull={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_fld, 14);
    delptr(&v_anull, 29);
    return;
  }
  newptr(&v_fld, 14, 0);
  c_fld=1;
  v_fld=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fld.branch==-1) || ((rtn_tbl_get_field_table(v_fld.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fld.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      v_nullval=snew(v_nullval, scpy("0"));
      v_typestr=snew(v_typestr, scpy(rtn_tbl_get_field_type(v_fld.rec)));
      if (scmp(v_typestr, "enumerate")==0) {
        v_typestr=snew(v_typestr, scon(scon(scpy("["), rtn_tbl_get_field_data(v_fld.rec)), "]"));
      }
      else {
        if (scmp(v_typestr, "string")==0) {
          v_typestr=snew(v_typestr, scpy("constr"));
        }
      }
      newptr(&v_anull, 29, 0);
      v_anull=rtn_tbl_search_action(null);
      while (1) {
        if (v_anull.branch==-1) {
          v_anull=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_anull.rec), (var1=snew(var1, scon(scpy("null "), rtn_tbl_get_field_type(v_fld.rec)))))==0) {
          break;
        }
        v_anull=rtn_ptrplus1(v_anull, 29);
      }
      if (v_anull.branch!=-1) {
        v_nullval=snew(v_nullval, scpy(rtn_tbl_get_action_codefront(v_anull.rec)));
      }
      swrite(" ", v_tf); wline(v_tf);
      swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_get_"), rtn_tbl_get_table_name(v_tbl.rec)), "_"), rtn_tbl_get_field_name(v_fld.rec)), "\" "), "type=\""), v_typestr), "\" "), "parameter=\"rec\" type=\"number\" system")))))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scon(scon(sadd(scpy("  if (v_rec<0 || v_rec>=u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len) return "), v_nullval), ";"))), v_tf); wline(v_tf);
      if (scmp(rtn_tbl_get_field_type(v_fld.rec), "string")==0) {
        swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  return *(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ");"))), v_tf); wline(v_tf);
      }
      else {
        if (scmp(rtn_tbl_get_field_type(v_fld.rec), "text")==0) {
          swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  return *(struct text*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ");"))), v_tf); wline(v_tf);
        }
        else {
          if (scmp(rtn_tbl_get_field_type(v_fld.rec), "enumerate")==0) {
            swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  return *(int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ");"))), v_tf); wline(v_tf);
          }
          else {
            if (scmp(rtn_tbl_get_field_type(v_fld.rec), "byte")==0) {
              swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  return *(char*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ");"))), v_tf); wline(v_tf);
            }
            else {
              swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  return *(long int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ");"))), v_tf); wline(v_tf);
            }
          }
        }
      }
      swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
      swrite(" ", v_tf); wline(v_tf);
      swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_put_"), rtn_tbl_get_table_name(v_tbl.rec)), "_"), rtn_tbl_get_field_name(v_fld.rec)), "\" "), "parameter=\"rec\" type=\"number\" "), "parameter=\"val\" type=\""), rtn_tbl_get_field_type(v_fld.rec)), "\" "), "system")))))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  if (v_rec<0 || v_rec>=u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len) {"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scon(scon(scon(scon(scpy("    printf(\"error in filling field "), rtn_tbl_get_table_name(v_tbl.rec)), "."), rtn_tbl_get_field_name(v_fld.rec)), "\\"), "n\");"))), v_tf); wline(v_tf);
      swrite("    return;", v_tf); wline(v_tf);
      swrite("  }", v_tf); wline(v_tf);
      if (scmp(rtn_tbl_get_field_type(v_fld.rec), "string")==0) {
        swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")=v_val;"))), v_tf); wline(v_tf);
      }
      else {
        if (scmp(rtn_tbl_get_field_type(v_fld.rec), "enumerate")==0) {
          swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")=v_val;"))), v_tf); wline(v_tf);
        }
        else {
          if (scmp(rtn_tbl_get_field_type(v_fld.rec), "byte")==0) {
            swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(char*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")=v_val;"))), v_tf); wline(v_tf);
          }
          else {
            if (scmp(rtn_tbl_get_field_type(v_fld.rec), "text")==0) {
              swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(struct text*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")=v_val;"))), v_tf); wline(v_tf);
            }
            else {
              swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(long int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")=v_val;"))), v_tf); wline(v_tf);
            }
          }
        }
      }
      swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
      swrite(" ", v_tf); wline(v_tf);
      swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_add_"), rtn_tbl_get_table_name(v_tbl.rec)), "_"), rtn_tbl_get_field_name(v_fld.rec)), "\" "), "parameter=\"rec\" type=\"number\" "), "parameter=\"val\" type=\""), rtn_tbl_get_field_type(v_fld.rec)), "\" "), "system")))))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("  if (v_rec<0 || v_rec>=u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len) {"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scon(scon(scon(scon(scpy("    printf(\"error in adding to field "), rtn_tbl_get_table_name(v_tbl.rec)), "."), rtn_tbl_get_field_name(v_fld.rec)), "\\"), "n\");"))), v_tf); wline(v_tf);
      swrite("    return;", v_tf); wline(v_tf);
      swrite("  }", v_tf); wline(v_tf);
      if (scmp(rtn_tbl_get_field_type(v_fld.rec), "string")==0) {
        swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")= "))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  sadd(*(char**)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), "), v_val);"))), v_tf); wline(v_tf);
      }
      else {
        if (scmp(rtn_tbl_get_field_type(v_fld.rec), "byte")==0) {
          swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(char*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")+=v_val;"))), v_tf); wline(v_tf);
        }
        else {
          if (scmp(rtn_tbl_get_field_type(v_fld.rec), "text")==0) {
            swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(struct text*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")= "))), v_tf); wline(v_tf);
            swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  rtn_addtext(*(struct text*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), "), v_val);"))), v_tf); wline(v_tf);
          }
          else {
            swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(long int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")+=v_val;"))), v_tf); wline(v_tf);
          }
        }
      }
      swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
      swrite(" ", v_tf); wline(v_tf);
      if (scmp(rtn_tbl_get_field_type(v_fld.rec), "string")!=0 && scmp(rtn_tbl_get_field_type(v_fld.rec), "text")!=0) {
        swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_sub_"), rtn_tbl_get_table_name(v_tbl.rec)), "_"), rtn_tbl_get_field_name(v_fld.rec)), "\" "), "parameter=\"rec\" type=\"number\" "), "parameter=\"val\" type=\""), v_typestr), "\" "), "system")))))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scpy("  if (v_rec<0 || v_rec>=u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].len) {"))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(scon(scon(scon(scon(scpy("    printf(\"Error in subtraction from field "), rtn_tbl_get_table_name(v_tbl.rec)), "."), rtn_tbl_get_field_name(v_fld.rec)), "\\"), "n\");"))), v_tf); wline(v_tf);
        swrite("    return;", v_tf); wline(v_tf);
        swrite("  }", v_tf); wline(v_tf);
        if (scmp(rtn_tbl_get_field_type(v_fld.rec), "byte")==0) {
          swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(char*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")-=v_val;"))), v_tf); wline(v_tf);
        }
        else {
          swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(sadd(scpy("  *(long int*)(u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].ptr[v_rec/250]+(v_rec%250)*u_table["), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "].size+"), get_int(rtn_tbl_get_field_position(v_fld.rec))), ")-=v_val;"))), v_tf); wline(v_tf);
        }
        swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
      }
      c_fld+=1;
    }
    if (v_fld.branch==-1) {
      v_fld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fld=rtn_ptrplus1(v_fld, 14);
    }
  }
  c_fld-=1;
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_fld, 14);
  delptr(&v_anull, 29);
}
 
 
void rtn_write_delete(long int v_table) {
  char *v_parm=0;
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_lf={-1, -1, -1};
  long int c_lf=0;
  struct pointer v_id3={-1, -1, -1};
  long int c_id3=0;
  struct pointer v_if3={-1, -1, -1};
  long int c_if3=0;
  struct pointer v_fh3={-1, -1, -1};
  struct pointer v_fhd={-1, -1, -1};
  long int c_fhd=0;
  struct pointer v_ac={-1, -1, -1};
  struct pointer v_id2={-1, -1, -1};
  long int c_id2=0;
  struct pointer v_ifh={-1, -1, -1};
  long int c_ifh=0;
  struct pointer v_fh={-1, -1, -1};
  struct pointer v_sid={-1, -1, -1};
  struct pointer v_sfl={-1, -1, -1};
  struct pointer v_id4={-1, -1, -1};
  long int c_id4=0;
  struct pointer v_if4={-1, -1, -1};
  long int c_if4=0;
  struct pointer v_fh4={-1, -1, -1};
  struct pointer v_id5={-1, -1, -1};
  long int c_id5=0;
  struct pointer v_if5={-1, -1, -1};
  long int c_if5=0;
  struct pointer v_fh5={-1, -1, -1};
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 16);
    delptr(&v_lf, 14);
    delptr(&v_id3, 16);
    delptr(&v_if3, 19);
    delptr(&v_fh3, 14);
    delptr(&v_fhd, 14);
    delptr(&v_ac, 29);
    delptr(&v_id2, 16);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_sid, 16);
    delptr(&v_sfl, 14);
    delptr(&v_id4, 16);
    delptr(&v_if4, 19);
    delptr(&v_fh4, 14);
    delptr(&v_id5, 16);
    delptr(&v_if5, 19);
    delptr(&v_fh5, 14);
    return;
  }
  newptr(&v_idx, 16, 0);
  v_idx=rtn_tbl_search_index(null);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 16);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 16);
    delptr(&v_lf, 14);
    delptr(&v_id3, 16);
    delptr(&v_if3, 19);
    delptr(&v_fh3, 14);
    delptr(&v_fhd, 14);
    delptr(&v_ac, 29);
    delptr(&v_id2, 16);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_sid, 16);
    delptr(&v_sfl, 14);
    delptr(&v_id4, 16);
    delptr(&v_if4, 19);
    delptr(&v_fh4, 14);
    delptr(&v_id5, 16);
    delptr(&v_if5, 19);
    delptr(&v_fh5, 14);
    return;
  }
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scpy("routine name=\"tbl_delete_"), rtn_tbl_get_table_name(v_tbl.rec)), "\""), rtn_char(10)), "  parameter=\"delrec\" type=\"number\" special")))))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scpy("  var last as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scpy("  var chk as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scpy("  var del as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  del=getrecptr(delrec, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("  output \"delete "), rtn_tbl_get_table_name(v_tbl.rec)), "("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), "):\"+"))), v_tf);
  newptr(&v_lf, 14, 0);
  c_lf=1;
  v_lf=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_lf.branch==-1) || ((rtn_tbl_get_field_table(v_lf.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_lf.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (!(c_lf==1)) {
        swrite("+\"|\"+", v_tf);
      }
      swrite((var1=snew(var1, scon(scpy("del."), rtn_tbl_get_field_name(v_lf.rec)))), v_tf);
      c_lf+=1;
    }
    if (v_lf.branch==-1) {
      v_lf=rtn_getpointer(0, 0, 14);
    }
    else {
      v_lf=rtn_ptrplus1(v_lf, 14);
    }
  }
  c_lf-=1;
  swrite("+\"|\" to log", v_tf); wline(v_tf);
  swrite("  flush(log)", v_tf); wline(v_tf);
  newptr(&v_id3, 16, 0);
  c_id3=1;
  v_id3=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_id3.branch==-1) || ((rtn_tbl_get_index_table(v_id3.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_id3.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (scmp(rtn_tbl_get_index_name(v_id3.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
        swrite((var1=snew(var1, scon(scon(scpy("  chk=tbl_search_"), rtn_tbl_get_index_name(v_id3.rec)), "("))), v_tf);
      }
      else {
        swrite((var1=snew(var1, scon(scon(scpy("  deleteindex(tbl_search_"), rtn_tbl_get_index_name(v_id3.rec)), "("))), v_tf);
      }
      v_parm=snew(v_parm, 0);
      newptr(&v_if3, 19, 0);
      c_if3=1;
      v_if3=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id3.rec), null);
      while (1) {
        if ((v_if3.branch==-1) || ((rtn_tbl_get_ifield_index(v_if3.rec)>rtn_tbl_get_index_index(v_id3.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_if3.rec)==rtn_tbl_get_index_index(v_id3.rec)) {
          if (!(c_if3==1)) {
            v_parm=sadd(v_parm, scpy(", "));
          }
          newptr(&v_fh3, 14, 0);
          v_fh3=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if3.rec));
          while (1) {
            if ((v_fh3.branch==-1) || ((rtn_tbl_get_field_table(v_fh3.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh3.rec)>rtn_tbl_get_ifield_field(v_if3.rec)))) {
              v_fh3=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh3.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh3.rec)==rtn_tbl_get_ifield_field(v_if3.rec)) {
              break;
            }
            v_fh3=rtn_ptrplus1(v_fh3, 14);
          }
          if (!(v_fh3.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 16);
            delptr(&v_lf, 14);
            delptr(&v_id3, 16);
            delptr(&v_if3, 19);
            delptr(&v_fh3, 14);
            delptr(&v_fhd, 14);
            delptr(&v_ac, 29);
            delptr(&v_id2, 16);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_sid, 16);
            delptr(&v_sfl, 14);
            delptr(&v_id4, 16);
            delptr(&v_if4, 19);
            delptr(&v_fh4, 14);
            delptr(&v_id5, 16);
            delptr(&v_if5, 19);
            delptr(&v_fh5, 14);
            return;
          }
          v_parm=sadd(v_parm, scon(scpy("del."), rtn_tbl_get_field_name(v_fh3.rec)));
          c_if3+=1;
        }
        if (v_if3.branch==-1) {
          v_if3=rtn_getpointer(0, 0, 19);
        }
        else {
          v_if3=rtn_ptrplus1(v_if3, 19);
        }
      }
      c_if3-=1;
      if (scmp(rtn_tbl_get_index_name(v_id3.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
        swrite((var1=snew(var1, scon(scpy(v_parm), ")"))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scpy("  deleteindex(chk, "), scpy(get_sort(rtn_tbl_get_index_index(v_id3.rec)))), ")"))), v_tf); wline(v_tf);
        if (v_fh3.branch!=-1 && scmp(rtn_tbl_get_field_type(v_fh3.rec), "sort")==0) {
          swrite((var1=snew(var1, scon(scon(scon(scon(scpy("  chk=tbl_search_"), rtn_tbl_get_index_name(v_id3.rec)), "("), v_parm), "+1)"))), v_tf); wline(v_tf);
        }
      }
      else {
        swrite((var1=snew(var1, scon(sadd(scon(scpy(v_parm), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_id3.rec)))), ")"))), v_tf); wline(v_tf);
      }
      c_id3+=1;
    }
    if (v_id3.branch==-1) {
      v_id3=rtn_getpointer(0, 0, 16);
    }
    else {
      v_id3=rtn_ptrplus1(v_id3, 16);
    }
  }
  c_id3-=1;
  newptr(&v_fhd, 14, 0);
  c_fhd=1;
  v_fhd=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fhd.branch==-1) || ((rtn_tbl_get_field_table(v_fhd.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fhd.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      newptr(&v_ac, 29, 0);
      v_ac=rtn_tbl_search_action(null);
      while (1) {
        if (v_ac.branch==-1) {
          v_ac=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_ac.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_field_type(v_fhd.rec)))))==0) {
          break;
        }
        v_ac=rtn_ptrplus1(v_ac, 29);
      }
      if (v_ac.branch!=-1) {
        swrite((var1=snew(var1, scon(scon(scpy(" del."), rtn_tbl_get_field_name(v_fhd.rec)), "=null"))), v_tf); wline(v_tf);
      }
      c_fhd+=1;
    }
    if (v_fhd.branch==-1) {
      v_fhd=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fhd=rtn_ptrplus1(v_fhd, 14);
    }
  }
  c_fhd-=1;
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("  if getrec(del, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")<>tablelen("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")-1 then"))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scon(sadd(scpy("    last=getrecptr(tablelen("), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")-1, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
  newptr(&v_id2, 16, 0);
  c_id2=1;
  v_id2=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_id2.branch==-1) || ((rtn_tbl_get_index_table(v_id2.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_id2.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(scon(scpy("    changeindex(tbl_search_"), rtn_tbl_get_index_name(v_id2.rec)), "("))), v_tf);
      v_parm=snew(v_parm, 0);
      newptr(&v_ifh, 19, 0);
      c_ifh=1;
      v_ifh=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id2.rec), null);
      while (1) {
        if ((v_ifh.branch==-1) || ((rtn_tbl_get_ifield_index(v_ifh.rec)>rtn_tbl_get_index_index(v_id2.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_ifh.rec)==rtn_tbl_get_index_index(v_id2.rec)) {
          if (!(c_ifh==1)) {
            v_parm=sadd(v_parm, scpy(", "));
          }
          newptr(&v_fh, 14, 0);
          v_fh=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_ifh.rec));
          while (1) {
            if ((v_fh.branch==-1) || ((rtn_tbl_get_field_table(v_fh.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)>rtn_tbl_get_ifield_field(v_ifh.rec)))) {
              v_fh=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)==rtn_tbl_get_ifield_field(v_ifh.rec)) {
              break;
            }
            v_fh=rtn_ptrplus1(v_fh, 14);
          }
          if (!(v_fh.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 16);
            delptr(&v_lf, 14);
            delptr(&v_id3, 16);
            delptr(&v_if3, 19);
            delptr(&v_fh3, 14);
            delptr(&v_fhd, 14);
            delptr(&v_ac, 29);
            delptr(&v_id2, 16);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_sid, 16);
            delptr(&v_sfl, 14);
            delptr(&v_id4, 16);
            delptr(&v_if4, 19);
            delptr(&v_fh4, 14);
            delptr(&v_id5, 16);
            delptr(&v_if5, 19);
            delptr(&v_fh5, 14);
            return;
          }
          v_parm=sadd(v_parm, scon(scpy("last."), rtn_tbl_get_field_name(v_fh.rec)));
          c_ifh+=1;
        }
        if (v_ifh.branch==-1) {
          v_ifh=rtn_getpointer(0, 0, 19);
        }
        else {
          v_ifh=rtn_ptrplus1(v_ifh, 19);
        }
      }
      c_ifh-=1;
      swrite((var1=snew(var1, scon(sadd(scon(scpy(v_parm), "), delrec, "), scpy(get_sort(rtn_tbl_get_index_index(v_id2.rec)))), ")"))), v_tf); wline(v_tf);
      c_id2+=1;
    }
    if (v_id2.branch==-1) {
      v_id2=rtn_getpointer(0, 0, 16);
    }
    else {
      v_id2=rtn_ptrplus1(v_id2, 16);
    }
  }
  c_id2-=1;
  swrite("  endif", v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  deleterecord(delrec, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
  newptr(&v_sid, 16, 0);
  v_sid=rtn_tbl_search_index(null);
  while (1) {
    if (v_sid.branch==-1) {
      v_sid=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_sid.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
      break;
    }
    v_sid=rtn_ptrplus1(v_sid, 16);
  }
  if (v_sid.branch!=-1) {
    swrite("  if chk=null then return endif", v_tf); wline(v_tf);
    swrite((var1=snew(var1, scon(sadd(scpy("  chk=recalcptr(chk, "), scpy(get_sort(rtn_tbl_get_index_index(v_sid.rec)))), ")"))), v_tf); wline(v_tf);
    newptr(&v_sfl, 14, 0);
    v_sfl=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
    while (1) {
      if ((v_sfl.branch==-1) || ((rtn_tbl_get_field_table(v_sfl.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
        v_sfl=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_field_table(v_sfl.rec)==rtn_tbl_get_table_table(v_tbl.rec) && scmp(rtn_tbl_get_field_type(v_sfl.rec), "sort")==0) {
        break;
      }
      v_sfl=rtn_ptrplus1(v_sfl, 14);
    }
    if (v_sfl.branch!=-1) {
      swrite("  var rec as number", v_tf); wline(v_tf);
      swrite("  loop", v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(scon(scpy("    if chk=null or chk."), rtn_tbl_get_field_name(v_sfl.rec)), "=1 then break endif"))), v_tf); wline(v_tf);
      swrite((var1=snew(var1, scon(sadd(scpy("    rec=getrec(chk, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
      newptr(&v_id4, 16, 0);
      c_id4=1;
      v_id4=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
      while (1) {
        if ((v_id4.branch==-1) || ((rtn_tbl_get_index_table(v_id4.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
          break;
        }
        if (rtn_tbl_get_index_table(v_id4.rec)==rtn_tbl_get_table_table(v_tbl.rec) && scmp(rtn_tbl_get_index_name(v_id4.rec), rtn_tbl_get_table_name(v_tbl.rec))!=0) {
          swrite((var1=snew(var1, scon(scon(scpy("    deleteindex(tbl_search_"), rtn_tbl_get_index_name(v_id4.rec)), "("))), v_tf);
          v_parm=snew(v_parm, 0);
          newptr(&v_if4, 19, 0);
          c_if4=1;
          v_if4=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id4.rec), null);
          while (1) {
            if ((v_if4.branch==-1) || ((rtn_tbl_get_ifield_index(v_if4.rec)>rtn_tbl_get_index_index(v_id4.rec)))) {
              break;
            }
            if (rtn_tbl_get_ifield_index(v_if4.rec)==rtn_tbl_get_index_index(v_id4.rec)) {
              if (!(c_if4==1)) {
                v_parm=sadd(v_parm, scpy(", "));
              }
              newptr(&v_fh4, 14, 0);
              v_fh4=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if4.rec));
              while (1) {
                if ((v_fh4.branch==-1) || ((rtn_tbl_get_field_table(v_fh4.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh4.rec)>rtn_tbl_get_ifield_field(v_if4.rec)))) {
                  v_fh4=rtn_nullpointer();
                  break;
                }
                if (rtn_tbl_get_field_table(v_fh4.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh4.rec)==rtn_tbl_get_ifield_field(v_if4.rec)) {
                  break;
                }
                v_fh4=rtn_ptrplus1(v_fh4, 14);
              }
              if (!(v_fh4.branch!=-1)) {
                rtn_puterror(scpy("Field error"));
                delptr(&v_tbl, 12);
                delptr(&v_idx, 16);
                delptr(&v_lf, 14);
                delptr(&v_id3, 16);
                delptr(&v_if3, 19);
                delptr(&v_fh3, 14);
                delptr(&v_fhd, 14);
                delptr(&v_ac, 29);
                delptr(&v_id2, 16);
                delptr(&v_ifh, 19);
                delptr(&v_fh, 14);
                delptr(&v_sid, 16);
                delptr(&v_sfl, 14);
                delptr(&v_id4, 16);
                delptr(&v_if4, 19);
                delptr(&v_fh4, 14);
                delptr(&v_id5, 16);
                delptr(&v_if5, 19);
                delptr(&v_fh5, 14);
                return;
              }
              v_parm=sadd(v_parm, scon(scpy("chk."), rtn_tbl_get_field_name(v_fh4.rec)));
              c_if4+=1;
            }
            if (v_if4.branch==-1) {
              v_if4=rtn_getpointer(0, 0, 19);
            }
            else {
              v_if4=rtn_ptrplus1(v_if4, 19);
            }
          }
          c_if4-=1;
          swrite((var1=snew(var1, scon(sadd(scon(scpy(v_parm), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_id4.rec)))), ")"))), v_tf); wline(v_tf);
          c_id4+=1;
        }
        if (v_id4.branch==-1) {
          v_id4=rtn_getpointer(0, 0, 16);
        }
        else {
          v_id4=rtn_ptrplus1(v_id4, 16);
        }
      }
      c_id4-=1;
      swrite((var1=snew(var1, scon(scon(scpy("    chk."), rtn_tbl_get_field_name(v_sfl.rec)), "-=1"))), v_tf); wline(v_tf);
      newptr(&v_id5, 16, 0);
      c_id5=1;
      v_id5=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
      while (1) {
        if ((v_id5.branch==-1) || ((rtn_tbl_get_index_table(v_id5.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
          break;
        }
        if (rtn_tbl_get_index_table(v_id5.rec)==rtn_tbl_get_table_table(v_tbl.rec) && scmp(rtn_tbl_get_index_name(v_id5.rec), rtn_tbl_get_table_name(v_tbl.rec))!=0) {
          swrite((var1=snew(var1, scon(scon(scpy("    addindex(tbl_search_"), rtn_tbl_get_index_name(v_id5.rec)), "("))), v_tf);
          v_parm=snew(v_parm, 0);
          newptr(&v_if5, 19, 0);
          c_if5=1;
          v_if5=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id5.rec), null);
          while (1) {
            if ((v_if5.branch==-1) || ((rtn_tbl_get_ifield_index(v_if5.rec)>rtn_tbl_get_index_index(v_id5.rec)))) {
              break;
            }
            if (rtn_tbl_get_ifield_index(v_if5.rec)==rtn_tbl_get_index_index(v_id5.rec)) {
              if (!(c_if5==1)) {
                v_parm=sadd(v_parm, scpy(", "));
              }
              newptr(&v_fh5, 14, 0);
              v_fh5=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if5.rec));
              while (1) {
                if ((v_fh5.branch==-1) || ((rtn_tbl_get_field_table(v_fh5.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh5.rec)>rtn_tbl_get_ifield_field(v_if5.rec)))) {
                  v_fh5=rtn_nullpointer();
                  break;
                }
                if (rtn_tbl_get_field_table(v_fh5.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh5.rec)==rtn_tbl_get_ifield_field(v_if5.rec)) {
                  break;
                }
                v_fh5=rtn_ptrplus1(v_fh5, 14);
              }
              if (!(v_fh5.branch!=-1)) {
                rtn_puterror(scpy("Field error"));
                delptr(&v_tbl, 12);
                delptr(&v_idx, 16);
                delptr(&v_lf, 14);
                delptr(&v_id3, 16);
                delptr(&v_if3, 19);
                delptr(&v_fh3, 14);
                delptr(&v_fhd, 14);
                delptr(&v_ac, 29);
                delptr(&v_id2, 16);
                delptr(&v_ifh, 19);
                delptr(&v_fh, 14);
                delptr(&v_sid, 16);
                delptr(&v_sfl, 14);
                delptr(&v_id4, 16);
                delptr(&v_if4, 19);
                delptr(&v_fh4, 14);
                delptr(&v_id5, 16);
                delptr(&v_if5, 19);
                delptr(&v_fh5, 14);
                return;
              }
              v_parm=sadd(v_parm, scon(scpy("chk."), rtn_tbl_get_field_name(v_fh5.rec)));
              c_if5+=1;
            }
            if (v_if5.branch==-1) {
              v_if5=rtn_getpointer(0, 0, 19);
            }
            else {
              v_if5=rtn_ptrplus1(v_if5, 19);
            }
          }
          c_if5-=1;
          swrite((var1=snew(var1, scon(sadd(scon(scpy(v_parm), "), rec, "), scpy(get_sort(rtn_tbl_get_index_index(v_id5.rec)))), ")"))), v_tf); wline(v_tf);
          c_id5+=1;
        }
        if (v_id5.branch==-1) {
          v_id5=rtn_getpointer(0, 0, 16);
        }
        else {
          v_id5=rtn_ptrplus1(v_id5, 16);
        }
      }
      c_id5-=1;
      swrite((var1=snew(var1, scon(sadd(scpy("    chk=ptrplus1(chk, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"))), v_tf); wline(v_tf);
      swrite("  do", v_tf); wline(v_tf);
    }
  }
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_idx, 16);
  delptr(&v_lf, 14);
  delptr(&v_id3, 16);
  delptr(&v_if3, 19);
  delptr(&v_fh3, 14);
  delptr(&v_fhd, 14);
  delptr(&v_ac, 29);
  delptr(&v_id2, 16);
  delptr(&v_ifh, 19);
  delptr(&v_fh, 14);
  delptr(&v_sid, 16);
  delptr(&v_sfl, 14);
  delptr(&v_id4, 16);
  delptr(&v_if4, 19);
  delptr(&v_fh4, 14);
  delptr(&v_id5, 16);
  delptr(&v_if5, 19);
  delptr(&v_fh5, 14);
}
 
 
void rtn_write_update(long int v_table) {
  char *v_parm=0;
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_id3={-1, -1, -1};
  long int c_id3=0;
  struct pointer v_if3={-1, -1, -1};
  long int c_if3=0;
  struct pointer v_fh3={-1, -1, -1};
  struct pointer v_id2={-1, -1, -1};
  long int c_id2=0;
  struct pointer v_ifh={-1, -1, -1};
  long int c_ifh=0;
  struct pointer v_fh={-1, -1, -1};
  struct pointer v_lf={-1, -1, -1};
  long int c_lf=0;
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 16);
    delptr(&v_id3, 16);
    delptr(&v_if3, 19);
    delptr(&v_fh3, 14);
    delptr(&v_id2, 16);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_lf, 14);
    return;
  }
  newptr(&v_idx, 16, 0);
  v_idx=rtn_tbl_search_index(null);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 16);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_idx, 16);
    delptr(&v_id3, 16);
    delptr(&v_if3, 19);
    delptr(&v_fh3, 14);
    delptr(&v_id2, 16);
    delptr(&v_ifh, 19);
    delptr(&v_fh, 14);
    delptr(&v_lf, 14);
    return;
  }
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_update_"), rtn_tbl_get_table_name(v_tbl.rec)), "\""), rtn_char(10)), "   type=\"^"), rtn_tbl_get_index_name(v_idx.rec)), "\" parameter=\"rec\" type=\"number\" special")))))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scpy("  var new as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scpy("  var del as ^"), rtn_tbl_get_index_name(v_idx.rec)))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("  del=getrecptr(rec, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
  newptr(&v_id3, 16, 0);
  c_id3=1;
  v_id3=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_id3.branch==-1) || ((rtn_tbl_get_index_table(v_id3.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_id3.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (scmp(rtn_tbl_get_index_name(v_id3.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
        swrite((var1=snew(var1, scon(scon(scpy("  new=tbl_search_"), rtn_tbl_get_index_name(v_id3.rec)), "("))), v_tf);
      }
      else {
        swrite((var1=snew(var1, scon(scon(scpy("  deleteindex(tbl_search_"), rtn_tbl_get_index_name(v_id3.rec)), "("))), v_tf);
      }
      v_parm=snew(v_parm, 0);
      newptr(&v_if3, 19, 0);
      c_if3=1;
      v_if3=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id3.rec), null);
      while (1) {
        if ((v_if3.branch==-1) || ((rtn_tbl_get_ifield_index(v_if3.rec)>rtn_tbl_get_index_index(v_id3.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_if3.rec)==rtn_tbl_get_index_index(v_id3.rec)) {
          if (!(c_if3==1)) {
            v_parm=sadd(v_parm, scpy(", "));
          }
          newptr(&v_fh3, 14, 0);
          v_fh3=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_if3.rec));
          while (1) {
            if ((v_fh3.branch==-1) || ((rtn_tbl_get_field_table(v_fh3.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh3.rec)>rtn_tbl_get_ifield_field(v_if3.rec)))) {
              v_fh3=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh3.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh3.rec)==rtn_tbl_get_ifield_field(v_if3.rec)) {
              break;
            }
            v_fh3=rtn_ptrplus1(v_fh3, 14);
          }
          if (!(v_fh3.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 16);
            delptr(&v_id3, 16);
            delptr(&v_if3, 19);
            delptr(&v_fh3, 14);
            delptr(&v_id2, 16);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_lf, 14);
            return;
          }
          v_parm=sadd(v_parm, scon(scpy("del."), rtn_tbl_get_field_name(v_fh3.rec)));
          c_if3+=1;
        }
        if (v_if3.branch==-1) {
          v_if3=rtn_getpointer(0, 0, 19);
        }
        else {
          v_if3=rtn_ptrplus1(v_if3, 19);
        }
      }
      c_if3-=1;
      if (scmp(rtn_tbl_get_index_name(v_id3.rec), rtn_tbl_get_table_name(v_tbl.rec))==0) {
        swrite((var1=snew(var1, scon(scpy(v_parm), ")"))), v_tf); wline(v_tf);
        swrite((var1=snew(var1, scon(sadd(scpy("  deleteindex(new, "), scpy(get_sort(rtn_tbl_get_index_index(v_id3.rec)))), ")"))), v_tf); wline(v_tf);
      }
      else {
        swrite((var1=snew(var1, scon(sadd(scon(scpy(v_parm), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_id3.rec)))), ")"))), v_tf); wline(v_tf);
      }
      c_id3+=1;
    }
    if (v_id3.branch==-1) {
      v_id3=rtn_getpointer(0, 0, 16);
    }
    else {
      v_id3=rtn_ptrplus1(v_id3, 16);
    }
  }
  c_id3-=1;
  swrite((var1=snew(var1, scon(sadd(scpy("  deleterecord(rec, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
  newptr(&v_id2, 16, 0);
  c_id2=1;
  v_id2=rtn_tbl_search_index(rtn_tbl_get_table_table(v_tbl.rec));
  while (1) {
    if ((v_id2.branch==-1) || ((rtn_tbl_get_index_table(v_id2.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_index_table(v_id2.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(scon(scpy("  addindex(tbl_search_"), rtn_tbl_get_index_name(v_id2.rec)), "("))), v_tf);
      v_parm=snew(v_parm, 0);
      newptr(&v_ifh, 19, 0);
      c_ifh=1;
      v_ifh=rtn_tbl_search_ifield(rtn_tbl_get_index_index(v_id2.rec), null);
      while (1) {
        if ((v_ifh.branch==-1) || ((rtn_tbl_get_ifield_index(v_ifh.rec)>rtn_tbl_get_index_index(v_id2.rec)))) {
          break;
        }
        if (rtn_tbl_get_ifield_index(v_ifh.rec)==rtn_tbl_get_index_index(v_id2.rec)) {
          if (!(c_ifh==1)) {
            v_parm=sadd(v_parm, scpy(", "));
          }
          newptr(&v_fh, 14, 0);
          v_fh=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), rtn_tbl_get_ifield_field(v_ifh.rec));
          while (1) {
            if ((v_fh.branch==-1) || ((rtn_tbl_get_field_table(v_fh.rec)>rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)>rtn_tbl_get_ifield_field(v_ifh.rec)))) {
              v_fh=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fh.rec)==rtn_tbl_get_table_table(v_tbl.rec) && rtn_tbl_get_field_field(v_fh.rec)==rtn_tbl_get_ifield_field(v_ifh.rec)) {
              break;
            }
            v_fh=rtn_ptrplus1(v_fh, 14);
          }
          if (!(v_fh.branch!=-1)) {
            rtn_puterror(scpy("Field error"));
            delptr(&v_tbl, 12);
            delptr(&v_idx, 16);
            delptr(&v_id3, 16);
            delptr(&v_if3, 19);
            delptr(&v_fh3, 14);
            delptr(&v_id2, 16);
            delptr(&v_ifh, 19);
            delptr(&v_fh, 14);
            delptr(&v_lf, 14);
            return;
          }
          v_parm=sadd(v_parm, scon(scpy("new."), rtn_tbl_get_field_name(v_fh.rec)));
          c_ifh+=1;
        }
        if (v_ifh.branch==-1) {
          v_ifh=rtn_getpointer(0, 0, 19);
        }
        else {
          v_ifh=rtn_ptrplus1(v_ifh, 19);
        }
      }
      c_ifh-=1;
      swrite((var1=snew(var1, scon(sadd(scon(sadd(scon(scpy(v_parm), "), getrec(new, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), "), "), scpy(get_sort(rtn_tbl_get_index_index(v_id2.rec)))), ")"))), v_tf); wline(v_tf);
      c_id2+=1;
    }
    if (v_id2.branch==-1) {
      v_id2=rtn_getpointer(0, 0, 16);
    }
    else {
      v_id2=rtn_ptrplus1(v_id2, 16);
    }
  }
  c_id2-=1;
  swrite("  if new=null then ", v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(sadd(scpy("    new=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec)))), ")"))), v_tf); wline(v_tf);
  swrite("  endif", v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scon(scpy("  output \"update "), rtn_tbl_get_table_name(v_tbl.rec)), ":\"+"))), v_tf);
  newptr(&v_lf, 14, 0);
  c_lf=1;
  v_lf=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_lf.branch==-1) || ((rtn_tbl_get_field_table(v_lf.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_lf.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (!(c_lf==1)) {
        swrite("+\"|\"+", v_tf);
      }
      swrite((var1=snew(var1, scon(scpy("new."), rtn_tbl_get_field_name(v_lf.rec)))), v_tf);
      c_lf+=1;
    }
    if (v_lf.branch==-1) {
      v_lf=rtn_getpointer(0, 0, 14);
    }
    else {
      v_lf=rtn_ptrplus1(v_lf, 14);
    }
  }
  c_lf-=1;
  swrite("+\"|\" to log", v_tf); wline(v_tf);
  swrite("  flush(log)", v_tf); wline(v_tf);
  swrite("  return new", v_tf); wline(v_tf);
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_idx, 16);
  delptr(&v_id3, 16);
  delptr(&v_if3, 19);
  delptr(&v_fh3, 14);
  delptr(&v_id2, 16);
  delptr(&v_ifh, 19);
  delptr(&v_fh, 14);
  delptr(&v_lf, 14);
}
 
 
void rtn_write_store(long int v_table) {
  struct pointer v_tbl={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_fld={-1, -1, -1};
  long int c_fld=0;
  struct pointer v_fldr={-1, -1, -1};
  long int c_fldr=0;
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(v_table);
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>v_table))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==v_table) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Table error"));
    delptr(&v_tbl, 12);
    delptr(&v_fld, 14);
    delptr(&v_fldr, 14);
    return;
  }
  swrite(" ", v_tf); wline(v_tf);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_write_"), rtn_tbl_get_table_name(v_tbl.rec)), "\" "), "parameter=\"ptr\" type=\"^"), rtn_tbl_get_table_name(v_tbl.rec)), "\" "), "parameter=\"stream\" type=\"stream\"")))))), v_tf); wline(v_tf);
  newptr(&v_fld, 14, 0);
  c_fld=1;
  v_fld=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fld.branch==-1) || ((rtn_tbl_get_field_table(v_fld.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fld.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      swrite((var1=snew(var1, scon(scon(scpy("  write(ptr."), rtn_tbl_get_field_name(v_fld.rec)), ", stream)"))), v_tf); wline(v_tf);
      c_fld+=1;
    }
    if (v_fld.branch==-1) {
      v_fld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fld=rtn_ptrplus1(v_fld, 14);
    }
  }
  c_fld-=1;
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scon(scon(scon(scon(scon(scpy("routine name=\"tbl_read_"), rtn_tbl_get_table_name(v_tbl.rec)), "\" "), "type=\"^"), rtn_tbl_get_table_name(v_tbl.rec)), "\" "), "parameter=\"stream\" type=\"stream\"")))))), v_tf); wline(v_tf);
  swrite((var1=snew(var1, scon(scon(scpy("  add "), rtn_tbl_get_table_name(v_tbl.rec)), " as new"))), v_tf); wline(v_tf);
  newptr(&v_fldr, 14, 0);
  c_fldr=1;
  v_fldr=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fldr.branch==-1) || ((rtn_tbl_get_field_table(v_fldr.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fldr.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      if (((scmp(rtn_tbl_get_field_type(v_fldr.rec), "text")==0) || (scmp(rtn_tbl_get_field_type(v_fldr.rec), "constr")==0)) || (scmp(rtn_tbl_get_field_type(v_fldr.rec), "string")==0)) {
        swrite((var1=snew(var1, scon(scon(scpy("  new."), rtn_tbl_get_field_name(v_fldr.rec)), "=readtext(stream)"))), v_tf); wline(v_tf);
      }
      else {
        swrite((var1=snew(var1, scon(scon(scpy("  new."), rtn_tbl_get_field_name(v_fldr.rec)), "=read(stream)"))), v_tf); wline(v_tf);
      }
      c_fldr+=1;
    }
    if (v_fldr.branch==-1) {
      v_fldr=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fldr=rtn_ptrplus1(v_fldr, 14);
    }
  }
  c_fldr-=1;
  swrite("  update", v_tf); wline(v_tf);
  swrite("  return new", v_tf); wline(v_tf);
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_tf); wline(v_tf);
  swrite(" ", v_tf); wline(v_tf);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbl, 12);
  delptr(&v_fld, 14);
  delptr(&v_fldr, 14);
}
 
 
char *rtn_scan_table() {
  char v_keyfound=0;
  char *v_iname=0;
  long int v_nr=0;
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  struct pointer v_table={-1, -1, -1};
  char *var1=0;
  struct pointer v_fs={-1, -1, -1};
  long int c_fs=0;
  struct pointer v_reserved={-1, -1, -1};
  struct pointer v_fn={-1, -1, -1};
  struct pointer v_field={-1, -1, -1};
  char *var2=0;
  struct pointer v_actionget={-1, -1, -1};
  struct pointer v_si={-1, -1, -1};
  long int c_si=0;
  struct pointer v_index={-1, -1, -1};
  char *v_ifld=0;
  long int c_ifld=0;
  struct pointer v_ifd={-1, -1, -1};
  struct pointer v_ifield={-1, -1, -1};
  if (v_scantype==1 && scmp(v_scantag, "table")==0) {
    v_tagfound=1;
    v_nr=1;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      v_keyfound=0;
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "name")==0 && v_nr==1) {
        if (rtn_check_name(scpy(rtn_tbl_get_scan_value(v_s.rec)), scpy("new table name"))) {
          v_keyfound=1;
          newptr(&v_table, 12, 0);
          v_table=rtn_addrecord(8);
          rtn_tbl_put_table_table(v_table.rec, 0);
          rtn_tbl_put_table_name(v_table.rec, 0);
          rtn_tbl_put_table_kind(v_table.rec, -1);
          rtn_tbl_put_table_module(v_table.rec, 0);
          rtn_tbl_put_table_use(v_table.rec, 0);
          rtn_tbl_put_table_size(v_table.rec, null);
          v_dbstate=1;
          rtn_tbl_put_table_name(v_table.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
          rtn_tbl_put_table_module(v_table.rec, scpy(v_cmodule));
          rtn_tbl_put_table_kind(v_table.rec, ienum("global", "public local"));
          v_table=rtn_tbl_add_table(v_table);
          v_dbstate=0;
        }
        else {
          var1=snew(var1, 0);
          delptr(&v_s, 1);
          delptr(&v_table, 12);
          delptr(&v_fs, 1);
          delptr(&v_reserved, 34);
          delptr(&v_fn, 15);
          delptr(&v_field, 14);
          delptr(&v_actionget, 30);
          delptr(&v_si, 1);
          delptr(&v_index, 16);
          delptr(&v_ifd, 15);
          delptr(&v_ifield, 19);
          return var1;
        }
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_s.rec), "local")==0 && v_nr>1) {
          v_keyfound=1;
          v_table=rtn_cpyrecord(v_table, 8);
          v_dbstate=2;
          rtn_tbl_put_table_kind(v_table.rec, 1);
          v_dbstate=3;
          v_table=rtn_tbl_update_table(rtn_getrec(rtn_recalcptr(v_table, 12), 8));
          v_dbstate=0;
        }
        else {
          if (scmp(rtn_tbl_get_scan_key(v_s.rec), "use")==0 && v_nr>1) {
            v_keyfound=1;
            v_table=rtn_cpyrecord(v_table, 8);
            v_dbstate=2;
            rtn_tbl_put_table_use(v_table.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
            v_dbstate=3;
            v_table=rtn_tbl_update_table(rtn_getrec(rtn_recalcptr(v_table, 12), 8));
            v_dbstate=0;
          }
          else {
            if (v_nr==1) {
              rtn_puterror(scpy("Unknown table name"));
              var1=snew(var1, 0);
              delptr(&v_s, 1);
              delptr(&v_table, 12);
              delptr(&v_fs, 1);
              delptr(&v_reserved, 34);
              delptr(&v_fn, 15);
              delptr(&v_field, 14);
              delptr(&v_actionget, 30);
              delptr(&v_si, 1);
              delptr(&v_index, 16);
              delptr(&v_ifd, 15);
              delptr(&v_ifield, 19);
              return var1;
            }
          }
        }
      }
      if (!(v_keyfound)) {
        rtn_putwarning(scon(scon(scpy("Unknown key '"), rtn_tbl_get_scan_key(v_s.rec)), "' found in table definition"));
      }
      v_nr+=1;
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
  }
  else {
    var1=snew(var1, 0);
    delptr(&v_s, 1);
    delptr(&v_table, 12);
    delptr(&v_fs, 1);
    delptr(&v_reserved, 34);
    delptr(&v_fn, 15);
    delptr(&v_field, 14);
    delptr(&v_actionget, 30);
    delptr(&v_si, 1);
    delptr(&v_index, 16);
    delptr(&v_ifd, 15);
    delptr(&v_ifield, 19);
    return var1;
  }
  rtn_do_scan(scpy("fields"));
  if ((v_scantype!=1) || (scmp(v_scantag, "fields")!=0)) {
    rtn_puterror(scon(scon(scpy("Cannot find fields tag inside definition of table '"), rtn_tbl_get_table_name(v_table.rec)), "'"));
    var1=snew(var1, 0);
    delptr(&v_s, 1);
    delptr(&v_table, 12);
    delptr(&v_fs, 1);
    delptr(&v_reserved, 34);
    delptr(&v_fn, 15);
    delptr(&v_field, 14);
    delptr(&v_actionget, 30);
    delptr(&v_si, 1);
    delptr(&v_index, 16);
    delptr(&v_ifd, 15);
    delptr(&v_ifield, 19);
    return var1;
  }
  v_nr=1;
  newptr(&v_fs, 1, 0);
  c_fs=1;
  v_fs=rtn_getpointer(0, 0, 1);
  while (1) {
    if (v_fs.branch==-1) {
      break;
    }
    v_keyfound=0;
    if (scmp(rtn_tbl_get_scan_key(v_fs.rec), "name")==0) {
      if (!(rtn_is_keyword(scpy(rtn_tbl_get_scan_value(v_fs.rec))))) {
        rtn_puterror(scon(scon(scpy("Field name '"), rtn_tbl_get_scan_value(v_fs.rec)), "' has impossible tokens"));
        break;
      }
      else {
        newptr(&v_reserved, 34, 0);
        v_reserved=rtn_tbl_search_reserved(scpy(rtn_tbl_get_scan_value(v_fs.rec)), -1);
        while (1) {
          if ((v_reserved.branch==-1) || ((scmp(rtn_tbl_get_reserved_keyword(v_reserved.rec), rtn_tbl_get_scan_value(v_fs.rec))>0))) {
            v_reserved=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_reserved_keyword(v_reserved.rec), rtn_tbl_get_scan_value(v_fs.rec))==0 && rtn_tbl_get_reserved_type(v_reserved.rec)==1) {
            break;
          }
          v_reserved=rtn_ptrplus1(v_reserved, 34);
        }
        if (v_reserved.branch!=-1) {
          rtn_puterror(scon(scon(scpy("Reserved name used in field '"), rtn_tbl_get_scan_value(v_fs.rec)), "'"));
          break;
        }
        else {
          newptr(&v_fn, 15, 0);
          v_fn=rtn_tbl_search_fieldname(rtn_tbl_get_table_table(v_table.rec), 0);
          while (1) {
            if ((v_fn.branch==-1) || ((rtn_tbl_get_field_table(v_fn.rec)>rtn_tbl_get_table_table(v_table.rec)))) {
              v_fn=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_field_table(v_fn.rec)==rtn_tbl_get_table_table(v_table.rec) && scmp(rtn_tbl_get_field_name(v_fn.rec), rtn_tbl_get_scan_value(v_fs.rec))==0) {
              break;
            }
            v_fn=rtn_ptrplus1(v_fn, 15);
          }
          if (v_fn.branch!=-1) {
            rtn_puterror(scon(scon(scpy("Field name '"), rtn_tbl_get_scan_value(v_fs.rec)), "' used twice"));
            break;
          }
          else {
            newptr(&v_field, 14, 0);
            v_field=rtn_addrecord(9);
            rtn_tbl_put_field_table(v_field.rec, null);
            rtn_tbl_put_field_field(v_field.rec, 0);
            rtn_tbl_put_field_name(v_field.rec, 0);
            rtn_tbl_put_field_type(v_field.rec, 0);
            rtn_tbl_put_field_data(v_field.rec, 0);
            rtn_tbl_put_field_dflt(v_field.rec, 0);
            rtn_tbl_put_field_use(v_field.rec, 0);
            rtn_tbl_put_field_position(v_field.rec, null);
            v_dbstate=1;
            rtn_tbl_put_field_table(v_field.rec, rtn_tbl_get_table_table(v_table.rec));
            rtn_tbl_put_field_name(v_field.rec, scpy(rtn_tbl_get_scan_value(v_fs.rec)));
            rtn_tbl_put_field_type(v_field.rec, scpy("string"));
            v_field=rtn_tbl_add_field(v_field);
            v_dbstate=0;
          }
        }
      }
    }
    else {
      if (scmp(rtn_tbl_get_scan_key(v_fs.rec), "type")==0 && v_nr>1) {
        if (scmp(rtn_tbl_get_field_type(v_field.rec), "string")!=0) {
          rtn_putwarning(scon(scon(scpy("Field '"), rtn_tbl_get_field_name(v_field.rec)), "' cannot have two types at once"));
        }
        else {
          if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_scan_value(v_fs.rec), 1))), "[")==0 && scmp((var2=snew(var2, rtn_right(rtn_tbl_get_scan_value(v_fs.rec), 1))), "]")==0) {
            v_field=rtn_cpyrecord(v_field, 9);
            v_dbstate=2;
            rtn_tbl_put_field_type(v_field.rec, scpy("enumerate"));
            rtn_tbl_put_field_data(v_field.rec, rtn_mid(rtn_tbl_get_scan_value(v_fs.rec), 2, rtn_length(rtn_tbl_get_scan_value(v_fs.rec))-2));
            v_dbstate=3;
            v_field=rtn_tbl_update_field(rtn_getrec(rtn_recalcptr(v_field, 14), 9));
            v_dbstate=0;
          }
          else {
            newptr(&v_actionget, 30, 0);
            v_actionget=rtn_tbl_search_actionget(scon(scpy("= "), rtn_tbl_get_scan_value(v_fs.rec)));
            while (1) {
              if ((v_actionget.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("= "), rtn_tbl_get_scan_value(v_fs.rec)))))>0))) {
                v_actionget=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_action_ident(v_actionget.rec), (var1=snew(var1, scon(scpy("= "), rtn_tbl_get_scan_value(v_fs.rec)))))==0) {
                break;
              }
              v_actionget=rtn_ptrplus1(v_actionget, 30);
            }
            if (v_actionget.branch!=-1) {
              v_field=rtn_cpyrecord(v_field, 9);
              v_dbstate=2;
              rtn_tbl_put_field_type(v_field.rec, scpy(rtn_tbl_get_scan_value(v_fs.rec)));
              v_dbstate=3;
              v_field=rtn_tbl_update_field(rtn_getrec(rtn_recalcptr(v_field, 14), 9));
              v_dbstate=0;
            }
            else {
              rtn_putwarning(scon(scon(scon(scon(scpy("Incorrect type '"), rtn_tbl_get_scan_value(v_fs.rec)), "' of field '"), rtn_tbl_get_field_name(v_field.rec)), "'"));
            }
          }
        }
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_fs.rec), "default")==0 && v_nr>1) {
          v_field=rtn_cpyrecord(v_field, 9);
          v_dbstate=2;
          rtn_tbl_put_field_dflt(v_field.rec, scpy(rtn_tbl_get_scan_value(v_fs.rec)));
          v_dbstate=3;
          v_field=rtn_tbl_update_field(rtn_getrec(rtn_recalcptr(v_field, 14), 9));
          v_dbstate=0;
        }
        else {
          if (scmp(rtn_tbl_get_scan_key(v_fs.rec), "use")==0 && v_nr>1) {
            v_field=rtn_cpyrecord(v_field, 9);
            v_dbstate=2;
            rtn_tbl_put_field_use(v_field.rec, scpy(rtn_tbl_get_scan_value(v_fs.rec)));
            v_dbstate=3;
            v_field=rtn_tbl_update_field(rtn_getrec(rtn_recalcptr(v_field, 14), 9));
            v_dbstate=0;
          }
          else {
            rtn_putwarning(scon(scon(scpy("Incorrect key '"), rtn_tbl_get_scan_key(v_fs.rec)), "' found in fields definition"));
          }
        }
      }
    }
    v_nr+=1;
    c_fs+=1;
    if (v_fs.branch==-1) {
      v_fs=rtn_getpointer(0, 0, 1);
    }
    else {
      v_fs=rtn_ptrplus1(v_fs, 1);
    }
  }
  rtn_do_scan(scpy("index table"));
  if (v_scantype!=1 && scmp(v_scantag, "index")!=0) {
    rtn_puterror(scpy("Every table should have a least a key index"));
    var1=snew(var1, 0);
    delptr(&v_s, 1);
    delptr(&v_table, 12);
    delptr(&v_fs, 1);
    delptr(&v_reserved, 34);
    delptr(&v_fn, 15);
    delptr(&v_field, 14);
    delptr(&v_actionget, 30);
    delptr(&v_si, 1);
    delptr(&v_index, 16);
    delptr(&v_ifd, 15);
    delptr(&v_ifield, 19);
    return var1;
  }
  while (1) {
    if (v_scantype!=1 && scmp(v_scantag, "index")!=0) {
      break;
    }
    v_nr=1;
    newptr(&v_si, 1, 0);
    c_si=1;
    v_si=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_si.branch==-1) {
        break;
      }
      if (scmp(rtn_tbl_get_scan_key(v_si.rec), "name")==0 && v_nr==1) {
        if (rtn_check_name(scpy(rtn_tbl_get_scan_value(v_si.rec)), scpy("new index name"))) {
          v_iname=snew(v_iname, scpy(rtn_tbl_get_scan_value(v_si.rec)));
        }
        else {
          var1=snew(var1, 0);
          delptr(&v_s, 1);
          delptr(&v_table, 12);
          delptr(&v_fs, 1);
          delptr(&v_reserved, 34);
          delptr(&v_fn, 15);
          delptr(&v_field, 14);
          delptr(&v_actionget, 30);
          delptr(&v_si, 1);
          delptr(&v_index, 16);
          delptr(&v_ifd, 15);
          delptr(&v_ifield, 19);
          return var1;
        }
      }
      else {
        v_iname=snew(v_iname, scpy(rtn_tbl_get_table_name(v_table.rec)));
      }
      if (v_nr==1) {
        newptr(&v_index, 16, 0);
        v_index=rtn_addrecord(10);
        rtn_tbl_put_index_index(v_index.rec, 0);
        rtn_tbl_put_index_table(v_index.rec, null);
        rtn_tbl_put_index_name(v_index.rec, 0);
        rtn_tbl_put_index_unique(v_index.rec, -1);
        rtn_tbl_put_index_complete(v_index.rec, -1);
        rtn_tbl_put_index_use(v_index.rec, 0);
        v_dbstate=1;
        rtn_tbl_put_index_table(v_index.rec, rtn_tbl_get_table_table(v_table.rec));
        rtn_tbl_put_index_name(v_index.rec, scpy(v_iname));
        rtn_tbl_put_index_unique(v_index.rec, 0);
        rtn_tbl_put_index_complete(v_index.rec, 0);
        v_index=rtn_tbl_add_index(v_index);
        v_dbstate=0;
      }
      if (scmp(rtn_tbl_get_scan_key(v_si.rec), "name")==0 && v_nr==1) {
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_si.rec), "fields")==0) {
          c_ifld=1;
          {int spp=0; if (v_ifld!=0) free(v_ifld); v_ifld=0; while (spp>=0) {if (spp<0) break; v_ifld=isep(&spp, rtn_tbl_get_scan_value(v_si.rec), " ");
            newptr(&v_ifd, 15, 0);
            v_ifd=rtn_tbl_search_fieldname(rtn_tbl_get_table_table(v_table.rec), 0);
            while (1) {
              if ((v_ifd.branch==-1) || ((rtn_tbl_get_field_table(v_ifd.rec)>rtn_tbl_get_table_table(v_table.rec)))) {
                v_ifd=rtn_nullpointer();
                break;
              }
              if (rtn_tbl_get_field_table(v_ifd.rec)==rtn_tbl_get_table_table(v_table.rec) && scmp(rtn_tbl_get_field_name(v_ifd.rec), v_ifld)==0) {
                break;
              }
              v_ifd=rtn_ptrplus1(v_ifd, 15);
            }
            if (v_ifd.branch!=-1) {
              newptr(&v_ifield, 19, 0);
              v_ifield=rtn_addrecord(11);
              rtn_tbl_put_ifield_index(v_ifield.rec, null);
              rtn_tbl_put_ifield_ifield(v_ifield.rec, 0);
              rtn_tbl_put_ifield_table(v_ifield.rec, null);
              rtn_tbl_put_ifield_field(v_ifield.rec, null);
              v_dbstate=1;
              rtn_tbl_put_ifield_table(v_ifield.rec, rtn_tbl_get_table_table(v_table.rec));
              rtn_tbl_put_ifield_index(v_ifield.rec, rtn_tbl_get_index_index(v_index.rec));
              rtn_tbl_put_ifield_field(v_ifield.rec, rtn_tbl_get_field_field(v_ifd.rec));
              v_ifield=rtn_tbl_add_ifield(v_ifield);
              v_dbstate=0;
            }
            else {
              rtn_putwarning(scon(scon(scpy("Unknown field '"), v_ifld), "' found in index definition"));
            }
            c_ifld+=1;
          }
        }}
        else {
          if (scmp(rtn_tbl_get_scan_key(v_si.rec), "doubles")==0 && v_nr>1) {
            v_index=rtn_cpyrecord(v_index, 10);
            v_dbstate=2;
            rtn_tbl_put_index_unique(v_index.rec, 1);
            v_dbstate=3;
            v_index=rtn_tbl_update_index(rtn_getrec(rtn_recalcptr(v_index, 16), 10));
            v_dbstate=0;
          }
          else {
            if (scmp(rtn_tbl_get_scan_key(v_si.rec), "complete")==0 && v_nr>1) {
              v_index=rtn_cpyrecord(v_index, 10);
              v_dbstate=2;
              rtn_tbl_put_index_complete(v_index.rec, 0);
              v_dbstate=3;
              v_index=rtn_tbl_update_index(rtn_getrec(rtn_recalcptr(v_index, 16), 10));
              v_dbstate=0;
            }
            else {
              if (scmp(rtn_tbl_get_scan_key(v_si.rec), "use")==0 && v_nr>1) {
                v_index=rtn_cpyrecord(v_index, 10);
                v_dbstate=2;
                rtn_tbl_put_index_use(v_index.rec, scpy(rtn_tbl_get_scan_value(v_si.rec)));
                v_dbstate=3;
                v_index=rtn_tbl_update_index(rtn_getrec(rtn_recalcptr(v_index, 16), 10));
                v_dbstate=0;
              }
              else {
                rtn_putwarning(scon(scon(scpy("Incorrect key '"), rtn_tbl_get_scan_key(v_si.rec)), "' found in index definition"));
              }
            }
          }
        }
      }
      v_nr+=1;
      c_si+=1;
      if (v_si.branch==-1) {
        v_si=rtn_getpointer(0, 0, 1);
      }
      else {
        v_si=rtn_ptrplus1(v_si, 1);
      }
    }
    rtn_do_scan(scpy("index table"));
  }
  if ((v_scantype!=2) || (scmp(v_scantag, "table")!=0)) {
    rtn_putwarning(scpy("Expected end tag of table"));
  }
  rtn_doc_table(rtn_tbl_get_table_table(v_table.rec));
  rtn_calc_table(rtn_tbl_get_table_table(v_table.rec));
  v_tf=rtn_create((var1=snew(var1, scon(scon(scpy("tbl_"), rtn_tbl_get_table_name(v_table.rec)), ".u"))));
  swrite((var1=snew(var1, rtn_tag("module title=\"Automatically generated module\""))), v_tf); wline(v_tf);
  rtn_write_fields(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_search(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_add(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_delete(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_update(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_clear(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_init(rtn_tbl_get_table_table(v_table.rec));
  rtn_write_store(rtn_tbl_get_table_table(v_table.rec));
  swrite((var1=snew(var1, rtn_tag("/module"))), v_tf); wline(v_tf);
  rtn_close(v_tf);
  var1=snew(var1, scon(scpy("tbl_"), rtn_tbl_get_table_name(v_table.rec)));
  delptr(&v_s, 1);
  delptr(&v_table, 12);
  delptr(&v_fs, 1);
  delptr(&v_reserved, 34);
  delptr(&v_fn, 15);
  delptr(&v_field, 14);
  delptr(&v_actionget, 30);
  delptr(&v_si, 1);
  delptr(&v_index, 16);
  delptr(&v_ifd, 15);
  delptr(&v_ifield, 19);
  return var1;
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_s, 1);
  delptr(&v_table, 12);
  delptr(&v_fs, 1);
  delptr(&v_reserved, 34);
  delptr(&v_fn, 15);
  delptr(&v_field, 14);
  delptr(&v_actionget, 30);
  delptr(&v_si, 1);
  delptr(&v_index, 16);
  delptr(&v_ifd, 15);
  delptr(&v_ifield, 19);
}
 
char *v_idxs=0;
char *v_extra=0;
char *v_till=0;
 
long int rtn_tbl_get_search_exp_ifield(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) return null;
  return *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+0);
}
 
void rtn_tbl_put_search_exp_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in filling field search_exp.ifield\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+0)=v_val;
}
 
void rtn_tbl_add_search_exp_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in adding to field search_exp.ifield\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+0)+=v_val;
}
 
void rtn_tbl_sub_search_exp_ifield(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("Error in subtraction from field search_exp.ifield\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+0)-=v_val;
}
 
long int rtn_tbl_get_search_exp_order(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) return 0;
  return *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+4);
}
 
void rtn_tbl_put_search_exp_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in filling field search_exp.order\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+4)=v_val;
}
 
void rtn_tbl_add_search_exp_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in adding to field search_exp.order\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+4)+=v_val;
}
 
void rtn_tbl_sub_search_exp_order(long int v_rec, long int v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("Error in subtraction from field search_exp.order\n");
    return;
  }
  *(long int*)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+4)-=v_val;
}
 
char *rtn_tbl_get_search_exp_expr(long int v_rec) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) return 0;
  return *(char**)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+8);
}
 
void rtn_tbl_put_search_exp_expr(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in filling field search_exp.expr\n");
    return;
  }
  *(char**)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+8)=v_val;
}
 
void rtn_tbl_add_search_exp_expr(long int v_rec, char *v_val) {
  
  if (v_rec<0 || v_rec>=u_table[27].len) {
    printf("error in adding to field search_exp.expr\n");
    return;
  }
  *(char**)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+8)= 
  sadd(*(char**)(u_table[27].ptr[v_rec/250]+(v_rec%250)*u_table[27].size+8), v_val);
}
 
struct pointer rtn_tbl_search_search_exp(long int v_p_ifield, long int v_p_order) {
  char v_level=0;
  long int v_curr=0;
  long int v_branch=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_ptr={-1, -1, -1};
  char v_brfnd=0;
  char v_nxt=0;
  newptr(&v_idx, 42, 1);
  newptr(&v_ptr, 42, 1);
  v_level=1;
  v_curr=-1;
  v_branch=-1;
  v_brfnd=0;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxbranch(42)+1);
    v_idx=rtn_getpointer(v_curr, 0, 42);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_ifield, rtn_tbl_get_search_exp_ifield(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_search_exp_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_branch=v_curr;
      v_ptr=v_idx;
    }
    if (v_nxt==0) {
      v_brfnd=1;
    }
    v_level+=1;
  }
  if (v_branch>0) {
    v_branch-=1;
  }
  if (v_branch==-1) {
    v_branch=rtn_maxbranch(42);
  }
  v_level=1;
  v_curr=-1;
  while (1) {
    v_curr=rtn_searchindex(v_curr, v_level, v_nxt, rtn_maxleaf(v_branch, 42)+1);
    v_idx=rtn_getpointer(v_branch, v_curr, 42);
    if ((v_curr==-1) || (v_idx.branch==-1)) {
      break;
    }
    v_nxt=0;
    v_nxt=rtn_check(v_p_ifield, rtn_tbl_get_search_exp_ifield(v_idx.rec));
    if (v_nxt==0) {
      v_nxt=rtn_check(v_p_order, rtn_tbl_get_search_exp_order(v_idx.rec));
    }
    if (v_nxt<=0) {
      v_ptr=v_idx;
    }
    v_level+=1;
  }
  if (v_brfnd && v_ptr.branch==-1) {
    v_ptr=rtn_getpointer(v_branch+1, 0, 42);
  }
  delptr(&v_idx, 42);
  delptr(&v_ptr, 42);
  return v_ptr;
  delptr(&v_idx, 42);
  delptr(&v_ptr, 42);
}
 
 
struct pointer rtn_tbl_add_search_exp(struct pointer v_new) {
  struct pointer v_idx_search_exp={-1, -1, -1};
  struct pointer v_last={-1, -1, -1};
  char *var1=0;
  newptr(&v_idx_search_exp, 42, 1);
  newptr(&v_last, 42, 1);
  rtn_tbl_put_search_exp_order(v_new.rec, 999999999);
  v_idx_search_exp=rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_new.rec), rtn_tbl_get_search_exp_order(v_new.rec));
  if (v_idx_search_exp.branch==-1) {
    v_last=rtn_getpointer(rtn_maxbranch(42), rtn_maxleaf(rtn_maxbranch(42), 42), 42);
  }
  else {
    v_last=rtn_ptrmin1(v_idx_search_exp, 42);
  }
  if ((v_last.branch==-1) || (rtn_tbl_get_search_exp_ifield(v_last.rec)!=rtn_tbl_get_search_exp_ifield(v_new.rec))) {
    rtn_tbl_put_search_exp_order(v_new.rec, 1);
  }
  else {
    rtn_tbl_put_search_exp_order(v_new.rec, rtn_tbl_get_search_exp_order(v_last.rec)+1);
  }
  rtn_addindex(v_idx_search_exp, rtn_tablelen(27)-1, 42);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("add search_exp(27):"), get_int(rtn_tbl_get_search_exp_ifield(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_search_exp_order(v_new.rec)))), "|"), rtn_tbl_get_search_exp_expr(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  if (v_last.branch==-1) {
    delptr(&v_new, 42);
    delptr(&v_idx_search_exp, 42);
    delptr(&v_last, 42);
    return rtn_getpointer(0, 0, 42);
  }
  delptr(&v_new, 42);
  delptr(&v_idx_search_exp, 42);
  delptr(&v_last, 42);
  return rtn_ptrplus1(v_last, 42);
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 42);
  delptr(&v_idx_search_exp, 42);
  delptr(&v_last, 42);
}
 
 
void rtn_tbl_delete_search_exp(long int v_delrec) {
  struct pointer v_last={-1, -1, -1};
  struct pointer v_chk={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  long int v_rec=0;
  newptr(&v_last, 42, 1);
  newptr(&v_chk, 42, 1);
  newptr(&v_del, 42, 1);
  v_del=rtn_getrecptr(v_delrec, 27);
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("delete search_exp(27):"), get_int(rtn_tbl_get_search_exp_ifield(v_del.rec))), "|"), scpy(get_sort(rtn_tbl_get_search_exp_order(v_del.rec)))), "|"), rtn_tbl_get_search_exp_expr(v_del.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  v_chk=rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_del.rec), rtn_tbl_get_search_exp_order(v_del.rec));
  rtn_deleteindex(v_chk, 42);
  v_chk=rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_del.rec), rtn_tbl_get_search_exp_order(v_del.rec)+1);
  rtn_tbl_put_search_exp_expr(v_del.rec, 0);
  if (rtn_getrec(v_del, 27)!=rtn_tablelen(27)-1) {
    v_last=rtn_getrecptr(rtn_tablelen(27)-1, 42);
    rtn_changeindex(rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_last.rec), rtn_tbl_get_search_exp_order(v_last.rec)), v_delrec, 42);
  }
  rtn_deleterecord(v_delrec, 27);
  if (v_chk.branch==-1) {
    delptr(&v_last, 42);
    delptr(&v_chk, 42);
    delptr(&v_del, 42);
    return;
  }
  v_chk=rtn_recalcptr(v_chk, 42);
  while (1) {
    if ((v_chk.branch==-1) || (rtn_tbl_get_search_exp_order(v_chk.rec)==1)) {
      break;
    }
    v_rec=rtn_getrec(v_chk, 27);
    rtn_tbl_sub_search_exp_order(v_chk.rec, 1);
    v_chk=rtn_ptrplus1(v_chk, 42);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_last, 42);
  delptr(&v_chk, 42);
  delptr(&v_del, 42);
}
 
 
struct pointer rtn_tbl_update_search_exp(long int v_rec) {
  struct pointer v_new={-1, -1, -1};
  struct pointer v_del={-1, -1, -1};
  char *var1=0;
  newptr(&v_new, 42, 1);
  newptr(&v_del, 42, 1);
  v_del=rtn_getrecptr(v_rec, 27);
  v_new=rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_del.rec), rtn_tbl_get_search_exp_order(v_del.rec));
  rtn_deleteindex(v_new, 42);
  rtn_deleterecord(v_rec, 27);
  rtn_addindex(rtn_tbl_search_search_exp(rtn_tbl_get_search_exp_ifield(v_new.rec), rtn_tbl_get_search_exp_order(v_new.rec)), rtn_getrec(v_new, 42), 42);
  if (v_new.branch==-1) {
    v_new=rtn_getpointer(0, 0, 27);
  }
  swrite((var1=snew(var1, scon(scon(scon(sadd(scon(sadd(scpy("update search_exp:"), get_int(rtn_tbl_get_search_exp_ifield(v_new.rec))), "|"), scpy(get_sort(rtn_tbl_get_search_exp_order(v_new.rec)))), "|"), rtn_tbl_get_search_exp_expr(v_new.rec)), "|"))), v_log); wline(v_log);
  rtn_flush(v_log);
  delptr(&v_new, 42);
  delptr(&v_del, 42);
  return v_new;
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_new, 42);
  delptr(&v_del, 42);
}
 
 
void rtn_tbl_clear_search_exp() {
  
  long int r=0;
  long int branch;
  while (r < u_table[27].len) {
    if (*(char**)(u_table[27].ptr[r/250]+(r%250)*u_table[27].size+8)!=0) {free(*(char**)(u_table[27].ptr[r/250]+(r%250)*u_table[27].size+8)); *(char**)(u_table[27].ptr[r/250]+(r%250)*u_table[27].size+8)=0;}
    r++;
  }
  free(u_table[27].ptr);
  u_table[27].ptr=0;
  u_table[27].len=0;
  for(branch=0; branch < u_index[42].scale; branch++)
  { free(u_index[42].ptr[branch]);
  }
  free(u_index[42].len);
  free(u_index[42].ptr);
  u_index[42].scale=0;
  u_index[42].len=0;
  u_index[42].ptr=0;
  fprintf(v_log, "clear search_exp(27)\n");
  fflush(v_log);
}
 
long int rtn_tbl_tablelength_search_exp() {
  
  return u_table[27].len;
}
 
void rtn_tbl_init_search_exp() {
  
  u_table[27].len=0;
  u_table[27].size=12;
  u_table[27].ptr=0;
  u_index[42].tbl=27;
  u_index[42].scale=0;
  u_index[42].len=0;
  u_index[42].ptr=0;
  u_index[42].ptrs=0;
  u_index[42].padm=0;
}
 
void rtn_tbl_write_search_exp(struct pointer v_ptr, FILE *v_stream) {
  newptr(&v_ptr, 42, 0);
  rtn_write(rtn_tbl_get_search_exp_ifield(v_ptr.rec), v_stream);
  rtn_write(rtn_tbl_get_search_exp_order(v_ptr.rec), v_stream);
  rtn_write(iscan(rtn_tbl_get_search_exp_expr(v_ptr.rec)), v_stream);
  delptr(&v_ptr, 42);
}
 
 
struct pointer rtn_tbl_read_search_exp(FILE *v_stream) {
  struct pointer v_new={-1, -1, -1};
  newptr(&v_new, 42, 0);
  v_new=rtn_addrecord(27);
  rtn_tbl_put_search_exp_ifield(v_new.rec, null);
  rtn_tbl_put_search_exp_order(v_new.rec, 0);
  rtn_tbl_put_search_exp_expr(v_new.rec, 0);
  v_dbstate=1;
  rtn_tbl_put_search_exp_ifield(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_search_exp_order(v_new.rec, rtn_read(v_stream));
  rtn_tbl_put_search_exp_expr(v_new.rec, rtn_gettext(rtn_readtext(v_stream)));
  v_new=rtn_tbl_add_search_exp(v_new);
  v_dbstate=0;
  delptr(&v_new, 42);
  return v_new;
  delptr(&v_new, 42);
}
 
 
void rtn_fillexpr(long int v_from, long int v_len, long int v_index) {
  long int v_chp=0;
  long int v_pos=0;
  long int v_tstf=0;
  long int v_level=0;
  long int v_etype=0;
  long int v_fpos=0;
  long int v_fps2=0;
  long int v_fnr=0;
  struct pointer v_cd={-1, -1, -1};
  struct pointer v_ac={-1, -1, -1};
  struct pointer v_vr={-1, -1, -1};
  char *var1=0;
  struct pointer v_ix={-1, -1, -1};
  struct pointer v_tb={-1, -1, -1};
  struct pointer v_fd={-1, -1, -1};
  struct pointer v_fx={-1, -1, -1};
  struct pointer v_se={-1, -1, -1};
  struct pointer v_fx2={-1, -1, -1};
  long int c_fx2=0;
  struct pointer v_ge={-1, -1, -1};
  rtn_tbl_clear_search_exp();
  v_pos=v_from;
  v_level=0;
  v_till=snew(v_till, 0);
  v_fnr=1;
  while (1) {
    if (v_pos==v_from+v_len) {
      break;
    }
    newptr(&v_cd, 33, 0);
    v_cd=rtn_tbl_search_code(v_croutine, -1, null);
    while (1) {
      if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_croutine))) {
        v_cd=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_code_routine(v_cd.rec)==v_croutine && rtn_tbl_get_code_kind(v_cd.rec)==1 && rtn_tbl_get_code_order(v_cd.rec)==v_pos) {
        break;
      }
      v_cd=rtn_ptrplus1(v_cd, 33);
    }
    if (!(v_cd.branch!=-1)) {
      break;
    }
    newptr(&v_ac, 29, 0);
    v_ac=rtn_tbl_search_action(rtn_tbl_get_code_action(v_cd.rec));
    while (1) {
      if ((v_ac.branch==-1) || ((rtn_tbl_get_action_action(v_ac.rec)>rtn_tbl_get_code_action(v_cd.rec)))) {
        v_ac=rtn_nullpointer();
        break;
      }
      if (rtn_tbl_get_action_action(v_ac.rec)==rtn_tbl_get_code_action(v_cd.rec)) {
        break;
      }
      v_ac=rtn_ptrplus1(v_ac, 29);
    }
    if (!(v_ac.branch!=-1)) {
      break;
    }
    if (v_etype==0) {
      v_fps2=v_pos;
    }
    if (v_etype==0 && scmp(rtn_tbl_get_action_ident(v_ac.rec), "variable pointer")==0) {
      newptr(&v_vr, 37, 0);
      v_vr=rtn_tbl_search_variable(0);
      while (1) {
        if (v_vr.branch==-1) {
          v_vr=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_variable_name(v_vr.rec), (var1=snew(var1, rtn_mid(rtn_tbl_get_code_par(v_cd.rec), 3, 999))))==0) {
          break;
        }
        v_vr=rtn_ptrplus1(v_vr, 37);
      }
      if (!(v_vr.branch!=-1)) {
        break;
      }
      newptr(&v_ix, 18, 0);
      v_ix=rtn_tbl_search_indexname(0);
      while (1) {
        if (v_ix.branch==-1) {
          v_ix=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_index_name(v_ix.rec), rtn_tbl_get_variable_data(v_vr.rec))==0) {
          break;
        }
        v_ix=rtn_ptrplus1(v_ix, 18);
      }
      if (!(v_ix.branch!=-1)) {
        break;
      }
      v_etype=1;
    }
    else {
      if (v_etype==1 && scmp(rtn_tbl_get_action_ident(v_ac.rec), "pointer -> number")==0) {
        v_etype=1;
      }
      else {
        if (v_etype==1 && scmp((var1=snew(var1, rtn_left(rtn_tbl_get_action_ident(v_ac.rec), 12))), "rtn_tbl_get_")==0) {
          v_tstf=iscan(rtn_tbl_get_code_data(v_cd.rec));
          v_chp=rtn_findstring(rtn_tbl_get_action_ident(v_ac.rec), "_", 13);
          newptr(&v_tb, 13, 0);
          v_tb=rtn_tbl_search_tablename(rtn_mid(rtn_tbl_get_action_ident(v_ac.rec), 13, v_chp-13));
          while (1) {
            if ((v_tb.branch==-1) || ((scmp(rtn_tbl_get_table_name(v_tb.rec), (var1=snew(var1, rtn_mid(rtn_tbl_get_action_ident(v_ac.rec), 13, v_chp-13))))>0))) {
              v_tb=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_table_name(v_tb.rec), (var1=snew(var1, rtn_mid(rtn_tbl_get_action_ident(v_ac.rec), 13, v_chp-13))))==0) {
              break;
            }
            v_tb=rtn_ptrplus1(v_tb, 13);
          }
          if (!(v_tb.branch!=-1)) {
            break;
          }
          newptr(&v_fd, 15, 0);
          v_fd=rtn_tbl_search_fieldname(null, 0);
          while (1) {
            if (v_fd.branch==-1) {
              v_fd=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_field_name(v_fd.rec), (var1=snew(var1, rtn_mid(rtn_tbl_get_action_ident(v_ac.rec), v_chp+1, 999))))==0) {
              break;
            }
            v_fd=rtn_ptrplus1(v_fd, 15);
          }
          if (!(v_fd.branch!=-1)) {
            break;
          }
          newptr(&v_fx, 19, 0);
          v_fx=rtn_tbl_search_ifield(v_index, v_fnr);
          while (1) {
            if ((v_fx.branch==-1) || ((rtn_tbl_get_ifield_index(v_fx.rec)>v_index && rtn_tbl_get_ifield_ifield(v_fx.rec)>v_fnr))) {
              v_fx=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_ifield_index(v_fx.rec)==v_index && rtn_tbl_get_ifield_ifield(v_fx.rec)==v_fnr && rtn_tbl_get_ifield_table(v_fx.rec)==rtn_tbl_get_index_table(v_ix.rec) && rtn_tbl_get_ifield_field(v_fx.rec)==rtn_tbl_get_field_field(v_fd.rec)) {
              break;
            }
            v_fx=rtn_ptrplus1(v_fx, 19);
          }
          if (!(v_fx.branch!=-1)) {
            break;
          }
          v_etype=2;
          v_level=1;
          v_fpos=v_pos;
          v_fnr+=1;
        }
        else {
          if (v_etype==2) {
            v_level-=rtn_tbl_get_action_parms(v_ac.rec);
            if (rtn_tbl_get_action_result(v_ac.rec)!=0) {
              v_level+=1;
            }
            if (v_level==1 && scmp(rtn_tbl_get_action_op(v_ac.rec), "->")!=0) {
              if (v_till!=0) {
                v_till=sadd(v_till, scpy(" and "));
              }
              newptr(&v_se, 42, 0);
              v_se=rtn_addrecord(27);
              rtn_tbl_put_search_exp_ifield(v_se.rec, null);
              rtn_tbl_put_search_exp_order(v_se.rec, 0);
              rtn_tbl_put_search_exp_expr(v_se.rec, 0);
              v_dbstate=1;
              rtn_tbl_put_search_exp_ifield(v_se.rec, rtn_tbl_get_ifield_ifield(v_fx.rec));
              if (scmp(rtn_tbl_get_action_op(v_ac.rec), "=")==0) {
                rtn_tbl_add_search_exp_expr(v_se.rec, rtn_original_expr(v_croutine, v_fpos+1, v_pos-1));
                v_till=sadd(v_till, sadd(scon(scon(scon(scpy(rtn_tbl_get_variable_name(v_vr.rec)), "."), rtn_tbl_get_field_name(v_fd.rec)), " > "), rtn_original_expr(v_croutine, v_fpos+1, v_pos-1)));
              }
              else {
                if (scmp(rtn_tbl_get_action_op(v_ac.rec), ">")==0) {
                  rtn_tbl_add_search_exp_expr(v_se.rec, rtn_original_expr(v_croutine, v_fpos+1, v_pos-1));
                }
                else {
                  if (scmp(rtn_tbl_get_action_op(v_ac.rec), ">=")==0) {
                    rtn_tbl_add_search_exp_expr(v_se.rec, rtn_original_expr(v_croutine, v_fpos+1, v_pos-1));
                  }
                  else {
                    if (scmp(rtn_tbl_get_action_op(v_ac.rec), "<=")==0) {
                      v_till=sadd(v_till, sadd(scon(scon(scon(scpy(rtn_tbl_get_variable_name(v_vr.rec)), "."), rtn_tbl_get_field_name(v_fd.rec)), " > "), rtn_original_expr(v_croutine, v_fpos+1, v_pos-1)));
                    }
                    else {
                      if (scmp(rtn_tbl_get_action_op(v_ac.rec), "<>")==0) {
                      }
                      else {
                        if (scmp(rtn_tbl_get_action_op(v_ac.rec), "<")==0) {
                          v_till=sadd(v_till, sadd(scon(scon(scon(scpy(rtn_tbl_get_variable_name(v_vr.rec)), "."), rtn_tbl_get_field_name(v_fd.rec)), " >= "), rtn_original_expr(v_croutine, v_fpos+1, v_pos-1)));
                        }
                      }
                    }
                  }
                }
              }
              v_se=rtn_tbl_add_search_exp(v_se);
              v_dbstate=0;
              v_etype=0;
            }
            else {
              if (v_fpos==v_pos-1 && scmp(rtn_tbl_get_action_op(v_ac.rec), "->")==0) {
                v_fpos=v_pos;
              }
            }
          }
          else {
            v_etype=0;
            v_level=0;
          }
        }
      }
    }
    v_pos+=1;
  }
  v_idxs=snew(v_idxs, 0);
  newptr(&v_fx2, 19, 0);
  c_fx2=1;
  v_fx2=rtn_tbl_search_ifield(v_index, null);
  while (1) {
    if ((v_fx2.branch==-1) || ((rtn_tbl_get_ifield_index(v_fx2.rec)>v_index))) {
      break;
    }
    if (rtn_tbl_get_ifield_index(v_fx2.rec)==v_index) {
      newptr(&v_ge, 42, 0);
      v_ge=rtn_tbl_search_search_exp(null, null);
      while (1) {
        if (v_ge.branch==-1) {
          v_ge=rtn_nullpointer();
          break;
        }
        if (rtn_tbl_get_search_exp_ifield(v_ge.rec)==rtn_tbl_get_ifield_ifield(v_fx2.rec) && rtn_tbl_get_search_exp_order(v_ge.rec)==1) {
          break;
        }
        v_ge=rtn_ptrplus1(v_ge, 42);
      }
      if (v_ge.branch!=-1) {
        if (v_idxs!=0) {
          v_idxs=sadd(v_idxs, scpy(", "));
        }
        v_idxs=sadd(v_idxs, scpy(rtn_tbl_get_search_exp_expr(v_ge.rec)));
      }
      else {
        if (v_idxs!=0) {
          v_idxs=sadd(v_idxs, scpy(", "));
        }
        v_idxs=sadd(v_idxs, scpy("null"));
      }
      c_fx2+=1;
    }
    if (v_fx2.branch==-1) {
      v_fx2=rtn_getpointer(0, 0, 19);
    }
    else {
      v_fx2=rtn_ptrplus1(v_fx2, 19);
    }
  }
  c_fx2-=1;
  v_extra=snew(v_extra, rtn_original_expr(v_croutine, v_from, v_from+v_len-1));
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_cd, 33);
  delptr(&v_ac, 29);
  delptr(&v_vr, 37);
  delptr(&v_ix, 18);
  delptr(&v_tb, 13);
  delptr(&v_fd, 15);
  delptr(&v_fx, 19);
  delptr(&v_se, 42);
  delptr(&v_fx2, 19);
  delptr(&v_ge, 42);
}
 
 
void rtn_db_search(char *v_index, long int v_from, long int v_len, long int v_level) {
  char *v_cd=0;
  char *v_ex=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_vr={-1, -1, -1};
  char *var1=0;
  struct pointer v_vfld={-1, -1, -1};
  v_cd=snew(v_cd, 0);
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    delptr(&v_vr, 37);
    delptr(&v_vfld, 37);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    delptr(&v_vr, 37);
    delptr(&v_vfld, 37);
    return;
  }
  newptr(&v_vr, 37, 0);
  v_vr=rtn_tbl_search_variable(0);
  while (1) {
    if (v_vr.branch==-1) {
      v_vr=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_variable_name(v_vr.rec), (var1=snew(var1, scon(scpy("c_"), v_cvarname))))==0) {
      break;
    }
    v_vr=rtn_ptrplus1(v_vr, 37);
  }
  if (!(v_vr.branch!=-1)) {
    rtn_addactioncode(scpy("define number"), 0, scon(scpy("c_"), v_cvarname), 0);
    newptr(&v_vfld, 37, 0);
    v_vfld=rtn_addrecord(22);
    rtn_tbl_put_variable_name(v_vfld.rec, 0);
    rtn_tbl_put_variable_kind(v_vfld.rec, -1);
    rtn_tbl_put_variable_type(v_vfld.rec, 0);
    rtn_tbl_put_variable_data(v_vfld.rec, 0);
    rtn_tbl_put_variable_claimed(v_vfld.rec, -1);
    rtn_tbl_put_variable_allowed(v_vfld.rec, -1);
    rtn_tbl_put_variable_usage(v_vfld.rec, -1);
    rtn_tbl_put_variable_use(v_vfld.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_variable_name(v_vfld.rec, scon(scpy("c_"), v_cvarname));
    rtn_tbl_put_variable_type(v_vfld.rec, scpy("number"));
    rtn_tbl_put_variable_usage(v_vfld.rec, 0);
    rtn_tbl_put_variable_kind(v_vfld.rec, 2);
    v_vfld=rtn_tbl_add_variable(v_vfld);
    v_dbstate=0;
  }
  rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
  rtn_addactioncode(scpy("= number"), 0, scon(scpy("c_"), v_cvarname), 0);
  if (v_len==0) {
    v_cd=sadd(v_cd, scon(scon(sadd(scon(scon(scpy("  "), v_cvarname), "=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
    v_cd=sadd(v_cd, scon(scpy("   loop"), rtn_char(10)));
    v_cd=sadd(v_cd, scon(scon(scon(scpy("     if "), v_cvarname), "=null then break endif"), rtn_char(10)));
    v_ex=snew(v_ex, scon(scon(scon(scpy("   "), v_cvarname), ".recnr+=1"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scon(scon(scpy("    if "), v_cvarname), "=null then"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scpy("      "), v_cvarname), "=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scpy("    else"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scon(scon(scpy("      "), v_cvarname), "=ptrplus1("), v_cvarname), ", "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scpy("    endif"), rtn_char(10)));
    v_ex=sadd(v_ex, scon(scpy("  do"), rtn_char(10)));
    rtn_insertextracode(scpy("next"), v_level+2, scpy(v_ex));
  }
  else {
    rtn_fillexpr(v_from, v_len, rtn_tbl_get_index_index(v_idx.rec));
    v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scon(scpy("  "), v_cvarname), "=tbl_search_"), v_index), "("), v_idxs), ")"));
    v_cd=sadd(v_cd, scon(scpy("  loop"), rtn_char(10)));
    if (v_till!=0) {
      v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scpy("    if "), v_cvarname), "=null or ("), v_till), ") then break endif"), rtn_char(10)));
    }
    else {
      v_cd=sadd(v_cd, scon(scon(scon(scpy("    if "), v_cvarname), "=null then break endif"), rtn_char(10)));
    }
    if (v_extra!=0) {
      v_cd=sadd(v_cd, scon(scon(scon(scpy("    if "), v_extra), " then"), rtn_char(10)));
      v_ex=snew(v_ex, scon(scon(scon(scpy("     "), v_cvarname), ".recnr+=1"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("    endif"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(scon(scpy("    if "), v_cvarname), "=null then"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scpy("      "), v_cvarname), "=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("    else"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scon(scon(scpy("      "), v_cvarname), "=ptrplus1("), v_cvarname), ", "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("    endif"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("  do"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(scon(scpy("  "), v_cvarname), ".recnr-=1"), rtn_char(10)));
      rtn_insertextracode(scpy("next"), v_level+3, scpy(v_ex));
    }
    else {
      v_ex=snew(v_ex, scon(scon(scon(scpy("   "), v_cvarname), ".recnr+=1"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(scon(scpy("    if "), v_cvarname), "=null then"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scpy("      "), v_cvarname), "=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("    else"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(sadd(scon(scon(scon(scon(scpy("      "), v_cvarname), "=ptrplus1("), v_cvarname), ", "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("    endif"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scpy("  do"), rtn_char(10)));
      v_ex=sadd(v_ex, scon(scon(scon(scpy("  "), v_cvarname), ".recnr-=1"), rtn_char(10)));
      rtn_insertextracode(scpy("next"), v_level+2, scpy(v_ex));
    }
  }
  rtn_addscancode(scpy(v_cd));
  if (var1!=0) {free(var1); var1=0;}
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
  delptr(&v_vr, 37);
  delptr(&v_vfld, 37);
}
 
 
void rtn_db_all() {
  FILE *v_g=0;
  char *var1=0;
  char *var2=0;
  struct pointer v_tbw={-1, -1, -1};
  long int c_tbw=0;
  struct pointer v_tchk={-1, -1, -1};
  struct pointer v_tbr={-1, -1, -1};
  long int c_tbr=0;
  v_g=rtn_create("global_definitions.u");
  swrite((var1=snew(var1, rtn_tag("module title=\"Global database routines for the current program\""))), v_g); wline(v_g);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scpy("routine name=\"tbl_write_all\" "), "parameter=\"stream\" type=\"stream\"")))))), v_g); wline(v_g);
  newptr(&v_tbw, 12, 0);
  c_tbw=1;
  v_tbw=rtn_tbl_search_table(null);
  while (1) {
    if (v_tbw.branch==-1) {
      break;
    }
    if (rtn_tbl_get_table_kind(v_tbw.rec)!=1) {
      swrite((var1=snew(var1, scon(scon(scpy("  write(tbl_tablelength_"), rtn_tbl_get_table_name(v_tbw.rec)), "(), stream)"))), v_g); wline(v_g);
      swrite((var1=snew(var1, sadd(scon(scon(scpy("  search "), rtn_tbl_get_table_name(v_tbw.rec)), " as t"), scpy(get_sort(rtn_tbl_get_table_table(v_tbw.rec)))))), v_g); wline(v_g);
      swrite((var1=snew(var1, scon(sadd(scon(scon(scpy("    tbl_write_"), rtn_tbl_get_table_name(v_tbw.rec)), "(t"), scpy(get_sort(rtn_tbl_get_table_table(v_tbw.rec)))), ", stream)"))), v_g); wline(v_g);
      swrite("  next", v_g); wline(v_g);
      c_tbw+=1;
    }
    if (v_tbw.branch==-1) {
      v_tbw=rtn_getpointer(0, 0, 12);
    }
    else {
      v_tbw=rtn_ptrplus1(v_tbw, 12);
    }
  }
  c_tbw-=1;
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_g); wline(v_g);
  swrite(" ", v_g); wline(v_g);
  swrite((var2=snew(var2, rtn_tag((var1=snew(var1, scon(scpy("routine name=\"tbl_read_all\" "), "parameter=\"stream\" type=\"stream\"")))))), v_g); wline(v_g);
  newptr(&v_tchk, 12, 0);
  v_tchk=rtn_tbl_search_table(null);
  while (1) {
    if (v_tchk.branch==-1) {
      v_tchk=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_kind(v_tchk.rec)!=1) {
      break;
    }
    v_tchk=rtn_ptrplus1(v_tchk, 12);
  }
  if (v_tchk.branch!=-1) {
    swrite("  var rec as number", v_g); wline(v_g);
    swrite("  var ptr as pointer", v_g); wline(v_g);
    newptr(&v_tbr, 12, 0);
    c_tbr=1;
    v_tbr=rtn_tbl_search_table(null);
    while (1) {
      if (v_tbr.branch==-1) {
        break;
      }
      if (rtn_tbl_get_table_kind(v_tbr.rec)!=1) {
        swrite("  rec=read(stream)", v_g); wline(v_g);
        swrite("  for num=1 to rec", v_g); wline(v_g);
        swrite((var1=snew(var1, scon(scon(scpy("    ptr=tbl_read_"), rtn_tbl_get_table_name(v_tbr.rec)), "(stream)"))), v_g); wline(v_g);
        swrite("  next", v_g); wline(v_g);
        c_tbr+=1;
      }
      if (v_tbr.branch==-1) {
        v_tbr=rtn_getpointer(0, 0, 12);
      }
      else {
        v_tbr=rtn_ptrplus1(v_tbr, 12);
      }
    }
    c_tbr-=1;
  }
  swrite((var1=snew(var1, rtn_tag("/routine"))), v_g); wline(v_g);
  swrite((var1=snew(var1, rtn_tag("/module"))), v_g); wline(v_g);
  rtn_close(v_g);
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_tbw, 12);
  delptr(&v_tchk, 12);
  delptr(&v_tbr, 12);
}
 
 
void rtn_db_init() {
  long int v_maxtable=0;
  long int v_maxindex=0;
  char *v_cd=0;
  struct pointer v_table={-1, -1, -1};
  long int c_table=0;
  struct pointer v_index={-1, -1, -1};
  long int c_index=0;
  struct pointer v_addt={-1, -1, -1};
  long int c_addt=0;
  v_maxtable=-1;
  newptr(&v_table, 12, 0);
  c_table=1;
  v_table=rtn_getpointer(0, 0, 12);
  while (1) {
    if (v_table.branch==-1) {
      break;
    }
    if (rtn_tbl_get_table_table(v_table.rec)>=v_maxtable) {
      v_maxtable=rtn_tbl_get_table_table(v_table.rec)+1;
    }
    c_table+=1;
    if (v_table.branch==-1) {
      v_table=rtn_getpointer(0, 0, 12);
    }
    else {
      v_table=rtn_ptrplus1(v_table, 12);
    }
  }
  newptr(&v_index, 16, 0);
  c_index=1;
  v_index=rtn_getpointer(0, 0, 16);
  while (1) {
    if (v_index.branch==-1) {
      break;
    }
    if (rtn_tbl_get_index_index(v_index.rec)>=v_maxindex) {
      v_maxindex=rtn_tbl_get_index_index(v_index.rec)+1;
    }
    c_index+=1;
    if (v_index.branch==-1) {
      v_index=rtn_getpointer(0, 0, 16);
    }
    else {
      v_index=rtn_ptrplus1(v_index, 16);
    }
  }
  if (v_maxtable!=-1) {
    v_cd=snew(v_cd, scon(scon(sadd(scon(sadd(scpy("  initdb("), get_int(v_maxtable)), ", "), get_int(v_maxindex)), ")"), rtn_char(10)));
  }
  newptr(&v_addt, 12, 0);
  c_addt=1;
  v_addt=rtn_getpointer(0, 0, 12);
  while (1) {
    if (v_addt.branch==-1) {
      break;
    }
    v_cd=sadd(v_cd, scon(scon(scon(scpy("  tbl_init_"), rtn_tbl_get_table_name(v_addt.rec)), "()"), rtn_char(10)));
    c_addt+=1;
    if (v_addt.branch==-1) {
      v_addt=rtn_getpointer(0, 0, 12);
    }
    else {
      v_addt=rtn_ptrplus1(v_addt, 12);
    }
  }
  if (v_cd!=0) {
    rtn_addscancode(scpy(v_cd));
  }
  delptr(&v_table, 12);
  delptr(&v_index, 16);
  delptr(&v_addt, 12);
}
 
 
void rtn_db_get(char *v_index, long int v_from, long int v_len) {
  char *v_cd=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  v_cd=snew(v_cd, 0);
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  if (v_len==0) {
    v_cd=sadd(v_cd, scon(scon(sadd(scon(scon(scpy("  "), v_cvarname), "=getpointer(0, 0, "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
  }
  else {
    rtn_fillexpr(v_from, v_len, rtn_tbl_get_index_index(v_idx.rec));
    v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scon(scpy("  "), v_cvarname), "=tbl_search_"), v_index), "("), v_idxs), ")"));
    if (v_extra!=0) {
      v_cd=sadd(v_cd, scon(scpy("  loop"), rtn_char(10)));
      if (v_till==0) {
        v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scpy("    if "), v_cvarname), "=null then "), v_cvarname), "=null break endif"), rtn_char(10)));
      }
      else {
        v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scon(scon(scpy("    if "), v_cvarname), "=null or ("), v_till), ") then "), v_cvarname), "=null break endif"), rtn_char(10)));
      }
      v_cd=sadd(v_cd, scon(scon(scon(scpy("    if "), v_extra), " then break endif"), rtn_char(10)));
      v_cd=sadd(v_cd, scon(scon(sadd(scon(scon(scon(scon(scpy("    "), v_cvarname), "=ptrplus1("), v_cvarname), ", "), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec)))), ")"), rtn_char(10)));
      v_cd=sadd(v_cd, scon(scpy("  do"), rtn_char(10)));
    }
    else {
      v_cd=sadd(v_cd, scon(scon(scon(scon(scon(scpy("  if ("), v_till), ") then "), v_cvarname), "=null endif"), rtn_char(10)));
    }
  }
  rtn_addscancode(scpy(v_cd));
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
}
 
 
void rtn_db_add(char *v_index) {
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  struct pointer v_fld={-1, -1, -1};
  long int c_fld=0;
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    delptr(&v_fld, 14);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    delptr(&v_fld, 14);
    return;
  }
  rtn_addactioncode(scpy("number"), 0, scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec))), 0);
  rtn_addactioncode(scpy("rtn_addrecord"), scpy("Cannot find add record routine"), 0, 0);
  rtn_addactioncode(scpy("= pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  newptr(&v_fld, 14, 0);
  c_fld=1;
  v_fld=rtn_tbl_search_field(rtn_tbl_get_table_table(v_tbl.rec), null);
  while (1) {
    if ((v_fld.branch==-1) || ((rtn_tbl_get_field_table(v_fld.rec)>rtn_tbl_get_table_table(v_tbl.rec)))) {
      break;
    }
    if (rtn_tbl_get_field_table(v_fld.rec)==rtn_tbl_get_table_table(v_tbl.rec)) {
      rtn_addactioncode(scpy("variable pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
      rtn_addactioncode(scpy("pointer -> number"), 0, 0, 0);
      rtn_addactioncode(scon(scpy("null "), rtn_tbl_get_field_type(v_fld.rec)), 0, 0, 0);
      rtn_addactioncode(scon(scon(scon(scpy("rtn_tbl_put_"), rtn_tbl_get_table_name(v_tbl.rec)), "_"), rtn_tbl_get_field_name(v_fld.rec)), scpy("Unknown type"), 0, 0);
      c_fld+=1;
    }
    if (v_fld.branch==-1) {
      v_fld=rtn_getpointer(0, 0, 14);
    }
    else {
      v_fld=rtn_ptrplus1(v_fld, 14);
    }
  }
  c_fld-=1;
  rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
  rtn_addactioncode(scpy("= number"), 0, scpy("v_dbstate"), 0);
  v_index=snew(v_index, scpy(v_index));
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
  delptr(&v_fld, 14);
}
 
 
void rtn_db_addupdate(char *v_index) {
  long int v_dummy=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  rtn_addactioncode(scpy("variable pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scon(scpy("rtn_tbl_add_"), rtn_tbl_get_table_name(v_tbl.rec)), scon(scon(scpy("Cannot find tbl_add_"), rtn_tbl_get_table_name(v_tbl.rec)), " routine"), 0, 0);
  rtn_addactioncode(scpy("= pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, scpy("0"), 0);
  rtn_addactioncode(scpy("= number"), 0, scpy("v_dbstate"), 0);
  v_dummy=v_dummy;
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
}
 
 
void rtn_db_edit(char *v_index) {
  struct pointer v_idx={-1, -1, -1};
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    return;
  }
  rtn_addactioncode(scpy("variable pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, get_int(rtn_tbl_get_index_table(v_idx.rec)), 0);
  rtn_addactioncode(scpy("rtn_cpyrecord"), scpy("Cannot find cpy record routine"), 0, 0);
  rtn_addactioncode(scpy("= pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, scpy("2"), 0);
  rtn_addactioncode(scpy("= number"), 0, scpy("v_dbstate"), 0);
  v_index=snew(v_index, scpy(v_index));
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
}
 
 
void rtn_db_editupdate(char *v_index) {
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  rtn_addactioncode(scpy("number"), 0, scpy("3"), 0);
  rtn_addactioncode(scpy("= number"), 0, scpy("v_dbstate"), 0);
  rtn_addactioncode(scpy("variable pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec))), 0);
  rtn_addactioncode(scpy("rtn_recalcptr"), 0, 0, 0);
  rtn_addactioncode(scpy("number"), 0, get_int(rtn_tbl_get_index_table(v_idx.rec)), 0);
  rtn_addactioncode(scpy("rtn_getrec"), 0, 0, 0);
  rtn_addactioncode(scon(scpy("rtn_tbl_update_"), rtn_tbl_get_table_name(v_tbl.rec)), 0, 0, 0);
  rtn_addactioncode(scpy("= pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, scpy("0"), 0);
  rtn_addactioncode(scpy("= number"), 0, scpy("v_dbstate"), 0);
  v_index=snew(v_index, scpy(v_index));
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
}
 
 
void rtn_db_delete() {
  long int v_v=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_cdata)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  rtn_addactioncode(scpy("variable pointer"), 0, scon(scpy("v_"), v_cvarname), 0);
  rtn_addactioncode(scpy("number"), 0, scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec))), 0);
  rtn_addactioncode(scpy("rtn_getrec"), 0, 0, 0);
  rtn_addactioncode(scon(scpy("rtn_tbl_delete_"), rtn_tbl_get_table_name(v_tbl.rec)), 0, 0, 0);
  v_v=v_v;
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
}
 
 
void rtn_db_clear(char *v_index) {
  long int v_v=0;
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_tbl={-1, -1, -1};
  newptr(&v_idx, 18, 0);
  v_idx=rtn_tbl_search_indexname(0);
  while (1) {
    if (v_idx.branch==-1) {
      v_idx=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_index)==0) {
      break;
    }
    v_idx=rtn_ptrplus1(v_idx, 18);
  }
  if (!(v_idx.branch!=-1)) {
    rtn_puterror(scpy("Cannot find index"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  newptr(&v_tbl, 12, 0);
  v_tbl=rtn_tbl_search_table(rtn_tbl_get_index_table(v_idx.rec));
  while (1) {
    if ((v_tbl.branch==-1) || ((rtn_tbl_get_table_table(v_tbl.rec)>rtn_tbl_get_index_table(v_idx.rec)))) {
      v_tbl=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_table_table(v_tbl.rec)==rtn_tbl_get_index_table(v_idx.rec)) {
      break;
    }
    v_tbl=rtn_ptrplus1(v_tbl, 12);
  }
  if (!(v_tbl.branch!=-1)) {
    rtn_puterror(scpy("Cannot find table"));
    if (v_index!=0) {free(v_index); v_index=0;}
    delptr(&v_idx, 18);
    delptr(&v_tbl, 12);
    return;
  }
  rtn_addactioncode(scpy("number"), 0, scpy(get_sort(rtn_tbl_get_table_table(v_tbl.rec))), 0);
  rtn_addactioncode(scon(scpy("rtn_tbl_clear_"), rtn_tbl_get_table_name(v_tbl.rec)), 0, 0, 0);
  v_v=v_v;
  if (v_index!=0) {free(v_index); v_index=0;}
  delptr(&v_idx, 18);
  delptr(&v_tbl, 12);
}
 
 
void rtn_show_routines() {
  char *v_str=0;
  struct pointer v_routine={-1, -1, -1};
  long int c_routine=0;
  char *var1=0;
  struct pointer v_parameter={-1, -1, -1};
  long int c_parameter=0;
  newptr(&v_routine, 6, 0);
  c_routine=1;
  v_routine=rtn_getpointer(0, 0, 6);
  while (1) {
    if (v_routine.branch==-1) {
      break;
    }
    swrite((var1=snew(var1, scon(scon(scon(scon(sadd(scpy("Routine "), scpy(get_sort(rtn_tbl_get_routine_order(v_routine.rec)))), " "), rtn_tbl_get_routine_module(v_routine.rec)), " "), rtn_tbl_get_routine_name(v_routine.rec)))), stdout); wline(stdout);
    swrite((var1=snew(var1, scon(scon(sadd(scon(sadd(scpy(" ("), get_enum(rtn_tbl_get_routine_type(v_routine.rec), "normal system special header")), "/"), get_enum(rtn_tbl_get_routine_kind(v_routine.rec), "public local")), ")"), rtn_tbl_get_routine_function(v_routine.rec)))), stdout); wline(stdout);
    swrite((var1=snew(var1, scon(scpy(" "), rtn_tbl_get_routine_use(v_routine.rec)))), stdout); wline(stdout);
    newptr(&v_parameter, 9, 0);
    c_parameter=1;
    v_parameter=rtn_tbl_search_parameter(rtn_tbl_get_routine_order(v_routine.rec), null);
    while (1) {
      if ((v_parameter.branch==-1) || ((rtn_tbl_get_parameter_routine(v_parameter.rec)>rtn_tbl_get_routine_order(v_routine.rec)))) {
        break;
      }
      if (rtn_tbl_get_parameter_routine(v_parameter.rec)==rtn_tbl_get_routine_order(v_routine.rec)) {
        v_str=snew(v_str, scpy(rtn_tbl_get_parameter_type(v_parameter.rec)));
        if (rtn_tbl_get_parameter_data(v_parameter.rec)!=0) {
          v_str=sadd(v_str, scon(scon(scpy("["), rtn_tbl_get_parameter_data(v_parameter.rec)), "] "));
        }
        if (rtn_tbl_get_parameter_defaultvalue(v_parameter.rec)!=0) {
          v_str=sadd(v_str, scon(scon(scpy("default: '"), rtn_tbl_get_parameter_defaultvalue(v_parameter.rec)), "' "));
        }
        swrite((var1=snew(var1, scon(scon(scon(scon(scpy(rtn_tbl_get_parameter_name(v_parameter.rec)), ": "), v_str), " "), rtn_tbl_get_parameter_use(v_parameter.rec)))), stdout); wline(stdout);
        c_parameter+=1;
      }
      if (v_parameter.branch==-1) {
        v_parameter=rtn_getpointer(0, 0, 9);
      }
      else {
        v_parameter=rtn_ptrplus1(v_parameter, 9);
      }
    }
    c_parameter-=1;
    if (rtn_tbl_get_routine_returntype(v_routine.rec)!=0) {
      v_str=snew(v_str, scpy(rtn_tbl_get_routine_returntype(v_routine.rec)));
      if (rtn_tbl_get_routine_returndata(v_routine.rec)!=0) {
        v_str=sadd(v_str, scon(scon(scpy("["), rtn_tbl_get_routine_returndata(v_routine.rec)), "] "));
      }
      swrite((var1=snew(var1, scon(scon(scon(scpy("returns: "), v_str), " "), rtn_tbl_get_routine_returnuse(v_routine.rec)))), stdout); wline(stdout);
    }
    swrite(" ", stdout); wline(stdout);
    c_routine+=1;
    if (v_routine.branch==-1) {
      v_routine=rtn_getpointer(0, 0, 6);
    }
    else {
      v_routine=rtn_ptrplus1(v_routine, 6);
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_routine, 6);
  delptr(&v_parameter, 9);
}
 
 
void rtn_scan_options() {
  struct pointer v_o={-1, -1, -1};
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  if (v_scantype==3 && scmp(v_scantag, "option")==0) {
    v_tagfound=1;
    newptr(&v_o, 4, 0);
    v_o=rtn_addrecord(3);
    rtn_tbl_put_options_option(v_o.rec, 0);
    rtn_tbl_put_options_value(v_o.rec, 0);
    v_dbstate=1;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "name")==0) {
        rtn_tbl_put_options_option(v_o.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
      }
      else {
        if (scmp(rtn_tbl_get_scan_key(v_s.rec), "value")==0) {
          rtn_tbl_put_options_value(v_o.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
        }
      }
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
    v_o=rtn_tbl_add_options(v_o);
    v_dbstate=0;
    rtn_doc_def(0, 0, 0);
    rtn_doc_def(scpy("option"), scpy(rtn_tbl_get_options_option(v_o.rec)), scpy(rtn_tbl_get_options_value(v_o.rec)));
    rtn_doc_def(0, 0, 0);
  }
  delptr(&v_o, 4);
  delptr(&v_s, 1);
}
 
 
char *rtn_test_option(char *v_option, char *v_default) {
  struct pointer v_o={-1, -1, -1};
  char *var1=0;
  newptr(&v_o, 4, 0);
  v_o=rtn_tbl_search_options(scpy(v_option));
  while (1) {
    if ((v_o.branch==-1) || ((scmp(rtn_tbl_get_options_option(v_o.rec), v_option)>0))) {
      v_o=rtn_nullpointer();
      break;
    }
    if (scmp(rtn_tbl_get_options_option(v_o.rec), v_option)==0) {
      break;
    }
    v_o=rtn_ptrplus1(v_o, 4);
  }
  if (v_o.branch!=-1) {
    var1=snew(var1, scpy(rtn_tbl_get_options_value(v_o.rec)));
    if (v_option!=0) {free(v_option); v_option=0;}
    if (v_default!=0) {free(v_default); v_default=0;}
    delptr(&v_o, 4);
    return var1;
  }
  else {
    var1=snew(var1, scpy(v_default));
    if (v_option!=0) {free(v_option); v_option=0;}
    if (v_default!=0) {free(v_default); v_default=0;}
    delptr(&v_o, 4);
    return var1;
  }
  if (v_option!=0) {free(v_option); v_option=0;}
  if (v_default!=0) {free(v_default); v_default=0;}
  delptr(&v_o, 4);
}
 
 
void rtn_doc_code(long int v_routine) {
  char *v_str=0;
  struct pointer v_code={-1, -1, -1};
  struct pointer v_cd={-1, -1, -1};
  long int c_cd=0;
  struct pointer v_ca={-1, -1, -1};
  char *var1=0;
  struct pointer v_fc={-1, -1, -1};
  newptr(&v_code, 33, 0);
  v_code=rtn_tbl_search_code(v_routine, -1, null);
  while (1) {
    if ((v_code.branch==-1) || ((rtn_tbl_get_code_routine(v_code.rec)>v_routine))) {
      v_code=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_code_routine(v_code.rec)==v_routine) {
      break;
    }
    v_code=rtn_ptrplus1(v_code, 33);
  }
  if (v_code.branch!=-1) {
    rtn_doc_def(rtn_notag("Internal code"), 0, 0);
  }
  newptr(&v_cd, 33, 0);
  c_cd=1;
  v_cd=rtn_tbl_search_code(v_routine, -1, null);
  while (1) {
    if ((v_cd.branch==-1) || ((rtn_tbl_get_code_routine(v_cd.rec)>v_routine))) {
      break;
    }
    if (rtn_tbl_get_code_routine(v_cd.rec)==v_routine) {
      newptr(&v_ca, 29, 0);
      v_ca=rtn_tbl_search_action(rtn_tbl_get_code_action(v_cd.rec));
      while (1) {
        if ((v_ca.branch==-1) || ((rtn_tbl_get_action_action(v_ca.rec)>rtn_tbl_get_code_action(v_cd.rec)))) {
          v_ca=rtn_nullpointer();
          break;
        }
        if (rtn_tbl_get_action_action(v_ca.rec)==rtn_tbl_get_code_action(v_cd.rec)) {
          break;
        }
        v_ca=rtn_ptrplus1(v_ca, 29);
      }
      if (v_ca.branch!=-1) {
        v_str=snew(v_str, 0);
        if (rtn_tbl_get_code_par(v_cd.rec)!=0) {
          v_str=snew(v_str, rtn_notag((var1=snew(var1, scon(scon(scpy("par: '"), rtn_tbl_get_code_par(v_cd.rec)), "'  ")))));
        }
        if (rtn_tbl_get_code_data(v_cd.rec)!=0) {
          v_str=sadd(v_str, rtn_notag((var1=snew(var1, scon(scon(scpy("data: '"), rtn_tbl_get_code_data(v_cd.rec)), "'  ")))));
        }
        if (rtn_tbl_get_code_block(v_cd.rec)!=0 && rtn_tbl_get_code_block(v_cd.rec)!=null) {
          v_str=sadd(v_str, rtn_notag((var1=snew(var1, scon(sadd(scpy("block: "), get_int(rtn_tbl_get_code_block(v_cd.rec))), "  ")))));
        }
        rtn_doc_def(rtn_notag((var1=snew(var1, scon(scon(scpy(get_sort(rtn_tbl_get_code_order(v_cd.rec))), ": "), rtn_tbl_get_action_ident(v_ca.rec))))), scpy(v_str), 0);
      }
      c_cd+=1;
    }
    if (v_cd.branch==-1) {
      v_cd=rtn_getpointer(0, 0, 33);
    }
    else {
      v_cd=rtn_ptrplus1(v_cd, 33);
    }
  }
  c_cd-=1;
  newptr(&v_fc, 33, 0);
  v_fc=rtn_tbl_search_code(v_routine, -1, null);
  while (1) {
    if ((v_fc.branch==-1) || ((rtn_tbl_get_code_routine(v_fc.rec)>v_routine))) {
      v_fc=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_code_routine(v_fc.rec)==v_routine) {
      break;
    }
    v_fc=rtn_ptrplus1(v_fc, 33);
  }
  if (v_fc.branch!=-1) {
    rtn_doc_def(0, 0, 0);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_code, 33);
  delptr(&v_cd, 33);
  delptr(&v_ca, 29);
  delptr(&v_fc, 33);
}
 
 
void rtn_doc_routine() {
  char *v_str=0;
  struct pointer v_routine={-1, -1, -1};
  char *var1=0;
  char *var2=0;
  struct pointer v_parameter={-1, -1, -1};
  long int c_parameter=0;
  newptr(&v_routine, 6, 0);
  v_routine=rtn_tbl_search_routine(v_croutine);
  while (1) {
    if ((v_routine.branch==-1) || ((rtn_tbl_get_routine_order(v_routine.rec)>v_croutine))) {
      v_routine=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_routine_order(v_routine.rec)==v_croutine) {
      break;
    }
    v_routine=rtn_ptrplus1(v_routine, 6);
  }
  if ((!(v_routine.branch!=-1)) || (rtn_tbl_get_routine_kind(v_routine.rec)==1)) {
    delptr(&v_routine, 6);
    delptr(&v_parameter, 9);
    return;
  }
  rtn_doc_def(scpy("Routine"), sadd(sadd(sadd(scon(sadd(sadd(rtn_tag("b"), rtn_tag((var1=snew(var1, scon(scon(scpy("A name=\""), rtn_tbl_get_routine_function(v_routine.rec)), "\""))))), rtn_tag((var2=snew(var2, scon(scon(scon(scon(scpy("A href=\""), rtn_tbl_get_routine_module(v_routine.rec)), ".u.html#"), rtn_tbl_get_routine_function(v_routine.rec)), "\""))))), rtn_tbl_get_routine_name(v_routine.rec)), rtn_tag("/A")), rtn_tag("/A")), rtn_tag("/b")), scpy(rtn_tbl_get_routine_use(v_routine.rec)));
  newptr(&v_parameter, 9, 0);
  c_parameter=1;
  v_parameter=rtn_tbl_search_parameter(rtn_tbl_get_routine_order(v_routine.rec), null);
  while (1) {
    if ((v_parameter.branch==-1) || ((rtn_tbl_get_parameter_routine(v_parameter.rec)>rtn_tbl_get_routine_order(v_routine.rec)))) {
      break;
    }
    if (rtn_tbl_get_parameter_routine(v_parameter.rec)==rtn_tbl_get_routine_order(v_routine.rec)) {
      v_str=snew(v_str, scpy(rtn_tbl_get_parameter_type(v_parameter.rec)));
      if (rtn_tbl_get_parameter_data(v_parameter.rec)!=0) {
        v_str=sadd(v_str, scon(scon(scpy("["), rtn_tbl_get_parameter_data(v_parameter.rec)), "] "));
      }
      if (rtn_tbl_get_parameter_defaultvalue(v_parameter.rec)!=0) {
        v_str=sadd(v_str, scon(scon(scpy("default: '"), rtn_tbl_get_parameter_defaultvalue(v_parameter.rec)), "' "));
      }
      rtn_doc_def(scon(rtn_notag("    "), rtn_tbl_get_parameter_name(v_parameter.rec)), scpy(v_str), scpy(rtn_tbl_get_parameter_use(v_parameter.rec)));
      c_parameter+=1;
    }
    if (v_parameter.branch==-1) {
      v_parameter=rtn_getpointer(0, 0, 9);
    }
    else {
      v_parameter=rtn_ptrplus1(v_parameter, 9);
    }
  }
  c_parameter-=1;
  if (rtn_tbl_get_routine_returntype(v_routine.rec)!=0) {
    v_str=snew(v_str, scpy(rtn_tbl_get_routine_returntype(v_routine.rec)));
    if (rtn_tbl_get_routine_returndata(v_routine.rec)!=0) {
      v_str=sadd(v_str, scon(scon(scpy("["), rtn_tbl_get_routine_returndata(v_routine.rec)), "] "));
    }
    rtn_doc_def(sadd(sadd(rtn_tag("i"), rtn_notag("    returns:")), rtn_tag("/i")), scpy(v_str), scpy(rtn_tbl_get_routine_returnuse(v_routine.rec)));
  }
  rtn_doc_def(0, 0, 0);
  if (scmp((var1=snew(var1, rtn_test_option(scpy("internal_code"), scpy("no")))), "yes")==0) {
    rtn_doc_code(v_croutine);
  }
  if (var1!=0) {free(var1); var1=0;}
  if (var2!=0) {free(var2); var2=0;}
  delptr(&v_routine, 6);
  delptr(&v_parameter, 9);
}
 
 
void rtn_instructions(long int v_level) {
  char *v_foundkeyword=0;
  char *v_foundvariable=0;
  long int v_foundlast=0;
  char *v_foundtbl=0;
  char *v_foundfld=0;
  char *v_foundtp=0;
  char *v_founddata=0;
  long int v_tel=0;
  char v_isline=0;
  long int v_ilevel=0;
  char v_firstloop=0;
  struct pointer v_vc={-1, -1, -1};
  struct pointer v_svar={-1, -1, -1};
  struct pointer v_v={-1, -1, -1};
  char *var1=0;
  struct pointer v_v1={-1, -1, -1};
  struct pointer v_v2={-1, -1, -1};
  struct pointer v_vc2={-1, -1, -1};
  struct pointer v_vfld={-1, -1, -1};
  struct pointer v_rr={-1, -1, -1};
  struct pointer v_rfr={-1, -1, -1};
  struct pointer v_e={-1, -1, -1};
  while (1) {
    v_conversionvar=1;
    v_ctype=snew(v_ctype, 0);
    v_cdata=snew(v_cdata, 0);
    if (v_keyword==0) {
      break;
    }
    else {
      if (scmp(v_keyword, "if")==0) {
        rtn_scankeyword();
        rtn_expression(scpy("boolean"), 0);
        v_ilevel=0;
        rtn_addactioncode(scpy("if"), scpy("Cannot find definition of if"), 0, 0);
        rtn_storecode();
        if (scmp(v_keyword, "then")!=0) {
          rtn_putwarning(scpy("Expecting 'then' in an 'if' statement"));
        }
        else {
          rtn_scankeyword();
        }
        rtn_instructions(v_level+1);
        rtn_endblockcode();
        while (1) {
          if (scmp(v_keyword, "elsif")!=0) {
            break;
          }
          rtn_scankeyword();
          rtn_addactioncode(scpy("else"), scpy("Cannot find definition of else"), 0, 0);
          rtn_storecode();
          v_ilevel+=1;
          rtn_expression(scpy("boolean"), 0);
          rtn_addactioncode(scpy("if"), scpy("Cannot find definition of if"), 0, 0);
          rtn_storecode();
          if (scmp(v_keyword, "then")!=0) {
            rtn_putwarning(scpy("Expecting 'then' behind 'elsif' in an 'if' statement"));
          }
          else {
            rtn_scankeyword();
          }
          rtn_instructions(v_level+1);
          rtn_endblockcode();
        }
        if (scmp(v_keyword, "else")==0) {
          rtn_scankeyword();
          rtn_addactioncode(scpy("else"), scpy("Cannot find definition of else"), 0, 0);
          rtn_storecode();
          rtn_instructions(v_level+1);
          rtn_endblockcode();
        }
        while (1) {
          if (v_ilevel==0) {
            break;
          }
          rtn_endblockcode();
          v_ilevel-=1;
        }
        if (scmp(v_keyword, "endif")!=0) {
          rtn_putwarning(scpy("Expecting 'endif' at the end of an 'if' statement"));
        }
        else {
          rtn_scankeyword();
        }
      }
      else {
        if (scmp(v_keyword, "case")==0) {
          rtn_scankeyword();
          rtn_expression(0, 0);
          v_foundtp=snew(v_foundtp, scpy(v_ctype));
          v_founddata=snew(v_founddata, scpy(v_cdata));
          if ((scmp(v_ctype, "string")==0) || (scmp(v_ctype, "constr")==0)) {
            rtn_puterror(scpy("Case not yet defined for strings use 'if'/'elsif'/'else'/'endif' meanwhile"));
            break;
          }
          rtn_addactioncode(scpy("case"), scpy("Could not find definition of case"), 0, 0);
          rtn_storecode();
          v_firstloop=1;
          while (1) {
            if (((scmp(v_keyword, "endcase")==0) || (scmp(v_keyword, "otherwise")==0)) || (v_keyword==0)) {
              break;
            }
            rtn_instructions(v_level+1);
            if (scmp(v_keyword, "when")==0) {
              rtn_scankeyword();
              if (scmp(((v_firstloop)?"true":"false"), ((1)?"true":"false"))==0) {
                v_firstloop=0;
              }
              else {
                rtn_addactioncode(scpy("break"), scpy("Could not find definition of break"), 0, 0);
              }
              rtn_expression(scpy(v_foundtp), scpy(v_founddata));
              rtn_addactioncode(scpy("when"), scpy("Could not find definition of when"), 0, 0);
              while (1) {
                if (scmp(v_keyword, ",")!=0) {
                  break;
                }
                rtn_scankeyword();
                rtn_expression(scpy(v_foundtp), scpy(v_founddata));
                rtn_addactioncode(scpy("when"), scpy("Could not find definition of when"), 0, 0);
              }
            }
          }
          if (scmp(v_keyword, "otherwise")==0) {
            rtn_scankeyword();
            rtn_addactioncode(scpy("otherwise"), scpy("Could not find definition of otherwise"), 0, 0);
            rtn_instructions(v_level+1);
          }
          if (scmp(v_keyword, "endcase")==0) {
            rtn_scankeyword();
          }
          else {
            rtn_putwarning(scpy("Expecting endcase at the end of a case statement"));
          }
          rtn_endblockcode();
        }
        else {
          if (scmp(v_keyword, "var")==0) {
            rtn_scankeyword();
            rtn_new_variable();
          }
          else {
            if (scmp(v_keyword, "output")==0) {
              v_isline=1;
              rtn_scankeyword();
              rtn_expression(scpy("constr"), 0);
              if (scmp(v_keyword, ";")==0) {
                v_isline=0;
                rtn_scankeyword();
              }
              if (scmp(v_keyword, "to")==0) {
                rtn_scankeyword();
                if (scmp(v_keyword, ";")==0) {
                  v_isline=0;
                  rtn_scankeyword();
                }
                rtn_expression(scpy("stream"), 0);
                if (scmp(v_keyword, ";")==0) {
                  v_isline=0;
                  rtn_scankeyword();
                }
                if (v_isline) {
                  rtn_addactioncode(scpy("foutput"), 0, 0, 0);
                }
                else {
                  rtn_addactioncode(scpy("fsoutput"), 0, 0, 0);
                }
              }
              else {
                if (v_isline) {
                  rtn_addactioncode(scpy("output"), 0, 0, 0);
                }
                else {
                  rtn_addactioncode(scpy("soutput"), 0, 0, 0);
                }
              }
            }
            else {
              if (scmp(v_keyword, "loop")==0) {
                rtn_addactioncode(scpy("loop"), 0, 0, 0);
                rtn_storecode();
                rtn_scankeyword();
                rtn_instructions(v_level+1);
                rtn_endblockcode();
                if (scmp(v_keyword, "do")!=0) {
                  rtn_putwarning(scpy("Expecting 'do' at the end of a 'loop' statement"));
                }
                else {
                  rtn_scankeyword();
                }
              }
              else {
                if (scmp(v_keyword, "separate")==0) {
                  rtn_scankeyword();
                  rtn_expression(scpy("constr"), 0);
                  if (scmp(v_keyword, "as")!=0) {
                    rtn_putwarning(scpy("Expecting 'as' in a separate statement"));
                  }
                  else {
                    rtn_scankeyword();
                  }
                  if (rtn_find_variable()) {
                    v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                    if (scmp(v_ctype, "string")!=0) {
                      rtn_puterror(scon(scon(scpy("Variable '"), v_ctype), "' inside separate statement is not of string type"));
                    }
                    else {
                      if (v_cdbfld!=0) {
                        rtn_puterror(scpy("Cannot use database fields in separate statement"));
                      }
                    }
                    newptr(&v_vc, 37, 0);
                    v_vc=rtn_tbl_search_variable(0);
                    while (1) {
                      if (v_vc.branch==-1) {
                        v_vc=rtn_nullpointer();
                        break;
                      }
                      if (scmp(rtn_tbl_get_variable_name(v_vc.rec), v_foundvariable)==0) {
                        break;
                      }
                      v_vc=rtn_ptrplus1(v_vc, 37);
                    }
                    v_vc=rtn_cpyrecord(v_vc, 22);
                    v_dbstate=2;
                    rtn_tbl_put_variable_data(v_vc.rec, scpy("separate"));
                    v_dbstate=3;
                    v_vc=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_vc, 37), 22));
                    v_dbstate=0;
                  }
                  else {
                    if (rtn_check_name(scpy(v_keyword), scpy("separate variable"))) {
                      rtn_addactioncode(scpy("define string"), scon(scpy("Cannot find definition of type "), v_ctype), scon(scpy("v_"), v_keyword), 0);
                      rtn_addactioncode(scpy("define number"), 0, scon(scpy("c_"), v_keyword), 0);
                      v_foundvariable=snew(v_foundvariable, scpy(v_keyword));
                      newptr(&v_svar, 37, 0);
                      v_svar=rtn_addrecord(22);
                      rtn_tbl_put_variable_name(v_svar.rec, 0);
                      rtn_tbl_put_variable_kind(v_svar.rec, -1);
                      rtn_tbl_put_variable_type(v_svar.rec, 0);
                      rtn_tbl_put_variable_data(v_svar.rec, 0);
                      rtn_tbl_put_variable_claimed(v_svar.rec, -1);
                      rtn_tbl_put_variable_allowed(v_svar.rec, -1);
                      rtn_tbl_put_variable_usage(v_svar.rec, -1);
                      rtn_tbl_put_variable_use(v_svar.rec, 0);
                      v_dbstate=1;
                      rtn_tbl_put_variable_name(v_svar.rec, scpy(v_keyword));
                      rtn_tbl_put_variable_type(v_svar.rec, scpy("string"));
                      rtn_tbl_put_variable_data(v_svar.rec, scpy("separate"));
                      rtn_tbl_put_variable_usage(v_svar.rec, 3);
                      rtn_tbl_put_variable_kind(v_svar.rec, 2);
                      rtn_tbl_put_variable_claimed(v_svar.rec, 0);
                      v_svar=rtn_tbl_add_variable(v_svar);
                      v_dbstate=0;
                      rtn_scankeyword();
                    }
                  }
                  newptr(&v_v, 37, 0);
                  v_v=rtn_tbl_search_variable(0);
                  while (1) {
                    if (v_v.branch==-1) {
                      v_v=rtn_nullpointer();
                      break;
                    }
                    if (scmp(rtn_tbl_get_variable_name(v_v.rec), (var1=snew(var1, scon(scpy(v_foundvariable), ".recnr"))))==0) {
                      break;
                    }
                    v_v=rtn_ptrplus1(v_v, 37);
                  }
                  if (!(v_v.branch!=-1)) {
                    newptr(&v_v1, 37, 0);
                    v_v1=rtn_addrecord(22);
                    rtn_tbl_put_variable_name(v_v1.rec, 0);
                    rtn_tbl_put_variable_kind(v_v1.rec, -1);
                    rtn_tbl_put_variable_type(v_v1.rec, 0);
                    rtn_tbl_put_variable_data(v_v1.rec, 0);
                    rtn_tbl_put_variable_claimed(v_v1.rec, -1);
                    rtn_tbl_put_variable_allowed(v_v1.rec, -1);
                    rtn_tbl_put_variable_usage(v_v1.rec, -1);
                    rtn_tbl_put_variable_use(v_v1.rec, 0);
                    v_dbstate=1;
                    rtn_tbl_put_variable_name(v_v1.rec, scon(scpy(v_foundvariable), ".recnr"));
                    rtn_tbl_put_variable_type(v_v1.rec, scpy("number"));
                    rtn_tbl_put_variable_data(v_v1.rec, scpy("recnr"));
                    v_v1=rtn_tbl_add_variable(v_v1);
                    v_dbstate=0;
                    newptr(&v_v2, 37, 0);
                    v_v2=rtn_addrecord(22);
                    rtn_tbl_put_variable_name(v_v2.rec, 0);
                    rtn_tbl_put_variable_kind(v_v2.rec, -1);
                    rtn_tbl_put_variable_type(v_v2.rec, 0);
                    rtn_tbl_put_variable_data(v_v2.rec, 0);
                    rtn_tbl_put_variable_claimed(v_v2.rec, -1);
                    rtn_tbl_put_variable_allowed(v_v2.rec, -1);
                    rtn_tbl_put_variable_usage(v_v2.rec, -1);
                    rtn_tbl_put_variable_use(v_v2.rec, 0);
                    v_dbstate=1;
                    rtn_tbl_put_variable_name(v_v2.rec, scon(scpy(v_foundvariable), ".first"));
                    rtn_tbl_put_variable_type(v_v2.rec, scpy("boolean"));
                    rtn_tbl_put_variable_data(v_v2.rec, scpy("first"));
                    v_v2=rtn_tbl_add_variable(v_v2);
                    v_dbstate=0;
                  }
                  if (scmp(v_keyword, "by")==0) {
                    rtn_scankeyword();
                  }
                  else {
                    rtn_putwarning(scpy("Expecting 'by' in separate statement"));
                  }
                  rtn_expression(scpy("constr"), 0);
                  rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
                  rtn_addactioncode(scpy("= number"), 0, scon(scpy("c_"), v_foundvariable), 0);
                  rtn_addactioncode(scpy("separate"), scpy("Cannot find separate definition"), scon(scpy("v_"), v_foundvariable), 0);
                  rtn_storecode();
                  rtn_instructions(v_level+1);
                  rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
                  rtn_addactioncode(scpy("+= number"), 0, scon(scpy("c_"), v_foundvariable), 0);
                  rtn_endblockcode();
                  if (scmp(v_keyword, "next")!=0) {
                    rtn_putwarning(scpy("Expecting 'next' at the end of a 'seperate' statement"));
                  }
                  else {
                    rtn_scankeyword();
                  }
                  newptr(&v_vc2, 37, 0);
                  v_vc2=rtn_tbl_search_variable(0);
                  while (1) {
                    if (v_vc2.branch==-1) {
                      v_vc2=rtn_nullpointer();
                      break;
                    }
                    if (scmp(rtn_tbl_get_variable_name(v_vc2.rec), v_foundvariable)==0) {
                      break;
                    }
                    v_vc2=rtn_ptrplus1(v_vc2, 37);
                  }
                  v_vc2=rtn_cpyrecord(v_vc2, 22);
                  v_dbstate=2;
                  rtn_tbl_put_variable_data(v_vc2.rec, 0);
                  v_dbstate=3;
                  v_vc2=rtn_tbl_update_variable(rtn_getrec(rtn_recalcptr(v_vc2, 37), 22));
                  v_dbstate=0;
                }
                else {
                  if (scmp(v_keyword, "break")==0) {
                    rtn_addactioncode(scpy("break"), 0, 0, 0);
                    rtn_scankeyword();
                  }
                  else {
                    if (scmp(v_keyword, "for")==0) {
                      rtn_scankeyword();
                      if (!(rtn_find_variable())) {
                        v_ctype=snew(v_ctype, scpy("number"));
                        rtn_addactioncode(scon(scpy("define "), v_ctype), 0, scon(scpy("v_"), v_cvarname), 0);
                        newptr(&v_vfld, 37, 0);
                        v_vfld=rtn_addrecord(22);
                        rtn_tbl_put_variable_name(v_vfld.rec, 0);
                        rtn_tbl_put_variable_kind(v_vfld.rec, -1);
                        rtn_tbl_put_variable_type(v_vfld.rec, 0);
                        rtn_tbl_put_variable_data(v_vfld.rec, 0);
                        rtn_tbl_put_variable_claimed(v_vfld.rec, -1);
                        rtn_tbl_put_variable_allowed(v_vfld.rec, -1);
                        rtn_tbl_put_variable_usage(v_vfld.rec, -1);
                        rtn_tbl_put_variable_use(v_vfld.rec, 0);
                        v_dbstate=1;
                        rtn_tbl_put_variable_name(v_vfld.rec, scpy(v_cvarname));
                        rtn_tbl_put_variable_type(v_vfld.rec, scpy(v_ctype));
                        rtn_tbl_put_variable_usage(v_vfld.rec, 0);
                        rtn_tbl_put_variable_kind(v_vfld.rec, 2);
                        v_vfld=rtn_tbl_add_variable(v_vfld);
                        v_dbstate=0;
                        v_cvarname=snew(v_cvarname, scpy(v_keyword));
                        rtn_scankeyword();
                      }
                      v_foundvariable=snew(v_foundvariable, scon(scpy("v_"), v_cvarname));
                      v_foundkeyword=snew(v_foundkeyword, scpy(v_ctype));
                      if (scmp(v_keyword, "=")!=0) {
                        rtn_putwarning(scpy("Expecting '='"));
                      }
                      else {
                        rtn_scankeyword();
                      }
                      rtn_expression(scpy(v_foundkeyword), 0);
                      rtn_addactioncode(scon(scpy("= "), v_foundkeyword), 0, scpy(v_foundvariable), 0);
                      rtn_addactioncode(scpy("loop"), 0, 0, 0);
                      rtn_storecode();
                      rtn_addactioncode(scon(scpy("variable "), v_foundkeyword), 0, scpy(v_foundvariable), 0);
                      if (scmp(v_keyword, "to")!=0) {
                        rtn_putwarning(scpy("Expecting 'to'"));
                      }
                      else {
                        rtn_scankeyword();
                      }
                      rtn_expression(scpy(v_foundkeyword), 0);
                      rtn_addactioncode(scon(scon(scpy(v_foundkeyword), " > "), v_foundkeyword), 0, 0, 0);
                      rtn_addactioncode(scpy("if"), 0, 0, 0);
                      rtn_storecode();
                      rtn_addactioncode(scpy("break"), 0, 0, 0);
                      rtn_endblockcode();
                      rtn_instructions(v_level+1);
                      rtn_addactioncode(scpy("number"), 0, scpy("1"), 0);
                      rtn_addactioncode(scon(scpy("+= "), v_foundkeyword), 0, scpy(v_foundvariable), 0);
                      rtn_endblockcode();
                      if (scmp(v_keyword, "next")==0) {
                        rtn_scankeyword();
                      }
                      else {
                        rtn_putwarning(scpy("For statement should be ended by next"));
                      }
                    }
                    else {
                      if (scmp(v_keyword, "search")==0) {
                        rtn_scankeyword();
                        v_cindex=snew(v_cindex, rtn_find_index(ienum("any", "any key")));
                        rtn_find_ptr(scpy(v_cindex));
                        v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                        if (scmp(v_keyword, "where")==0) {
                          rtn_scankeyword();
                          v_foundlast=v_lastcode;
                          rtn_expression(scpy("boolean"), 0);
                          v_cvarname=snew(v_cvarname, scpy(v_foundvariable));
                          rtn_db_search(scpy(v_cindex), v_foundlast+1, v_lastcode-v_foundlast, v_level);
                        }
                        else {
                          rtn_db_search(scpy(v_cindex), 0, 0, v_level);
                        }
                        rtn_instructions(v_level+1);
                        if (scmp(v_keyword, "next")==0) {
                          rtn_scankeyword();
                        }
                        else {
                          rtn_putwarning(scpy("Search should be ended by next"));
                        }
                      }
                      else {
                        if (scmp(v_keyword, "get")==0) {
                          rtn_scankeyword();
                          v_cindex=snew(v_cindex, rtn_find_index(ienum("any", "any key")));
                          rtn_find_ptr(scpy(v_cindex));
                          v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                          if (scmp(v_keyword, "where")==0) {
                            rtn_scankeyword();
                            v_foundlast=v_lastcode;
                            rtn_expression(scpy("boolean"), 0);
                            v_cvarname=snew(v_cvarname, scpy(v_foundvariable));
                            rtn_db_get(scpy(v_cindex), v_foundlast+1, v_lastcode-v_foundlast);
                          }
                          else {
                            rtn_db_get(scpy(v_cindex), 0, 0);
                          }
                        }
                        else {
                          if (scmp(v_keyword, "add")==0) {
                            rtn_scankeyword();
                            v_cindex=snew(v_cindex, rtn_find_index(ienum("key", "any key")));
                            rtn_find_ptr(scpy(v_cindex));
                            v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                            rtn_db_add(scpy(v_cindex));
                            v_foundtbl=snew(v_foundtbl, scpy(v_cindex));
                            rtn_instructions(v_level+1);
                            if (scmp(v_keyword, "update")==0) {
                              rtn_scankeyword();
                            }
                            else {
                              rtn_putwarning(scpy("Add should be ended by update"));
                            }
                            v_cvarname=snew(v_cvarname, scpy(v_foundvariable));
                            rtn_db_addupdate(scpy(v_foundtbl));
                          }
                          else {
                            if (scmp(v_keyword, "edit")==0) {
                              rtn_scankeyword();
                              if (!(rtn_find_variable())) {
                                rtn_puterror(scpy("Expecting pointer to record to delete"));
                              }
                              v_cindex=snew(v_cindex, scpy(v_cdata));
                              v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                              v_foundtbl=snew(v_foundtbl, scpy(v_cindex));
                              rtn_db_edit(scpy(v_cindex));
                              rtn_instructions(v_level+1);
                              if (scmp(v_keyword, "update")==0) {
                                rtn_scankeyword();
                              }
                              else {
                                rtn_putwarning(scpy("Edit should be ended by update"));
                              }
                              v_cvarname=snew(v_cvarname, scpy(v_foundvariable));
                              rtn_db_editupdate(scpy(v_foundtbl));
                            }
                            else {
                              if (scmp(v_keyword, "delete")==0) {
                                rtn_scankeyword();
                                if (!(rtn_find_variable())) {
                                  rtn_puterror(scpy("Expecting pointer to record to delete"));
                                }
                                rtn_db_delete();
                              }
                              else {
                                if (scmp(v_keyword, "clear")==0) {
                                  rtn_scankeyword();
                                  v_cindex=snew(v_cindex, rtn_find_index(ienum("key", "any key")));
                                  rtn_db_clear(scpy(v_cindex));
                                }
                                else {
                                  if (scmp(v_keyword, "return")==0) {
                                    rtn_scankeyword();
                                    newptr(&v_rr, 6, 0);
                                    v_rr=rtn_tbl_search_routine(v_croutine);
                                    while (1) {
                                      if ((v_rr.branch==-1) || ((rtn_tbl_get_routine_order(v_rr.rec)>v_croutine))) {
                                        v_rr=rtn_nullpointer();
                                        break;
                                      }
                                      if (rtn_tbl_get_routine_order(v_rr.rec)==v_croutine) {
                                        break;
                                      }
                                      v_rr=rtn_ptrplus1(v_rr, 6);
                                    }
                                    if (v_rr.branch!=-1 && rtn_tbl_get_routine_returntype(v_rr.rec)!=0) {
                                      rtn_expression(scpy(rtn_tbl_get_routine_returntype(v_rr.rec)), scpy(rtn_tbl_get_routine_returndata(v_rr.rec)));
                                      newptr(&v_rfr, 30, 0);
                                      v_rfr=rtn_tbl_search_actionget(scon(scpy("free "), v_ctype));
                                      while (1) {
                                        if ((v_rfr.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_rfr.rec), (var1=snew(var1, scon(scpy("free "), v_ctype))))>0))) {
                                          v_rfr=rtn_nullpointer();
                                          break;
                                        }
                                        if (scmp(rtn_tbl_get_action_ident(v_rfr.rec), (var1=snew(var1, scon(scpy("free "), v_ctype))))==0) {
                                          break;
                                        }
                                        v_rfr=rtn_ptrplus1(v_rfr, 30);
                                      }
                                      if (v_rfr.branch!=-1 && scmp(v_ctype, "pointer")!=0) {
                                        if (v_conversionvar>v_maxconversion) {
                                          rtn_addactioncode(scon(scpy("define "), v_ctype), scon(scpy("Cannot find definition of type "), v_ctype), sadd(scpy("var"), get_int(v_conversionvar)), 0);
                                          v_maxconversion=v_conversionvar;
                                        }
                                        rtn_addactioncode(scon(scpy("= "), v_ctype), scon(scpy("Cannot change variable of type "), v_ctype), sadd(scpy("var"), get_int(v_conversionvar)), 0);
                                        rtn_addactioncode(scon(scpy("variable "), v_ctype), scon(scpy("Cannot get variable of type "), v_ctype), sadd(scpy("var"), get_int(v_conversionvar)), 0);
                                        v_conversionvar+=1;
                                      }
                                      rtn_addactioncode(scpy("fnreturn"), scpy("Cannot find definition of return"), 0, 0);
                                    }
                                    else {
                                      rtn_addactioncode(scpy("return"), scpy("Cannot find definition of return"), 0, 0);
                                    }
                                  }
                                  else {
                                    if (rtn_find_variable()) {
                                      v_foundvariable=snew(v_foundvariable, scpy(v_cvarname));
                                      v_foundtbl=snew(v_foundtbl, scpy(v_cdbtbl));
                                      if (v_cdbfld==0) {
                                        v_foundfld=snew(v_foundfld, 0);
                                      }
                                      else {
                                        v_foundfld=snew(v_foundfld, scpy(v_cdbfld));
                                      }
                                      if (((((scmp(v_keyword, "-")==0) || (scmp(v_keyword, "+")==0)) || (scmp(v_keyword, "/")==0)) || (scmp(v_keyword, "*")==0)) || (scmp(v_keyword, "%")==0)) {
                                        v_foundkeyword=snew(v_foundkeyword, scpy(v_keyword));
                                        rtn_scankeyword();
                                      }
                                      else {
                                        v_foundkeyword=snew(v_foundkeyword, 0);
                                      }
                                      if (scmp(v_keyword, "=")==0) {
                                        v_foundkeyword=sadd(v_foundkeyword, scpy(v_keyword));
                                        rtn_scankeyword();
                                      }
                                      else {
                                        rtn_putwarning(scpy("Expecting '=' after variable"));
                                      }
                                      if (!(v_cdbfld==0)) {
                                        v_tel=rtn_findstring(v_foundvariable, ".", 1);
                                        rtn_addactioncode(scpy("variable pointer"), scpy("Internal error on 'variable pointer'"), sadd(scpy("v_"), rtn_left(v_foundvariable, v_tel-1)), 0);
                                        rtn_addactioncode(scpy("pointer -> number"), 0, 0, 0);
                                      }
                                      rtn_expression(scpy(v_ctype), scpy(v_cdata));
                                      if (!(v_foundfld==0)) {
                                        if (scmp(v_foundkeyword, "=")==0) {
                                          rtn_addactioncode(scon(scon(scon(scpy("rtn_tbl_put_"), v_foundtbl), "_"), v_foundfld), scpy("Unknown field operation"), 0, 0);
                                        }
                                        else {
                                          if (scmp(v_foundkeyword, "+=")==0) {
                                            rtn_addactioncode(scon(scon(scon(scpy("rtn_tbl_add_"), v_foundtbl), "_"), v_foundfld), scpy("Unknown field operation"), 0, 0);
                                          }
                                          else {
                                            if (scmp(v_foundkeyword, "-=")==0) {
                                              rtn_addactioncode(scon(scon(scon(scpy("rtn_tbl_sub_"), v_foundtbl), "_"), v_foundfld), scpy("Unknown field operation"), 0, 0);
                                            }
                                          }
                                        }
                                      }
                                      else {
                                        if (scmp((var1=snew(var1, rtn_right(v_foundvariable, 6))), ".recnr")==0) {
                                          v_tel=rtn_findstring(v_foundvariable, ".", 1);
                                          rtn_addactioncode(scon(scon(scpy(v_foundkeyword), " "), v_ctype), 0, sadd(scpy("c_"), rtn_left(v_foundvariable, v_tel-1)), 0);
                                        }
                                        else {
                                          rtn_addactioncode(scon(scon(scpy(v_foundkeyword), " "), v_ctype), scon(scon(scon(scon(scpy("Cannot perform operation '"), v_foundkeyword), "' on type '"), v_ctype), "'"), scon(scpy("v_"), v_foundvariable), scpy(v_cdata));
                                        }
                                      }
                                    }
                                    else {
                                      if (rtn_find_routine()) {
                                      }
                                      else {
                                        if (v_level>1 && (((((((((scmp(v_keyword, "endif")==0) || (scmp(v_keyword, "else")==0)) || (scmp(v_keyword, "elsif")==0)) || (scmp(v_keyword, "do")==0)) || (scmp(v_keyword, "next")==0)) || (scmp(v_keyword, "update")==0)) || (scmp(v_keyword, "endcase")==0)) || (scmp(v_keyword, "when")==0)) || (scmp(v_keyword, "otherwise")==0))) {
                                          newptr(&v_e, 11, 0);
                                          v_e=rtn_tbl_search_extracode(scpy(v_keyword), v_level);
                                          while (1) {
                                            if ((v_e.branch==-1) || ((scmp(rtn_tbl_get_extracode_keyword(v_e.rec), v_keyword)>0 && rtn_tbl_get_extracode_level(v_e.rec)>v_level))) {
                                              v_e=rtn_nullpointer();
                                              break;
                                            }
                                            if (scmp(rtn_tbl_get_extracode_keyword(v_e.rec), v_keyword)==0 && rtn_tbl_get_extracode_level(v_e.rec)==v_level) {
                                              break;
                                            }
                                            v_e=rtn_ptrplus1(v_e, 11);
                                          }
                                          if (v_e.branch!=-1) {
                                            rtn_addscancode(scpy(rtn_tbl_get_extracode_code(v_e.rec)));
                                            rtn_tbl_delete_extracode(rtn_getrec(v_e, 11));
                                          }
                                          else {
                                            break;
                                          }
                                        }
                                        else {
                                          if (v_keyword!=0) {
                                            rtn_putwarning(scon(scon(scpy("Unknown keyword '"), v_keyword), "' found"));
                                          }
                                          else {
                                            rtn_putwarning(scpy("Unexpected string found"));
                                          }
                                          rtn_scankeyword();
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_vc, 37);
  delptr(&v_svar, 37);
  delptr(&v_v, 37);
  delptr(&v_v1, 37);
  delptr(&v_v2, 37);
  delptr(&v_vc2, 37);
  delptr(&v_vfld, 37);
  delptr(&v_rr, 6);
  delptr(&v_rfr, 30);
  delptr(&v_e, 11);
}
 
 
void rtn_scan_module(char *v_file);
 
 
void rtn_write_routine() {
  struct pointer v_routine={-1, -1, -1};
  struct pointer v_td1={-1, -1, -1};
  char *var1=0;
  struct pointer v_p1={-1, -1, -1};
  long int c_p1=0;
  struct pointer v_td2={-1, -1, -1};
  newptr(&v_routine, 6, 0);
  v_routine=rtn_tbl_search_routine(v_croutine);
  while (1) {
    if ((v_routine.branch==-1) || ((rtn_tbl_get_routine_order(v_routine.rec)>v_croutine))) {
      v_routine=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_routine_order(v_routine.rec)==v_croutine) {
      break;
    }
    v_routine=rtn_ptrplus1(v_routine, 6);
  }
  if (v_routine.branch!=-1) {
    swrite(" ", v_c); wline(v_c);
    if (rtn_tbl_get_routine_returntype(v_routine.rec)==0) {
      swrite("void ", v_c);
    }
    else {
      newptr(&v_td1, 30, 0);
      v_td1=rtn_tbl_search_actionget(scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_routine.rec)));
      while (1) {
        if ((v_td1.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_td1.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_routine.rec)))))>0))) {
          v_td1=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_td1.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_routine.rec)))))==0) {
          break;
        }
        v_td1=rtn_ptrplus1(v_td1, 30);
      }
      if (v_td1.branch!=-1) {
        swrite((var1=snew(var1, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_td1.rec)), 0, 0, 0, 0))), v_c);
      }
      else {
        rtn_putwarning(scon(scon(scpy("type '"), rtn_tbl_get_routine_returntype(v_routine.rec)), "' is not allowed as a return type"));
        swrite("void ", v_c);
      }
    }
    if (scmp(rtn_tbl_get_routine_name(v_routine.rec), "main")==0) {
      swrite((var1=snew(var1, scon(scpy(rtn_tbl_get_routine_name(v_routine.rec)), "("))), v_c);
    }
    else {
      swrite((var1=snew(var1, scon(scpy(rtn_tbl_get_routine_function(v_routine.rec)), "("))), v_c);
    }
    newptr(&v_p1, 9, 0);
    c_p1=1;
    v_p1=rtn_tbl_search_parameter(v_croutine, null);
    while (1) {
      if ((v_p1.branch==-1) || ((rtn_tbl_get_parameter_routine(v_p1.rec)>v_croutine))) {
        break;
      }
      if (rtn_tbl_get_parameter_routine(v_p1.rec)==v_croutine) {
        if (!(c_p1==1)) {
          swrite(", ", v_c);
        }
        newptr(&v_td2, 30, 0);
        v_td2=rtn_tbl_search_actionget(scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)));
        while (1) {
          if ((v_td2.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_td2.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)))))>0))) {
            v_td2=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_action_ident(v_td2.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)))))==0) {
            break;
          }
          v_td2=rtn_ptrplus1(v_td2, 30);
        }
        if (v_td2.branch!=-1) {
          swrite((var1=snew(var1, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_td2.rec)), scon(scpy("v_"), rtn_tbl_get_parameter_name(v_p1.rec)), 0, 0, 0))), v_c);
        }
        else {
          rtn_putwarning(scon(scon(scpy("type '"), rtn_tbl_get_parameter_type(v_p1.rec)), "' is not allowed as a parameter"));
          swrite((var1=snew(var1, scon(scpy("void v_"), rtn_tbl_get_parameter_name(v_p1.rec)))), v_c);
        }
        c_p1+=1;
      }
      if (v_p1.branch==-1) {
        v_p1=rtn_getpointer(0, 0, 9);
      }
      else {
        v_p1=rtn_ptrplus1(v_p1, 9);
      }
    }
    c_p1-=1;
    if (rtn_tbl_get_routine_type(v_routine.rec)==3) {
      swrite(");", v_c); wline(v_c);
    }
    else {
      swrite(") {", v_c); wline(v_c);
      rtn_compile();
      swrite("}", v_c); wline(v_c);
    }
    swrite(" ", v_c); wline(v_c);
  }
  else {
    rtn_puterror(scpy("Internally no routine found"));
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_routine, 6);
  delptr(&v_td1, 30);
  delptr(&v_p1, 9);
  delptr(&v_td2, 30);
}
 
 
void rtn_new_routine() {
  struct pointer v_fp={-1, -1, -1};
  long int c_fp=0;
  struct pointer v_fa={-1, -1, -1};
  char *var1=0;
  struct pointer v_ismain={-1, -1, -1};
  rtn_scankeyword();
  rtn_copy_globals(v_croutine);
  newptr(&v_fp, 9, 0);
  c_fp=1;
  v_fp=rtn_tbl_search_parameter(v_croutine, null);
  while (1) {
    if ((v_fp.branch==-1) || ((rtn_tbl_get_parameter_routine(v_fp.rec)>v_croutine))) {
      break;
    }
    if (rtn_tbl_get_parameter_routine(v_fp.rec)==v_croutine) {
      v_cindex=snew(v_cindex, scpy(rtn_tbl_get_parameter_data(v_fp.rec)));
      newptr(&v_fa, 29, 0);
      v_fa=rtn_tbl_search_action(null);
      while (1) {
        if (v_fa.branch==-1) {
          v_fa=rtn_nullpointer();
          break;
        }
        if (scmp(rtn_tbl_get_action_ident(v_fa.rec), (var1=snew(var1, scon(scpy("free "), rtn_tbl_get_parameter_type(v_fp.rec)))))==0) {
          break;
        }
        v_fa=rtn_ptrplus1(v_fa, 29);
      }
      if (v_fa.branch!=-1) {
        rtn_addcode(rtn_tbl_get_action_action(v_fa.rec), scon(scpy("v_"), rtn_tbl_get_parameter_name(v_fp.rec)), scpy("free"));
      }
      c_fp+=1;
    }
    if (v_fp.branch==-1) {
      v_fp=rtn_getpointer(0, 0, 9);
    }
    else {
      v_fp=rtn_ptrplus1(v_fp, 9);
    }
  }
  c_fp-=1;
  newptr(&v_ismain, 6, 0);
  v_ismain=rtn_tbl_search_routine(v_croutine);
  while (1) {
    if ((v_ismain.branch==-1) || ((rtn_tbl_get_routine_order(v_ismain.rec)>v_croutine))) {
      v_ismain=rtn_nullpointer();
      break;
    }
    if (rtn_tbl_get_routine_order(v_ismain.rec)==v_croutine) {
      break;
    }
    v_ismain=rtn_ptrplus1(v_ismain, 6);
  }
  if (v_ismain.branch!=-1 && scmp(rtn_tbl_get_routine_name(v_ismain.rec), "main")==0) {
    rtn_db_init();
  }
  v_maxconversion=0;
  rtn_instructions(1);
  rtn_freevariables();
  v_scanstring=snew(v_scanstring, 0);
  rtn_write_routine();
  rtn_tbl_clear_variable();
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_fp, 9);
  delptr(&v_fa, 29);
  delptr(&v_ismain, 6);
}
 
 
void rtn_scan_routine() {
  long int v_cnt=0;
  char *v_cpuse=0;
  char v_used=0;
  char *v_cparm=0;
  char *v_cdefault=0;
  long int v_lastcroutine=0;
  char *v_lastroutine=0;
  char v_single=0;
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  struct pointer v_lr={-1, -1, -1};
  struct pointer v_chkr={-1, -1, -1};
  struct pointer v_rc={-1, -1, -1};
  long int c_rc=0;
  struct pointer v_cp={-1, -1, -1};
  long int c_cp=0;
  struct pointer v_rnext={-1, -1, -1};
  struct pointer v_rnew={-1, -1, -1};
  struct pointer v_routine={-1, -1, -1};
  char *var1=0;
  struct pointer v_chktp={-1, -1, -1};
  struct pointer v_p2={-1, -1, -1};
  struct pointer v_idx={-1, -1, -1};
  struct pointer v_p3={-1, -1, -1};
  struct pointer v_id2={-1, -1, -1};
  struct pointer v_rtn={-1, -1, -1};
  struct pointer v_pc={-1, -1, -1};
  long int c_pc=0;
  struct pointer v_sroutine={-1, -1, -1};
  struct pointer v_td1={-1, -1, -1};
  struct pointer v_p1={-1, -1, -1};
  long int c_p1=0;
  struct pointer v_td2={-1, -1, -1};
  if (((v_scantype==3) || (v_scantype==1)) && scmp(v_scantag, "routine")==0) {
    v_single=(v_scantype==3);
    v_tagfound=1;
    v_specrout=0;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      v_used=0;
      if (c_s==1) {
        if (scmp(rtn_tbl_get_scan_key(v_s.rec), "name")!=0) {
          rtn_putwarning(scpy("Unknown routine name"));
        }
        else {
          if (v_croutine!=null) {
            newptr(&v_lr, 6, 0);
            v_lr=rtn_tbl_search_routine(v_croutine);
            while (1) {
              if ((v_lr.branch==-1) || ((rtn_tbl_get_routine_order(v_lr.rec)>v_croutine))) {
                v_lr=rtn_nullpointer();
                break;
              }
              if (rtn_tbl_get_routine_order(v_lr.rec)==v_croutine) {
                break;
              }
              v_lr=rtn_ptrplus1(v_lr, 6);
            }
            if (v_lr.branch!=-1) {
              v_lastroutine=snew(v_lastroutine, scpy(rtn_tbl_get_routine_name(v_lr.rec)));
            }
          }
          newptr(&v_chkr, 6, 0);
          v_chkr=rtn_tbl_search_routine(null);
          while (1) {
            if (v_chkr.branch==-1) {
              v_chkr=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_routine_name(v_chkr.rec), rtn_tbl_get_scan_value(v_s.rec))==0) {
              break;
            }
            v_chkr=rtn_ptrplus1(v_chkr, 6);
          }
          if (v_chkr.branch!=-1) {
            v_cnt=0;
            newptr(&v_rc, 6, 0);
            c_rc=1;
            v_rc=rtn_tbl_search_routine(null);
            while (1) {
              if (v_rc.branch==-1) {
                break;
              }
              if (scmp(rtn_tbl_get_routine_name(v_rc.rec), rtn_tbl_get_scan_value(v_s.rec))==0) {
                v_cnt+=1;
                c_rc+=1;
              }
              if (v_rc.branch==-1) {
                v_rc=rtn_getpointer(0, 0, 6);
              }
              else {
                v_rc=rtn_ptrplus1(v_rc, 6);
              }
            }
            c_rc-=1;
            if (scmp(rtn_tbl_get_scan_value(v_s.rec), v_lastroutine)!=0) {
              if (rtn_tbl_get_routine_type(v_chkr.rec)!=3) {
                rtn_putwarning(scon(scpy("Beware... second declaration of same routine in module "), rtn_tbl_get_routine_module(v_chkr.rec)));
              }
              v_chkr=rtn_cpyrecord(v_chkr, 5);
              v_dbstate=2;
              rtn_tbl_put_routine_type(v_chkr.rec, 0);
              v_dbstate=3;
              v_chkr=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_chkr, 6), 5));
              v_dbstate=0;
              newptr(&v_cp, 9, 0);
              c_cp=1;
              v_cp=rtn_tbl_search_parameter(rtn_tbl_get_routine_order(v_chkr.rec), null);
              while (1) {
                if ((v_cp.branch==-1) || ((rtn_tbl_get_parameter_routine(v_cp.rec)>rtn_tbl_get_routine_order(v_chkr.rec)))) {
                  break;
                }
                if (rtn_tbl_get_parameter_routine(v_cp.rec)==rtn_tbl_get_routine_order(v_chkr.rec)) {
                  rtn_tbl_delete_parameter(rtn_getrec(v_cp, 9));
                  c_cp+=1;
                }
                if (v_cp.branch==-1) {
                  v_cp=rtn_getpointer(0, 0, 9);
                }
                else {
                  v_cp=rtn_ptrplus1(v_cp, 9);
                }
              }
              c_cp-=1;
              rtn_addtag(scon(scon(scpy("a name=\""), rtn_tbl_get_routine_function(v_chkr.rec)), "\""), scpy("/a"));
              v_croutine=rtn_tbl_get_routine_order(v_chkr.rec);
            }
            else {
              newptr(&v_rnext, 6, 0);
              v_rnext=rtn_addrecord(5);
              rtn_tbl_put_routine_order(v_rnext.rec, 0);
              rtn_tbl_put_routine_module(v_rnext.rec, 0);
              rtn_tbl_put_routine_function(v_rnext.rec, 0);
              rtn_tbl_put_routine_name(v_rnext.rec, 0);
              rtn_tbl_put_routine_kind(v_rnext.rec, -1);
              rtn_tbl_put_routine_type(v_rnext.rec, -1);
              rtn_tbl_put_routine_use(v_rnext.rec, 0);
              rtn_tbl_put_routine_returntype(v_rnext.rec, 0);
              rtn_tbl_put_routine_returndata(v_rnext.rec, 0);
              rtn_tbl_put_routine_returnuse(v_rnext.rec, 0);
              v_dbstate=1;
              rtn_tbl_put_routine_module(v_rnext.rec, scpy(v_cmodule));
              rtn_tbl_put_routine_name(v_rnext.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
              rtn_tbl_put_routine_function(v_rnext.rec, sadd(scon(scpy("rtn_"), rtn_tbl_get_scan_value(v_s.rec)), get_int(v_cnt)));
              rtn_tbl_put_routine_returntype(v_rnext.rec, 0);
              rtn_addtag(scon(scon(scpy("a name=\""), rtn_tbl_get_routine_function(v_rnext.rec)), "\""), scpy("/a"));
              v_rnext=rtn_tbl_add_routine(v_rnext);
              v_dbstate=0;
              v_croutine=rtn_tbl_get_routine_order(v_rnext.rec);
            }
          }
          else {
            if (rtn_check_name(scpy(rtn_tbl_get_scan_value(v_s.rec)), scpy("new routine name"))) {
              newptr(&v_rnew, 6, 0);
              v_rnew=rtn_addrecord(5);
              rtn_tbl_put_routine_order(v_rnew.rec, 0);
              rtn_tbl_put_routine_module(v_rnew.rec, 0);
              rtn_tbl_put_routine_function(v_rnew.rec, 0);
              rtn_tbl_put_routine_name(v_rnew.rec, 0);
              rtn_tbl_put_routine_kind(v_rnew.rec, -1);
              rtn_tbl_put_routine_type(v_rnew.rec, -1);
              rtn_tbl_put_routine_use(v_rnew.rec, 0);
              rtn_tbl_put_routine_returntype(v_rnew.rec, 0);
              rtn_tbl_put_routine_returndata(v_rnew.rec, 0);
              rtn_tbl_put_routine_returnuse(v_rnew.rec, 0);
              v_dbstate=1;
              rtn_tbl_put_routine_module(v_rnew.rec, scpy(v_cmodule));
              rtn_tbl_put_routine_name(v_rnew.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
              rtn_tbl_put_routine_returntype(v_rnew.rec, 0);
              rtn_tbl_put_routine_function(v_rnew.rec, scon(scpy("rtn_"), rtn_tbl_get_scan_value(v_s.rec)));
              v_rnew=rtn_tbl_add_routine(v_rnew);
              v_dbstate=0;
              rtn_addtag(scon(scon(scpy("a name=\""), rtn_tbl_get_routine_function(v_rnew.rec)), "\""), scpy("/a"));
              v_croutine=rtn_tbl_get_routine_order(v_rnew.rec);
            }
          }
          newptr(&v_routine, 6, 0);
          v_routine=rtn_tbl_search_routine(v_croutine);
          while (1) {
            if ((v_routine.branch==-1) || ((rtn_tbl_get_routine_order(v_routine.rec)>v_croutine))) {
              v_routine=rtn_nullpointer();
              break;
            }
            if (rtn_tbl_get_routine_order(v_routine.rec)==v_croutine) {
              break;
            }
            v_routine=rtn_ptrplus1(v_routine, 6);
          }
        }
        v_cparm=snew(v_cparm, 0);
        v_used=1;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "type")==0) {
        v_used=1;
        if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_scan_value(v_s.rec), 1))), "^")==0) {
          v_ctype=snew(v_ctype, scpy("pointer"));
          v_cdata=snew(v_cdata, rtn_mid(rtn_tbl_get_scan_value(v_s.rec), 2, 999));
          v_cindex=snew(v_cindex, scpy(v_cdata));
        }
        else {
          if (scmp((var1=snew(var1, rtn_left(rtn_tbl_get_scan_value(v_s.rec), 1))), "[")==0) {
            v_ctype=snew(v_ctype, scpy("enumerate"));
            if (scmp((var1=snew(var1, rtn_right(rtn_tbl_get_scan_value(v_s.rec), 1))), "]")!=0) {
              rtn_puterror(scpy("Missing ']' after enumerate type definition"));
            }
            else {
              v_cdata=snew(v_cdata, rtn_mid(rtn_tbl_get_scan_value(v_s.rec), 2, rtn_length(rtn_tbl_get_scan_value(v_s.rec))-2));
            }
          }
          else {
            v_ctype=snew(v_ctype, scpy(rtn_tbl_get_scan_value(v_s.rec)));
          }
        }
        if (v_cparm==0) {
          if (rtn_tbl_get_routine_returntype(v_routine.rec)!=0) {
            rtn_puterror(scon(scon(scpy("Cannot assign two return-types to routine '"), rtn_tbl_get_routine_name(v_routine.rec)), "'"));
          }
          v_routine=rtn_cpyrecord(v_routine, 5);
          v_dbstate=2;
          rtn_tbl_put_routine_returntype(v_routine.rec, scpy(v_ctype));
          newptr(&v_chktp, 30, 0);
          v_chktp=rtn_tbl_search_actionget(scon(scpy("parm "), v_ctype));
          while (1) {
            if ((v_chktp.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_chktp.rec), (var1=snew(var1, scon(scpy("parm "), v_ctype))))>0))) {
              v_chktp=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_chktp.rec), (var1=snew(var1, scon(scpy("parm "), v_ctype))))==0) {
              break;
            }
            v_chktp=rtn_ptrplus1(v_chktp, 30);
          }
          if (!(v_chktp.branch!=-1)) {
            rtn_puterror(scon(scon(scon(scon(scpy("Unknown return type '"), v_ctype), "' to routine '"), rtn_tbl_get_routine_name(v_routine.rec)), "'"));
          }
          rtn_tbl_put_routine_returndata(v_routine.rec, scpy(v_cdata));
          v_dbstate=3;
          v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
          v_dbstate=0;
          v_ctype=snew(v_ctype, 0);
          v_cdata=snew(v_cdata, 0);
        }
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "parameter")==0) {
        v_used=1;
        if (v_cparm!=0) {
          newptr(&v_p2, 9, 0);
          v_p2=rtn_addrecord(6);
          rtn_tbl_put_parameter_routine(v_p2.rec, null);
          rtn_tbl_put_parameter_order(v_p2.rec, 0);
          rtn_tbl_put_parameter_name(v_p2.rec, 0);
          rtn_tbl_put_parameter_type(v_p2.rec, 0);
          rtn_tbl_put_parameter_data(v_p2.rec, 0);
          rtn_tbl_put_parameter_code(v_p2.rec, 0);
          rtn_tbl_put_parameter_defaultvalue(v_p2.rec, 0);
          rtn_tbl_put_parameter_use(v_p2.rec, 0);
          v_dbstate=1;
          rtn_tbl_put_parameter_routine(v_p2.rec, v_croutine);
          rtn_tbl_put_parameter_name(v_p2.rec, scpy(v_cparm));
          if (v_ctype==0) {
            rtn_tbl_put_parameter_type(v_p2.rec, scpy("string"));
          }
          else {
            rtn_tbl_put_parameter_type(v_p2.rec, scpy(v_ctype));
          }
          rtn_tbl_put_parameter_data(v_p2.rec, scpy(v_cdata));
          rtn_tbl_put_parameter_use(v_p2.rec, scpy(v_cpuse));
          rtn_tbl_put_parameter_defaultvalue(v_p2.rec, scpy(v_cdefault));
          v_p2=rtn_tbl_add_parameter(v_p2);
          v_dbstate=0;
          if (scmp(rtn_tbl_get_parameter_type(v_p2.rec), "pointer")==0 && rtn_tbl_get_parameter_data(v_p2.rec)!=0) {
            newptr(&v_idx, 18, 0);
            v_idx=rtn_tbl_search_indexname(0);
            while (1) {
              if (v_idx.branch==-1) {
                v_idx=rtn_nullpointer();
                break;
              }
              if (scmp(rtn_tbl_get_index_name(v_idx.rec), v_cdata)==0) {
                break;
              }
              v_idx=rtn_ptrplus1(v_idx, 18);
            }
            if (v_idx.branch!=-1) {
              rtn_addactioncode(scpy("number"), 0, get_int(v_specrout), 0);
              rtn_addactioncode(scpy("new pointer"), 0, scon(scpy("v_"), rtn_tbl_get_parameter_name(v_p2.rec)), scpy(get_sort(rtn_tbl_get_index_index(v_idx.rec))));
            }
            rtn_table_fields(scpy(rtn_tbl_get_parameter_name(v_p2.rec)), scpy(rtn_tbl_get_parameter_data(v_p2.rec)));
          }
          v_cparm=snew(v_cparm, 0);
          v_ctype=snew(v_ctype, 0);
          v_cdata=snew(v_cdata, 0);
          v_cpuse=snew(v_cpuse, 0);
          v_cdefault=snew(v_cdefault, 0);
        }
        v_cparm=snew(v_cparm, scpy(rtn_tbl_get_scan_value(v_s.rec)));
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "default")==0) {
        v_used=1;
        if (v_cparm==0) {
          rtn_putwarning(scpy("No current parameter for default value"));
        }
        else {
          v_cdefault=snew(v_cdefault, scpy(rtn_tbl_get_scan_value(v_s.rec)));
        }
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "use")==0) {
        v_used=1;
        if (v_cparm!=0) {
          v_cpuse=snew(v_cpuse, scpy(rtn_tbl_get_scan_value(v_s.rec)));
        }
        else {
          if (rtn_tbl_get_routine_returntype(v_routine.rec)!=0) {
            v_routine=rtn_cpyrecord(v_routine, 5);
            v_dbstate=2;
            rtn_tbl_put_routine_returnuse(v_routine.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
            v_dbstate=3;
            v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
            v_dbstate=0;
          }
          else {
            v_routine=rtn_cpyrecord(v_routine, 5);
            v_dbstate=2;
            rtn_tbl_put_routine_use(v_routine.rec, scpy(rtn_tbl_get_scan_value(v_s.rec)));
            v_dbstate=3;
            v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
            v_dbstate=0;
          }
        }
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "system")==0) {
        v_used=1;
        v_routine=rtn_cpyrecord(v_routine, 5);
        v_dbstate=2;
        rtn_tbl_put_routine_type(v_routine.rec, 1);
        v_dbstate=3;
        v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
        v_dbstate=0;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "special")==0) {
        v_used=1;
        v_routine=rtn_cpyrecord(v_routine, 5);
        v_dbstate=2;
        rtn_tbl_put_routine_type(v_routine.rec, 2);
        v_dbstate=3;
        v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
        v_dbstate=0;
        v_specrout=1;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "local")==0) {
        v_used=1;
        v_routine=rtn_cpyrecord(v_routine, 5);
        v_dbstate=2;
        rtn_tbl_put_routine_kind(v_routine.rec, 1);
        v_dbstate=3;
        v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
        v_dbstate=0;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "header")==0) {
        v_used=1;
        if (scmp(((v_single)?"true":"false"), ((0)?"true":"false"))==0) {
          rtn_putwarning(scpy("A routine header should be a module without code"));
        }
        v_routine=rtn_cpyrecord(v_routine, 5);
        v_dbstate=2;
        rtn_tbl_put_routine_type(v_routine.rec, 3);
        v_dbstate=3;
        v_routine=rtn_tbl_update_routine(rtn_getrec(rtn_recalcptr(v_routine, 6), 5));
        v_dbstate=0;
      }
      if (scmp(((v_used)?"true":"false"), ((0)?"true":"false"))==0) {
        rtn_puterror(scon(scon(scpy("Unknown tag field '"), rtn_tbl_get_scan_key(v_s.rec)), "'"));
      }
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
    if (v_cparm!=0) {
      if (v_ctype==0) {
        v_ctype=snew(v_ctype, scpy("string"));
      }
      newptr(&v_p3, 9, 0);
      v_p3=rtn_addrecord(6);
      rtn_tbl_put_parameter_routine(v_p3.rec, null);
      rtn_tbl_put_parameter_order(v_p3.rec, 0);
      rtn_tbl_put_parameter_name(v_p3.rec, 0);
      rtn_tbl_put_parameter_type(v_p3.rec, 0);
      rtn_tbl_put_parameter_data(v_p3.rec, 0);
      rtn_tbl_put_parameter_code(v_p3.rec, 0);
      rtn_tbl_put_parameter_defaultvalue(v_p3.rec, 0);
      rtn_tbl_put_parameter_use(v_p3.rec, 0);
      v_dbstate=1;
      rtn_tbl_put_parameter_routine(v_p3.rec, v_croutine);
      rtn_tbl_put_parameter_name(v_p3.rec, scpy(v_cparm));
      rtn_tbl_put_parameter_type(v_p3.rec, scpy(v_ctype));
      rtn_tbl_put_parameter_data(v_p3.rec, scpy(v_cdata));
      rtn_tbl_put_parameter_use(v_p3.rec, scpy(v_cpuse));
      rtn_tbl_put_parameter_defaultvalue(v_p3.rec, scpy(v_cdefault));
      v_p3=rtn_tbl_add_parameter(v_p3);
      v_dbstate=0;
      if (scmp(rtn_tbl_get_parameter_type(v_p3.rec), "pointer")==0 && rtn_tbl_get_parameter_data(v_p3.rec)!=0) {
        newptr(&v_id2, 18, 0);
        v_id2=rtn_tbl_search_indexname(0);
        while (1) {
          if (v_id2.branch==-1) {
            v_id2=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_index_name(v_id2.rec), v_cdata)==0) {
            break;
          }
          v_id2=rtn_ptrplus1(v_id2, 18);
        }
        if (v_idx.branch!=-1) {
          rtn_addactioncode(scpy("number"), 0, get_int(v_specrout), 0);
          rtn_addactioncode(scpy("new pointer"), 0, scon(scpy("v_"), rtn_tbl_get_parameter_name(v_p3.rec)), scpy(get_sort(rtn_tbl_get_index_index(v_id2.rec))));
        }
        rtn_table_fields(scpy(rtn_tbl_get_parameter_name(v_p3.rec)), scpy(rtn_tbl_get_parameter_data(v_p3.rec)));
      }
    }
    newptr(&v_rtn, 29, 0);
    v_rtn=rtn_addrecord(17);
    rtn_tbl_put_action_ident(v_rtn.rec, 0);
    rtn_tbl_put_action_action(v_rtn.rec, 0);
    rtn_tbl_put_action_left(v_rtn.rec, 0);
    rtn_tbl_put_action_op(v_rtn.rec, 0);
    rtn_tbl_put_action_right(v_rtn.rec, 0);
    rtn_tbl_put_action_parms(v_rtn.rec, null);
    rtn_tbl_put_action_cleft(v_rtn.rec, -1);
    rtn_tbl_put_action_cright(v_rtn.rec, -1);
    rtn_tbl_put_action_result(v_rtn.rec, 0);
    rtn_tbl_put_action_codefront(v_rtn.rec, 0);
    rtn_tbl_put_action_codeback(v_rtn.rec, 0);
    rtn_tbl_put_action_replace(v_rtn.rec, 0);
    v_dbstate=1;
    rtn_tbl_put_action_ident(v_rtn.rec, scpy(rtn_tbl_get_routine_function(v_routine.rec)));
    rtn_tbl_put_action_op(v_rtn.rec, scpy(rtn_tbl_get_routine_function(v_routine.rec)));
    rtn_tbl_put_action_codefront(v_rtn.rec, scpy(rtn_tbl_get_routine_function(v_routine.rec)));
    if (rtn_tbl_get_routine_returntype(v_routine.rec)==0) {
      rtn_tbl_put_action_codeback(v_rtn.rec, scpy(";"));
    }
    rtn_tbl_put_action_parms(v_rtn.rec, 0);
    newptr(&v_pc, 9, 0);
    c_pc=1;
    v_pc=rtn_tbl_search_parameter(rtn_tbl_get_routine_order(v_routine.rec), null);
    while (1) {
      if ((v_pc.branch==-1) || ((rtn_tbl_get_parameter_routine(v_pc.rec)>rtn_tbl_get_routine_order(v_routine.rec)))) {
        break;
      }
      if (rtn_tbl_get_parameter_routine(v_pc.rec)==rtn_tbl_get_routine_order(v_routine.rec)) {
        rtn_tbl_add_action_parms(v_rtn.rec, 1);
        c_pc+=1;
      }
      if (v_pc.branch==-1) {
        v_pc=rtn_getpointer(0, 0, 9);
      }
      else {
        v_pc=rtn_ptrplus1(v_pc, 9);
      }
    }
    c_pc-=1;
    rtn_tbl_put_action_result(v_rtn.rec, scpy(rtn_tbl_get_routine_returntype(v_routine.rec)));
    v_rtn=rtn_tbl_add_action(v_rtn);
    v_dbstate=0;
    v_lastroutine=snew(v_lastroutine, scpy(rtn_tbl_get_routine_function(v_routine.rec)));
    v_lastcroutine=v_croutine;
    if (scmp(rtn_tbl_get_routine_name(v_routine.rec), "main")==0) {
      rtn_db_all();
      rtn_scan_module(scpy("global_definitions"));
    }
    v_croutine=v_lastcroutine;
    newptr(&v_sroutine, 6, 0);
    v_sroutine=rtn_tbl_search_routine(null);
    while (1) {
      if (v_sroutine.branch==-1) {
        v_sroutine=rtn_nullpointer();
        break;
      }
      if (scmp(rtn_tbl_get_routine_function(v_sroutine.rec), v_lastroutine)==0) {
        break;
      }
      v_sroutine=rtn_ptrplus1(v_sroutine, 6);
    }
    if (rtn_tbl_get_routine_type(v_sroutine.rec)==1) {
      rtn_do_scan(scpy("routine"));
      swrite(" ", v_c); wline(v_c);
      if (rtn_tbl_get_routine_returntype(v_sroutine.rec)==0) {
        swrite("void ", v_c);
      }
      else {
        newptr(&v_td1, 30, 0);
        v_td1=rtn_tbl_search_actionget(scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_sroutine.rec)));
        while (1) {
          if ((v_td1.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_td1.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_sroutine.rec)))))>0))) {
            v_td1=rtn_nullpointer();
            break;
          }
          if (scmp(rtn_tbl_get_action_ident(v_td1.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_routine_returntype(v_sroutine.rec)))))==0) {
            break;
          }
          v_td1=rtn_ptrplus1(v_td1, 30);
        }
        if (v_td1.branch!=-1) {
          swrite((var1=snew(var1, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_td1.rec)), 0, 0, 0, 0))), v_c);
        }
        else {
          rtn_putwarning(scon(scon(scpy("type '"), rtn_tbl_get_routine_returntype(v_sroutine.rec)), "' is not allowed as return type"));
          swrite("void ", v_c);
        }
      }
      if (scmp(rtn_tbl_get_routine_name(v_sroutine.rec), "main")==0) {
        swrite((var1=snew(var1, scon(scpy(rtn_tbl_get_routine_name(v_sroutine.rec)), "("))), v_c);
      }
      else {
        swrite((var1=snew(var1, scon(scpy(rtn_tbl_get_routine_function(v_sroutine.rec)), "("))), v_c);
      }
      newptr(&v_p1, 9, 0);
      c_p1=1;
      v_p1=rtn_tbl_search_parameter(v_croutine, null);
      while (1) {
        if ((v_p1.branch==-1) || ((rtn_tbl_get_parameter_routine(v_p1.rec)>v_croutine))) {
          break;
        }
        if (rtn_tbl_get_parameter_routine(v_p1.rec)==v_croutine) {
          if (!(c_p1==1)) {
            swrite(", ", v_c);
          }
          newptr(&v_td2, 30, 0);
          v_td2=rtn_tbl_search_actionget(scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)));
          while (1) {
            if ((v_td2.branch==-1) || ((scmp(rtn_tbl_get_action_ident(v_td2.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)))))>0))) {
              v_td2=rtn_nullpointer();
              break;
            }
            if (scmp(rtn_tbl_get_action_ident(v_td2.rec), (var1=snew(var1, scon(scpy("parm "), rtn_tbl_get_parameter_type(v_p1.rec)))))==0) {
              break;
            }
            v_td2=rtn_ptrplus1(v_td2, 30);
          }
          if (v_td2.branch!=-1) {
            swrite((var1=snew(var1, rtn_typereplace(scpy(rtn_tbl_get_action_codefront(v_td2.rec)), scon(scpy("v_"), rtn_tbl_get_parameter_name(v_p1.rec)), 0, 0, 0))), v_c);
          }
          else {
            rtn_putwarning(scon(scon(scpy("type '"), rtn_tbl_get_parameter_type(v_p1.rec)), "' is not allowed as a parameter"));
            swrite((var1=snew(var1, scon(scpy("void v_"), rtn_tbl_get_parameter_name(v_p1.rec)))), v_c);
          }
          c_p1+=1;
        }
        if (v_p1.branch==-1) {
          v_p1=rtn_getpointer(0, 0, 9);
        }
        else {
          v_p1=rtn_ptrplus1(v_p1, 9);
        }
      }
      c_p1-=1;
      swrite(") {", v_c); wline(v_c);
      swrite((var1=snew(var1, scon(scpy("  "), v_scanstring))), v_c);
      swrite("}", v_c); wline(v_c);
      if ((v_scantype!=2) || (scmp(v_scantag, "routine")!=0)) {
        rtn_putwarning(scpy("No end tag of routine found"));
      }
      rtn_doc_routine();
    }
    else {
      if (rtn_tbl_get_routine_type(v_sroutine.rec)==3) {
        rtn_write_routine();
      }
      else {
        rtn_new_routine();
        rtn_do_scan(scpy("routine"));
        if ((v_scantype!=2) || (scmp(v_scantag, "routine")!=0)) {
          rtn_putwarning(scpy("No end tag of routine found"));
        }
        rtn_doc_routine();
      }
    }
    v_scanstring=snew(v_scanstring, 0);
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_s, 1);
  delptr(&v_lr, 6);
  delptr(&v_chkr, 6);
  delptr(&v_rc, 6);
  delptr(&v_cp, 9);
  delptr(&v_rnext, 6);
  delptr(&v_rnew, 6);
  delptr(&v_routine, 6);
  delptr(&v_chktp, 30);
  delptr(&v_p2, 9);
  delptr(&v_idx, 18);
  delptr(&v_p3, 9);
  delptr(&v_id2, 18);
  delptr(&v_rtn, 29);
  delptr(&v_pc, 9);
  delptr(&v_sroutine, 6);
  delptr(&v_td1, 30);
  delptr(&v_p1, 9);
  delptr(&v_td2, 30);
}
 
 
void rtn_scan_include() {
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  char *var1=0;
  if (v_scantype==3 && scmp(v_scantag, "include")==0) {
    v_tagfound=1;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "file")==0) {
        swrite((var1=snew(var1, scon(scon(scpy("#include \""), rtn_tbl_get_scan_value(v_s.rec)), ".h\""))), v_c); wline(v_c);
      }
      else {
        rtn_puterror(scon(scon(scpy("Unknown scan key '"), rtn_tbl_get_scan_key(v_s.rec)), "' in include"));
      }
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
  }
  if (var1!=0) {free(var1); var1=0;}
  delptr(&v_s, 1);
}
 
 
void rtn_scan_module(char *v_file) {
  char *v_mod=0;
  long int v_chap=0;
  long int v_param=0;
  char *v_tfile=0;
  struct pointer v_s={-1, -1, -1};
  long int c_s=0;
  if (v_file==0 && v_scantype==3 && scmp(v_scantag, "import")==0) {
    v_tagfound=1;
    newptr(&v_s, 1, 0);
    c_s=1;
    v_s=rtn_getpointer(0, 0, 1);
    while (1) {
      if (v_s.branch==-1) {
        break;
      }
      if (scmp(rtn_tbl_get_scan_key(v_s.rec), "module")==0) {
        v_file=snew(v_file, scpy(rtn_tbl_get_scan_value(v_s.rec)));
      }
      else {
        rtn_puterror(scon(scon(scpy("Unknown scan key "), rtn_tbl_get_scan_key(v_s.rec)), " in module"));
        if (v_file!=0) {free(v_file); v_file=0;}
        delptr(&v_s, 1);
        return;
      }
      c_s+=1;
      if (v_s.branch==-1) {
        v_s=rtn_getpointer(0, 0, 1);
      }
      else {
        v_s=rtn_ptrplus1(v_s, 1);
      }
    }
  }
  else {
    if (v_file==0) {
      if (v_file!=0) {free(v_file); v_file=0;}
      delptr(&v_s, 1);
      return;
    }
  }
  rtn_scanpush(scon(scpy(v_file), ".u"));
  v_mod=snew(v_mod, scpy(v_cmodule));
  v_chap=v_cchapter;
  v_param=v_cparagraph;
  v_cmodule=snew(v_cmodule, scpy(v_file));
  rtn_scan_moduleheader();
  rtn_remaining_text();
  rtn_do_scan(scpy("chapter sub list syntax option include import routine variable table module operations reserved_keywords reserved_fields actions"));
  while (1) {
    if ((v_scantype==0) || ((v_scantype==2 && scmp(v_scantag, "module")==0))) {
      break;
    }
    v_tagfound=0;
    rtn_scan_type();
    rtn_remaining_text();
    v_tfile=snew(v_tfile, rtn_scan_table());
    if ((v_tfile!=0)) {
      rtn_scan_module(scpy(v_tfile));
    }
    rtn_scan_module(0);
    rtn_scan_options();
    rtn_scan_documentation();
    rtn_scan_include();
    rtn_scan_routine();
    rtn_scan_variable();
    if (!(v_tagfound) && v_scantype!=ienum("Keyword", "")) {
      rtn_putwarning(scon(scon(scon(sadd(scpy("Unknown "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " '"), v_scantag), "' found"));
    }
    rtn_remaining_text();
    rtn_do_scan(scpy("chapter sub list syntax option include import routine variable table module operations reserved_keywords reserved_fields actions"));
  }
  rtn_remaining_text();
  if ((v_scantype!=2) || (scmp(v_scantag, "module")!=0)) {
    rtn_putwarning(scpy("Module not finished with an module endtag"));
  }
  rtn_scanpop();
  v_cmodule=snew(v_cmodule, scpy(v_mod));
  v_cchapter=v_chap;
  v_cparagraph=v_param;
  if (v_file!=0) {free(v_file); v_file=0;}
  delptr(&v_s, 1);
}
 
 
void rtn_tbl_write_all(FILE *v_stream) {
  struct pointer v_t1={-1, -1, -1};
  long int c_t1=0;
  struct pointer v_t3={-1, -1, -1};
  long int c_t3=0;
  struct pointer v_t4={-1, -1, -1};
  long int c_t4=0;
  struct pointer v_t5={-1, -1, -1};
  long int c_t5=0;
  struct pointer v_t6={-1, -1, -1};
  long int c_t6=0;
  struct pointer v_t7={-1, -1, -1};
  long int c_t7=0;
  struct pointer v_t8={-1, -1, -1};
  long int c_t8=0;
  struct pointer v_t9={-1, -1, -1};
  long int c_t9=0;
  struct pointer v_t10={-1, -1, -1};
  long int c_t10=0;
  struct pointer v_t11={-1, -1, -1};
  long int c_t11=0;
  struct pointer v_t12={-1, -1, -1};
  long int c_t12=0;
  struct pointer v_t13={-1, -1, -1};
  long int c_t13=0;
  struct pointer v_t14={-1, -1, -1};
  long int c_t14=0;
  struct pointer v_t15={-1, -1, -1};
  long int c_t15=0;
  struct pointer v_t16={-1, -1, -1};
  long int c_t16=0;
  struct pointer v_t17={-1, -1, -1};
  long int c_t17=0;
  struct pointer v_t18={-1, -1, -1};
  long int c_t18=0;
  struct pointer v_t19={-1, -1, -1};
  long int c_t19=0;
  struct pointer v_t20={-1, -1, -1};
  long int c_t20=0;
  struct pointer v_t21={-1, -1, -1};
  long int c_t21=0;
  struct pointer v_t22={-1, -1, -1};
  long int c_t22=0;
  struct pointer v_t23={-1, -1, -1};
  long int c_t23=0;
  struct pointer v_t24={-1, -1, -1};
  long int c_t24=0;
  struct pointer v_t25={-1, -1, -1};
  long int c_t25=0;
  struct pointer v_t26={-1, -1, -1};
  long int c_t26=0;
  struct pointer v_t27={-1, -1, -1};
  long int c_t27=0;
  rtn_write(rtn_tbl_tablelength_scan(), v_stream);
  newptr(&v_t1, 1, 0);
  c_t1=1;
  v_t1=rtn_getpointer(0, 0, 1);
  while (1) {
    if (v_t1.branch==-1) {
      break;
    }
    rtn_tbl_write_scan(v_t1, v_stream);
    c_t1+=1;
    if (v_t1.branch==-1) {
      v_t1=rtn_getpointer(0, 0, 1);
    }
    else {
      v_t1=rtn_ptrplus1(v_t1, 1);
    }
  }
  rtn_write(rtn_tbl_tablelength_options(), v_stream);
  newptr(&v_t3, 4, 0);
  c_t3=1;
  v_t3=rtn_getpointer(0, 0, 4);
  while (1) {
    if (v_t3.branch==-1) {
      break;
    }
    rtn_tbl_write_options(v_t3, v_stream);
    c_t3+=1;
    if (v_t3.branch==-1) {
      v_t3=rtn_getpointer(0, 0, 4);
    }
    else {
      v_t3=rtn_ptrplus1(v_t3, 4);
    }
  }
  rtn_write(rtn_tbl_tablelength_module(), v_stream);
  newptr(&v_t4, 5, 0);
  c_t4=1;
  v_t4=rtn_getpointer(0, 0, 5);
  while (1) {
    if (v_t4.branch==-1) {
      break;
    }
    rtn_tbl_write_module(v_t4, v_stream);
    c_t4+=1;
    if (v_t4.branch==-1) {
      v_t4=rtn_getpointer(0, 0, 5);
    }
    else {
      v_t4=rtn_ptrplus1(v_t4, 5);
    }
  }
  rtn_write(rtn_tbl_tablelength_routine(), v_stream);
  newptr(&v_t5, 6, 0);
  c_t5=1;
  v_t5=rtn_getpointer(0, 0, 6);
  while (1) {
    if (v_t5.branch==-1) {
      break;
    }
    rtn_tbl_write_routine(v_t5, v_stream);
    c_t5+=1;
    if (v_t5.branch==-1) {
      v_t5=rtn_getpointer(0, 0, 6);
    }
    else {
      v_t5=rtn_ptrplus1(v_t5, 6);
    }
  }
  rtn_write(rtn_tbl_tablelength_parameter(), v_stream);
  newptr(&v_t6, 9, 0);
  c_t6=1;
  v_t6=rtn_getpointer(0, 0, 9);
  while (1) {
    if (v_t6.branch==-1) {
      break;
    }
    rtn_tbl_write_parameter(v_t6, v_stream);
    c_t6+=1;
    if (v_t6.branch==-1) {
      v_t6=rtn_getpointer(0, 0, 9);
    }
    else {
      v_t6=rtn_ptrplus1(v_t6, 9);
    }
  }
  rtn_write(rtn_tbl_tablelength_extracode(), v_stream);
  newptr(&v_t7, 11, 0);
  c_t7=1;
  v_t7=rtn_getpointer(0, 0, 11);
  while (1) {
    if (v_t7.branch==-1) {
      break;
    }
    rtn_tbl_write_extracode(v_t7, v_stream);
    c_t7+=1;
    if (v_t7.branch==-1) {
      v_t7=rtn_getpointer(0, 0, 11);
    }
    else {
      v_t7=rtn_ptrplus1(v_t7, 11);
    }
  }
  rtn_write(rtn_tbl_tablelength_table(), v_stream);
  newptr(&v_t8, 12, 0);
  c_t8=1;
  v_t8=rtn_getpointer(0, 0, 12);
  while (1) {
    if (v_t8.branch==-1) {
      break;
    }
    rtn_tbl_write_table(v_t8, v_stream);
    c_t8+=1;
    if (v_t8.branch==-1) {
      v_t8=rtn_getpointer(0, 0, 12);
    }
    else {
      v_t8=rtn_ptrplus1(v_t8, 12);
    }
  }
  rtn_write(rtn_tbl_tablelength_field(), v_stream);
  newptr(&v_t9, 14, 0);
  c_t9=1;
  v_t9=rtn_getpointer(0, 0, 14);
  while (1) {
    if (v_t9.branch==-1) {
      break;
    }
    rtn_tbl_write_field(v_t9, v_stream);
    c_t9+=1;
    if (v_t9.branch==-1) {
      v_t9=rtn_getpointer(0, 0, 14);
    }
    else {
      v_t9=rtn_ptrplus1(v_t9, 14);
    }
  }
  rtn_write(rtn_tbl_tablelength_index(), v_stream);
  newptr(&v_t10, 16, 0);
  c_t10=1;
  v_t10=rtn_getpointer(0, 0, 16);
  while (1) {
    if (v_t10.branch==-1) {
      break;
    }
    rtn_tbl_write_index(v_t10, v_stream);
    c_t10+=1;
    if (v_t10.branch==-1) {
      v_t10=rtn_getpointer(0, 0, 16);
    }
    else {
      v_t10=rtn_ptrplus1(v_t10, 16);
    }
  }
  rtn_write(rtn_tbl_tablelength_ifield(), v_stream);
  newptr(&v_t11, 19, 0);
  c_t11=1;
  v_t11=rtn_getpointer(0, 0, 19);
  while (1) {
    if (v_t11.branch==-1) {
      break;
    }
    rtn_tbl_write_ifield(v_t11, v_stream);
    c_t11+=1;
    if (v_t11.branch==-1) {
      v_t11=rtn_getpointer(0, 0, 19);
    }
    else {
      v_t11=rtn_ptrplus1(v_t11, 19);
    }
  }
  rtn_write(rtn_tbl_tablelength_chapter(), v_stream);
  newptr(&v_t12, 21, 0);
  c_t12=1;
  v_t12=rtn_getpointer(0, 0, 21);
  while (1) {
    if (v_t12.branch==-1) {
      break;
    }
    rtn_tbl_write_chapter(v_t12, v_stream);
    c_t12+=1;
    if (v_t12.branch==-1) {
      v_t12=rtn_getpointer(0, 0, 21);
    }
    else {
      v_t12=rtn_ptrplus1(v_t12, 21);
    }
  }
  rtn_write(rtn_tbl_tablelength_paragraph(), v_stream);
  newptr(&v_t13, 22, 0);
  c_t13=1;
  v_t13=rtn_getpointer(0, 0, 22);
  while (1) {
    if (v_t13.branch==-1) {
      break;
    }
    rtn_tbl_write_paragraph(v_t13, v_stream);
    c_t13+=1;
    if (v_t13.branch==-1) {
      v_t13=rtn_getpointer(0, 0, 22);
    }
    else {
      v_t13=rtn_ptrplus1(v_t13, 22);
    }
  }
  rtn_write(rtn_tbl_tablelength_list(), v_stream);
  newptr(&v_t14, 24, 0);
  c_t14=1;
  v_t14=rtn_getpointer(0, 0, 24);
  while (1) {
    if (v_t14.branch==-1) {
      break;
    }
    rtn_tbl_write_list(v_t14, v_stream);
    c_t14+=1;
    if (v_t14.branch==-1) {
      v_t14=rtn_getpointer(0, 0, 24);
    }
    else {
      v_t14=rtn_ptrplus1(v_t14, 24);
    }
  }
  rtn_write(rtn_tbl_tablelength_opdef(), v_stream);
  newptr(&v_t15, 25, 0);
  c_t15=1;
  v_t15=rtn_getpointer(0, 0, 25);
  while (1) {
    if (v_t15.branch==-1) {
      break;
    }
    rtn_tbl_write_opdef(v_t15, v_stream);
    c_t15+=1;
    if (v_t15.branch==-1) {
      v_t15=rtn_getpointer(0, 0, 25);
    }
    else {
      v_t15=rtn_ptrplus1(v_t15, 25);
    }
  }
  rtn_write(rtn_tbl_tablelength_type(), v_stream);
  newptr(&v_t16, 27, 0);
  c_t16=1;
  v_t16=rtn_getpointer(0, 0, 27);
  while (1) {
    if (v_t16.branch==-1) {
      break;
    }
    rtn_tbl_write_type(v_t16, v_stream);
    c_t16+=1;
    if (v_t16.branch==-1) {
      v_t16=rtn_getpointer(0, 0, 27);
    }
    else {
      v_t16=rtn_ptrplus1(v_t16, 27);
    }
  }
  rtn_write(rtn_tbl_tablelength_action(), v_stream);
  newptr(&v_t17, 29, 0);
  c_t17=1;
  v_t17=rtn_getpointer(0, 0, 29);
  while (1) {
    if (v_t17.branch==-1) {
      break;
    }
    rtn_tbl_write_action(v_t17, v_stream);
    c_t17+=1;
    if (v_t17.branch==-1) {
      v_t17=rtn_getpointer(0, 0, 29);
    }
    else {
      v_t17=rtn_ptrplus1(v_t17, 29);
    }
  }
  rtn_write(rtn_tbl_tablelength_code(), v_stream);
  newptr(&v_t18, 33, 0);
  c_t18=1;
  v_t18=rtn_getpointer(0, 0, 33);
  while (1) {
    if (v_t18.branch==-1) {
      break;
    }
    rtn_tbl_write_code(v_t18, v_stream);
    c_t18+=1;
    if (v_t18.branch==-1) {
      v_t18=rtn_getpointer(0, 0, 33);
    }
    else {
      v_t18=rtn_ptrplus1(v_t18, 33);
    }
  }
  rtn_write(rtn_tbl_tablelength_reserved(), v_stream);
  newptr(&v_t19, 34, 0);
  c_t19=1;
  v_t19=rtn_getpointer(0, 0, 34);
  while (1) {
    if (v_t19.branch==-1) {
      break;
    }
    rtn_tbl_write_reserved(v_t19, v_stream);
    c_t19+=1;
    if (v_t19.branch==-1) {
      v_t19=rtn_getpointer(0, 0, 34);
    }
    else {
      v_t19=rtn_ptrplus1(v_t19, 34);
    }
  }
  rtn_write(rtn_tbl_tablelength_freevar(), v_stream);
  newptr(&v_t20, 35, 0);
  c_t20=1;
  v_t20=rtn_getpointer(0, 0, 35);
  while (1) {
    if (v_t20.branch==-1) {
      break;
    }
    rtn_tbl_write_freevar(v_t20, v_stream);
    c_t20+=1;
    if (v_t20.branch==-1) {
      v_t20=rtn_getpointer(0, 0, 35);
    }
    else {
      v_t20=rtn_ptrplus1(v_t20, 35);
    }
  }
  rtn_write(rtn_tbl_tablelength_codestore(), v_stream);
  newptr(&v_t21, 36, 0);
  c_t21=1;
  v_t21=rtn_getpointer(0, 0, 36);
  while (1) {
    if (v_t21.branch==-1) {
      break;
    }
    rtn_tbl_write_codestore(v_t21, v_stream);
    c_t21+=1;
    if (v_t21.branch==-1) {
      v_t21=rtn_getpointer(0, 0, 36);
    }
    else {
      v_t21=rtn_ptrplus1(v_t21, 36);
    }
  }
  rtn_write(rtn_tbl_tablelength_variable(), v_stream);
  newptr(&v_t22, 37, 0);
  c_t22=1;
  v_t22=rtn_getpointer(0, 0, 37);
  while (1) {
    if (v_t22.branch==-1) {
      break;
    }
    rtn_tbl_write_variable(v_t22, v_stream);
    c_t22+=1;
    if (v_t22.branch==-1) {
      v_t22=rtn_getpointer(0, 0, 37);
    }
    else {
      v_t22=rtn_ptrplus1(v_t22, 37);
    }
  }
  rtn_write(rtn_tbl_tablelength_global(), v_stream);
  newptr(&v_t23, 38, 0);
  c_t23=1;
  v_t23=rtn_getpointer(0, 0, 38);
  while (1) {
    if (v_t23.branch==-1) {
      break;
    }
    rtn_tbl_write_global(v_t23, v_stream);
    c_t23+=1;
    if (v_t23.branch==-1) {
      v_t23=rtn_getpointer(0, 0, 38);
    }
    else {
      v_t23=rtn_ptrplus1(v_t23, 38);
    }
  }
  rtn_write(rtn_tbl_tablelength_para(), v_stream);
  newptr(&v_t24, 39, 0);
  c_t24=1;
  v_t24=rtn_getpointer(0, 0, 39);
  while (1) {
    if (v_t24.branch==-1) {
      break;
    }
    rtn_tbl_write_para(v_t24, v_stream);
    c_t24+=1;
    if (v_t24.branch==-1) {
      v_t24=rtn_getpointer(0, 0, 39);
    }
    else {
      v_t24=rtn_ptrplus1(v_t24, 39);
    }
  }
  rtn_write(rtn_tbl_tablelength_stack(), v_stream);
  newptr(&v_t25, 40, 0);
  c_t25=1;
  v_t25=rtn_getpointer(0, 0, 40);
  while (1) {
    if (v_t25.branch==-1) {
      break;
    }
    rtn_tbl_write_stack(v_t25, v_stream);
    c_t25+=1;
    if (v_t25.branch==-1) {
      v_t25=rtn_getpointer(0, 0, 40);
    }
    else {
      v_t25=rtn_ptrplus1(v_t25, 40);
    }
  }
  rtn_write(rtn_tbl_tablelength_endblock(), v_stream);
  newptr(&v_t26, 41, 0);
  c_t26=1;
  v_t26=rtn_getpointer(0, 0, 41);
  while (1) {
    if (v_t26.branch==-1) {
      break;
    }
    rtn_tbl_write_endblock(v_t26, v_stream);
    c_t26+=1;
    if (v_t26.branch==-1) {
      v_t26=rtn_getpointer(0, 0, 41);
    }
    else {
      v_t26=rtn_ptrplus1(v_t26, 41);
    }
  }
  rtn_write(rtn_tbl_tablelength_search_exp(), v_stream);
  newptr(&v_t27, 42, 0);
  c_t27=1;
  v_t27=rtn_getpointer(0, 0, 42);
  while (1) {
    if (v_t27.branch==-1) {
      break;
    }
    rtn_tbl_write_search_exp(v_t27, v_stream);
    c_t27+=1;
    if (v_t27.branch==-1) {
      v_t27=rtn_getpointer(0, 0, 42);
    }
    else {
      v_t27=rtn_ptrplus1(v_t27, 42);
    }
  }
  delptr(&v_t1, 1);
  delptr(&v_t3, 4);
  delptr(&v_t4, 5);
  delptr(&v_t5, 6);
  delptr(&v_t6, 9);
  delptr(&v_t7, 11);
  delptr(&v_t8, 12);
  delptr(&v_t9, 14);
  delptr(&v_t10, 16);
  delptr(&v_t11, 19);
  delptr(&v_t12, 21);
  delptr(&v_t13, 22);
  delptr(&v_t14, 24);
  delptr(&v_t15, 25);
  delptr(&v_t16, 27);
  delptr(&v_t17, 29);
  delptr(&v_t18, 33);
  delptr(&v_t19, 34);
  delptr(&v_t20, 35);
  delptr(&v_t21, 36);
  delptr(&v_t22, 37);
  delptr(&v_t23, 38);
  delptr(&v_t24, 39);
  delptr(&v_t25, 40);
  delptr(&v_t26, 41);
  delptr(&v_t27, 42);
}
 
 
void rtn_tbl_read_all(FILE *v_stream) {
  long int v_rec=0;
  struct pointer v_ptr={-1, -1, -1};
  long int v_num=0;
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_scan(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_options(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_module(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_routine(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_parameter(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_extracode(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_table(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_field(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_index(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_ifield(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_chapter(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_paragraph(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_list(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_opdef(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_type(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_action(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_code(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_reserved(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_freevar(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_codestore(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_variable(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_global(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_para(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_stack(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_endblock(v_stream);
    v_num+=1;
  }
  v_rec=rtn_read(v_stream);
  v_num=1;
  while (1) {
    if (v_num>v_rec) {
      break;
    }
    v_ptr=rtn_tbl_read_search_exp(v_stream);
    v_num+=1;
  }
}
 
 
int main(int v_parameters, char **v_paravalues) {
  char *v_file=0;
  char *v_tfile=0;
  char *var1=0;
  rtn_initdb(28, 43);
  rtn_tbl_init_scan();
  rtn_tbl_init_scanstack();
  rtn_tbl_init_options();
  rtn_tbl_init_module();
  rtn_tbl_init_routine();
  rtn_tbl_init_parameter();
  rtn_tbl_init_extracode();
  rtn_tbl_init_table();
  rtn_tbl_init_field();
  rtn_tbl_init_index();
  rtn_tbl_init_ifield();
  rtn_tbl_init_chapter();
  rtn_tbl_init_paragraph();
  rtn_tbl_init_list();
  rtn_tbl_init_opdef();
  rtn_tbl_init_type();
  rtn_tbl_init_action();
  rtn_tbl_init_code();
  rtn_tbl_init_reserved();
  rtn_tbl_init_freevar();
  rtn_tbl_init_codestore();
  rtn_tbl_init_variable();
  rtn_tbl_init_global();
  rtn_tbl_init_para();
  rtn_tbl_init_stack();
  rtn_tbl_init_endblock();
  rtn_tbl_init_search_exp();
  if (v_parameters>1) {
    v_file=snew(v_file, scpy(rtn_getstring(v_paravalues, 2)));
  }
  else {
    swrite((var1=snew(var1, scon(scpy("language <"), "source file>"))), stdout); wline(stdout);
    return 1;
  }
  rtn_initscan(scpy(v_file));
  v_file=snew(v_file, rtn_left(v_file, rtn_length(v_file)-2));
  v_c=rtn_create((var1=snew(var1, scon(scon(scpy("uni_"), v_file), ".c"))));
  rtn_startlog(scpy("errors.html"));
  v_errnr=0;
  v_routinelevel=1;
  v_cmodule=snew(v_cmodule, scpy(v_file));
  swrite((var1=snew(var1, scon(scpy("#include <"), "stdio.h>"))), v_c); wline(v_c);
  swrite((var1=snew(var1, scon(scpy("#include <"), "stdlib.h>"))), v_c); wline(v_c);
  swrite((var1=snew(var1, scon(scpy("#include <"), "string.h>"))), v_c); wline(v_c);
  swrite((var1=snew(var1, scon(scpy("#include <"), "ctype.h>"))), v_c); wline(v_c);
  rtn_scan_moduleheader();
  rtn_remaining_text();
  rtn_do_scan(scpy("chapter sub list syntax option include import routine variable table module operations reserved_keywords reserved_fields actions"));
  while (1) {
    if ((v_scantype==0) || ((v_scantype==2 && scmp(v_scantag, "module")==0))) {
      break;
    }
    v_tagfound=0;
    rtn_scan_type();
    v_tfile=snew(v_tfile, rtn_scan_table());
    if (v_tfile!=0) {
      rtn_scan_module(scpy(v_tfile));
    }
    rtn_remaining_text();
    rtn_scan_module(0);
    rtn_scan_options();
    rtn_scan_documentation();
    rtn_scan_include();
    rtn_scan_routine();
    rtn_scan_variable();
    if (!(v_tagfound) && v_scantype!=ienum("Keyword", "")) {
      rtn_putwarning(scon(scon(scon(sadd(scpy("Unknown "), get_enum(v_scantype, "EOF StartTag EndTag SingleTag")), " "), v_scantag), " found"));
    }
    rtn_remaining_text();
    rtn_do_scan(scpy("chapter sub list syntax option include import routine variable table module operations reserved_keywords reserved_fields actions"));
  }
  rtn_remaining_text();
  if ((v_scantype!=2) || (scmp(v_scantag, "module")!=0)) {
    rtn_putwarning(scpy("Module not finished with an module endtag"));
  }
  rtn_export_website();
  if (scmp((var1=snew(var1, rtn_test_option(scpy("list_actions"), scpy("no")))), "yes")==0) {
    rtn_doc_types();
  }
  if (v_errormsg!=0) {
    swrite((var1=snew(var1, scon(scpy("Error found :"), v_errormsg))), stdout); wline(stdout);
    swrite((var1=snew(var1, scon(rtn_tag("br"), "End of log"))), v_logfile); wline(v_logfile);
    return 1;
  }
  swrite((var1=snew(var1, scon(rtn_tag("br"), "Success"))), v_logfile); wline(v_logfile);
  return 0;
  if (var1!=0) {free(var1); var1=0;}
}
 
